/******/ (function(modules) { // webpackBootstrap
/******/ 	// install a JSONP callback for chunk loading
/******/ 	function webpackJsonpCallback(data) {
/******/ 		var chunkIds = data[0];
/******/ 		var moreModules = data[1];
/******/ 		var executeModules = data[2];
/******/
/******/ 		// add "moreModules" to the modules object,
/******/ 		// then flag all "chunkIds" as loaded and fire callback
/******/ 		var moduleId, chunkId, i = 0, resolves = [];
/******/ 		for(;i < chunkIds.length; i++) {
/******/ 			chunkId = chunkIds[i];
/******/ 			if(Object.prototype.hasOwnProperty.call(installedChunks, chunkId) && installedChunks[chunkId]) {
/******/ 				resolves.push(installedChunks[chunkId][0]);
/******/ 			}
/******/ 			installedChunks[chunkId] = 0;
/******/ 		}
/******/ 		for(moduleId in moreModules) {
/******/ 			if(Object.prototype.hasOwnProperty.call(moreModules, moduleId)) {
/******/ 				modules[moduleId] = moreModules[moduleId];
/******/ 			}
/******/ 		}
/******/ 		if(parentJsonpFunction) parentJsonpFunction(data);
/******/
/******/ 		while(resolves.length) {
/******/ 			resolves.shift()();
/******/ 		}
/******/
/******/ 		// add entry modules from loaded chunk to deferred list
/******/ 		deferredModules.push.apply(deferredModules, executeModules || []);
/******/
/******/ 		// run deferred modules when all chunks ready
/******/ 		return checkDeferredModules();
/******/ 	};
/******/ 	function checkDeferredModules() {
/******/ 		var result;
/******/ 		for(var i = 0; i < deferredModules.length; i++) {
/******/ 			var deferredModule = deferredModules[i];
/******/ 			var fulfilled = true;
/******/ 			for(var j = 1; j < deferredModule.length; j++) {
/******/ 				var depId = deferredModule[j];
/******/ 				if(installedChunks[depId] !== 0) fulfilled = false;
/******/ 			}
/******/ 			if(fulfilled) {
/******/ 				deferredModules.splice(i--, 1);
/******/ 				result = __webpack_require__(__webpack_require__.s = deferredModule[0]);
/******/ 			}
/******/ 		}
/******/
/******/ 		return result;
/******/ 	}
/******/
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// object to store loaded and loading chunks
/******/ 	// undefined = chunk not loaded, null = chunk preloaded/prefetched
/******/ 	// Promise = chunk loading, 0 = chunk loaded
/******/ 	var installedChunks = {
/******/ 		"app": 0
/******/ 	};
/******/
/******/ 	var deferredModules = [];
/******/
/******/ 	// script path function
/******/ 	function jsonpScriptSrc(chunkId) {
/******/ 		return __webpack_require__.p + "js/" + ({}[chunkId]||chunkId) + ".js"
/******/ 	}
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/ 	// This file contains only the entry chunk.
/******/ 	// The chunk loading function for additional chunks
/******/ 	__webpack_require__.e = function requireEnsure(chunkId) {
/******/ 		var promises = [];
/******/
/******/
/******/ 		// JSONP chunk loading for javascript
/******/
/******/ 		var installedChunkData = installedChunks[chunkId];
/******/ 		if(installedChunkData !== 0) { // 0 means "already installed".
/******/
/******/ 			// a Promise means "currently loading".
/******/ 			if(installedChunkData) {
/******/ 				promises.push(installedChunkData[2]);
/******/ 			} else {
/******/ 				// setup Promise in chunk cache
/******/ 				var promise = new Promise(function(resolve, reject) {
/******/ 					installedChunkData = installedChunks[chunkId] = [resolve, reject];
/******/ 				});
/******/ 				promises.push(installedChunkData[2] = promise);
/******/
/******/ 				// start chunk loading
/******/ 				var script = document.createElement('script');
/******/ 				var onScriptComplete;
/******/
/******/ 				script.charset = 'utf-8';
/******/ 				script.timeout = 120;
/******/ 				if (__webpack_require__.nc) {
/******/ 					script.setAttribute("nonce", __webpack_require__.nc);
/******/ 				}
/******/ 				script.src = jsonpScriptSrc(chunkId);
/******/
/******/ 				// create error before stack unwound to get useful stacktrace later
/******/ 				var error = new Error();
/******/ 				onScriptComplete = function (event) {
/******/ 					// avoid mem leaks in IE.
/******/ 					script.onerror = script.onload = null;
/******/ 					clearTimeout(timeout);
/******/ 					var chunk = installedChunks[chunkId];
/******/ 					if(chunk !== 0) {
/******/ 						if(chunk) {
/******/ 							var errorType = event && (event.type === 'load' ? 'missing' : event.type);
/******/ 							var realSrc = event && event.target && event.target.src;
/******/ 							error.message = 'Loading chunk ' + chunkId + ' failed.\n(' + errorType + ': ' + realSrc + ')';
/******/ 							error.name = 'ChunkLoadError';
/******/ 							error.type = errorType;
/******/ 							error.request = realSrc;
/******/ 							chunk[1](error);
/******/ 						}
/******/ 						installedChunks[chunkId] = undefined;
/******/ 					}
/******/ 				};
/******/ 				var timeout = setTimeout(function(){
/******/ 					onScriptComplete({ type: 'timeout', target: script });
/******/ 				}, 120000);
/******/ 				script.onerror = script.onload = onScriptComplete;
/******/ 				document.head.appendChild(script);
/******/ 			}
/******/ 		}
/******/ 		return Promise.all(promises);
/******/ 	};
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/";
/******/
/******/ 	// on error function for async loading
/******/ 	__webpack_require__.oe = function(err) { console.error(err); throw err; };
/******/
/******/ 	var jsonpArray = window["webpackJsonp"] = window["webpackJsonp"] || [];
/******/ 	var oldJsonpFunction = jsonpArray.push.bind(jsonpArray);
/******/ 	jsonpArray.push = webpackJsonpCallback;
/******/ 	jsonpArray = jsonpArray.slice();
/******/ 	for(var i = 0; i < jsonpArray.length; i++) webpackJsonpCallback(jsonpArray[i]);
/******/ 	var parentJsonpFunction = oldJsonpFunction;
/******/
/******/
/******/ 	// add entry module to deferred list
/******/ 	deferredModules.push([0,"chunk-vendors"]);
/******/ 	// run deferred modules when ready
/******/ 	return checkDeferredModules();
/******/ })
/************************************************************************/
/******/ ({

/***/ "./node_modules/cache-loader/dist/cjs.js?!./node_modules/babel-loader/lib/index.js!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/App.vue?vue&type=script&lang=js&":
/*!*************************************************************************************************************************************************************************************************************************************!*\
  !*** ./node_modules/cache-loader/dist/cjs.js??ref--12-0!./node_modules/babel-loader/lib!./node_modules/cache-loader/dist/cjs.js??ref--0-0!./node_modules/vue-loader/lib??vue-loader-options!./src/App.vue?vue&type=script&lang=js& ***!
  \*************************************************************************************************************************************************************************************************************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _components_main_Nav__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @/components/main/Nav */ \"./src/components/main/Nav.vue\");\n/* harmony import */ var _components_main_Breadcrumb__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @/components/main/Breadcrumb */ \"./src/components/main/Breadcrumb.vue\");\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n\n\n\n/* harmony default export */ __webpack_exports__[\"default\"] = ({\n  components: {\n    Nav: _components_main_Nav__WEBPACK_IMPORTED_MODULE_0__[\"default\"],\n    Breadcrumb: _components_main_Breadcrumb__WEBPACK_IMPORTED_MODULE_1__[\"default\"],\n    NotificationBar: () => __webpack_require__.e(/*! import() */ 93).then(__webpack_require__.bind(null, /*! @/components/main/packages/NotificationBar.vue */ \"./src/components/main/packages/NotificationBar.vue\")),\n    Unsealer: () => __webpack_require__.e(/*! import() */ 106).then(__webpack_require__.bind(null, /*! @/components/main/user/Unsealer.vue */ \"./src/components/main/user/Unsealer.vue\")),\n    LicenseExceeded: () => __webpack_require__.e(/*! import() */ 59).then(__webpack_require__.bind(null, /*! @/components/main/user/LicenseExceeded.vue */ \"./src/components/main/user/LicenseExceeded.vue\"))\n  },\n  data() {\n    return {\n      showHelp: true\n    };\n  },\n  computed: {\n    showBg() {\n      return this.$route.path === `/signin` || this.$route.path.startsWith(\"/resetpassword\");\n    },\n    css() {\n      return this.showBg ? \"full-bg fade\" : \"\";\n    },\n    showInfobar() {\n      return this.$store.state.infobar.package && this.$route.params.computerUID && this.$store.state.settings.user.profile && this.$store.state.settings.user.profile.infobar && this.$store.state.settings.user.profile.infobar.workingStatus;\n    }\n  }\n});\n\n//# sourceURL=webpack:///./src/App.vue?./node_modules/cache-loader/dist/cjs.js??ref--12-0!./node_modules/babel-loader/lib!./node_modules/cache-loader/dist/cjs.js??ref--0-0!./node_modules/vue-loader/lib??vue-loader-options");

/***/ }),

/***/ "./node_modules/cache-loader/dist/cjs.js?!./node_modules/babel-loader/lib/index.js!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/main/Breadcrumb.vue?vue&type=script&lang=js&":
/*!************************************************************************************************************************************************************************************************************************************************************!*\
  !*** ./node_modules/cache-loader/dist/cjs.js??ref--12-0!./node_modules/babel-loader/lib!./node_modules/cache-loader/dist/cjs.js??ref--0-0!./node_modules/vue-loader/lib??vue-loader-options!./src/components/main/Breadcrumb.vue?vue&type=script&lang=js& ***!
  \************************************************************************************************************************************************************************************************************************************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _utils_computer__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @/utils/computer */ \"./src/utils/computer.js\");\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n\n\n/* harmony default export */ __webpack_exports__[\"default\"] = ({\n  computed: {\n    domain() {\n      return this.$store.getters[\"domain/single\"](this.$route.params.domainUID);\n    },\n    source() {\n      return this.$store.getters[\"source/single\"](this.$route.params.repoUID);\n    },\n    computer() {\n      if (this.$route.params.domainUID) {\n        this.$store.dispatch(\"computer/fetch\", {\n          domainUID: this.$route.params.domainUID\n        });\n      }\n      return this.$store.getters[\"computer/singleComputer\"](this.$route.params.computerUID);\n    },\n    groupInfo() {\n      return this.$store.getters[\"group/single\"](this.$route.params.groupUID);\n    },\n    computerName() {\n      return computer => {\n        return _utils_computer__WEBPACK_IMPORTED_MODULE_0__[\"default\"].getName(computer);\n      };\n    }\n  },\n  async mounted() {\n    await this.$store.dispatch(\"domain/fetch\");\n  }\n});\n\n//# sourceURL=webpack:///./src/components/main/Breadcrumb.vue?./node_modules/cache-loader/dist/cjs.js??ref--12-0!./node_modules/babel-loader/lib!./node_modules/cache-loader/dist/cjs.js??ref--0-0!./node_modules/vue-loader/lib??vue-loader-options");

/***/ }),

/***/ "./node_modules/cache-loader/dist/cjs.js?{\"cacheDirectory\":\"node_modules/.cache/vue-loader\",\"cacheIdentifier\":\"60671cf1-vue-loader-template\"}!./node_modules/vue-loader/lib/loaders/templateLoader.js?!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/App.vue?vue&type=template&id=7ba5bd90&scoped=true&":
/*!*********************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************!*\
  !*** ./node_modules/cache-loader/dist/cjs.js?{"cacheDirectory":"node_modules/.cache/vue-loader","cacheIdentifier":"60671cf1-vue-loader-template"}!./node_modules/vue-loader/lib/loaders/templateLoader.js??vue-loader-options!./node_modules/cache-loader/dist/cjs.js??ref--0-0!./node_modules/vue-loader/lib??vue-loader-options!./src/App.vue?vue&type=template&id=7ba5bd90&scoped=true& ***!
  \*********************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************/
/*! exports provided: render, staticRenderFns */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"render\", function() { return render; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"staticRenderFns\", function() { return staticRenderFns; });\nvar render = function() {\n  var _vm = this\n  var _h = _vm.$createElement\n  var _c = _vm._self._c || _h\n  return _c(\n    \"div\",\n    { class: _vm.css, attrs: { id: \"app\" } },\n    [\n      _vm.showInfobar\n        ? _c(\"NotificationBar\", {\n            domProps: { innerHTML: _vm._s(_vm.$store.state.infobar.text) }\n          })\n        : _vm._e(),\n      _c(\"Nav\", {\n        directives: [\n          {\n            name: \"show\",\n            rawName: \"v-show\",\n            value: !_vm.showBg,\n            expression: \"!showBg\"\n          }\n        ]\n      }),\n      _c(\"Breadcrumb\"),\n      _c(\"LicenseExceeded\"),\n      _c(\"router-view\"),\n      _c(\"notifications\", {\n        staticClass: \"clickable\",\n        attrs: { group: \"all\", position: \"bottom center\" }\n      }),\n      _vm.$store.state.settings.server &&\n      _vm.$store.state.settings.server.sealed &&\n      _vm.$store.state.settings.server.webUnsealEnabled\n        ? _c(\"Unsealer\", {\n            attrs: {\n              value:\n                _vm.$store.state.settings.server &&\n                _vm.$store.state.settings.server.sealed &&\n                _vm.$store.state.settings.server.webUnsealEnabled\n            }\n          })\n        : _vm._e()\n    ],\n    1\n  )\n}\nvar staticRenderFns = []\nrender._withStripped = true\n\n\n\n//# sourceURL=webpack:///./src/App.vue?./node_modules/cache-loader/dist/cjs.js?%7B%22cacheDirectory%22:%22node_modules/.cache/vue-loader%22,%22cacheIdentifier%22:%2260671cf1-vue-loader-template%22%7D!./node_modules/vue-loader/lib/loaders/templateLoader.js??vue-loader-options!./node_modules/cache-loader/dist/cjs.js??ref--0-0!./node_modules/vue-loader/lib??vue-loader-options");

/***/ }),

/***/ "./node_modules/cache-loader/dist/cjs.js?{\"cacheDirectory\":\"node_modules/.cache/vue-loader\",\"cacheIdentifier\":\"60671cf1-vue-loader-template\"}!./node_modules/vue-loader/lib/loaders/templateLoader.js?!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/main/Breadcrumb.vue?vue&type=template&id=11f3f7d9&scoped=true&":
/*!********************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************!*\
  !*** ./node_modules/cache-loader/dist/cjs.js?{"cacheDirectory":"node_modules/.cache/vue-loader","cacheIdentifier":"60671cf1-vue-loader-template"}!./node_modules/vue-loader/lib/loaders/templateLoader.js??vue-loader-options!./node_modules/cache-loader/dist/cjs.js??ref--0-0!./node_modules/vue-loader/lib??vue-loader-options!./src/components/main/Breadcrumb.vue?vue&type=template&id=11f3f7d9&scoped=true& ***!
  \********************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************/
/*! exports provided: render, staticRenderFns */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"render\", function() { return render; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"staticRenderFns\", function() { return staticRenderFns; });\nvar render = function() {\n  var _vm = this\n  var _h = _vm.$createElement\n  var _c = _vm._self._c || _h\n  return _vm.$store.state.auth.success\n    ? _c(\"section\", { staticClass: \"section small container\" }, [\n        _c(\n          \"nav\",\n          { staticClass: \"breadcrumb\", attrs: { \"aria-label\": \"breadcrumbs\" } },\n          [\n            _c(\"ul\", [\n              _c(\n                \"li\",\n                { class: { \"is-active\": _vm.$route.path === \"/domains\" } },\n                [\n                  _c(\"router-link\", { attrs: { to: \"/domains\" } }, [\n                    _vm._v(\"Start\")\n                  ])\n                ],\n                1\n              ),\n              _vm.$route.path === \"/profile\"\n                ? _c(\"li\", { staticClass: \"is-active\" }, [\n                    _c(\"a\", [_vm._v(\"Profile\")])\n                  ])\n                : _vm._e(),\n              _vm.$route.path === \"/api-documentation\"\n                ? _c(\"li\", { staticClass: \"is-active\" }, [\n                    _c(\"a\", [_vm._v(\"API documentation\")])\n                  ])\n                : _vm._e(),\n              _vm.domain\n                ? _c(\n                    \"li\",\n                    {\n                      class: {\n                        \"is-active\":\n                          _vm.$route.path === \"/domains/\" + _vm.domain.uid\n                      }\n                    },\n                    [\n                      _c(\n                        \"router-link\",\n                        { attrs: { to: \"/domains/\" + _vm.domain.uid } },\n                        [\n                          _c(\"span\", { staticClass: \"icon\" }, [\n                            _c(\"i\", { staticClass: \"mdi mdi-domain\" })\n                          ]),\n                          _c(\"span\", [_vm._v(_vm._s(_vm.domain.friendlyName))]),\n                          _vm.domain.shared\n                            ? _c(\n                                \"span\",\n                                {\n                                  staticClass: \"margin-left-5\",\n                                  attrs: { \"data-tooltip\": \"Shared with me\" }\n                                },\n                                [\n                                  _c(\"i\", {\n                                    staticClass: \"mdi mdi-share-variant\"\n                                  })\n                                ]\n                              )\n                            : _vm._e()\n                        ]\n                      )\n                    ],\n                    1\n                  )\n                : _vm._e(),\n              _vm.computer && _vm.domain\n                ? _c(\n                    \"li\",\n                    {\n                      class: {\n                        \"is-active\":\n                          _vm.$route.path ===\n                          \"/domains/\" +\n                            _vm.domain.uid +\n                            \"/computers/\" +\n                            _vm.computer.uid +\n                            \"/packages\"\n                      }\n                    },\n                    [\n                      _c(\n                        \"router-link\",\n                        {\n                          attrs: {\n                            to:\n                              \"/domains/\" +\n                              _vm.domain.uid +\n                              \"/computers/\" +\n                              _vm.computer.uid +\n                              \"/packages\"\n                          }\n                        },\n                        [\n                          _c(\n                            \"span\",\n                            {\n                              staticClass: \"icon\",\n                              class: { \"has-text-success\": _vm.computer.online }\n                            },\n                            [_c(\"i\", { staticClass: \"mdi mdi-laptop\" })]\n                          ),\n                          _c(\"span\", [\n                            _vm._v(_vm._s(_vm.computerName(_vm.computer)))\n                          ])\n                        ]\n                      ),\n                      _vm.computer.inventorying\n                        ? _c(\n                            \"span\",\n                            {\n                              staticClass: \"margin-right-10\",\n                              attrs: { \"data-tooltip\": \"Inventorying\" }\n                            },\n                            [_c(\"span\", { staticClass: \"spinner small mg\" })]\n                          )\n                        : _vm._e()\n                    ],\n                    1\n                  )\n                : _vm._e(),\n              (_vm.computer &&\n                _vm.domain &&\n                _vm.$route.path ===\n                  \"/domains/\" +\n                    _vm.domain.uid +\n                    \"/computers/\" +\n                    _vm.computer.uid +\n                    \"/applications\") ||\n              (_vm.domain &&\n                _vm.$route.path ===\n                  \"/domains/\" + _vm.domain.uid + \"/applications\")\n                ? _c(\"li\", { staticClass: \"is-active\" }, [_vm._m(0)])\n                : _vm._e(),\n              _vm.groupInfo && _vm.domain\n                ? _c(\n                    \"li\",\n                    {\n                      class: {\n                        \"is-active\":\n                          _vm.$route.path ===\n                          \"/domains/\" +\n                            _vm.domain.uid +\n                            \"/groups/\" +\n                            _vm.groupInfo.group.uid +\n                            \"/packages\"\n                      }\n                    },\n                    [\n                      _c(\n                        \"router-link\",\n                        {\n                          attrs: {\n                            to:\n                              \"/domains/\" +\n                              _vm.domain.uid +\n                              \"/groups/\" +\n                              _vm.groupInfo.group.uid +\n                              \"/packages\"\n                          }\n                        },\n                        [\n                          _c(\"span\", { staticClass: \"icon\" }, [\n                            _c(\"i\", { staticClass: \"mdi mdi-monitor-multiple\" })\n                          ]),\n                          _c(\"span\", [_vm._v(_vm._s(_vm.groupInfo.group.name))])\n                        ]\n                      )\n                    ],\n                    1\n                  )\n                : _vm._e(),\n              _vm.domain &&\n              _vm.$route.path === \"/domains/\" + _vm.domain.uid + \"/shares\"\n                ? _c(\"li\", { staticClass: \"is-active\" }, [_vm._m(1)])\n                : _vm._e(),\n              _vm.$route.path === \"/settings\"\n                ? _c(\"li\", { staticClass: \"is-active\" }, [_vm._m(2)])\n                : _vm._e(),\n              _vm.source && _vm.$route.path === \"/repos/\" + _vm.source.uid\n                ? _c(\"li\", { staticClass: \"is-active\" }, [\n                    _c(\"a\", [\n                      _vm._m(3),\n                      _c(\"span\", [_vm._v(_vm._s(_vm.source.name))]),\n                      _vm.source &&\n                      !_vm.source.external &&\n                      _vm.source.version >= 2\n                        ? _c(\"span\", { staticClass: \"margin-left-5\" }, [\n                            _c(\"i\", {\n                              staticClass: \"mdi mdi-alpha-h-circle-outline\"\n                            })\n                          ])\n                        : _vm._e(),\n                      _vm.source && _vm.source.shared\n                        ? _c(\n                            \"span\",\n                            {\n                              staticClass: \"margin-left-5\",\n                              attrs: { \"data-tooltip\": \"Shared with me\" }\n                            },\n                            [_c(\"i\", { staticClass: \"mdi mdi-share-variant\" })]\n                          )\n                        : _vm._e()\n                    ])\n                  ])\n                : _vm._e()\n            ])\n          ]\n        )\n      ])\n    : _vm._e()\n}\nvar staticRenderFns = [\n  function() {\n    var _vm = this\n    var _h = _vm.$createElement\n    var _c = _vm._self._c || _h\n    return _c(\"a\", [\n      _c(\"span\", { staticClass: \"icon\" }, [\n        _c(\"i\", { staticClass: \"mdi mdi-format-list-checks\" })\n      ]),\n      _c(\"span\", [_vm._v(\"Applications\")])\n    ])\n  },\n  function() {\n    var _vm = this\n    var _h = _vm.$createElement\n    var _c = _vm._self._c || _h\n    return _c(\"a\", [\n      _c(\"span\", { staticClass: \"icon\" }, [\n        _c(\"i\", { staticClass: \"mdi mdi-account-multiple-plus\" })\n      ]),\n      _c(\"span\", [_vm._v(\"Shares\")])\n    ])\n  },\n  function() {\n    var _vm = this\n    var _h = _vm.$createElement\n    var _c = _vm._self._c || _h\n    return _c(\"a\", [\n      _c(\"span\", { staticClass: \"icon\" }, [\n        _c(\"i\", { staticClass: \"mdi mdi-cog\" })\n      ]),\n      _c(\"span\", [_vm._v(\"Global settings\")])\n    ])\n  },\n  function() {\n    var _vm = this\n    var _h = _vm.$createElement\n    var _c = _vm._self._c || _h\n    return _c(\"span\", { staticClass: \"icon\" }, [\n      _c(\"i\", { staticClass: \"mdi mdi-database\" })\n    ])\n  }\n]\nrender._withStripped = true\n\n\n\n//# sourceURL=webpack:///./src/components/main/Breadcrumb.vue?./node_modules/cache-loader/dist/cjs.js?%7B%22cacheDirectory%22:%22node_modules/.cache/vue-loader%22,%22cacheIdentifier%22:%2260671cf1-vue-loader-template%22%7D!./node_modules/vue-loader/lib/loaders/templateLoader.js??vue-loader-options!./node_modules/cache-loader/dist/cjs.js??ref--0-0!./node_modules/vue-loader/lib??vue-loader-options");

/***/ }),

/***/ "./node_modules/cache-loader/dist/cjs.js?{\"cacheDirectory\":\"node_modules/.cache/vue-loader\",\"cacheIdentifier\":\"60671cf1-vue-loader-template\"}!./node_modules/vue-loader/lib/loaders/templateLoader.js?!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/main/Nav.vue?vue&type=template&id=d8fd8586&":
/*!*************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************!*\
  !*** ./node_modules/cache-loader/dist/cjs.js?{"cacheDirectory":"node_modules/.cache/vue-loader","cacheIdentifier":"60671cf1-vue-loader-template"}!./node_modules/vue-loader/lib/loaders/templateLoader.js??vue-loader-options!./node_modules/cache-loader/dist/cjs.js??ref--0-0!./node_modules/vue-loader/lib??vue-loader-options!./src/components/main/Nav.vue?vue&type=template&id=d8fd8586& ***!
  \*************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************/
/*! exports provided: render, staticRenderFns */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"render\", function() { return render; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"staticRenderFns\", function() { return staticRenderFns; });\nvar render = function() {\n  var _vm = this\n  var _h = _vm.$createElement\n  var _c = _vm._self._c || _h\n  return _c(\"div\", { attrs: { \"ng-controller\": \"NavController\" } }, [\n    _c(\n      \"nav\",\n      {\n        staticClass: \"navbar\",\n        attrs: { role: \"navigation\", \"aria-label\": \"main navigation\" }\n      },\n      [\n        _c(\n          \"div\",\n          { staticClass: \"navbar-brand\" },\n          [\n            _c(\n              \"router-link\",\n              {\n                staticClass: \"navbar-item is-size-4\",\n                attrs: { to: \"/domains\" }\n              },\n              [\n                _c(\"img\", {\n                  staticStyle: { \"margin-right\": \"5px\" },\n                  attrs: { src: \"/favicon.ico\" }\n                }),\n                _vm._v(\" Deployify \")\n              ]\n            )\n          ],\n          1\n        ),\n        _c(\"div\", { staticClass: \"navbar-end\" }, [\n          _c(\"div\", { staticClass: \"navbar-item\" }, [\n            _c(\n              \"div\",\n              { staticClass: \"buttons\" },\n              [\n                _c(\n                  \"router-link\",\n                  {\n                    directives: [\n                      {\n                        name: \"show\",\n                        rawName: \"v-show\",\n                        value: _vm.$store.state.auth.success,\n                        expression: \"$store.state.auth.success\"\n                      }\n                    ],\n                    staticClass: \"button is-primary\",\n                    attrs: { to: \"/profile\" }\n                  },\n                  [\n                    _c(\"span\", { staticClass: \"icon\" }, [\n                      _c(\"i\", { staticClass: \"mdi mdi-cog\" })\n                    ]),\n                    _vm.$store.state.auth.user &&\n                    _vm.$store.state.settings.user &&\n                    _vm.$store.state.settings.user.profile\n                      ? _c(\"span\", [\n                          _vm._v(_vm._s(_vm.$store.state.auth.user.firstName))\n                        ])\n                      : _vm._e()\n                  ]\n                ),\n                _c(\n                  \"router-link\",\n                  {\n                    directives: [\n                      {\n                        name: \"show\",\n                        rawName: \"v-show\",\n                        value: _vm.$store.state.auth.success,\n                        expression: \"$store.state.auth.success\"\n                      }\n                    ],\n                    staticClass: \"button is-light\",\n                    attrs: { to: \"/signout\" }\n                  },\n                  [\n                    _c(\"span\", { staticClass: \"icon\" }, [\n                      _c(\"i\", { staticClass: \"mdi mdi-logout-variant\" })\n                    ]),\n                    _c(\"span\", [_vm._v(\"Sign out\")])\n                  ]\n                )\n              ],\n              1\n            )\n          ])\n        ])\n      ]\n    )\n  ])\n}\nvar staticRenderFns = []\nrender._withStripped = true\n\n\n\n//# sourceURL=webpack:///./src/components/main/Nav.vue?./node_modules/cache-loader/dist/cjs.js?%7B%22cacheDirectory%22:%22node_modules/.cache/vue-loader%22,%22cacheIdentifier%22:%2260671cf1-vue-loader-template%22%7D!./node_modules/vue-loader/lib/loaders/templateLoader.js??vue-loader-options!./node_modules/cache-loader/dist/cjs.js??ref--0-0!./node_modules/vue-loader/lib??vue-loader-options");

/***/ }),

/***/ "./node_modules/css-loader/dist/cjs.js?!./node_modules/postcss-loader/src/index.js?!./node_modules/sass-loader/dist/cjs.js?!./src/assets/styles/base.scss":
/*!**********************************************************************************************************************************************************************************************************!*\
  !*** ./node_modules/css-loader/dist/cjs.js??ref--8-oneOf-3-1!./node_modules/postcss-loader/src??ref--8-oneOf-3-2!./node_modules/sass-loader/dist/cjs.js??ref--8-oneOf-3-3!./src/assets/styles/base.scss ***!
  \**********************************************************************************************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("// Imports\nvar ___CSS_LOADER_API_IMPORT___ = __webpack_require__(/*! ../../../node_modules/css-loader/dist/runtime/api.js */ \"./node_modules/css-loader/dist/runtime/api.js\");\nexports = ___CSS_LOADER_API_IMPORT___(false);\n// Module\nexports.push([module.i, \"html {\\n  overflow-y: auto;\\n}\\n\\n.button:focus:not(:active),\\n.button:not(:active) {\\n  -webkit-box-shadow: none !important;\\n  box-shadow: none !important;\\n}\\n\\n:focus {\\n  outline: none !important;\\n}\\n\\n.select select:focus {\\n  -webkit-box-shadow: none !important;\\n  box-shadow: none !important;\\n}\\n\\nfooter.modal-card-foot {\\n  -webkit-box-pack: end;\\n      -ms-flex-pack: end;\\n          justify-content: flex-end;\\n}\\n\\n.no-border {\\n  background-color: inherit !important;\\n  border-color: inherit !important;\\n  border: 0px;\\n}\\n\\n.is-size-7 {\\n  font-size: 0.75em !important;\\n}\\n\\n.is-size-8 {\\n  font-size: 0.5em !important;\\n}\\n\\n.radio-margin {\\n  margin-left: 14px;\\n}\\n\\n.tips-text {\\n  padding-right: 7px;\\n  padding-left: 7px;\\n}\\n\\n.tabs a {\\n  padding-left: 0.7em;\\n  padding-right: 0.7em;\\n}\\n\\n.tag.small {\\n  height: 1.5em;\\n}\\n\\n.mdi-checkbox-marked-circle:hover {\\n  cursor: pointer;\\n}\\n\\n.clickable:hover {\\n  cursor: pointer;\\n}\\n\\n.dot.large {\\n  height: 12px;\\n  width: 12px;\\n}\\n\\n.dot {\\n  vertical-align: middle !important;\\n  height: 6px;\\n  width: 6px;\\n  background-color: #bbb;\\n  border-radius: 50%;\\n  display: inline-block;\\n}\\n\\n.dot.margin {\\n  margin-right: 0.75rem !important;\\n}\\n\\nimg.package-icon {\\n  vertical-align: middle;\\n  width: 1rem;\\n}\\n\\n.button.is-small.smaller {\\n  height: 2em;\\n  line-height: 1em;\\n}\\n\\npre {\\n  white-space: pre-wrap;\\n  /* css-3 */\\n  white-space: -moz-pre-wrap;\\n  /* Mozilla, since 1999 */\\n  white-space: -pre-wrap;\\n  /* Opera 4-6 */\\n  white-space: -o-pre-wrap;\\n  /* Opera 7 */\\n  word-wrap: break-word;\\n  /* Internet Explorer 5.5+ */\\n}\\n\\ndiv.columns.extrapadding {\\n  padding: 1rem 1rem;\\n}\\n\\ntable.center {\\n  margin-left: auto;\\n  margin-right: auto;\\n}\\n\\n.margin-top-5 {\\n  margin-top: 5px;\\n}\\n\\n.margin-top-10 {\\n  margin-top: 10px;\\n}\\n\\n.margin-top-1 {\\n  margin-top: 1em;\\n}\\n\\n.margin-top-2 {\\n  margin-top: 2em;\\n}\\n\\n.margin-top-3 {\\n  margin-top: 3em;\\n}\\n\\n.margin-top-4 {\\n  margin-top: 4em;\\n}\\n\\n.margin-bottom-1 {\\n  margin-bottom: 1em;\\n}\\n\\n.margin-bottom-2 {\\n  margin-bottom: 2em;\\n}\\n\\n.margin-bottom-5 {\\n  margin-bottom: 5px;\\n}\\n\\n.margin-bottom-10 {\\n  margin-bottom: 10px;\\n}\\n\\n.margin-bottom-20 {\\n  margin-bottom: 20px;\\n}\\n\\n.margin-bottom-25 {\\n  margin-bottom: 25px;\\n}\\n\\n.margin-bottom-30 {\\n  margin-bottom: 30px;\\n}\\n\\n.margin-left-1 {\\n  margin-left: 1em;\\n}\\n\\n.margin-right-5 {\\n  margin-right: 5px;\\n}\\n\\n.margin-right-10 {\\n  margin-right: 10px;\\n}\\n\\n.margin-left-5 {\\n  margin-left: 5px;\\n}\\n\\n.margin-left-10 {\\n  margin-left: 10px;\\n}\\n\\np {\\n  margin-bottom: 20px;\\n}\\n\\n.is-loading.is-info::after {\\n  border-color: transparent transparent #3298dc #3298dc !important;\\n}\\n\\n.is-loading.is-success::after {\\n  border-color: transparent transparent #48c774 #48c774 !important;\\n}\\n\\n.modal-card-body {\\n  overflow-x: hidden !important;\\n}\\n\\n.section.smaller {\\n  padding-top: 0.5rem;\\n  padding-bottom: 0.5rem;\\n}\\n\\n.section.small {\\n  padding-top: 0.5rem;\\n  padding-bottom: 0.5em;\\n}\\n\\n.right {\\n  float: right;\\n  -webkit-box-pack: end;\\n      -ms-flex-pack: end;\\n          justify-content: flex-end;\\n}\\n\\nli.menu-item {\\n  display: inline-block;\\n  margin-right: 15px;\\n}\\n\\nth {\\n  font-weight: normal;\\n  cursor: pointer;\\n}\\n\\na.dropdown-item {\\n  padding: 0.3rem 1rem;\\n}\\n\\na.dropdown-item.is-small {\\n  padding: 0.1rem 1rem;\\n}\\n\\n.notification > p:last-child {\\n  margin-bottom: 0;\\n}\", \"\"]);\n// Exports\nmodule.exports = exports;\n\n\n//# sourceURL=webpack:///./src/assets/styles/base.scss?./node_modules/css-loader/dist/cjs.js??ref--8-oneOf-3-1!./node_modules/postcss-loader/src??ref--8-oneOf-3-2!./node_modules/sass-loader/dist/cjs.js??ref--8-oneOf-3-3");

/***/ }),

/***/ "./node_modules/css-loader/dist/cjs.js?!./node_modules/postcss-loader/src/index.js?!./node_modules/sass-loader/dist/cjs.js?!./src/assets/styles/dark.scss":
/*!**********************************************************************************************************************************************************************************************************!*\
  !*** ./node_modules/css-loader/dist/cjs.js??ref--8-oneOf-3-1!./node_modules/postcss-loader/src??ref--8-oneOf-3-2!./node_modules/sass-loader/dist/cjs.js??ref--8-oneOf-3-3!./src/assets/styles/dark.scss ***!
  \**********************************************************************************************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("// Imports\nvar ___CSS_LOADER_API_IMPORT___ = __webpack_require__(/*! ../../../node_modules/css-loader/dist/runtime/api.js */ \"./node_modules/css-loader/dist/runtime/api.js\");\nexports = ___CSS_LOADER_API_IMPORT___(false);\n// Module\nexports.push([module.i, \"\", \"\"]);\n// Exports\nmodule.exports = exports;\n\n\n//# sourceURL=webpack:///./src/assets/styles/dark.scss?./node_modules/css-loader/dist/cjs.js??ref--8-oneOf-3-1!./node_modules/postcss-loader/src??ref--8-oneOf-3-2!./node_modules/sass-loader/dist/cjs.js??ref--8-oneOf-3-3");

/***/ }),

/***/ "./node_modules/css-loader/dist/cjs.js?!./node_modules/postcss-loader/src/index.js?!./node_modules/sass-loader/dist/cjs.js?!./src/assets/styles/notifications.scss":
/*!*******************************************************************************************************************************************************************************************************************!*\
  !*** ./node_modules/css-loader/dist/cjs.js??ref--8-oneOf-3-1!./node_modules/postcss-loader/src??ref--8-oneOf-3-2!./node_modules/sass-loader/dist/cjs.js??ref--8-oneOf-3-3!./src/assets/styles/notifications.scss ***!
  \*******************************************************************************************************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("// Imports\nvar ___CSS_LOADER_API_IMPORT___ = __webpack_require__(/*! ../../../node_modules/css-loader/dist/runtime/api.js */ \"./node_modules/css-loader/dist/runtime/api.js\");\nexports = ___CSS_LOADER_API_IMPORT___(false);\n// Module\nexports.push([module.i, \"@charset \\\"UTF-8\\\";\\n/*! bulma.io v0.9.3 | MIT License | github.com/jgthms/bulma */\\n/* Bulma Utilities */\\n.pagination-previous,\\n.pagination-next,\\n.pagination-link,\\n.pagination-ellipsis, .file-cta,\\n.file-name, .select select, .textarea, .input, .button {\\n  -moz-appearance: none;\\n  -webkit-appearance: none;\\n  -webkit-box-align: center;\\n      -ms-flex-align: center;\\n          align-items: center;\\n  border: 1px solid transparent;\\n  border-radius: 4px;\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  display: -webkit-inline-box;\\n  display: -ms-inline-flexbox;\\n  display: inline-flex;\\n  font-size: 1rem;\\n  height: 2.5em;\\n  -webkit-box-pack: start;\\n      -ms-flex-pack: start;\\n          justify-content: flex-start;\\n  line-height: 1.5;\\n  padding-bottom: calc(0.5em - 1px);\\n  padding-left: calc(0.75em - 1px);\\n  padding-right: calc(0.75em - 1px);\\n  padding-top: calc(0.5em - 1px);\\n  position: relative;\\n  vertical-align: top;\\n}\\n.pagination-previous:focus,\\n.pagination-next:focus,\\n.pagination-link:focus,\\n.pagination-ellipsis:focus, .file-cta:focus,\\n.file-name:focus, .select select:focus, .textarea:focus, .input:focus, .button:focus, .is-focused.pagination-previous,\\n.is-focused.pagination-next,\\n.is-focused.pagination-link,\\n.is-focused.pagination-ellipsis, .is-focused.file-cta,\\n.is-focused.file-name, .select select.is-focused, .is-focused.textarea, .is-focused.input, .is-focused.button, .pagination-previous:active,\\n.pagination-next:active,\\n.pagination-link:active,\\n.pagination-ellipsis:active, .file-cta:active,\\n.file-name:active, .select select:active, .textarea:active, .input:active, .button:active, .is-active.pagination-previous,\\n.is-active.pagination-next,\\n.is-active.pagination-link,\\n.is-active.pagination-ellipsis, .is-active.file-cta,\\n.is-active.file-name, .select select.is-active, .is-active.textarea, .is-active.input, .is-active.button {\\n  outline: none;\\n}\\n[disabled].pagination-previous,\\n[disabled].pagination-next,\\n[disabled].pagination-link,\\n[disabled].pagination-ellipsis, [disabled].file-cta,\\n[disabled].file-name, .select select[disabled], [disabled].textarea, [disabled].input, [disabled].button, fieldset[disabled] .pagination-previous,\\nfieldset[disabled] .pagination-next,\\nfieldset[disabled] .pagination-link,\\nfieldset[disabled] .pagination-ellipsis, fieldset[disabled] .file-cta,\\nfieldset[disabled] .file-name, fieldset[disabled] .select select, .select fieldset[disabled] select, fieldset[disabled] .textarea, fieldset[disabled] .input, fieldset[disabled] .button {\\n  cursor: not-allowed;\\n}\\n\\n.is-unselectable, .tabs, .pagination-previous,\\n.pagination-next,\\n.pagination-link,\\n.pagination-ellipsis, .breadcrumb, .file, .button {\\n  -webkit-touch-callout: none;\\n  -webkit-user-select: none;\\n  -moz-user-select: none;\\n  -ms-user-select: none;\\n  user-select: none;\\n}\\n\\n.navbar-link:not(.is-arrowless)::after, .select:not(.is-multiple):not(.is-loading)::after {\\n  border: 3px solid transparent;\\n  border-radius: 2px;\\n  border-right: 0;\\n  border-top: 0;\\n  content: \\\" \\\";\\n  display: block;\\n  height: 0.625em;\\n  margin-top: -0.4375em;\\n  pointer-events: none;\\n  position: absolute;\\n  top: 50%;\\n  -webkit-transform: rotate(-45deg);\\n          transform: rotate(-45deg);\\n  -webkit-transform-origin: center;\\n          transform-origin: center;\\n  width: 0.625em;\\n}\\n\\n.tabs:not(:last-child), .pagination:not(:last-child), .message:not(:last-child), .level:not(:last-child), .breadcrumb:not(:last-child), .block:not(:last-child), .title:not(:last-child),\\n.subtitle:not(:last-child), .table-container:not(:last-child), .table:not(:last-child), .progress:not(:last-child), .notification:not(:last-child), .content:not(:last-child), .box:not(:last-child) {\\n  margin-bottom: 1.5rem;\\n}\\n\\n.modal-close, .delete {\\n  -webkit-touch-callout: none;\\n  -webkit-user-select: none;\\n  -moz-user-select: none;\\n  -ms-user-select: none;\\n  user-select: none;\\n  -moz-appearance: none;\\n  -webkit-appearance: none;\\n  background-color: rgba(10, 10, 10, 0.2);\\n  border: none;\\n  border-radius: 9999px;\\n  cursor: pointer;\\n  pointer-events: auto;\\n  display: inline-block;\\n  -webkit-box-flex: 0;\\n      -ms-flex-positive: 0;\\n          flex-grow: 0;\\n  -ms-flex-negative: 0;\\n      flex-shrink: 0;\\n  font-size: 0;\\n  height: 20px;\\n  max-height: 20px;\\n  max-width: 20px;\\n  min-height: 20px;\\n  min-width: 20px;\\n  outline: none;\\n  position: relative;\\n  vertical-align: top;\\n  width: 20px;\\n}\\n.modal-close::before, .delete::before, .modal-close::after, .delete::after {\\n  background-color: hsl(0deg, 0%, 100%);\\n  content: \\\"\\\";\\n  display: block;\\n  left: 50%;\\n  position: absolute;\\n  top: 50%;\\n  -webkit-transform: translateX(-50%) translateY(-50%) rotate(45deg);\\n          transform: translateX(-50%) translateY(-50%) rotate(45deg);\\n  -webkit-transform-origin: center center;\\n          transform-origin: center center;\\n}\\n.modal-close::before, .delete::before {\\n  height: 2px;\\n  width: 50%;\\n}\\n.modal-close::after, .delete::after {\\n  height: 50%;\\n  width: 2px;\\n}\\n.modal-close:hover, .delete:hover, .modal-close:focus, .delete:focus {\\n  background-color: rgba(10, 10, 10, 0.3);\\n}\\n.modal-close:active, .delete:active {\\n  background-color: rgba(10, 10, 10, 0.4);\\n}\\n.is-small.modal-close, .is-small.delete {\\n  height: 16px;\\n  max-height: 16px;\\n  max-width: 16px;\\n  min-height: 16px;\\n  min-width: 16px;\\n  width: 16px;\\n}\\n.is-medium.modal-close, .is-medium.delete {\\n  height: 24px;\\n  max-height: 24px;\\n  max-width: 24px;\\n  min-height: 24px;\\n  min-width: 24px;\\n  width: 24px;\\n}\\n.is-large.modal-close, .is-large.delete {\\n  height: 32px;\\n  max-height: 32px;\\n  max-width: 32px;\\n  min-height: 32px;\\n  min-width: 32px;\\n  width: 32px;\\n}\\n\\n.control.is-loading::after, .select.is-loading::after, .loader, .button.is-loading::after {\\n  -webkit-animation: spinAround 500ms infinite linear;\\n          animation: spinAround 500ms infinite linear;\\n  border: 2px solid hsl(0deg, 0%, 86%);\\n  border-radius: 9999px;\\n  border-right-color: transparent;\\n  border-top-color: transparent;\\n  content: \\\"\\\";\\n  display: block;\\n  height: 1em;\\n  position: relative;\\n  width: 1em;\\n}\\n\\n.hero-video, .is-overlay, .modal-background, .modal, .image.is-square img,\\n.image.is-square .has-ratio, .image.is-1by1 img,\\n.image.is-1by1 .has-ratio, .image.is-5by4 img,\\n.image.is-5by4 .has-ratio, .image.is-4by3 img,\\n.image.is-4by3 .has-ratio, .image.is-3by2 img,\\n.image.is-3by2 .has-ratio, .image.is-5by3 img,\\n.image.is-5by3 .has-ratio, .image.is-16by9 img,\\n.image.is-16by9 .has-ratio, .image.is-2by1 img,\\n.image.is-2by1 .has-ratio, .image.is-3by1 img,\\n.image.is-3by1 .has-ratio, .image.is-4by5 img,\\n.image.is-4by5 .has-ratio, .image.is-3by4 img,\\n.image.is-3by4 .has-ratio, .image.is-2by3 img,\\n.image.is-2by3 .has-ratio, .image.is-3by5 img,\\n.image.is-3by5 .has-ratio, .image.is-9by16 img,\\n.image.is-9by16 .has-ratio, .image.is-1by2 img,\\n.image.is-1by2 .has-ratio, .image.is-1by3 img,\\n.image.is-1by3 .has-ratio {\\n  bottom: 0;\\n  left: 0;\\n  position: absolute;\\n  right: 0;\\n  top: 0;\\n}\\n\\n.navbar-burger {\\n  -moz-appearance: none;\\n  -webkit-appearance: none;\\n  appearance: none;\\n  background: none;\\n  border: none;\\n  color: currentColor;\\n  font-family: inherit;\\n  font-size: 1em;\\n  margin: 0;\\n  padding: 0;\\n}\\n\\n/* Bulma Base */ /*! minireset.css v0.0.6 | MIT License | github.com/jgthms/minireset.css */\\nhtml,\\nbody,\\np,\\nol,\\nul,\\nli,\\ndl,\\ndt,\\ndd,\\nblockquote,\\nfigure,\\nfieldset,\\nlegend,\\ntextarea,\\npre,\\niframe,\\nhr,\\nh1,\\nh2,\\nh3,\\nh4,\\nh5,\\nh6 {\\n  margin: 0;\\n  padding: 0;\\n}\\n\\nh1,\\nh2,\\nh3,\\nh4,\\nh5,\\nh6 {\\n  font-size: 100%;\\n  font-weight: normal;\\n}\\n\\nul {\\n  list-style: none;\\n}\\n\\nbutton,\\ninput,\\nselect,\\ntextarea {\\n  margin: 0;\\n}\\n\\nhtml {\\n  -webkit-box-sizing: border-box;\\n          box-sizing: border-box;\\n}\\n\\n*, *::before, *::after {\\n  -webkit-box-sizing: inherit;\\n          box-sizing: inherit;\\n}\\n\\nimg,\\nvideo {\\n  height: auto;\\n  max-width: 100%;\\n}\\n\\niframe {\\n  border: 0;\\n}\\n\\ntable {\\n  border-collapse: collapse;\\n  border-spacing: 0;\\n}\\n\\ntd,\\nth {\\n  padding: 0;\\n}\\ntd:not([align]),\\nth:not([align]) {\\n  text-align: inherit;\\n}\\n\\nhtml {\\n  background-color: hsl(0deg, 0%, 100%);\\n  font-size: 16px;\\n  -moz-osx-font-smoothing: grayscale;\\n  -webkit-font-smoothing: antialiased;\\n  min-width: 300px;\\n  overflow-x: hidden;\\n  overflow-y: scroll;\\n  text-rendering: optimizeLegibility;\\n  -webkit-text-size-adjust: 100%;\\n     -moz-text-size-adjust: 100%;\\n      -ms-text-size-adjust: 100%;\\n          text-size-adjust: 100%;\\n}\\n\\narticle,\\naside,\\nfigure,\\nfooter,\\nheader,\\nhgroup,\\nsection {\\n  display: block;\\n}\\n\\nbody,\\nbutton,\\ninput,\\noptgroup,\\nselect,\\ntextarea {\\n  font-family: BlinkMacSystemFont, -apple-system, \\\"Segoe UI\\\", \\\"Roboto\\\", \\\"Oxygen\\\", \\\"Ubuntu\\\", \\\"Cantarell\\\", \\\"Fira Sans\\\", \\\"Droid Sans\\\", \\\"Helvetica Neue\\\", \\\"Helvetica\\\", \\\"Arial\\\", sans-serif;\\n}\\n\\ncode,\\npre {\\n  -moz-osx-font-smoothing: auto;\\n  -webkit-font-smoothing: auto;\\n  font-family: monospace;\\n}\\n\\nbody {\\n  color: hsl(0deg, 0%, 29%);\\n  font-size: 1em;\\n  font-weight: 400;\\n  line-height: 1.5;\\n}\\n\\na {\\n  color: hsl(229deg, 53%, 53%);\\n  cursor: pointer;\\n  text-decoration: none;\\n}\\na strong {\\n  color: currentColor;\\n}\\na:hover {\\n  color: hsl(0deg, 0%, 21%);\\n}\\n\\ncode {\\n  background-color: hsl(0deg, 0%, 96%);\\n  color: #da1039;\\n  font-size: 0.875em;\\n  font-weight: normal;\\n  padding: 0.25em 0.5em 0.25em;\\n}\\n\\nhr {\\n  background-color: hsl(0deg, 0%, 96%);\\n  border: none;\\n  display: block;\\n  height: 2px;\\n  margin: 1.5rem 0;\\n}\\n\\nimg {\\n  height: auto;\\n  max-width: 100%;\\n}\\n\\ninput[type=checkbox],\\ninput[type=radio] {\\n  vertical-align: baseline;\\n}\\n\\nsmall {\\n  font-size: 0.875em;\\n}\\n\\nspan {\\n  font-style: inherit;\\n  font-weight: inherit;\\n}\\n\\nstrong {\\n  color: hsl(0deg, 0%, 21%);\\n  font-weight: 700;\\n}\\n\\nfieldset {\\n  border: none;\\n}\\n\\npre {\\n  -webkit-overflow-scrolling: touch;\\n  background-color: hsl(0deg, 0%, 96%);\\n  color: hsl(0deg, 0%, 29%);\\n  font-size: 0.875em;\\n  overflow-x: auto;\\n  padding: 1.25rem 1.5rem;\\n  white-space: pre;\\n  word-wrap: normal;\\n}\\npre code {\\n  background-color: transparent;\\n  color: currentColor;\\n  font-size: 1em;\\n  padding: 0;\\n}\\n\\ntable td,\\ntable th {\\n  vertical-align: top;\\n}\\ntable td:not([align]),\\ntable th:not([align]) {\\n  text-align: inherit;\\n}\\ntable th {\\n  color: hsl(0deg, 0%, 21%);\\n}\\n\\n@-webkit-keyframes spinAround {\\n  from {\\n    -webkit-transform: rotate(0deg);\\n            transform: rotate(0deg);\\n  }\\n  to {\\n    -webkit-transform: rotate(359deg);\\n            transform: rotate(359deg);\\n  }\\n}\\n\\n@keyframes spinAround {\\n  from {\\n    -webkit-transform: rotate(0deg);\\n            transform: rotate(0deg);\\n  }\\n  to {\\n    -webkit-transform: rotate(359deg);\\n            transform: rotate(359deg);\\n  }\\n}\\n/* Bulma Elements */\\n.box {\\n  background-color: hsl(0deg, 0%, 100%);\\n  border-radius: 6px;\\n  -webkit-box-shadow: 0 0.5em 1em -0.125em rgba(10, 10, 10, 0.1), 0 0px 0 1px rgba(10, 10, 10, 0.02);\\n          box-shadow: 0 0.5em 1em -0.125em rgba(10, 10, 10, 0.1), 0 0px 0 1px rgba(10, 10, 10, 0.02);\\n  color: hsl(0deg, 0%, 29%);\\n  display: block;\\n  padding: 1.25rem;\\n}\\n\\na.box:hover, a.box:focus {\\n  -webkit-box-shadow: 0 0.5em 1em -0.125em rgba(10, 10, 10, 0.1), 0 0 0 1px hsl(229deg, 53%, 53%);\\n          box-shadow: 0 0.5em 1em -0.125em rgba(10, 10, 10, 0.1), 0 0 0 1px hsl(229deg, 53%, 53%);\\n}\\na.box:active {\\n  -webkit-box-shadow: inset 0 1px 2px rgba(10, 10, 10, 0.2), 0 0 0 1px hsl(229deg, 53%, 53%);\\n          box-shadow: inset 0 1px 2px rgba(10, 10, 10, 0.2), 0 0 0 1px hsl(229deg, 53%, 53%);\\n}\\n\\n.button {\\n  background-color: hsl(0deg, 0%, 100%);\\n  border-color: hsl(0deg, 0%, 86%);\\n  border-width: 1px;\\n  color: hsl(0deg, 0%, 21%);\\n  cursor: pointer;\\n  -webkit-box-pack: center;\\n      -ms-flex-pack: center;\\n          justify-content: center;\\n  padding-bottom: calc(0.5em - 1px);\\n  padding-left: 1em;\\n  padding-right: 1em;\\n  padding-top: calc(0.5em - 1px);\\n  text-align: center;\\n  white-space: nowrap;\\n}\\n.button strong {\\n  color: inherit;\\n}\\n.button .icon, .button .icon.is-small, .button .icon.is-medium, .button .icon.is-large {\\n  height: 1.5em;\\n  width: 1.5em;\\n}\\n.button .icon:first-child:not(:last-child) {\\n  margin-left: calc(-0.5em - 1px);\\n  margin-right: 0.25em;\\n}\\n.button .icon:last-child:not(:first-child) {\\n  margin-left: 0.25em;\\n  margin-right: calc(-0.5em - 1px);\\n}\\n.button .icon:first-child:last-child {\\n  margin-left: calc(-0.5em - 1px);\\n  margin-right: calc(-0.5em - 1px);\\n}\\n.button:hover, .button.is-hovered {\\n  border-color: hsl(0deg, 0%, 71%);\\n  color: hsl(0deg, 0%, 21%);\\n}\\n.button:focus, .button.is-focused {\\n  border-color: hsl(229deg, 53%, 53%);\\n  color: hsl(0deg, 0%, 21%);\\n}\\n.button:focus:not(:active), .button.is-focused:not(:active) {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(72, 95, 199, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(72, 95, 199, 0.25);\\n}\\n.button:active, .button.is-active {\\n  border-color: hsl(0deg, 0%, 29%);\\n  color: hsl(0deg, 0%, 21%);\\n}\\n.button.is-text {\\n  background-color: transparent;\\n  border-color: transparent;\\n  color: hsl(0deg, 0%, 29%);\\n  text-decoration: underline;\\n}\\n.button.is-text:hover, .button.is-text.is-hovered, .button.is-text:focus, .button.is-text.is-focused {\\n  background-color: hsl(0deg, 0%, 96%);\\n  color: hsl(0deg, 0%, 21%);\\n}\\n.button.is-text:active, .button.is-text.is-active {\\n  background-color: #e8e8e8;\\n  color: hsl(0deg, 0%, 21%);\\n}\\n.button.is-text[disabled], fieldset[disabled] .button.is-text {\\n  background-color: transparent;\\n  border-color: transparent;\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n}\\n.button.is-ghost {\\n  background: none;\\n  border-color: transparent;\\n  color: hsl(229deg, 53%, 53%);\\n  text-decoration: none;\\n}\\n.button.is-ghost:hover, .button.is-ghost.is-hovered {\\n  color: hsl(229deg, 53%, 53%);\\n  text-decoration: underline;\\n}\\n.button.is-white {\\n  background-color: hsl(0deg, 0%, 100%);\\n  border-color: transparent;\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.button.is-white:hover, .button.is-white.is-hovered {\\n  background-color: #f9f9f9;\\n  border-color: transparent;\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.button.is-white:focus, .button.is-white.is-focused {\\n  border-color: transparent;\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.button.is-white:focus:not(:active), .button.is-white.is-focused:not(:active) {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(255, 255, 255, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(255, 255, 255, 0.25);\\n}\\n.button.is-white:active, .button.is-white.is-active {\\n  background-color: #f2f2f2;\\n  border-color: transparent;\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.button.is-white[disabled], fieldset[disabled] .button.is-white {\\n  background-color: hsl(0deg, 0%, 100%);\\n  border-color: transparent;\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n}\\n.button.is-white.is-inverted {\\n  background-color: hsl(0deg, 0%, 4%);\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.button.is-white.is-inverted:hover, .button.is-white.is-inverted.is-hovered {\\n  background-color: black;\\n}\\n.button.is-white.is-inverted[disabled], fieldset[disabled] .button.is-white.is-inverted {\\n  background-color: hsl(0deg, 0%, 4%);\\n  border-color: transparent;\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.button.is-white.is-loading::after {\\n  border-color: transparent transparent hsl(0deg, 0%, 4%) hsl(0deg, 0%, 4%) !important;\\n}\\n.button.is-white.is-outlined {\\n  background-color: transparent;\\n  border-color: hsl(0deg, 0%, 100%);\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.button.is-white.is-outlined:hover, .button.is-white.is-outlined.is-hovered, .button.is-white.is-outlined:focus, .button.is-white.is-outlined.is-focused {\\n  background-color: hsl(0deg, 0%, 100%);\\n  border-color: hsl(0deg, 0%, 100%);\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.button.is-white.is-outlined.is-loading::after {\\n  border-color: transparent transparent hsl(0deg, 0%, 100%) hsl(0deg, 0%, 100%) !important;\\n}\\n.button.is-white.is-outlined.is-loading:hover::after, .button.is-white.is-outlined.is-loading.is-hovered::after, .button.is-white.is-outlined.is-loading:focus::after, .button.is-white.is-outlined.is-loading.is-focused::after {\\n  border-color: transparent transparent hsl(0deg, 0%, 4%) hsl(0deg, 0%, 4%) !important;\\n}\\n.button.is-white.is-outlined[disabled], fieldset[disabled] .button.is-white.is-outlined {\\n  background-color: transparent;\\n  border-color: hsl(0deg, 0%, 100%);\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.button.is-white.is-inverted.is-outlined {\\n  background-color: transparent;\\n  border-color: hsl(0deg, 0%, 4%);\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.button.is-white.is-inverted.is-outlined:hover, .button.is-white.is-inverted.is-outlined.is-hovered, .button.is-white.is-inverted.is-outlined:focus, .button.is-white.is-inverted.is-outlined.is-focused {\\n  background-color: hsl(0deg, 0%, 4%);\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.button.is-white.is-inverted.is-outlined.is-loading:hover::after, .button.is-white.is-inverted.is-outlined.is-loading.is-hovered::after, .button.is-white.is-inverted.is-outlined.is-loading:focus::after, .button.is-white.is-inverted.is-outlined.is-loading.is-focused::after {\\n  border-color: transparent transparent hsl(0deg, 0%, 100%) hsl(0deg, 0%, 100%) !important;\\n}\\n.button.is-white.is-inverted.is-outlined[disabled], fieldset[disabled] .button.is-white.is-inverted.is-outlined {\\n  background-color: transparent;\\n  border-color: hsl(0deg, 0%, 4%);\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.button.is-black {\\n  background-color: hsl(0deg, 0%, 4%);\\n  border-color: transparent;\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.button.is-black:hover, .button.is-black.is-hovered {\\n  background-color: #040404;\\n  border-color: transparent;\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.button.is-black:focus, .button.is-black.is-focused {\\n  border-color: transparent;\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.button.is-black:focus:not(:active), .button.is-black.is-focused:not(:active) {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(10, 10, 10, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(10, 10, 10, 0.25);\\n}\\n.button.is-black:active, .button.is-black.is-active {\\n  background-color: black;\\n  border-color: transparent;\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.button.is-black[disabled], fieldset[disabled] .button.is-black {\\n  background-color: hsl(0deg, 0%, 4%);\\n  border-color: transparent;\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n}\\n.button.is-black.is-inverted {\\n  background-color: hsl(0deg, 0%, 100%);\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.button.is-black.is-inverted:hover, .button.is-black.is-inverted.is-hovered {\\n  background-color: #f2f2f2;\\n}\\n.button.is-black.is-inverted[disabled], fieldset[disabled] .button.is-black.is-inverted {\\n  background-color: hsl(0deg, 0%, 100%);\\n  border-color: transparent;\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.button.is-black.is-loading::after {\\n  border-color: transparent transparent hsl(0deg, 0%, 100%) hsl(0deg, 0%, 100%) !important;\\n}\\n.button.is-black.is-outlined {\\n  background-color: transparent;\\n  border-color: hsl(0deg, 0%, 4%);\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.button.is-black.is-outlined:hover, .button.is-black.is-outlined.is-hovered, .button.is-black.is-outlined:focus, .button.is-black.is-outlined.is-focused {\\n  background-color: hsl(0deg, 0%, 4%);\\n  border-color: hsl(0deg, 0%, 4%);\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.button.is-black.is-outlined.is-loading::after {\\n  border-color: transparent transparent hsl(0deg, 0%, 4%) hsl(0deg, 0%, 4%) !important;\\n}\\n.button.is-black.is-outlined.is-loading:hover::after, .button.is-black.is-outlined.is-loading.is-hovered::after, .button.is-black.is-outlined.is-loading:focus::after, .button.is-black.is-outlined.is-loading.is-focused::after {\\n  border-color: transparent transparent hsl(0deg, 0%, 100%) hsl(0deg, 0%, 100%) !important;\\n}\\n.button.is-black.is-outlined[disabled], fieldset[disabled] .button.is-black.is-outlined {\\n  background-color: transparent;\\n  border-color: hsl(0deg, 0%, 4%);\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.button.is-black.is-inverted.is-outlined {\\n  background-color: transparent;\\n  border-color: hsl(0deg, 0%, 100%);\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.button.is-black.is-inverted.is-outlined:hover, .button.is-black.is-inverted.is-outlined.is-hovered, .button.is-black.is-inverted.is-outlined:focus, .button.is-black.is-inverted.is-outlined.is-focused {\\n  background-color: hsl(0deg, 0%, 100%);\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.button.is-black.is-inverted.is-outlined.is-loading:hover::after, .button.is-black.is-inverted.is-outlined.is-loading.is-hovered::after, .button.is-black.is-inverted.is-outlined.is-loading:focus::after, .button.is-black.is-inverted.is-outlined.is-loading.is-focused::after {\\n  border-color: transparent transparent hsl(0deg, 0%, 4%) hsl(0deg, 0%, 4%) !important;\\n}\\n.button.is-black.is-inverted.is-outlined[disabled], fieldset[disabled] .button.is-black.is-inverted.is-outlined {\\n  background-color: transparent;\\n  border-color: hsl(0deg, 0%, 100%);\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.button.is-light {\\n  background-color: hsl(0deg, 0%, 96%);\\n  border-color: transparent;\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.button.is-light:hover, .button.is-light.is-hovered {\\n  background-color: #eeeeee;\\n  border-color: transparent;\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.button.is-light:focus, .button.is-light.is-focused {\\n  border-color: transparent;\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.button.is-light:focus:not(:active), .button.is-light.is-focused:not(:active) {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(245, 245, 245, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(245, 245, 245, 0.25);\\n}\\n.button.is-light:active, .button.is-light.is-active {\\n  background-color: #e8e8e8;\\n  border-color: transparent;\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.button.is-light[disabled], fieldset[disabled] .button.is-light {\\n  background-color: hsl(0deg, 0%, 96%);\\n  border-color: transparent;\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n}\\n.button.is-light.is-inverted {\\n  background-color: rgba(0, 0, 0, 0.7);\\n  color: hsl(0deg, 0%, 96%);\\n}\\n.button.is-light.is-inverted:hover, .button.is-light.is-inverted.is-hovered {\\n  background-color: rgba(0, 0, 0, 0.7);\\n}\\n.button.is-light.is-inverted[disabled], fieldset[disabled] .button.is-light.is-inverted {\\n  background-color: rgba(0, 0, 0, 0.7);\\n  border-color: transparent;\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: hsl(0deg, 0%, 96%);\\n}\\n.button.is-light.is-loading::after {\\n  border-color: transparent transparent rgba(0, 0, 0, 0.7) rgba(0, 0, 0, 0.7) !important;\\n}\\n.button.is-light.is-outlined {\\n  background-color: transparent;\\n  border-color: hsl(0deg, 0%, 96%);\\n  color: hsl(0deg, 0%, 96%);\\n}\\n.button.is-light.is-outlined:hover, .button.is-light.is-outlined.is-hovered, .button.is-light.is-outlined:focus, .button.is-light.is-outlined.is-focused {\\n  background-color: hsl(0deg, 0%, 96%);\\n  border-color: hsl(0deg, 0%, 96%);\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.button.is-light.is-outlined.is-loading::after {\\n  border-color: transparent transparent hsl(0deg, 0%, 96%) hsl(0deg, 0%, 96%) !important;\\n}\\n.button.is-light.is-outlined.is-loading:hover::after, .button.is-light.is-outlined.is-loading.is-hovered::after, .button.is-light.is-outlined.is-loading:focus::after, .button.is-light.is-outlined.is-loading.is-focused::after {\\n  border-color: transparent transparent rgba(0, 0, 0, 0.7) rgba(0, 0, 0, 0.7) !important;\\n}\\n.button.is-light.is-outlined[disabled], fieldset[disabled] .button.is-light.is-outlined {\\n  background-color: transparent;\\n  border-color: hsl(0deg, 0%, 96%);\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: hsl(0deg, 0%, 96%);\\n}\\n.button.is-light.is-inverted.is-outlined {\\n  background-color: transparent;\\n  border-color: rgba(0, 0, 0, 0.7);\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.button.is-light.is-inverted.is-outlined:hover, .button.is-light.is-inverted.is-outlined.is-hovered, .button.is-light.is-inverted.is-outlined:focus, .button.is-light.is-inverted.is-outlined.is-focused {\\n  background-color: rgba(0, 0, 0, 0.7);\\n  color: hsl(0deg, 0%, 96%);\\n}\\n.button.is-light.is-inverted.is-outlined.is-loading:hover::after, .button.is-light.is-inverted.is-outlined.is-loading.is-hovered::after, .button.is-light.is-inverted.is-outlined.is-loading:focus::after, .button.is-light.is-inverted.is-outlined.is-loading.is-focused::after {\\n  border-color: transparent transparent hsl(0deg, 0%, 96%) hsl(0deg, 0%, 96%) !important;\\n}\\n.button.is-light.is-inverted.is-outlined[disabled], fieldset[disabled] .button.is-light.is-inverted.is-outlined {\\n  background-color: transparent;\\n  border-color: rgba(0, 0, 0, 0.7);\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.button.is-dark {\\n  background-color: hsl(0deg, 0%, 21%);\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.button.is-dark:hover, .button.is-dark.is-hovered {\\n  background-color: #2f2f2f;\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.button.is-dark:focus, .button.is-dark.is-focused {\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.button.is-dark:focus:not(:active), .button.is-dark.is-focused:not(:active) {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(54, 54, 54, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(54, 54, 54, 0.25);\\n}\\n.button.is-dark:active, .button.is-dark.is-active {\\n  background-color: #292929;\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.button.is-dark[disabled], fieldset[disabled] .button.is-dark {\\n  background-color: hsl(0deg, 0%, 21%);\\n  border-color: transparent;\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n}\\n.button.is-dark.is-inverted {\\n  background-color: #fff;\\n  color: hsl(0deg, 0%, 21%);\\n}\\n.button.is-dark.is-inverted:hover, .button.is-dark.is-inverted.is-hovered {\\n  background-color: #f2f2f2;\\n}\\n.button.is-dark.is-inverted[disabled], fieldset[disabled] .button.is-dark.is-inverted {\\n  background-color: #fff;\\n  border-color: transparent;\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: hsl(0deg, 0%, 21%);\\n}\\n.button.is-dark.is-loading::after {\\n  border-color: transparent transparent #fff #fff !important;\\n}\\n.button.is-dark.is-outlined {\\n  background-color: transparent;\\n  border-color: hsl(0deg, 0%, 21%);\\n  color: hsl(0deg, 0%, 21%);\\n}\\n.button.is-dark.is-outlined:hover, .button.is-dark.is-outlined.is-hovered, .button.is-dark.is-outlined:focus, .button.is-dark.is-outlined.is-focused {\\n  background-color: hsl(0deg, 0%, 21%);\\n  border-color: hsl(0deg, 0%, 21%);\\n  color: #fff;\\n}\\n.button.is-dark.is-outlined.is-loading::after {\\n  border-color: transparent transparent hsl(0deg, 0%, 21%) hsl(0deg, 0%, 21%) !important;\\n}\\n.button.is-dark.is-outlined.is-loading:hover::after, .button.is-dark.is-outlined.is-loading.is-hovered::after, .button.is-dark.is-outlined.is-loading:focus::after, .button.is-dark.is-outlined.is-loading.is-focused::after {\\n  border-color: transparent transparent #fff #fff !important;\\n}\\n.button.is-dark.is-outlined[disabled], fieldset[disabled] .button.is-dark.is-outlined {\\n  background-color: transparent;\\n  border-color: hsl(0deg, 0%, 21%);\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: hsl(0deg, 0%, 21%);\\n}\\n.button.is-dark.is-inverted.is-outlined {\\n  background-color: transparent;\\n  border-color: #fff;\\n  color: #fff;\\n}\\n.button.is-dark.is-inverted.is-outlined:hover, .button.is-dark.is-inverted.is-outlined.is-hovered, .button.is-dark.is-inverted.is-outlined:focus, .button.is-dark.is-inverted.is-outlined.is-focused {\\n  background-color: #fff;\\n  color: hsl(0deg, 0%, 21%);\\n}\\n.button.is-dark.is-inverted.is-outlined.is-loading:hover::after, .button.is-dark.is-inverted.is-outlined.is-loading.is-hovered::after, .button.is-dark.is-inverted.is-outlined.is-loading:focus::after, .button.is-dark.is-inverted.is-outlined.is-loading.is-focused::after {\\n  border-color: transparent transparent hsl(0deg, 0%, 21%) hsl(0deg, 0%, 21%) !important;\\n}\\n.button.is-dark.is-inverted.is-outlined[disabled], fieldset[disabled] .button.is-dark.is-inverted.is-outlined {\\n  background-color: transparent;\\n  border-color: #fff;\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: #fff;\\n}\\n.button.is-primary {\\n  background-color: hsl(171deg, 100%, 41%);\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.button.is-primary:hover, .button.is-primary.is-hovered {\\n  background-color: #00c4a7;\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.button.is-primary:focus, .button.is-primary.is-focused {\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.button.is-primary:focus:not(:active), .button.is-primary.is-focused:not(:active) {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(0, 209, 178, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(0, 209, 178, 0.25);\\n}\\n.button.is-primary:active, .button.is-primary.is-active {\\n  background-color: #00b89c;\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.button.is-primary[disabled], fieldset[disabled] .button.is-primary {\\n  background-color: hsl(171deg, 100%, 41%);\\n  border-color: transparent;\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n}\\n.button.is-primary.is-inverted {\\n  background-color: #fff;\\n  color: hsl(171deg, 100%, 41%);\\n}\\n.button.is-primary.is-inverted:hover, .button.is-primary.is-inverted.is-hovered {\\n  background-color: #f2f2f2;\\n}\\n.button.is-primary.is-inverted[disabled], fieldset[disabled] .button.is-primary.is-inverted {\\n  background-color: #fff;\\n  border-color: transparent;\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: hsl(171deg, 100%, 41%);\\n}\\n.button.is-primary.is-loading::after {\\n  border-color: transparent transparent #fff #fff !important;\\n}\\n.button.is-primary.is-outlined {\\n  background-color: transparent;\\n  border-color: hsl(171deg, 100%, 41%);\\n  color: hsl(171deg, 100%, 41%);\\n}\\n.button.is-primary.is-outlined:hover, .button.is-primary.is-outlined.is-hovered, .button.is-primary.is-outlined:focus, .button.is-primary.is-outlined.is-focused {\\n  background-color: hsl(171deg, 100%, 41%);\\n  border-color: hsl(171deg, 100%, 41%);\\n  color: #fff;\\n}\\n.button.is-primary.is-outlined.is-loading::after {\\n  border-color: transparent transparent hsl(171deg, 100%, 41%) hsl(171deg, 100%, 41%) !important;\\n}\\n.button.is-primary.is-outlined.is-loading:hover::after, .button.is-primary.is-outlined.is-loading.is-hovered::after, .button.is-primary.is-outlined.is-loading:focus::after, .button.is-primary.is-outlined.is-loading.is-focused::after {\\n  border-color: transparent transparent #fff #fff !important;\\n}\\n.button.is-primary.is-outlined[disabled], fieldset[disabled] .button.is-primary.is-outlined {\\n  background-color: transparent;\\n  border-color: hsl(171deg, 100%, 41%);\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: hsl(171deg, 100%, 41%);\\n}\\n.button.is-primary.is-inverted.is-outlined {\\n  background-color: transparent;\\n  border-color: #fff;\\n  color: #fff;\\n}\\n.button.is-primary.is-inverted.is-outlined:hover, .button.is-primary.is-inverted.is-outlined.is-hovered, .button.is-primary.is-inverted.is-outlined:focus, .button.is-primary.is-inverted.is-outlined.is-focused {\\n  background-color: #fff;\\n  color: hsl(171deg, 100%, 41%);\\n}\\n.button.is-primary.is-inverted.is-outlined.is-loading:hover::after, .button.is-primary.is-inverted.is-outlined.is-loading.is-hovered::after, .button.is-primary.is-inverted.is-outlined.is-loading:focus::after, .button.is-primary.is-inverted.is-outlined.is-loading.is-focused::after {\\n  border-color: transparent transparent hsl(171deg, 100%, 41%) hsl(171deg, 100%, 41%) !important;\\n}\\n.button.is-primary.is-inverted.is-outlined[disabled], fieldset[disabled] .button.is-primary.is-inverted.is-outlined {\\n  background-color: transparent;\\n  border-color: #fff;\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: #fff;\\n}\\n.button.is-primary.is-light {\\n  background-color: #ebfffc;\\n  color: #00947e;\\n}\\n.button.is-primary.is-light:hover, .button.is-primary.is-light.is-hovered {\\n  background-color: #defffa;\\n  border-color: transparent;\\n  color: #00947e;\\n}\\n.button.is-primary.is-light:active, .button.is-primary.is-light.is-active {\\n  background-color: #d1fff8;\\n  border-color: transparent;\\n  color: #00947e;\\n}\\n.button.is-link {\\n  background-color: hsl(229deg, 53%, 53%);\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.button.is-link:hover, .button.is-link.is-hovered {\\n  background-color: #3e56c4;\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.button.is-link:focus, .button.is-link.is-focused {\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.button.is-link:focus:not(:active), .button.is-link.is-focused:not(:active) {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(72, 95, 199, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(72, 95, 199, 0.25);\\n}\\n.button.is-link:active, .button.is-link.is-active {\\n  background-color: #3a51bb;\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.button.is-link[disabled], fieldset[disabled] .button.is-link {\\n  background-color: hsl(229deg, 53%, 53%);\\n  border-color: transparent;\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n}\\n.button.is-link.is-inverted {\\n  background-color: #fff;\\n  color: hsl(229deg, 53%, 53%);\\n}\\n.button.is-link.is-inverted:hover, .button.is-link.is-inverted.is-hovered {\\n  background-color: #f2f2f2;\\n}\\n.button.is-link.is-inverted[disabled], fieldset[disabled] .button.is-link.is-inverted {\\n  background-color: #fff;\\n  border-color: transparent;\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: hsl(229deg, 53%, 53%);\\n}\\n.button.is-link.is-loading::after {\\n  border-color: transparent transparent #fff #fff !important;\\n}\\n.button.is-link.is-outlined {\\n  background-color: transparent;\\n  border-color: hsl(229deg, 53%, 53%);\\n  color: hsl(229deg, 53%, 53%);\\n}\\n.button.is-link.is-outlined:hover, .button.is-link.is-outlined.is-hovered, .button.is-link.is-outlined:focus, .button.is-link.is-outlined.is-focused {\\n  background-color: hsl(229deg, 53%, 53%);\\n  border-color: hsl(229deg, 53%, 53%);\\n  color: #fff;\\n}\\n.button.is-link.is-outlined.is-loading::after {\\n  border-color: transparent transparent hsl(229deg, 53%, 53%) hsl(229deg, 53%, 53%) !important;\\n}\\n.button.is-link.is-outlined.is-loading:hover::after, .button.is-link.is-outlined.is-loading.is-hovered::after, .button.is-link.is-outlined.is-loading:focus::after, .button.is-link.is-outlined.is-loading.is-focused::after {\\n  border-color: transparent transparent #fff #fff !important;\\n}\\n.button.is-link.is-outlined[disabled], fieldset[disabled] .button.is-link.is-outlined {\\n  background-color: transparent;\\n  border-color: hsl(229deg, 53%, 53%);\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: hsl(229deg, 53%, 53%);\\n}\\n.button.is-link.is-inverted.is-outlined {\\n  background-color: transparent;\\n  border-color: #fff;\\n  color: #fff;\\n}\\n.button.is-link.is-inverted.is-outlined:hover, .button.is-link.is-inverted.is-outlined.is-hovered, .button.is-link.is-inverted.is-outlined:focus, .button.is-link.is-inverted.is-outlined.is-focused {\\n  background-color: #fff;\\n  color: hsl(229deg, 53%, 53%);\\n}\\n.button.is-link.is-inverted.is-outlined.is-loading:hover::after, .button.is-link.is-inverted.is-outlined.is-loading.is-hovered::after, .button.is-link.is-inverted.is-outlined.is-loading:focus::after, .button.is-link.is-inverted.is-outlined.is-loading.is-focused::after {\\n  border-color: transparent transparent hsl(229deg, 53%, 53%) hsl(229deg, 53%, 53%) !important;\\n}\\n.button.is-link.is-inverted.is-outlined[disabled], fieldset[disabled] .button.is-link.is-inverted.is-outlined {\\n  background-color: transparent;\\n  border-color: #fff;\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: #fff;\\n}\\n.button.is-link.is-light {\\n  background-color: #eff1fa;\\n  color: #3850b7;\\n}\\n.button.is-link.is-light:hover, .button.is-link.is-light.is-hovered {\\n  background-color: #e6e9f7;\\n  border-color: transparent;\\n  color: #3850b7;\\n}\\n.button.is-link.is-light:active, .button.is-link.is-light.is-active {\\n  background-color: #dce0f4;\\n  border-color: transparent;\\n  color: #3850b7;\\n}\\n.button.is-info {\\n  background-color: hsl(207deg, 61%, 53%);\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.button.is-info:hover, .button.is-info.is-hovered {\\n  background-color: #3488ce;\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.button.is-info:focus, .button.is-info.is-focused {\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.button.is-info:focus:not(:active), .button.is-info.is-focused:not(:active) {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(62, 142, 208, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(62, 142, 208, 0.25);\\n}\\n.button.is-info:active, .button.is-info.is-active {\\n  background-color: #3082c5;\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.button.is-info[disabled], fieldset[disabled] .button.is-info {\\n  background-color: hsl(207deg, 61%, 53%);\\n  border-color: transparent;\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n}\\n.button.is-info.is-inverted {\\n  background-color: #fff;\\n  color: hsl(207deg, 61%, 53%);\\n}\\n.button.is-info.is-inverted:hover, .button.is-info.is-inverted.is-hovered {\\n  background-color: #f2f2f2;\\n}\\n.button.is-info.is-inverted[disabled], fieldset[disabled] .button.is-info.is-inverted {\\n  background-color: #fff;\\n  border-color: transparent;\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: hsl(207deg, 61%, 53%);\\n}\\n.button.is-info.is-loading::after {\\n  border-color: transparent transparent #fff #fff !important;\\n}\\n.button.is-info.is-outlined {\\n  background-color: transparent;\\n  border-color: hsl(207deg, 61%, 53%);\\n  color: hsl(207deg, 61%, 53%);\\n}\\n.button.is-info.is-outlined:hover, .button.is-info.is-outlined.is-hovered, .button.is-info.is-outlined:focus, .button.is-info.is-outlined.is-focused {\\n  background-color: hsl(207deg, 61%, 53%);\\n  border-color: hsl(207deg, 61%, 53%);\\n  color: #fff;\\n}\\n.button.is-info.is-outlined.is-loading::after {\\n  border-color: transparent transparent hsl(207deg, 61%, 53%) hsl(207deg, 61%, 53%) !important;\\n}\\n.button.is-info.is-outlined.is-loading:hover::after, .button.is-info.is-outlined.is-loading.is-hovered::after, .button.is-info.is-outlined.is-loading:focus::after, .button.is-info.is-outlined.is-loading.is-focused::after {\\n  border-color: transparent transparent #fff #fff !important;\\n}\\n.button.is-info.is-outlined[disabled], fieldset[disabled] .button.is-info.is-outlined {\\n  background-color: transparent;\\n  border-color: hsl(207deg, 61%, 53%);\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: hsl(207deg, 61%, 53%);\\n}\\n.button.is-info.is-inverted.is-outlined {\\n  background-color: transparent;\\n  border-color: #fff;\\n  color: #fff;\\n}\\n.button.is-info.is-inverted.is-outlined:hover, .button.is-info.is-inverted.is-outlined.is-hovered, .button.is-info.is-inverted.is-outlined:focus, .button.is-info.is-inverted.is-outlined.is-focused {\\n  background-color: #fff;\\n  color: hsl(207deg, 61%, 53%);\\n}\\n.button.is-info.is-inverted.is-outlined.is-loading:hover::after, .button.is-info.is-inverted.is-outlined.is-loading.is-hovered::after, .button.is-info.is-inverted.is-outlined.is-loading:focus::after, .button.is-info.is-inverted.is-outlined.is-loading.is-focused::after {\\n  border-color: transparent transparent hsl(207deg, 61%, 53%) hsl(207deg, 61%, 53%) !important;\\n}\\n.button.is-info.is-inverted.is-outlined[disabled], fieldset[disabled] .button.is-info.is-inverted.is-outlined {\\n  background-color: transparent;\\n  border-color: #fff;\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: #fff;\\n}\\n.button.is-info.is-light {\\n  background-color: #eff5fb;\\n  color: #296fa8;\\n}\\n.button.is-info.is-light:hover, .button.is-info.is-light.is-hovered {\\n  background-color: #e4eff9;\\n  border-color: transparent;\\n  color: #296fa8;\\n}\\n.button.is-info.is-light:active, .button.is-info.is-light.is-active {\\n  background-color: #dae9f6;\\n  border-color: transparent;\\n  color: #296fa8;\\n}\\n.button.is-success {\\n  background-color: hsl(153deg, 53%, 53%);\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.button.is-success:hover, .button.is-success.is-hovered {\\n  background-color: #3ec487;\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.button.is-success:focus, .button.is-success.is-focused {\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.button.is-success:focus:not(:active), .button.is-success.is-focused:not(:active) {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(72, 199, 142, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(72, 199, 142, 0.25);\\n}\\n.button.is-success:active, .button.is-success.is-active {\\n  background-color: #3abb81;\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.button.is-success[disabled], fieldset[disabled] .button.is-success {\\n  background-color: hsl(153deg, 53%, 53%);\\n  border-color: transparent;\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n}\\n.button.is-success.is-inverted {\\n  background-color: #fff;\\n  color: hsl(153deg, 53%, 53%);\\n}\\n.button.is-success.is-inverted:hover, .button.is-success.is-inverted.is-hovered {\\n  background-color: #f2f2f2;\\n}\\n.button.is-success.is-inverted[disabled], fieldset[disabled] .button.is-success.is-inverted {\\n  background-color: #fff;\\n  border-color: transparent;\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: hsl(153deg, 53%, 53%);\\n}\\n.button.is-success.is-loading::after {\\n  border-color: transparent transparent #fff #fff !important;\\n}\\n.button.is-success.is-outlined {\\n  background-color: transparent;\\n  border-color: hsl(153deg, 53%, 53%);\\n  color: hsl(153deg, 53%, 53%);\\n}\\n.button.is-success.is-outlined:hover, .button.is-success.is-outlined.is-hovered, .button.is-success.is-outlined:focus, .button.is-success.is-outlined.is-focused {\\n  background-color: hsl(153deg, 53%, 53%);\\n  border-color: hsl(153deg, 53%, 53%);\\n  color: #fff;\\n}\\n.button.is-success.is-outlined.is-loading::after {\\n  border-color: transparent transparent hsl(153deg, 53%, 53%) hsl(153deg, 53%, 53%) !important;\\n}\\n.button.is-success.is-outlined.is-loading:hover::after, .button.is-success.is-outlined.is-loading.is-hovered::after, .button.is-success.is-outlined.is-loading:focus::after, .button.is-success.is-outlined.is-loading.is-focused::after {\\n  border-color: transparent transparent #fff #fff !important;\\n}\\n.button.is-success.is-outlined[disabled], fieldset[disabled] .button.is-success.is-outlined {\\n  background-color: transparent;\\n  border-color: hsl(153deg, 53%, 53%);\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: hsl(153deg, 53%, 53%);\\n}\\n.button.is-success.is-inverted.is-outlined {\\n  background-color: transparent;\\n  border-color: #fff;\\n  color: #fff;\\n}\\n.button.is-success.is-inverted.is-outlined:hover, .button.is-success.is-inverted.is-outlined.is-hovered, .button.is-success.is-inverted.is-outlined:focus, .button.is-success.is-inverted.is-outlined.is-focused {\\n  background-color: #fff;\\n  color: hsl(153deg, 53%, 53%);\\n}\\n.button.is-success.is-inverted.is-outlined.is-loading:hover::after, .button.is-success.is-inverted.is-outlined.is-loading.is-hovered::after, .button.is-success.is-inverted.is-outlined.is-loading:focus::after, .button.is-success.is-inverted.is-outlined.is-loading.is-focused::after {\\n  border-color: transparent transparent hsl(153deg, 53%, 53%) hsl(153deg, 53%, 53%) !important;\\n}\\n.button.is-success.is-inverted.is-outlined[disabled], fieldset[disabled] .button.is-success.is-inverted.is-outlined {\\n  background-color: transparent;\\n  border-color: #fff;\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: #fff;\\n}\\n.button.is-success.is-light {\\n  background-color: #effaf5;\\n  color: #257953;\\n}\\n.button.is-success.is-light:hover, .button.is-success.is-light.is-hovered {\\n  background-color: #e6f7ef;\\n  border-color: transparent;\\n  color: #257953;\\n}\\n.button.is-success.is-light:active, .button.is-success.is-light.is-active {\\n  background-color: #dcf4e9;\\n  border-color: transparent;\\n  color: #257953;\\n}\\n.button.is-warning {\\n  background-color: hsl(44deg, 100%, 77%);\\n  border-color: transparent;\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.button.is-warning:hover, .button.is-warning.is-hovered {\\n  background-color: #ffdc7d;\\n  border-color: transparent;\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.button.is-warning:focus, .button.is-warning.is-focused {\\n  border-color: transparent;\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.button.is-warning:focus:not(:active), .button.is-warning.is-focused:not(:active) {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(255, 224, 138, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(255, 224, 138, 0.25);\\n}\\n.button.is-warning:active, .button.is-warning.is-active {\\n  background-color: #ffd970;\\n  border-color: transparent;\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.button.is-warning[disabled], fieldset[disabled] .button.is-warning {\\n  background-color: hsl(44deg, 100%, 77%);\\n  border-color: transparent;\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n}\\n.button.is-warning.is-inverted {\\n  background-color: rgba(0, 0, 0, 0.7);\\n  color: hsl(44deg, 100%, 77%);\\n}\\n.button.is-warning.is-inverted:hover, .button.is-warning.is-inverted.is-hovered {\\n  background-color: rgba(0, 0, 0, 0.7);\\n}\\n.button.is-warning.is-inverted[disabled], fieldset[disabled] .button.is-warning.is-inverted {\\n  background-color: rgba(0, 0, 0, 0.7);\\n  border-color: transparent;\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: hsl(44deg, 100%, 77%);\\n}\\n.button.is-warning.is-loading::after {\\n  border-color: transparent transparent rgba(0, 0, 0, 0.7) rgba(0, 0, 0, 0.7) !important;\\n}\\n.button.is-warning.is-outlined {\\n  background-color: transparent;\\n  border-color: hsl(44deg, 100%, 77%);\\n  color: hsl(44deg, 100%, 77%);\\n}\\n.button.is-warning.is-outlined:hover, .button.is-warning.is-outlined.is-hovered, .button.is-warning.is-outlined:focus, .button.is-warning.is-outlined.is-focused {\\n  background-color: hsl(44deg, 100%, 77%);\\n  border-color: hsl(44deg, 100%, 77%);\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.button.is-warning.is-outlined.is-loading::after {\\n  border-color: transparent transparent hsl(44deg, 100%, 77%) hsl(44deg, 100%, 77%) !important;\\n}\\n.button.is-warning.is-outlined.is-loading:hover::after, .button.is-warning.is-outlined.is-loading.is-hovered::after, .button.is-warning.is-outlined.is-loading:focus::after, .button.is-warning.is-outlined.is-loading.is-focused::after {\\n  border-color: transparent transparent rgba(0, 0, 0, 0.7) rgba(0, 0, 0, 0.7) !important;\\n}\\n.button.is-warning.is-outlined[disabled], fieldset[disabled] .button.is-warning.is-outlined {\\n  background-color: transparent;\\n  border-color: hsl(44deg, 100%, 77%);\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: hsl(44deg, 100%, 77%);\\n}\\n.button.is-warning.is-inverted.is-outlined {\\n  background-color: transparent;\\n  border-color: rgba(0, 0, 0, 0.7);\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.button.is-warning.is-inverted.is-outlined:hover, .button.is-warning.is-inverted.is-outlined.is-hovered, .button.is-warning.is-inverted.is-outlined:focus, .button.is-warning.is-inverted.is-outlined.is-focused {\\n  background-color: rgba(0, 0, 0, 0.7);\\n  color: hsl(44deg, 100%, 77%);\\n}\\n.button.is-warning.is-inverted.is-outlined.is-loading:hover::after, .button.is-warning.is-inverted.is-outlined.is-loading.is-hovered::after, .button.is-warning.is-inverted.is-outlined.is-loading:focus::after, .button.is-warning.is-inverted.is-outlined.is-loading.is-focused::after {\\n  border-color: transparent transparent hsl(44deg, 100%, 77%) hsl(44deg, 100%, 77%) !important;\\n}\\n.button.is-warning.is-inverted.is-outlined[disabled], fieldset[disabled] .button.is-warning.is-inverted.is-outlined {\\n  background-color: transparent;\\n  border-color: rgba(0, 0, 0, 0.7);\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.button.is-warning.is-light {\\n  background-color: #fffaeb;\\n  color: #946c00;\\n}\\n.button.is-warning.is-light:hover, .button.is-warning.is-light.is-hovered {\\n  background-color: #fff6de;\\n  border-color: transparent;\\n  color: #946c00;\\n}\\n.button.is-warning.is-light:active, .button.is-warning.is-light.is-active {\\n  background-color: #fff3d1;\\n  border-color: transparent;\\n  color: #946c00;\\n}\\n.button.is-danger {\\n  background-color: hsl(348deg, 86%, 61%);\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.button.is-danger:hover, .button.is-danger.is-hovered {\\n  background-color: #f03a5f;\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.button.is-danger:focus, .button.is-danger.is-focused {\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.button.is-danger:focus:not(:active), .button.is-danger.is-focused:not(:active) {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(241, 70, 104, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(241, 70, 104, 0.25);\\n}\\n.button.is-danger:active, .button.is-danger.is-active {\\n  background-color: #ef2e55;\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.button.is-danger[disabled], fieldset[disabled] .button.is-danger {\\n  background-color: hsl(348deg, 86%, 61%);\\n  border-color: transparent;\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n}\\n.button.is-danger.is-inverted {\\n  background-color: #fff;\\n  color: hsl(348deg, 86%, 61%);\\n}\\n.button.is-danger.is-inverted:hover, .button.is-danger.is-inverted.is-hovered {\\n  background-color: #f2f2f2;\\n}\\n.button.is-danger.is-inverted[disabled], fieldset[disabled] .button.is-danger.is-inverted {\\n  background-color: #fff;\\n  border-color: transparent;\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: hsl(348deg, 86%, 61%);\\n}\\n.button.is-danger.is-loading::after {\\n  border-color: transparent transparent #fff #fff !important;\\n}\\n.button.is-danger.is-outlined {\\n  background-color: transparent;\\n  border-color: hsl(348deg, 86%, 61%);\\n  color: hsl(348deg, 86%, 61%);\\n}\\n.button.is-danger.is-outlined:hover, .button.is-danger.is-outlined.is-hovered, .button.is-danger.is-outlined:focus, .button.is-danger.is-outlined.is-focused {\\n  background-color: hsl(348deg, 86%, 61%);\\n  border-color: hsl(348deg, 86%, 61%);\\n  color: #fff;\\n}\\n.button.is-danger.is-outlined.is-loading::after {\\n  border-color: transparent transparent hsl(348deg, 86%, 61%) hsl(348deg, 86%, 61%) !important;\\n}\\n.button.is-danger.is-outlined.is-loading:hover::after, .button.is-danger.is-outlined.is-loading.is-hovered::after, .button.is-danger.is-outlined.is-loading:focus::after, .button.is-danger.is-outlined.is-loading.is-focused::after {\\n  border-color: transparent transparent #fff #fff !important;\\n}\\n.button.is-danger.is-outlined[disabled], fieldset[disabled] .button.is-danger.is-outlined {\\n  background-color: transparent;\\n  border-color: hsl(348deg, 86%, 61%);\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: hsl(348deg, 86%, 61%);\\n}\\n.button.is-danger.is-inverted.is-outlined {\\n  background-color: transparent;\\n  border-color: #fff;\\n  color: #fff;\\n}\\n.button.is-danger.is-inverted.is-outlined:hover, .button.is-danger.is-inverted.is-outlined.is-hovered, .button.is-danger.is-inverted.is-outlined:focus, .button.is-danger.is-inverted.is-outlined.is-focused {\\n  background-color: #fff;\\n  color: hsl(348deg, 86%, 61%);\\n}\\n.button.is-danger.is-inverted.is-outlined.is-loading:hover::after, .button.is-danger.is-inverted.is-outlined.is-loading.is-hovered::after, .button.is-danger.is-inverted.is-outlined.is-loading:focus::after, .button.is-danger.is-inverted.is-outlined.is-loading.is-focused::after {\\n  border-color: transparent transparent hsl(348deg, 86%, 61%) hsl(348deg, 86%, 61%) !important;\\n}\\n.button.is-danger.is-inverted.is-outlined[disabled], fieldset[disabled] .button.is-danger.is-inverted.is-outlined {\\n  background-color: transparent;\\n  border-color: #fff;\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: #fff;\\n}\\n.button.is-danger.is-light {\\n  background-color: #feecf0;\\n  color: #cc0f35;\\n}\\n.button.is-danger.is-light:hover, .button.is-danger.is-light.is-hovered {\\n  background-color: #fde0e6;\\n  border-color: transparent;\\n  color: #cc0f35;\\n}\\n.button.is-danger.is-light:active, .button.is-danger.is-light.is-active {\\n  background-color: #fcd4dc;\\n  border-color: transparent;\\n  color: #cc0f35;\\n}\\n.button.is-small {\\n  font-size: 0.75rem;\\n}\\n.button.is-small:not(.is-rounded) {\\n  border-radius: 2px;\\n}\\n.button.is-normal {\\n  font-size: 1rem;\\n}\\n.button.is-medium {\\n  font-size: 1.25rem;\\n}\\n.button.is-large {\\n  font-size: 1.5rem;\\n}\\n.button[disabled], fieldset[disabled] .button {\\n  background-color: hsl(0deg, 0%, 100%);\\n  border-color: hsl(0deg, 0%, 86%);\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  opacity: 0.5;\\n}\\n.button.is-fullwidth {\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n  width: 100%;\\n}\\n.button.is-loading {\\n  color: transparent !important;\\n  pointer-events: none;\\n}\\n.button.is-loading::after {\\n  position: absolute;\\n  left: calc(50% - (1em * 0.5));\\n  top: calc(50% - (1em * 0.5));\\n  position: absolute !important;\\n}\\n.button.is-static {\\n  background-color: hsl(0deg, 0%, 96%);\\n  border-color: hsl(0deg, 0%, 86%);\\n  color: hsl(0deg, 0%, 48%);\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  pointer-events: none;\\n}\\n.button.is-rounded {\\n  border-radius: 9999px;\\n  padding-left: calc(1em + 0.25em);\\n  padding-right: calc(1em + 0.25em);\\n}\\n\\n.buttons {\\n  -webkit-box-align: center;\\n      -ms-flex-align: center;\\n          align-items: center;\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n  -ms-flex-wrap: wrap;\\n      flex-wrap: wrap;\\n  -webkit-box-pack: start;\\n      -ms-flex-pack: start;\\n          justify-content: flex-start;\\n}\\n.buttons .button {\\n  margin-bottom: 0.5rem;\\n}\\n.buttons .button:not(:last-child):not(.is-fullwidth) {\\n  margin-right: 0.5rem;\\n}\\n.buttons:last-child {\\n  margin-bottom: -0.5rem;\\n}\\n.buttons:not(:last-child) {\\n  margin-bottom: 1rem;\\n}\\n.buttons.are-small .button:not(.is-normal):not(.is-medium):not(.is-large) {\\n  font-size: 0.75rem;\\n}\\n.buttons.are-small .button:not(.is-normal):not(.is-medium):not(.is-large):not(.is-rounded) {\\n  border-radius: 2px;\\n}\\n.buttons.are-medium .button:not(.is-small):not(.is-normal):not(.is-large) {\\n  font-size: 1.25rem;\\n}\\n.buttons.are-large .button:not(.is-small):not(.is-normal):not(.is-medium) {\\n  font-size: 1.5rem;\\n}\\n.buttons.has-addons .button:not(:first-child) {\\n  border-bottom-left-radius: 0;\\n  border-top-left-radius: 0;\\n}\\n.buttons.has-addons .button:not(:last-child) {\\n  border-bottom-right-radius: 0;\\n  border-top-right-radius: 0;\\n  margin-right: -1px;\\n}\\n.buttons.has-addons .button:last-child {\\n  margin-right: 0;\\n}\\n.buttons.has-addons .button:hover, .buttons.has-addons .button.is-hovered {\\n  z-index: 2;\\n}\\n.buttons.has-addons .button:focus, .buttons.has-addons .button.is-focused, .buttons.has-addons .button:active, .buttons.has-addons .button.is-active, .buttons.has-addons .button.is-selected {\\n  z-index: 3;\\n}\\n.buttons.has-addons .button:focus:hover, .buttons.has-addons .button.is-focused:hover, .buttons.has-addons .button:active:hover, .buttons.has-addons .button.is-active:hover, .buttons.has-addons .button.is-selected:hover {\\n  z-index: 4;\\n}\\n.buttons.has-addons .button.is-expanded {\\n  -webkit-box-flex: 1;\\n      -ms-flex-positive: 1;\\n          flex-grow: 1;\\n  -ms-flex-negative: 1;\\n      flex-shrink: 1;\\n}\\n.buttons.is-centered {\\n  -webkit-box-pack: center;\\n      -ms-flex-pack: center;\\n          justify-content: center;\\n}\\n.buttons.is-centered:not(.has-addons) .button:not(.is-fullwidth) {\\n  margin-left: 0.25rem;\\n  margin-right: 0.25rem;\\n}\\n.buttons.is-right {\\n  -webkit-box-pack: end;\\n      -ms-flex-pack: end;\\n          justify-content: flex-end;\\n}\\n.buttons.is-right:not(.has-addons) .button:not(.is-fullwidth) {\\n  margin-left: 0.25rem;\\n  margin-right: 0.25rem;\\n}\\n\\n.container {\\n  -webkit-box-flex: 1;\\n      -ms-flex-positive: 1;\\n          flex-grow: 1;\\n  margin: 0 auto;\\n  position: relative;\\n  width: auto;\\n}\\n.container.is-fluid {\\n  max-width: none !important;\\n  padding-left: 32px;\\n  padding-right: 32px;\\n  width: 100%;\\n}\\n@media screen and (min-width: 1024px) {\\n  .container {\\n    max-width: 960px;\\n  }\\n}\\n@media screen and (max-width: 1215px) {\\n  .container.is-widescreen:not(.is-max-desktop) {\\n    max-width: 1152px;\\n  }\\n}\\n@media screen and (max-width: 1407px) {\\n  .container.is-fullhd:not(.is-max-desktop):not(.is-max-widescreen) {\\n    max-width: 1344px;\\n  }\\n}\\n@media screen and (min-width: 1216px) {\\n  .container:not(.is-max-desktop) {\\n    max-width: 1152px;\\n  }\\n}\\n@media screen and (min-width: 1408px) {\\n  .container:not(.is-max-desktop):not(.is-max-widescreen) {\\n    max-width: 1344px;\\n  }\\n}\\n\\n.content li + li {\\n  margin-top: 0.25em;\\n}\\n.content p:not(:last-child),\\n.content dl:not(:last-child),\\n.content ol:not(:last-child),\\n.content ul:not(:last-child),\\n.content blockquote:not(:last-child),\\n.content pre:not(:last-child),\\n.content table:not(:last-child) {\\n  margin-bottom: 1em;\\n}\\n.content h1,\\n.content h2,\\n.content h3,\\n.content h4,\\n.content h5,\\n.content h6 {\\n  color: hsl(0deg, 0%, 21%);\\n  font-weight: 600;\\n  line-height: 1.125;\\n}\\n.content h1 {\\n  font-size: 2em;\\n  margin-bottom: 0.5em;\\n}\\n.content h1:not(:first-child) {\\n  margin-top: 1em;\\n}\\n.content h2 {\\n  font-size: 1.75em;\\n  margin-bottom: 0.5714em;\\n}\\n.content h2:not(:first-child) {\\n  margin-top: 1.1428em;\\n}\\n.content h3 {\\n  font-size: 1.5em;\\n  margin-bottom: 0.6666em;\\n}\\n.content h3:not(:first-child) {\\n  margin-top: 1.3333em;\\n}\\n.content h4 {\\n  font-size: 1.25em;\\n  margin-bottom: 0.8em;\\n}\\n.content h5 {\\n  font-size: 1.125em;\\n  margin-bottom: 0.8888em;\\n}\\n.content h6 {\\n  font-size: 1em;\\n  margin-bottom: 1em;\\n}\\n.content blockquote {\\n  background-color: hsl(0deg, 0%, 96%);\\n  border-left: 5px solid hsl(0deg, 0%, 86%);\\n  padding: 1.25em 1.5em;\\n}\\n.content ol {\\n  list-style-position: outside;\\n  margin-left: 2em;\\n  margin-top: 1em;\\n}\\n.content ol:not([type]) {\\n  list-style-type: decimal;\\n}\\n.content ol:not([type]).is-lower-alpha {\\n  list-style-type: lower-alpha;\\n}\\n.content ol:not([type]).is-lower-roman {\\n  list-style-type: lower-roman;\\n}\\n.content ol:not([type]).is-upper-alpha {\\n  list-style-type: upper-alpha;\\n}\\n.content ol:not([type]).is-upper-roman {\\n  list-style-type: upper-roman;\\n}\\n.content ul {\\n  list-style: disc outside;\\n  margin-left: 2em;\\n  margin-top: 1em;\\n}\\n.content ul ul {\\n  list-style-type: circle;\\n  margin-top: 0.5em;\\n}\\n.content ul ul ul {\\n  list-style-type: square;\\n}\\n.content dd {\\n  margin-left: 2em;\\n}\\n.content figure {\\n  margin-left: 2em;\\n  margin-right: 2em;\\n  text-align: center;\\n}\\n.content figure:not(:first-child) {\\n  margin-top: 2em;\\n}\\n.content figure:not(:last-child) {\\n  margin-bottom: 2em;\\n}\\n.content figure img {\\n  display: inline-block;\\n}\\n.content figure figcaption {\\n  font-style: italic;\\n}\\n.content pre {\\n  -webkit-overflow-scrolling: touch;\\n  overflow-x: auto;\\n  padding: 1.25em 1.5em;\\n  white-space: pre;\\n  word-wrap: normal;\\n}\\n.content sup,\\n.content sub {\\n  font-size: 75%;\\n}\\n.content table {\\n  width: 100%;\\n}\\n.content table td,\\n.content table th {\\n  border: 1px solid hsl(0deg, 0%, 86%);\\n  border-width: 0 0 1px;\\n  padding: 0.5em 0.75em;\\n  vertical-align: top;\\n}\\n.content table th {\\n  color: hsl(0deg, 0%, 21%);\\n}\\n.content table th:not([align]) {\\n  text-align: inherit;\\n}\\n.content table thead td,\\n.content table thead th {\\n  border-width: 0 0 2px;\\n  color: hsl(0deg, 0%, 21%);\\n}\\n.content table tfoot td,\\n.content table tfoot th {\\n  border-width: 2px 0 0;\\n  color: hsl(0deg, 0%, 21%);\\n}\\n.content table tbody tr:last-child td,\\n.content table tbody tr:last-child th {\\n  border-bottom-width: 0;\\n}\\n.content .tabs li + li {\\n  margin-top: 0;\\n}\\n.content.is-small {\\n  font-size: 0.75rem;\\n}\\n.content.is-normal {\\n  font-size: 1rem;\\n}\\n.content.is-medium {\\n  font-size: 1.25rem;\\n}\\n.content.is-large {\\n  font-size: 1.5rem;\\n}\\n\\n.icon {\\n  -webkit-box-align: center;\\n      -ms-flex-align: center;\\n          align-items: center;\\n  display: -webkit-inline-box;\\n  display: -ms-inline-flexbox;\\n  display: inline-flex;\\n  -webkit-box-pack: center;\\n      -ms-flex-pack: center;\\n          justify-content: center;\\n  height: 1.5rem;\\n  width: 1.5rem;\\n}\\n.icon.is-small {\\n  height: 1rem;\\n  width: 1rem;\\n}\\n.icon.is-medium {\\n  height: 2rem;\\n  width: 2rem;\\n}\\n.icon.is-large {\\n  height: 3rem;\\n  width: 3rem;\\n}\\n\\n.icon-text {\\n  -webkit-box-align: start;\\n      -ms-flex-align: start;\\n          align-items: flex-start;\\n  color: inherit;\\n  display: -webkit-inline-box;\\n  display: -ms-inline-flexbox;\\n  display: inline-flex;\\n  -ms-flex-wrap: wrap;\\n      flex-wrap: wrap;\\n  line-height: 1.5rem;\\n  vertical-align: top;\\n}\\n.icon-text .icon {\\n  -webkit-box-flex: 0;\\n      -ms-flex-positive: 0;\\n          flex-grow: 0;\\n  -ms-flex-negative: 0;\\n      flex-shrink: 0;\\n}\\n.icon-text .icon:not(:last-child) {\\n  margin-right: 0.25em;\\n}\\n.icon-text .icon:not(:first-child) {\\n  margin-left: 0.25em;\\n}\\n\\ndiv.icon-text {\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n}\\n\\n.image {\\n  display: block;\\n  position: relative;\\n}\\n.image img {\\n  display: block;\\n  height: auto;\\n  width: 100%;\\n}\\n.image img.is-rounded {\\n  border-radius: 9999px;\\n}\\n.image.is-fullwidth {\\n  width: 100%;\\n}\\n.image.is-square img,\\n.image.is-square .has-ratio, .image.is-1by1 img,\\n.image.is-1by1 .has-ratio, .image.is-5by4 img,\\n.image.is-5by4 .has-ratio, .image.is-4by3 img,\\n.image.is-4by3 .has-ratio, .image.is-3by2 img,\\n.image.is-3by2 .has-ratio, .image.is-5by3 img,\\n.image.is-5by3 .has-ratio, .image.is-16by9 img,\\n.image.is-16by9 .has-ratio, .image.is-2by1 img,\\n.image.is-2by1 .has-ratio, .image.is-3by1 img,\\n.image.is-3by1 .has-ratio, .image.is-4by5 img,\\n.image.is-4by5 .has-ratio, .image.is-3by4 img,\\n.image.is-3by4 .has-ratio, .image.is-2by3 img,\\n.image.is-2by3 .has-ratio, .image.is-3by5 img,\\n.image.is-3by5 .has-ratio, .image.is-9by16 img,\\n.image.is-9by16 .has-ratio, .image.is-1by2 img,\\n.image.is-1by2 .has-ratio, .image.is-1by3 img,\\n.image.is-1by3 .has-ratio {\\n  height: 100%;\\n  width: 100%;\\n}\\n.image.is-square, .image.is-1by1 {\\n  padding-top: 100%;\\n}\\n.image.is-5by4 {\\n  padding-top: 80%;\\n}\\n.image.is-4by3 {\\n  padding-top: 75%;\\n}\\n.image.is-3by2 {\\n  padding-top: 66.6666%;\\n}\\n.image.is-5by3 {\\n  padding-top: 60%;\\n}\\n.image.is-16by9 {\\n  padding-top: 56.25%;\\n}\\n.image.is-2by1 {\\n  padding-top: 50%;\\n}\\n.image.is-3by1 {\\n  padding-top: 33.3333%;\\n}\\n.image.is-4by5 {\\n  padding-top: 125%;\\n}\\n.image.is-3by4 {\\n  padding-top: 133.3333%;\\n}\\n.image.is-2by3 {\\n  padding-top: 150%;\\n}\\n.image.is-3by5 {\\n  padding-top: 166.6666%;\\n}\\n.image.is-9by16 {\\n  padding-top: 177.7777%;\\n}\\n.image.is-1by2 {\\n  padding-top: 200%;\\n}\\n.image.is-1by3 {\\n  padding-top: 300%;\\n}\\n.image.is-16x16 {\\n  height: 16px;\\n  width: 16px;\\n}\\n.image.is-24x24 {\\n  height: 24px;\\n  width: 24px;\\n}\\n.image.is-32x32 {\\n  height: 32px;\\n  width: 32px;\\n}\\n.image.is-48x48 {\\n  height: 48px;\\n  width: 48px;\\n}\\n.image.is-64x64 {\\n  height: 64px;\\n  width: 64px;\\n}\\n.image.is-96x96 {\\n  height: 96px;\\n  width: 96px;\\n}\\n.image.is-128x128 {\\n  height: 128px;\\n  width: 128px;\\n}\\n\\n.notification {\\n  background-color: hsl(0deg, 0%, 96%);\\n  border-radius: 4px;\\n  position: relative;\\n  padding: 1.25rem 2.5rem 1.25rem 1.5rem;\\n}\\n.notification a:not(.button):not(.dropdown-item) {\\n  color: currentColor;\\n  text-decoration: underline;\\n}\\n.notification strong {\\n  color: currentColor;\\n}\\n.notification code,\\n.notification pre {\\n  background: hsl(0deg, 0%, 100%);\\n}\\n.notification pre code {\\n  background: transparent;\\n}\\n.notification > .delete {\\n  right: 0.5rem;\\n  position: absolute;\\n  top: 0.5rem;\\n}\\n.notification .title,\\n.notification .subtitle,\\n.notification .content {\\n  color: currentColor;\\n}\\n.notification.is-white {\\n  background-color: hsl(0deg, 0%, 100%);\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.notification.is-black {\\n  background-color: hsl(0deg, 0%, 4%);\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.notification.is-light {\\n  background-color: hsl(0deg, 0%, 96%);\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.notification.is-dark {\\n  background-color: hsl(0deg, 0%, 21%);\\n  color: #fff;\\n}\\n.notification.is-primary {\\n  background-color: hsl(171deg, 100%, 41%);\\n  color: #fff;\\n}\\n.notification.is-primary.is-light {\\n  background-color: #ebfffc;\\n  color: #00947e;\\n}\\n.notification.is-link {\\n  background-color: hsl(229deg, 53%, 53%);\\n  color: #fff;\\n}\\n.notification.is-link.is-light {\\n  background-color: #eff1fa;\\n  color: #3850b7;\\n}\\n.notification.is-info {\\n  background-color: hsl(207deg, 61%, 53%);\\n  color: #fff;\\n}\\n.notification.is-info.is-light {\\n  background-color: #eff5fb;\\n  color: #296fa8;\\n}\\n.notification.is-success {\\n  background-color: hsl(153deg, 53%, 53%);\\n  color: #fff;\\n}\\n.notification.is-success.is-light {\\n  background-color: #effaf5;\\n  color: #257953;\\n}\\n.notification.is-warning {\\n  background-color: hsl(44deg, 100%, 77%);\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.notification.is-warning.is-light {\\n  background-color: #fffaeb;\\n  color: #946c00;\\n}\\n.notification.is-danger {\\n  background-color: hsl(348deg, 86%, 61%);\\n  color: #fff;\\n}\\n.notification.is-danger.is-light {\\n  background-color: #feecf0;\\n  color: #cc0f35;\\n}\\n\\n.progress {\\n  -moz-appearance: none;\\n  -webkit-appearance: none;\\n  border: none;\\n  border-radius: 9999px;\\n  display: block;\\n  height: 1rem;\\n  overflow: hidden;\\n  padding: 0;\\n  width: 100%;\\n}\\n.progress::-webkit-progress-bar {\\n  background-color: hsl(0deg, 0%, 93%);\\n}\\n.progress::-webkit-progress-value {\\n  background-color: hsl(0deg, 0%, 29%);\\n}\\n.progress::-moz-progress-bar {\\n  background-color: hsl(0deg, 0%, 29%);\\n}\\n.progress::-ms-fill {\\n  background-color: hsl(0deg, 0%, 29%);\\n  border: none;\\n}\\n.progress.is-white::-webkit-progress-value {\\n  background-color: hsl(0deg, 0%, 100%);\\n}\\n.progress.is-white::-moz-progress-bar {\\n  background-color: hsl(0deg, 0%, 100%);\\n}\\n.progress.is-white::-ms-fill {\\n  background-color: hsl(0deg, 0%, 100%);\\n}\\n.progress.is-white:indeterminate {\\n  background-image: -webkit-gradient(linear, left top, right top, color-stop(30%, hsl(0deg, 0%, 100%)), color-stop(30%, hsl(0deg, 0%, 93%)));\\n  background-image: linear-gradient(to right, hsl(0deg, 0%, 100%) 30%, hsl(0deg, 0%, 93%) 30%);\\n}\\n.progress.is-black::-webkit-progress-value {\\n  background-color: hsl(0deg, 0%, 4%);\\n}\\n.progress.is-black::-moz-progress-bar {\\n  background-color: hsl(0deg, 0%, 4%);\\n}\\n.progress.is-black::-ms-fill {\\n  background-color: hsl(0deg, 0%, 4%);\\n}\\n.progress.is-black:indeterminate {\\n  background-image: -webkit-gradient(linear, left top, right top, color-stop(30%, hsl(0deg, 0%, 4%)), color-stop(30%, hsl(0deg, 0%, 93%)));\\n  background-image: linear-gradient(to right, hsl(0deg, 0%, 4%) 30%, hsl(0deg, 0%, 93%) 30%);\\n}\\n.progress.is-light::-webkit-progress-value {\\n  background-color: hsl(0deg, 0%, 96%);\\n}\\n.progress.is-light::-moz-progress-bar {\\n  background-color: hsl(0deg, 0%, 96%);\\n}\\n.progress.is-light::-ms-fill {\\n  background-color: hsl(0deg, 0%, 96%);\\n}\\n.progress.is-light:indeterminate {\\n  background-image: -webkit-gradient(linear, left top, right top, color-stop(30%, hsl(0deg, 0%, 96%)), color-stop(30%, hsl(0deg, 0%, 93%)));\\n  background-image: linear-gradient(to right, hsl(0deg, 0%, 96%) 30%, hsl(0deg, 0%, 93%) 30%);\\n}\\n.progress.is-dark::-webkit-progress-value {\\n  background-color: hsl(0deg, 0%, 21%);\\n}\\n.progress.is-dark::-moz-progress-bar {\\n  background-color: hsl(0deg, 0%, 21%);\\n}\\n.progress.is-dark::-ms-fill {\\n  background-color: hsl(0deg, 0%, 21%);\\n}\\n.progress.is-dark:indeterminate {\\n  background-image: -webkit-gradient(linear, left top, right top, color-stop(30%, hsl(0deg, 0%, 21%)), color-stop(30%, hsl(0deg, 0%, 93%)));\\n  background-image: linear-gradient(to right, hsl(0deg, 0%, 21%) 30%, hsl(0deg, 0%, 93%) 30%);\\n}\\n.progress.is-primary::-webkit-progress-value {\\n  background-color: hsl(171deg, 100%, 41%);\\n}\\n.progress.is-primary::-moz-progress-bar {\\n  background-color: hsl(171deg, 100%, 41%);\\n}\\n.progress.is-primary::-ms-fill {\\n  background-color: hsl(171deg, 100%, 41%);\\n}\\n.progress.is-primary:indeterminate {\\n  background-image: -webkit-gradient(linear, left top, right top, color-stop(30%, hsl(171deg, 100%, 41%)), color-stop(30%, hsl(0deg, 0%, 93%)));\\n  background-image: linear-gradient(to right, hsl(171deg, 100%, 41%) 30%, hsl(0deg, 0%, 93%) 30%);\\n}\\n.progress.is-link::-webkit-progress-value {\\n  background-color: hsl(229deg, 53%, 53%);\\n}\\n.progress.is-link::-moz-progress-bar {\\n  background-color: hsl(229deg, 53%, 53%);\\n}\\n.progress.is-link::-ms-fill {\\n  background-color: hsl(229deg, 53%, 53%);\\n}\\n.progress.is-link:indeterminate {\\n  background-image: -webkit-gradient(linear, left top, right top, color-stop(30%, hsl(229deg, 53%, 53%)), color-stop(30%, hsl(0deg, 0%, 93%)));\\n  background-image: linear-gradient(to right, hsl(229deg, 53%, 53%) 30%, hsl(0deg, 0%, 93%) 30%);\\n}\\n.progress.is-info::-webkit-progress-value {\\n  background-color: hsl(207deg, 61%, 53%);\\n}\\n.progress.is-info::-moz-progress-bar {\\n  background-color: hsl(207deg, 61%, 53%);\\n}\\n.progress.is-info::-ms-fill {\\n  background-color: hsl(207deg, 61%, 53%);\\n}\\n.progress.is-info:indeterminate {\\n  background-image: -webkit-gradient(linear, left top, right top, color-stop(30%, hsl(207deg, 61%, 53%)), color-stop(30%, hsl(0deg, 0%, 93%)));\\n  background-image: linear-gradient(to right, hsl(207deg, 61%, 53%) 30%, hsl(0deg, 0%, 93%) 30%);\\n}\\n.progress.is-success::-webkit-progress-value {\\n  background-color: hsl(153deg, 53%, 53%);\\n}\\n.progress.is-success::-moz-progress-bar {\\n  background-color: hsl(153deg, 53%, 53%);\\n}\\n.progress.is-success::-ms-fill {\\n  background-color: hsl(153deg, 53%, 53%);\\n}\\n.progress.is-success:indeterminate {\\n  background-image: -webkit-gradient(linear, left top, right top, color-stop(30%, hsl(153deg, 53%, 53%)), color-stop(30%, hsl(0deg, 0%, 93%)));\\n  background-image: linear-gradient(to right, hsl(153deg, 53%, 53%) 30%, hsl(0deg, 0%, 93%) 30%);\\n}\\n.progress.is-warning::-webkit-progress-value {\\n  background-color: hsl(44deg, 100%, 77%);\\n}\\n.progress.is-warning::-moz-progress-bar {\\n  background-color: hsl(44deg, 100%, 77%);\\n}\\n.progress.is-warning::-ms-fill {\\n  background-color: hsl(44deg, 100%, 77%);\\n}\\n.progress.is-warning:indeterminate {\\n  background-image: -webkit-gradient(linear, left top, right top, color-stop(30%, hsl(44deg, 100%, 77%)), color-stop(30%, hsl(0deg, 0%, 93%)));\\n  background-image: linear-gradient(to right, hsl(44deg, 100%, 77%) 30%, hsl(0deg, 0%, 93%) 30%);\\n}\\n.progress.is-danger::-webkit-progress-value {\\n  background-color: hsl(348deg, 86%, 61%);\\n}\\n.progress.is-danger::-moz-progress-bar {\\n  background-color: hsl(348deg, 86%, 61%);\\n}\\n.progress.is-danger::-ms-fill {\\n  background-color: hsl(348deg, 86%, 61%);\\n}\\n.progress.is-danger:indeterminate {\\n  background-image: -webkit-gradient(linear, left top, right top, color-stop(30%, hsl(348deg, 86%, 61%)), color-stop(30%, hsl(0deg, 0%, 93%)));\\n  background-image: linear-gradient(to right, hsl(348deg, 86%, 61%) 30%, hsl(0deg, 0%, 93%) 30%);\\n}\\n.progress:indeterminate {\\n  -webkit-animation-duration: 1.5s;\\n          animation-duration: 1.5s;\\n  -webkit-animation-iteration-count: infinite;\\n          animation-iteration-count: infinite;\\n  -webkit-animation-name: moveIndeterminate;\\n          animation-name: moveIndeterminate;\\n  -webkit-animation-timing-function: linear;\\n          animation-timing-function: linear;\\n  background-color: hsl(0deg, 0%, 93%);\\n  background-image: -webkit-gradient(linear, left top, right top, color-stop(30%, hsl(0deg, 0%, 29%)), color-stop(30%, hsl(0deg, 0%, 93%)));\\n  background-image: linear-gradient(to right, hsl(0deg, 0%, 29%) 30%, hsl(0deg, 0%, 93%) 30%);\\n  background-position: top left;\\n  background-repeat: no-repeat;\\n  background-size: 150% 150%;\\n}\\n.progress:indeterminate::-webkit-progress-bar {\\n  background-color: transparent;\\n}\\n.progress:indeterminate::-moz-progress-bar {\\n  background-color: transparent;\\n}\\n.progress:indeterminate::-ms-fill {\\n  animation-name: none;\\n}\\n.progress.is-small {\\n  height: 0.75rem;\\n}\\n.progress.is-medium {\\n  height: 1.25rem;\\n}\\n.progress.is-large {\\n  height: 1.5rem;\\n}\\n\\n@-webkit-keyframes moveIndeterminate {\\n  from {\\n    background-position: 200% 0;\\n  }\\n  to {\\n    background-position: -200% 0;\\n  }\\n}\\n\\n@keyframes moveIndeterminate {\\n  from {\\n    background-position: 200% 0;\\n  }\\n  to {\\n    background-position: -200% 0;\\n  }\\n}\\n.table {\\n  background-color: hsl(0deg, 0%, 100%);\\n  color: hsl(0deg, 0%, 21%);\\n}\\n.table td,\\n.table th {\\n  border: 1px solid hsl(0deg, 0%, 86%);\\n  border-width: 0 0 1px;\\n  padding: 0.5em 0.75em;\\n  vertical-align: top;\\n}\\n.table td.is-white,\\n.table th.is-white {\\n  background-color: hsl(0deg, 0%, 100%);\\n  border-color: hsl(0deg, 0%, 100%);\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.table td.is-black,\\n.table th.is-black {\\n  background-color: hsl(0deg, 0%, 4%);\\n  border-color: hsl(0deg, 0%, 4%);\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.table td.is-light,\\n.table th.is-light {\\n  background-color: hsl(0deg, 0%, 96%);\\n  border-color: hsl(0deg, 0%, 96%);\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.table td.is-dark,\\n.table th.is-dark {\\n  background-color: hsl(0deg, 0%, 21%);\\n  border-color: hsl(0deg, 0%, 21%);\\n  color: #fff;\\n}\\n.table td.is-primary,\\n.table th.is-primary {\\n  background-color: hsl(171deg, 100%, 41%);\\n  border-color: hsl(171deg, 100%, 41%);\\n  color: #fff;\\n}\\n.table td.is-link,\\n.table th.is-link {\\n  background-color: hsl(229deg, 53%, 53%);\\n  border-color: hsl(229deg, 53%, 53%);\\n  color: #fff;\\n}\\n.table td.is-info,\\n.table th.is-info {\\n  background-color: hsl(207deg, 61%, 53%);\\n  border-color: hsl(207deg, 61%, 53%);\\n  color: #fff;\\n}\\n.table td.is-success,\\n.table th.is-success {\\n  background-color: hsl(153deg, 53%, 53%);\\n  border-color: hsl(153deg, 53%, 53%);\\n  color: #fff;\\n}\\n.table td.is-warning,\\n.table th.is-warning {\\n  background-color: hsl(44deg, 100%, 77%);\\n  border-color: hsl(44deg, 100%, 77%);\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.table td.is-danger,\\n.table th.is-danger {\\n  background-color: hsl(348deg, 86%, 61%);\\n  border-color: hsl(348deg, 86%, 61%);\\n  color: #fff;\\n}\\n.table td.is-narrow,\\n.table th.is-narrow {\\n  white-space: nowrap;\\n  width: 1%;\\n}\\n.table td.is-selected,\\n.table th.is-selected {\\n  background-color: hsl(171deg, 100%, 41%);\\n  color: #fff;\\n}\\n.table td.is-selected a,\\n.table td.is-selected strong,\\n.table th.is-selected a,\\n.table th.is-selected strong {\\n  color: currentColor;\\n}\\n.table td.is-vcentered,\\n.table th.is-vcentered {\\n  vertical-align: middle;\\n}\\n.table th {\\n  color: hsl(0deg, 0%, 21%);\\n}\\n.table th:not([align]) {\\n  text-align: inherit;\\n}\\n.table tr.is-selected {\\n  background-color: hsl(171deg, 100%, 41%);\\n  color: #fff;\\n}\\n.table tr.is-selected a,\\n.table tr.is-selected strong {\\n  color: currentColor;\\n}\\n.table tr.is-selected td,\\n.table tr.is-selected th {\\n  border-color: #fff;\\n  color: currentColor;\\n}\\n.table thead {\\n  background-color: transparent;\\n}\\n.table thead td,\\n.table thead th {\\n  border-width: 0 0 2px;\\n  color: hsl(0deg, 0%, 21%);\\n}\\n.table tfoot {\\n  background-color: transparent;\\n}\\n.table tfoot td,\\n.table tfoot th {\\n  border-width: 2px 0 0;\\n  color: hsl(0deg, 0%, 21%);\\n}\\n.table tbody {\\n  background-color: transparent;\\n}\\n.table tbody tr:last-child td,\\n.table tbody tr:last-child th {\\n  border-bottom-width: 0;\\n}\\n.table.is-bordered td,\\n.table.is-bordered th {\\n  border-width: 1px;\\n}\\n.table.is-bordered tr:last-child td,\\n.table.is-bordered tr:last-child th {\\n  border-bottom-width: 1px;\\n}\\n.table.is-fullwidth {\\n  width: 100%;\\n}\\n.table.is-hoverable tbody tr:not(.is-selected):hover {\\n  background-color: hsl(0deg, 0%, 98%);\\n}\\n.table.is-hoverable.is-striped tbody tr:not(.is-selected):hover {\\n  background-color: hsl(0deg, 0%, 98%);\\n}\\n.table.is-hoverable.is-striped tbody tr:not(.is-selected):hover:nth-child(even) {\\n  background-color: hsl(0deg, 0%, 96%);\\n}\\n.table.is-narrow td,\\n.table.is-narrow th {\\n  padding: 0.25em 0.5em;\\n}\\n.table.is-striped tbody tr:not(.is-selected):nth-child(even) {\\n  background-color: hsl(0deg, 0%, 98%);\\n}\\n\\n.table-container {\\n  -webkit-overflow-scrolling: touch;\\n  overflow: auto;\\n  overflow-y: hidden;\\n  max-width: 100%;\\n}\\n\\n.tags {\\n  -webkit-box-align: center;\\n      -ms-flex-align: center;\\n          align-items: center;\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n  -ms-flex-wrap: wrap;\\n      flex-wrap: wrap;\\n  -webkit-box-pack: start;\\n      -ms-flex-pack: start;\\n          justify-content: flex-start;\\n}\\n.tags .tag {\\n  margin-bottom: 0.5rem;\\n}\\n.tags .tag:not(:last-child) {\\n  margin-right: 0.5rem;\\n}\\n.tags:last-child {\\n  margin-bottom: -0.5rem;\\n}\\n.tags:not(:last-child) {\\n  margin-bottom: 1rem;\\n}\\n.tags.are-medium .tag:not(.is-normal):not(.is-large) {\\n  font-size: 1rem;\\n}\\n.tags.are-large .tag:not(.is-normal):not(.is-medium) {\\n  font-size: 1.25rem;\\n}\\n.tags.is-centered {\\n  -webkit-box-pack: center;\\n      -ms-flex-pack: center;\\n          justify-content: center;\\n}\\n.tags.is-centered .tag {\\n  margin-right: 0.25rem;\\n  margin-left: 0.25rem;\\n}\\n.tags.is-right {\\n  -webkit-box-pack: end;\\n      -ms-flex-pack: end;\\n          justify-content: flex-end;\\n}\\n.tags.is-right .tag:not(:first-child) {\\n  margin-left: 0.5rem;\\n}\\n.tags.is-right .tag:not(:last-child) {\\n  margin-right: 0;\\n}\\n.tags.has-addons .tag {\\n  margin-right: 0;\\n}\\n.tags.has-addons .tag:not(:first-child) {\\n  margin-left: 0;\\n  border-top-left-radius: 0;\\n  border-bottom-left-radius: 0;\\n}\\n.tags.has-addons .tag:not(:last-child) {\\n  border-top-right-radius: 0;\\n  border-bottom-right-radius: 0;\\n}\\n\\n.tag:not(body) {\\n  -webkit-box-align: center;\\n      -ms-flex-align: center;\\n          align-items: center;\\n  background-color: hsl(0deg, 0%, 96%);\\n  border-radius: 4px;\\n  color: hsl(0deg, 0%, 29%);\\n  display: -webkit-inline-box;\\n  display: -ms-inline-flexbox;\\n  display: inline-flex;\\n  font-size: 0.75rem;\\n  height: 2em;\\n  -webkit-box-pack: center;\\n      -ms-flex-pack: center;\\n          justify-content: center;\\n  line-height: 1.5;\\n  padding-left: 0.75em;\\n  padding-right: 0.75em;\\n  white-space: nowrap;\\n}\\n.tag:not(body) .delete {\\n  margin-left: 0.25rem;\\n  margin-right: -0.375rem;\\n}\\n.tag:not(body).is-white {\\n  background-color: hsl(0deg, 0%, 100%);\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.tag:not(body).is-black {\\n  background-color: hsl(0deg, 0%, 4%);\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.tag:not(body).is-light {\\n  background-color: hsl(0deg, 0%, 96%);\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.tag:not(body).is-dark {\\n  background-color: hsl(0deg, 0%, 21%);\\n  color: #fff;\\n}\\n.tag:not(body).is-primary {\\n  background-color: hsl(171deg, 100%, 41%);\\n  color: #fff;\\n}\\n.tag:not(body).is-primary.is-light {\\n  background-color: #ebfffc;\\n  color: #00947e;\\n}\\n.tag:not(body).is-link {\\n  background-color: hsl(229deg, 53%, 53%);\\n  color: #fff;\\n}\\n.tag:not(body).is-link.is-light {\\n  background-color: #eff1fa;\\n  color: #3850b7;\\n}\\n.tag:not(body).is-info {\\n  background-color: hsl(207deg, 61%, 53%);\\n  color: #fff;\\n}\\n.tag:not(body).is-info.is-light {\\n  background-color: #eff5fb;\\n  color: #296fa8;\\n}\\n.tag:not(body).is-success {\\n  background-color: hsl(153deg, 53%, 53%);\\n  color: #fff;\\n}\\n.tag:not(body).is-success.is-light {\\n  background-color: #effaf5;\\n  color: #257953;\\n}\\n.tag:not(body).is-warning {\\n  background-color: hsl(44deg, 100%, 77%);\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.tag:not(body).is-warning.is-light {\\n  background-color: #fffaeb;\\n  color: #946c00;\\n}\\n.tag:not(body).is-danger {\\n  background-color: hsl(348deg, 86%, 61%);\\n  color: #fff;\\n}\\n.tag:not(body).is-danger.is-light {\\n  background-color: #feecf0;\\n  color: #cc0f35;\\n}\\n.tag:not(body).is-normal {\\n  font-size: 0.75rem;\\n}\\n.tag:not(body).is-medium {\\n  font-size: 1rem;\\n}\\n.tag:not(body).is-large {\\n  font-size: 1.25rem;\\n}\\n.tag:not(body) .icon:first-child:not(:last-child) {\\n  margin-left: -0.375em;\\n  margin-right: 0.1875em;\\n}\\n.tag:not(body) .icon:last-child:not(:first-child) {\\n  margin-left: 0.1875em;\\n  margin-right: -0.375em;\\n}\\n.tag:not(body) .icon:first-child:last-child {\\n  margin-left: -0.375em;\\n  margin-right: -0.375em;\\n}\\n.tag:not(body).is-delete {\\n  margin-left: 1px;\\n  padding: 0;\\n  position: relative;\\n  width: 2em;\\n}\\n.tag:not(body).is-delete::before, .tag:not(body).is-delete::after {\\n  background-color: currentColor;\\n  content: \\\"\\\";\\n  display: block;\\n  left: 50%;\\n  position: absolute;\\n  top: 50%;\\n  -webkit-transform: translateX(-50%) translateY(-50%) rotate(45deg);\\n          transform: translateX(-50%) translateY(-50%) rotate(45deg);\\n  -webkit-transform-origin: center center;\\n          transform-origin: center center;\\n}\\n.tag:not(body).is-delete::before {\\n  height: 1px;\\n  width: 50%;\\n}\\n.tag:not(body).is-delete::after {\\n  height: 50%;\\n  width: 1px;\\n}\\n.tag:not(body).is-delete:hover, .tag:not(body).is-delete:focus {\\n  background-color: #e8e8e8;\\n}\\n.tag:not(body).is-delete:active {\\n  background-color: #dbdbdb;\\n}\\n.tag:not(body).is-rounded {\\n  border-radius: 9999px;\\n}\\n\\na.tag:hover {\\n  text-decoration: underline;\\n}\\n\\n.title,\\n.subtitle {\\n  word-break: break-word;\\n}\\n.title em,\\n.title span,\\n.subtitle em,\\n.subtitle span {\\n  font-weight: inherit;\\n}\\n.title sub,\\n.subtitle sub {\\n  font-size: 0.75em;\\n}\\n.title sup,\\n.subtitle sup {\\n  font-size: 0.75em;\\n}\\n.title .tag,\\n.subtitle .tag {\\n  vertical-align: middle;\\n}\\n\\n.title {\\n  color: hsl(0deg, 0%, 21%);\\n  font-size: 2rem;\\n  font-weight: 600;\\n  line-height: 1.125;\\n}\\n.title strong {\\n  color: inherit;\\n  font-weight: inherit;\\n}\\n.title:not(.is-spaced) + .subtitle {\\n  margin-top: -1.25rem;\\n}\\n.title.is-1 {\\n  font-size: 3rem;\\n}\\n.title.is-2 {\\n  font-size: 2.5rem;\\n}\\n.title.is-3 {\\n  font-size: 2rem;\\n}\\n.title.is-4 {\\n  font-size: 1.5rem;\\n}\\n.title.is-5 {\\n  font-size: 1.25rem;\\n}\\n.title.is-6 {\\n  font-size: 1rem;\\n}\\n.title.is-7 {\\n  font-size: 0.75rem;\\n}\\n\\n.subtitle {\\n  color: hsl(0deg, 0%, 29%);\\n  font-size: 1.25rem;\\n  font-weight: 400;\\n  line-height: 1.25;\\n}\\n.subtitle strong {\\n  color: hsl(0deg, 0%, 21%);\\n  font-weight: 600;\\n}\\n.subtitle:not(.is-spaced) + .title {\\n  margin-top: -1.25rem;\\n}\\n.subtitle.is-1 {\\n  font-size: 3rem;\\n}\\n.subtitle.is-2 {\\n  font-size: 2.5rem;\\n}\\n.subtitle.is-3 {\\n  font-size: 2rem;\\n}\\n.subtitle.is-4 {\\n  font-size: 1.5rem;\\n}\\n.subtitle.is-5 {\\n  font-size: 1.25rem;\\n}\\n.subtitle.is-6 {\\n  font-size: 1rem;\\n}\\n.subtitle.is-7 {\\n  font-size: 0.75rem;\\n}\\n\\n.heading {\\n  display: block;\\n  font-size: 11px;\\n  letter-spacing: 1px;\\n  margin-bottom: 5px;\\n  text-transform: uppercase;\\n}\\n\\n.number {\\n  -webkit-box-align: center;\\n      -ms-flex-align: center;\\n          align-items: center;\\n  background-color: hsl(0deg, 0%, 96%);\\n  border-radius: 9999px;\\n  display: -webkit-inline-box;\\n  display: -ms-inline-flexbox;\\n  display: inline-flex;\\n  font-size: 1.25rem;\\n  height: 2em;\\n  -webkit-box-pack: center;\\n      -ms-flex-pack: center;\\n          justify-content: center;\\n  margin-right: 1.5rem;\\n  min-width: 2.5em;\\n  padding: 0.25rem 0.5rem;\\n  text-align: center;\\n  vertical-align: top;\\n}\\n\\n/* Bulma Form */\\n.select select, .textarea, .input {\\n  background-color: hsl(0deg, 0%, 100%);\\n  border-color: hsl(0deg, 0%, 86%);\\n  border-radius: 4px;\\n  color: hsl(0deg, 0%, 21%);\\n}\\n.select select::-moz-placeholder, .textarea::-moz-placeholder, .input::-moz-placeholder {\\n  color: rgba(54, 54, 54, 0.3);\\n}\\n.select select::-webkit-input-placeholder, .textarea::-webkit-input-placeholder, .input::-webkit-input-placeholder {\\n  color: rgba(54, 54, 54, 0.3);\\n}\\n.select select:-moz-placeholder, .textarea:-moz-placeholder, .input:-moz-placeholder {\\n  color: rgba(54, 54, 54, 0.3);\\n}\\n.select select:-ms-input-placeholder, .textarea:-ms-input-placeholder, .input:-ms-input-placeholder {\\n  color: rgba(54, 54, 54, 0.3);\\n}\\n.select select:hover, .textarea:hover, .input:hover, .select select.is-hovered, .is-hovered.textarea, .is-hovered.input {\\n  border-color: hsl(0deg, 0%, 71%);\\n}\\n.select select:focus, .textarea:focus, .input:focus, .select select.is-focused, .is-focused.textarea, .is-focused.input, .select select:active, .textarea:active, .input:active, .select select.is-active, .is-active.textarea, .is-active.input {\\n  border-color: hsl(229deg, 53%, 53%);\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(72, 95, 199, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(72, 95, 199, 0.25);\\n}\\n.select select[disabled], [disabled].textarea, [disabled].input, fieldset[disabled] .select select, .select fieldset[disabled] select, fieldset[disabled] .textarea, fieldset[disabled] .input {\\n  background-color: hsl(0deg, 0%, 96%);\\n  border-color: hsl(0deg, 0%, 96%);\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: hsl(0deg, 0%, 48%);\\n}\\n.select select[disabled]::-moz-placeholder, [disabled].textarea::-moz-placeholder, [disabled].input::-moz-placeholder, fieldset[disabled] .select select::-moz-placeholder, .select fieldset[disabled] select::-moz-placeholder, fieldset[disabled] .textarea::-moz-placeholder, fieldset[disabled] .input::-moz-placeholder {\\n  color: rgba(122, 122, 122, 0.3);\\n}\\n.select select[disabled]::-webkit-input-placeholder, [disabled].textarea::-webkit-input-placeholder, [disabled].input::-webkit-input-placeholder, fieldset[disabled] .select select::-webkit-input-placeholder, .select fieldset[disabled] select::-webkit-input-placeholder, fieldset[disabled] .textarea::-webkit-input-placeholder, fieldset[disabled] .input::-webkit-input-placeholder {\\n  color: rgba(122, 122, 122, 0.3);\\n}\\n.select select[disabled]:-moz-placeholder, [disabled].textarea:-moz-placeholder, [disabled].input:-moz-placeholder, fieldset[disabled] .select select:-moz-placeholder, .select fieldset[disabled] select:-moz-placeholder, fieldset[disabled] .textarea:-moz-placeholder, fieldset[disabled] .input:-moz-placeholder {\\n  color: rgba(122, 122, 122, 0.3);\\n}\\n.select select[disabled]:-ms-input-placeholder, [disabled].textarea:-ms-input-placeholder, [disabled].input:-ms-input-placeholder, fieldset[disabled] .select select:-ms-input-placeholder, .select fieldset[disabled] select:-ms-input-placeholder, fieldset[disabled] .textarea:-ms-input-placeholder, fieldset[disabled] .input:-ms-input-placeholder {\\n  color: rgba(122, 122, 122, 0.3);\\n}\\n\\n.textarea, .input {\\n  -webkit-box-shadow: inset 0 0.0625em 0.125em rgba(10, 10, 10, 0.05);\\n          box-shadow: inset 0 0.0625em 0.125em rgba(10, 10, 10, 0.05);\\n  max-width: 100%;\\n  width: 100%;\\n}\\n[readonly].textarea, [readonly].input {\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n}\\n.is-white.textarea, .is-white.input {\\n  border-color: hsl(0deg, 0%, 100%);\\n}\\n.is-white.textarea:focus, .is-white.input:focus, .is-white.is-focused.textarea, .is-white.is-focused.input, .is-white.textarea:active, .is-white.input:active, .is-white.is-active.textarea, .is-white.is-active.input {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(255, 255, 255, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(255, 255, 255, 0.25);\\n}\\n.is-black.textarea, .is-black.input {\\n  border-color: hsl(0deg, 0%, 4%);\\n}\\n.is-black.textarea:focus, .is-black.input:focus, .is-black.is-focused.textarea, .is-black.is-focused.input, .is-black.textarea:active, .is-black.input:active, .is-black.is-active.textarea, .is-black.is-active.input {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(10, 10, 10, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(10, 10, 10, 0.25);\\n}\\n.is-light.textarea, .is-light.input {\\n  border-color: hsl(0deg, 0%, 96%);\\n}\\n.is-light.textarea:focus, .is-light.input:focus, .is-light.is-focused.textarea, .is-light.is-focused.input, .is-light.textarea:active, .is-light.input:active, .is-light.is-active.textarea, .is-light.is-active.input {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(245, 245, 245, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(245, 245, 245, 0.25);\\n}\\n.is-dark.textarea, .is-dark.input {\\n  border-color: hsl(0deg, 0%, 21%);\\n}\\n.is-dark.textarea:focus, .is-dark.input:focus, .is-dark.is-focused.textarea, .is-dark.is-focused.input, .is-dark.textarea:active, .is-dark.input:active, .is-dark.is-active.textarea, .is-dark.is-active.input {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(54, 54, 54, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(54, 54, 54, 0.25);\\n}\\n.is-primary.textarea, .is-primary.input {\\n  border-color: hsl(171deg, 100%, 41%);\\n}\\n.is-primary.textarea:focus, .is-primary.input:focus, .is-primary.is-focused.textarea, .is-primary.is-focused.input, .is-primary.textarea:active, .is-primary.input:active, .is-primary.is-active.textarea, .is-primary.is-active.input {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(0, 209, 178, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(0, 209, 178, 0.25);\\n}\\n.is-link.textarea, .is-link.input {\\n  border-color: hsl(229deg, 53%, 53%);\\n}\\n.is-link.textarea:focus, .is-link.input:focus, .is-link.is-focused.textarea, .is-link.is-focused.input, .is-link.textarea:active, .is-link.input:active, .is-link.is-active.textarea, .is-link.is-active.input {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(72, 95, 199, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(72, 95, 199, 0.25);\\n}\\n.is-info.textarea, .is-info.input {\\n  border-color: hsl(207deg, 61%, 53%);\\n}\\n.is-info.textarea:focus, .is-info.input:focus, .is-info.is-focused.textarea, .is-info.is-focused.input, .is-info.textarea:active, .is-info.input:active, .is-info.is-active.textarea, .is-info.is-active.input {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(62, 142, 208, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(62, 142, 208, 0.25);\\n}\\n.is-success.textarea, .is-success.input {\\n  border-color: hsl(153deg, 53%, 53%);\\n}\\n.is-success.textarea:focus, .is-success.input:focus, .is-success.is-focused.textarea, .is-success.is-focused.input, .is-success.textarea:active, .is-success.input:active, .is-success.is-active.textarea, .is-success.is-active.input {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(72, 199, 142, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(72, 199, 142, 0.25);\\n}\\n.is-warning.textarea, .is-warning.input {\\n  border-color: hsl(44deg, 100%, 77%);\\n}\\n.is-warning.textarea:focus, .is-warning.input:focus, .is-warning.is-focused.textarea, .is-warning.is-focused.input, .is-warning.textarea:active, .is-warning.input:active, .is-warning.is-active.textarea, .is-warning.is-active.input {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(255, 224, 138, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(255, 224, 138, 0.25);\\n}\\n.is-danger.textarea, .is-danger.input {\\n  border-color: hsl(348deg, 86%, 61%);\\n}\\n.is-danger.textarea:focus, .is-danger.input:focus, .is-danger.is-focused.textarea, .is-danger.is-focused.input, .is-danger.textarea:active, .is-danger.input:active, .is-danger.is-active.textarea, .is-danger.is-active.input {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(241, 70, 104, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(241, 70, 104, 0.25);\\n}\\n.is-small.textarea, .is-small.input {\\n  border-radius: 2px;\\n  font-size: 0.75rem;\\n}\\n.is-medium.textarea, .is-medium.input {\\n  font-size: 1.25rem;\\n}\\n.is-large.textarea, .is-large.input {\\n  font-size: 1.5rem;\\n}\\n.is-fullwidth.textarea, .is-fullwidth.input {\\n  display: block;\\n  width: 100%;\\n}\\n.is-inline.textarea, .is-inline.input {\\n  display: inline;\\n  width: auto;\\n}\\n\\n.input.is-rounded {\\n  border-radius: 9999px;\\n  padding-left: calc(calc(0.75em - 1px) + 0.375em);\\n  padding-right: calc(calc(0.75em - 1px) + 0.375em);\\n}\\n.input.is-static {\\n  background-color: transparent;\\n  border-color: transparent;\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  padding-left: 0;\\n  padding-right: 0;\\n}\\n\\n.textarea {\\n  display: block;\\n  max-width: 100%;\\n  min-width: 100%;\\n  padding: calc(0.75em - 1px);\\n  resize: vertical;\\n}\\n.textarea:not([rows]) {\\n  max-height: 40em;\\n  min-height: 8em;\\n}\\n.textarea[rows] {\\n  height: initial;\\n}\\n.textarea.has-fixed-size {\\n  resize: none;\\n}\\n\\n.radio, .checkbox {\\n  cursor: pointer;\\n  display: inline-block;\\n  line-height: 1.25;\\n  position: relative;\\n}\\n.radio input, .checkbox input {\\n  cursor: pointer;\\n}\\n.radio:hover, .checkbox:hover {\\n  color: hsl(0deg, 0%, 21%);\\n}\\n[disabled].radio, [disabled].checkbox, fieldset[disabled] .radio, fieldset[disabled] .checkbox,\\n.radio input[disabled],\\n.checkbox input[disabled] {\\n  color: hsl(0deg, 0%, 48%);\\n  cursor: not-allowed;\\n}\\n\\n.radio + .radio {\\n  margin-left: 0.5em;\\n}\\n\\n.select {\\n  display: inline-block;\\n  max-width: 100%;\\n  position: relative;\\n  vertical-align: top;\\n}\\n.select:not(.is-multiple) {\\n  height: 2.5em;\\n}\\n.select:not(.is-multiple):not(.is-loading)::after {\\n  border-color: hsl(229deg, 53%, 53%);\\n  right: 1.125em;\\n  z-index: 4;\\n}\\n.select.is-rounded select {\\n  border-radius: 9999px;\\n  padding-left: 1em;\\n}\\n.select select {\\n  cursor: pointer;\\n  display: block;\\n  font-size: 1em;\\n  max-width: 100%;\\n  outline: none;\\n}\\n.select select::-ms-expand {\\n  display: none;\\n}\\n.select select[disabled]:hover, fieldset[disabled] .select select:hover {\\n  border-color: hsl(0deg, 0%, 96%);\\n}\\n.select select:not([multiple]) {\\n  padding-right: 2.5em;\\n}\\n.select select[multiple] {\\n  height: auto;\\n  padding: 0;\\n}\\n.select select[multiple] option {\\n  padding: 0.5em 1em;\\n}\\n.select:not(.is-multiple):not(.is-loading):hover::after {\\n  border-color: hsl(0deg, 0%, 21%);\\n}\\n.select.is-white:not(:hover)::after {\\n  border-color: hsl(0deg, 0%, 100%);\\n}\\n.select.is-white select {\\n  border-color: hsl(0deg, 0%, 100%);\\n}\\n.select.is-white select:hover, .select.is-white select.is-hovered {\\n  border-color: #f2f2f2;\\n}\\n.select.is-white select:focus, .select.is-white select.is-focused, .select.is-white select:active, .select.is-white select.is-active {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(255, 255, 255, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(255, 255, 255, 0.25);\\n}\\n.select.is-black:not(:hover)::after {\\n  border-color: hsl(0deg, 0%, 4%);\\n}\\n.select.is-black select {\\n  border-color: hsl(0deg, 0%, 4%);\\n}\\n.select.is-black select:hover, .select.is-black select.is-hovered {\\n  border-color: black;\\n}\\n.select.is-black select:focus, .select.is-black select.is-focused, .select.is-black select:active, .select.is-black select.is-active {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(10, 10, 10, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(10, 10, 10, 0.25);\\n}\\n.select.is-light:not(:hover)::after {\\n  border-color: hsl(0deg, 0%, 96%);\\n}\\n.select.is-light select {\\n  border-color: hsl(0deg, 0%, 96%);\\n}\\n.select.is-light select:hover, .select.is-light select.is-hovered {\\n  border-color: #e8e8e8;\\n}\\n.select.is-light select:focus, .select.is-light select.is-focused, .select.is-light select:active, .select.is-light select.is-active {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(245, 245, 245, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(245, 245, 245, 0.25);\\n}\\n.select.is-dark:not(:hover)::after {\\n  border-color: hsl(0deg, 0%, 21%);\\n}\\n.select.is-dark select {\\n  border-color: hsl(0deg, 0%, 21%);\\n}\\n.select.is-dark select:hover, .select.is-dark select.is-hovered {\\n  border-color: #292929;\\n}\\n.select.is-dark select:focus, .select.is-dark select.is-focused, .select.is-dark select:active, .select.is-dark select.is-active {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(54, 54, 54, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(54, 54, 54, 0.25);\\n}\\n.select.is-primary:not(:hover)::after {\\n  border-color: hsl(171deg, 100%, 41%);\\n}\\n.select.is-primary select {\\n  border-color: hsl(171deg, 100%, 41%);\\n}\\n.select.is-primary select:hover, .select.is-primary select.is-hovered {\\n  border-color: #00b89c;\\n}\\n.select.is-primary select:focus, .select.is-primary select.is-focused, .select.is-primary select:active, .select.is-primary select.is-active {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(0, 209, 178, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(0, 209, 178, 0.25);\\n}\\n.select.is-link:not(:hover)::after {\\n  border-color: hsl(229deg, 53%, 53%);\\n}\\n.select.is-link select {\\n  border-color: hsl(229deg, 53%, 53%);\\n}\\n.select.is-link select:hover, .select.is-link select.is-hovered {\\n  border-color: #3a51bb;\\n}\\n.select.is-link select:focus, .select.is-link select.is-focused, .select.is-link select:active, .select.is-link select.is-active {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(72, 95, 199, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(72, 95, 199, 0.25);\\n}\\n.select.is-info:not(:hover)::after {\\n  border-color: hsl(207deg, 61%, 53%);\\n}\\n.select.is-info select {\\n  border-color: hsl(207deg, 61%, 53%);\\n}\\n.select.is-info select:hover, .select.is-info select.is-hovered {\\n  border-color: #3082c5;\\n}\\n.select.is-info select:focus, .select.is-info select.is-focused, .select.is-info select:active, .select.is-info select.is-active {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(62, 142, 208, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(62, 142, 208, 0.25);\\n}\\n.select.is-success:not(:hover)::after {\\n  border-color: hsl(153deg, 53%, 53%);\\n}\\n.select.is-success select {\\n  border-color: hsl(153deg, 53%, 53%);\\n}\\n.select.is-success select:hover, .select.is-success select.is-hovered {\\n  border-color: #3abb81;\\n}\\n.select.is-success select:focus, .select.is-success select.is-focused, .select.is-success select:active, .select.is-success select.is-active {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(72, 199, 142, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(72, 199, 142, 0.25);\\n}\\n.select.is-warning:not(:hover)::after {\\n  border-color: hsl(44deg, 100%, 77%);\\n}\\n.select.is-warning select {\\n  border-color: hsl(44deg, 100%, 77%);\\n}\\n.select.is-warning select:hover, .select.is-warning select.is-hovered {\\n  border-color: #ffd970;\\n}\\n.select.is-warning select:focus, .select.is-warning select.is-focused, .select.is-warning select:active, .select.is-warning select.is-active {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(255, 224, 138, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(255, 224, 138, 0.25);\\n}\\n.select.is-danger:not(:hover)::after {\\n  border-color: hsl(348deg, 86%, 61%);\\n}\\n.select.is-danger select {\\n  border-color: hsl(348deg, 86%, 61%);\\n}\\n.select.is-danger select:hover, .select.is-danger select.is-hovered {\\n  border-color: #ef2e55;\\n}\\n.select.is-danger select:focus, .select.is-danger select.is-focused, .select.is-danger select:active, .select.is-danger select.is-active {\\n  -webkit-box-shadow: 0 0 0 0.125em rgba(241, 70, 104, 0.25);\\n          box-shadow: 0 0 0 0.125em rgba(241, 70, 104, 0.25);\\n}\\n.select.is-small {\\n  border-radius: 2px;\\n  font-size: 0.75rem;\\n}\\n.select.is-medium {\\n  font-size: 1.25rem;\\n}\\n.select.is-large {\\n  font-size: 1.5rem;\\n}\\n.select.is-disabled::after {\\n  border-color: hsl(0deg, 0%, 48%);\\n}\\n.select.is-fullwidth {\\n  width: 100%;\\n}\\n.select.is-fullwidth select {\\n  width: 100%;\\n}\\n.select.is-loading::after {\\n  margin-top: 0;\\n  position: absolute;\\n  right: 0.625em;\\n  top: 0.625em;\\n  -webkit-transform: none;\\n          transform: none;\\n}\\n.select.is-loading.is-small:after {\\n  font-size: 0.75rem;\\n}\\n.select.is-loading.is-medium:after {\\n  font-size: 1.25rem;\\n}\\n.select.is-loading.is-large:after {\\n  font-size: 1.5rem;\\n}\\n\\n.file {\\n  -webkit-box-align: stretch;\\n      -ms-flex-align: stretch;\\n          align-items: stretch;\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n  -webkit-box-pack: start;\\n      -ms-flex-pack: start;\\n          justify-content: flex-start;\\n  position: relative;\\n}\\n.file.is-white .file-cta {\\n  background-color: hsl(0deg, 0%, 100%);\\n  border-color: transparent;\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.file.is-white:hover .file-cta, .file.is-white.is-hovered .file-cta {\\n  background-color: #f9f9f9;\\n  border-color: transparent;\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.file.is-white:focus .file-cta, .file.is-white.is-focused .file-cta {\\n  border-color: transparent;\\n  -webkit-box-shadow: 0 0 0.5em rgba(255, 255, 255, 0.25);\\n          box-shadow: 0 0 0.5em rgba(255, 255, 255, 0.25);\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.file.is-white:active .file-cta, .file.is-white.is-active .file-cta {\\n  background-color: #f2f2f2;\\n  border-color: transparent;\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.file.is-black .file-cta {\\n  background-color: hsl(0deg, 0%, 4%);\\n  border-color: transparent;\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.file.is-black:hover .file-cta, .file.is-black.is-hovered .file-cta {\\n  background-color: #040404;\\n  border-color: transparent;\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.file.is-black:focus .file-cta, .file.is-black.is-focused .file-cta {\\n  border-color: transparent;\\n  -webkit-box-shadow: 0 0 0.5em rgba(10, 10, 10, 0.25);\\n          box-shadow: 0 0 0.5em rgba(10, 10, 10, 0.25);\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.file.is-black:active .file-cta, .file.is-black.is-active .file-cta {\\n  background-color: black;\\n  border-color: transparent;\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.file.is-light .file-cta {\\n  background-color: hsl(0deg, 0%, 96%);\\n  border-color: transparent;\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.file.is-light:hover .file-cta, .file.is-light.is-hovered .file-cta {\\n  background-color: #eeeeee;\\n  border-color: transparent;\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.file.is-light:focus .file-cta, .file.is-light.is-focused .file-cta {\\n  border-color: transparent;\\n  -webkit-box-shadow: 0 0 0.5em rgba(245, 245, 245, 0.25);\\n          box-shadow: 0 0 0.5em rgba(245, 245, 245, 0.25);\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.file.is-light:active .file-cta, .file.is-light.is-active .file-cta {\\n  background-color: #e8e8e8;\\n  border-color: transparent;\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.file.is-dark .file-cta {\\n  background-color: hsl(0deg, 0%, 21%);\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.file.is-dark:hover .file-cta, .file.is-dark.is-hovered .file-cta {\\n  background-color: #2f2f2f;\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.file.is-dark:focus .file-cta, .file.is-dark.is-focused .file-cta {\\n  border-color: transparent;\\n  -webkit-box-shadow: 0 0 0.5em rgba(54, 54, 54, 0.25);\\n          box-shadow: 0 0 0.5em rgba(54, 54, 54, 0.25);\\n  color: #fff;\\n}\\n.file.is-dark:active .file-cta, .file.is-dark.is-active .file-cta {\\n  background-color: #292929;\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.file.is-primary .file-cta {\\n  background-color: hsl(171deg, 100%, 41%);\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.file.is-primary:hover .file-cta, .file.is-primary.is-hovered .file-cta {\\n  background-color: #00c4a7;\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.file.is-primary:focus .file-cta, .file.is-primary.is-focused .file-cta {\\n  border-color: transparent;\\n  -webkit-box-shadow: 0 0 0.5em rgba(0, 209, 178, 0.25);\\n          box-shadow: 0 0 0.5em rgba(0, 209, 178, 0.25);\\n  color: #fff;\\n}\\n.file.is-primary:active .file-cta, .file.is-primary.is-active .file-cta {\\n  background-color: #00b89c;\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.file.is-link .file-cta {\\n  background-color: hsl(229deg, 53%, 53%);\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.file.is-link:hover .file-cta, .file.is-link.is-hovered .file-cta {\\n  background-color: #3e56c4;\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.file.is-link:focus .file-cta, .file.is-link.is-focused .file-cta {\\n  border-color: transparent;\\n  -webkit-box-shadow: 0 0 0.5em rgba(72, 95, 199, 0.25);\\n          box-shadow: 0 0 0.5em rgba(72, 95, 199, 0.25);\\n  color: #fff;\\n}\\n.file.is-link:active .file-cta, .file.is-link.is-active .file-cta {\\n  background-color: #3a51bb;\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.file.is-info .file-cta {\\n  background-color: hsl(207deg, 61%, 53%);\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.file.is-info:hover .file-cta, .file.is-info.is-hovered .file-cta {\\n  background-color: #3488ce;\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.file.is-info:focus .file-cta, .file.is-info.is-focused .file-cta {\\n  border-color: transparent;\\n  -webkit-box-shadow: 0 0 0.5em rgba(62, 142, 208, 0.25);\\n          box-shadow: 0 0 0.5em rgba(62, 142, 208, 0.25);\\n  color: #fff;\\n}\\n.file.is-info:active .file-cta, .file.is-info.is-active .file-cta {\\n  background-color: #3082c5;\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.file.is-success .file-cta {\\n  background-color: hsl(153deg, 53%, 53%);\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.file.is-success:hover .file-cta, .file.is-success.is-hovered .file-cta {\\n  background-color: #3ec487;\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.file.is-success:focus .file-cta, .file.is-success.is-focused .file-cta {\\n  border-color: transparent;\\n  -webkit-box-shadow: 0 0 0.5em rgba(72, 199, 142, 0.25);\\n          box-shadow: 0 0 0.5em rgba(72, 199, 142, 0.25);\\n  color: #fff;\\n}\\n.file.is-success:active .file-cta, .file.is-success.is-active .file-cta {\\n  background-color: #3abb81;\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.file.is-warning .file-cta {\\n  background-color: hsl(44deg, 100%, 77%);\\n  border-color: transparent;\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.file.is-warning:hover .file-cta, .file.is-warning.is-hovered .file-cta {\\n  background-color: #ffdc7d;\\n  border-color: transparent;\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.file.is-warning:focus .file-cta, .file.is-warning.is-focused .file-cta {\\n  border-color: transparent;\\n  -webkit-box-shadow: 0 0 0.5em rgba(255, 224, 138, 0.25);\\n          box-shadow: 0 0 0.5em rgba(255, 224, 138, 0.25);\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.file.is-warning:active .file-cta, .file.is-warning.is-active .file-cta {\\n  background-color: #ffd970;\\n  border-color: transparent;\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.file.is-danger .file-cta {\\n  background-color: hsl(348deg, 86%, 61%);\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.file.is-danger:hover .file-cta, .file.is-danger.is-hovered .file-cta {\\n  background-color: #f03a5f;\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.file.is-danger:focus .file-cta, .file.is-danger.is-focused .file-cta {\\n  border-color: transparent;\\n  -webkit-box-shadow: 0 0 0.5em rgba(241, 70, 104, 0.25);\\n          box-shadow: 0 0 0.5em rgba(241, 70, 104, 0.25);\\n  color: #fff;\\n}\\n.file.is-danger:active .file-cta, .file.is-danger.is-active .file-cta {\\n  background-color: #ef2e55;\\n  border-color: transparent;\\n  color: #fff;\\n}\\n.file.is-small {\\n  font-size: 0.75rem;\\n}\\n.file.is-normal {\\n  font-size: 1rem;\\n}\\n.file.is-medium {\\n  font-size: 1.25rem;\\n}\\n.file.is-medium .file-icon .fa {\\n  font-size: 21px;\\n}\\n.file.is-large {\\n  font-size: 1.5rem;\\n}\\n.file.is-large .file-icon .fa {\\n  font-size: 28px;\\n}\\n.file.has-name .file-cta {\\n  border-bottom-right-radius: 0;\\n  border-top-right-radius: 0;\\n}\\n.file.has-name .file-name {\\n  border-bottom-left-radius: 0;\\n  border-top-left-radius: 0;\\n}\\n.file.has-name.is-empty .file-cta {\\n  border-radius: 4px;\\n}\\n.file.has-name.is-empty .file-name {\\n  display: none;\\n}\\n.file.is-boxed .file-label {\\n  -webkit-box-orient: vertical;\\n  -webkit-box-direction: normal;\\n      -ms-flex-direction: column;\\n          flex-direction: column;\\n}\\n.file.is-boxed .file-cta {\\n  -webkit-box-orient: vertical;\\n  -webkit-box-direction: normal;\\n      -ms-flex-direction: column;\\n          flex-direction: column;\\n  height: auto;\\n  padding: 1em 3em;\\n}\\n.file.is-boxed .file-name {\\n  border-width: 0 1px 1px;\\n}\\n.file.is-boxed .file-icon {\\n  height: 1.5em;\\n  width: 1.5em;\\n}\\n.file.is-boxed .file-icon .fa {\\n  font-size: 21px;\\n}\\n.file.is-boxed.is-small .file-icon .fa {\\n  font-size: 14px;\\n}\\n.file.is-boxed.is-medium .file-icon .fa {\\n  font-size: 28px;\\n}\\n.file.is-boxed.is-large .file-icon .fa {\\n  font-size: 35px;\\n}\\n.file.is-boxed.has-name .file-cta {\\n  border-radius: 4px 4px 0 0;\\n}\\n.file.is-boxed.has-name .file-name {\\n  border-radius: 0 0 4px 4px;\\n  border-width: 0 1px 1px;\\n}\\n.file.is-centered {\\n  -webkit-box-pack: center;\\n      -ms-flex-pack: center;\\n          justify-content: center;\\n}\\n.file.is-fullwidth .file-label {\\n  width: 100%;\\n}\\n.file.is-fullwidth .file-name {\\n  -webkit-box-flex: 1;\\n      -ms-flex-positive: 1;\\n          flex-grow: 1;\\n  max-width: none;\\n}\\n.file.is-right {\\n  -webkit-box-pack: end;\\n      -ms-flex-pack: end;\\n          justify-content: flex-end;\\n}\\n.file.is-right .file-cta {\\n  border-radius: 0 4px 4px 0;\\n}\\n.file.is-right .file-name {\\n  border-radius: 4px 0 0 4px;\\n  border-width: 1px 0 1px 1px;\\n  -webkit-box-ordinal-group: 0;\\n      -ms-flex-order: -1;\\n          order: -1;\\n}\\n\\n.file-label {\\n  -webkit-box-align: stretch;\\n      -ms-flex-align: stretch;\\n          align-items: stretch;\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n  cursor: pointer;\\n  -webkit-box-pack: start;\\n      -ms-flex-pack: start;\\n          justify-content: flex-start;\\n  overflow: hidden;\\n  position: relative;\\n}\\n.file-label:hover .file-cta {\\n  background-color: #eeeeee;\\n  color: hsl(0deg, 0%, 21%);\\n}\\n.file-label:hover .file-name {\\n  border-color: #d5d5d5;\\n}\\n.file-label:active .file-cta {\\n  background-color: #e8e8e8;\\n  color: hsl(0deg, 0%, 21%);\\n}\\n.file-label:active .file-name {\\n  border-color: #cfcfcf;\\n}\\n\\n.file-input {\\n  height: 100%;\\n  left: 0;\\n  opacity: 0;\\n  outline: none;\\n  position: absolute;\\n  top: 0;\\n  width: 100%;\\n}\\n\\n.file-cta,\\n.file-name {\\n  border-color: hsl(0deg, 0%, 86%);\\n  border-radius: 4px;\\n  font-size: 1em;\\n  padding-left: 1em;\\n  padding-right: 1em;\\n  white-space: nowrap;\\n}\\n\\n.file-cta {\\n  background-color: hsl(0deg, 0%, 96%);\\n  color: hsl(0deg, 0%, 29%);\\n}\\n\\n.file-name {\\n  border-color: hsl(0deg, 0%, 86%);\\n  border-style: solid;\\n  border-width: 1px 1px 1px 0;\\n  display: block;\\n  max-width: 16em;\\n  overflow: hidden;\\n  text-align: inherit;\\n  text-overflow: ellipsis;\\n}\\n\\n.file-icon {\\n  -webkit-box-align: center;\\n      -ms-flex-align: center;\\n          align-items: center;\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n  height: 1em;\\n  -webkit-box-pack: center;\\n      -ms-flex-pack: center;\\n          justify-content: center;\\n  margin-right: 0.5em;\\n  width: 1em;\\n}\\n.file-icon .fa {\\n  font-size: 14px;\\n}\\n\\n.label {\\n  color: hsl(0deg, 0%, 21%);\\n  display: block;\\n  font-size: 1rem;\\n  font-weight: 700;\\n}\\n.label:not(:last-child) {\\n  margin-bottom: 0.5em;\\n}\\n.label.is-small {\\n  font-size: 0.75rem;\\n}\\n.label.is-medium {\\n  font-size: 1.25rem;\\n}\\n.label.is-large {\\n  font-size: 1.5rem;\\n}\\n\\n.help {\\n  display: block;\\n  font-size: 0.75rem;\\n  margin-top: 0.25rem;\\n}\\n.help.is-white {\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.help.is-black {\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.help.is-light {\\n  color: hsl(0deg, 0%, 96%);\\n}\\n.help.is-dark {\\n  color: hsl(0deg, 0%, 21%);\\n}\\n.help.is-primary {\\n  color: hsl(171deg, 100%, 41%);\\n}\\n.help.is-link {\\n  color: hsl(229deg, 53%, 53%);\\n}\\n.help.is-info {\\n  color: hsl(207deg, 61%, 53%);\\n}\\n.help.is-success {\\n  color: hsl(153deg, 53%, 53%);\\n}\\n.help.is-warning {\\n  color: hsl(44deg, 100%, 77%);\\n}\\n.help.is-danger {\\n  color: hsl(348deg, 86%, 61%);\\n}\\n\\n.field:not(:last-child) {\\n  margin-bottom: 0.75rem;\\n}\\n.field.has-addons {\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n  -webkit-box-pack: start;\\n      -ms-flex-pack: start;\\n          justify-content: flex-start;\\n}\\n.field.has-addons .control:not(:last-child) {\\n  margin-right: -1px;\\n}\\n.field.has-addons .control:not(:first-child):not(:last-child) .button,\\n.field.has-addons .control:not(:first-child):not(:last-child) .input,\\n.field.has-addons .control:not(:first-child):not(:last-child) .select select {\\n  border-radius: 0;\\n}\\n.field.has-addons .control:first-child:not(:only-child) .button,\\n.field.has-addons .control:first-child:not(:only-child) .input,\\n.field.has-addons .control:first-child:not(:only-child) .select select {\\n  border-bottom-right-radius: 0;\\n  border-top-right-radius: 0;\\n}\\n.field.has-addons .control:last-child:not(:only-child) .button,\\n.field.has-addons .control:last-child:not(:only-child) .input,\\n.field.has-addons .control:last-child:not(:only-child) .select select {\\n  border-bottom-left-radius: 0;\\n  border-top-left-radius: 0;\\n}\\n.field.has-addons .control .button:not([disabled]):hover, .field.has-addons .control .button:not([disabled]).is-hovered,\\n.field.has-addons .control .input:not([disabled]):hover,\\n.field.has-addons .control .input:not([disabled]).is-hovered,\\n.field.has-addons .control .select select:not([disabled]):hover,\\n.field.has-addons .control .select select:not([disabled]).is-hovered {\\n  z-index: 2;\\n}\\n.field.has-addons .control .button:not([disabled]):focus, .field.has-addons .control .button:not([disabled]).is-focused, .field.has-addons .control .button:not([disabled]):active, .field.has-addons .control .button:not([disabled]).is-active,\\n.field.has-addons .control .input:not([disabled]):focus,\\n.field.has-addons .control .input:not([disabled]).is-focused,\\n.field.has-addons .control .input:not([disabled]):active,\\n.field.has-addons .control .input:not([disabled]).is-active,\\n.field.has-addons .control .select select:not([disabled]):focus,\\n.field.has-addons .control .select select:not([disabled]).is-focused,\\n.field.has-addons .control .select select:not([disabled]):active,\\n.field.has-addons .control .select select:not([disabled]).is-active {\\n  z-index: 3;\\n}\\n.field.has-addons .control .button:not([disabled]):focus:hover, .field.has-addons .control .button:not([disabled]).is-focused:hover, .field.has-addons .control .button:not([disabled]):active:hover, .field.has-addons .control .button:not([disabled]).is-active:hover,\\n.field.has-addons .control .input:not([disabled]):focus:hover,\\n.field.has-addons .control .input:not([disabled]).is-focused:hover,\\n.field.has-addons .control .input:not([disabled]):active:hover,\\n.field.has-addons .control .input:not([disabled]).is-active:hover,\\n.field.has-addons .control .select select:not([disabled]):focus:hover,\\n.field.has-addons .control .select select:not([disabled]).is-focused:hover,\\n.field.has-addons .control .select select:not([disabled]):active:hover,\\n.field.has-addons .control .select select:not([disabled]).is-active:hover {\\n  z-index: 4;\\n}\\n.field.has-addons .control.is-expanded {\\n  -webkit-box-flex: 1;\\n      -ms-flex-positive: 1;\\n          flex-grow: 1;\\n  -ms-flex-negative: 1;\\n      flex-shrink: 1;\\n}\\n.field.has-addons.has-addons-centered {\\n  -webkit-box-pack: center;\\n      -ms-flex-pack: center;\\n          justify-content: center;\\n}\\n.field.has-addons.has-addons-right {\\n  -webkit-box-pack: end;\\n      -ms-flex-pack: end;\\n          justify-content: flex-end;\\n}\\n.field.has-addons.has-addons-fullwidth .control {\\n  -webkit-box-flex: 1;\\n      -ms-flex-positive: 1;\\n          flex-grow: 1;\\n  -ms-flex-negative: 0;\\n      flex-shrink: 0;\\n}\\n.field.is-grouped {\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n  -webkit-box-pack: start;\\n      -ms-flex-pack: start;\\n          justify-content: flex-start;\\n}\\n.field.is-grouped > .control {\\n  -ms-flex-negative: 0;\\n      flex-shrink: 0;\\n}\\n.field.is-grouped > .control:not(:last-child) {\\n  margin-bottom: 0;\\n  margin-right: 0.75rem;\\n}\\n.field.is-grouped > .control.is-expanded {\\n  -webkit-box-flex: 1;\\n      -ms-flex-positive: 1;\\n          flex-grow: 1;\\n  -ms-flex-negative: 1;\\n      flex-shrink: 1;\\n}\\n.field.is-grouped.is-grouped-centered {\\n  -webkit-box-pack: center;\\n      -ms-flex-pack: center;\\n          justify-content: center;\\n}\\n.field.is-grouped.is-grouped-right {\\n  -webkit-box-pack: end;\\n      -ms-flex-pack: end;\\n          justify-content: flex-end;\\n}\\n.field.is-grouped.is-grouped-multiline {\\n  -ms-flex-wrap: wrap;\\n      flex-wrap: wrap;\\n}\\n.field.is-grouped.is-grouped-multiline > .control:last-child, .field.is-grouped.is-grouped-multiline > .control:not(:last-child) {\\n  margin-bottom: 0.75rem;\\n}\\n.field.is-grouped.is-grouped-multiline:last-child {\\n  margin-bottom: -0.75rem;\\n}\\n.field.is-grouped.is-grouped-multiline:not(:last-child) {\\n  margin-bottom: 0;\\n}\\n@media screen and (min-width: 769px), print {\\n  .field.is-horizontal {\\n    display: -webkit-box;\\n    display: -ms-flexbox;\\n    display: flex;\\n  }\\n}\\n\\n.field-label .label {\\n  font-size: inherit;\\n}\\n@media screen and (max-width: 768px) {\\n  .field-label {\\n    margin-bottom: 0.5rem;\\n  }\\n}\\n@media screen and (min-width: 769px), print {\\n  .field-label {\\n    -ms-flex-preferred-size: 0;\\n        flex-basis: 0;\\n    -webkit-box-flex: 1;\\n        -ms-flex-positive: 1;\\n            flex-grow: 1;\\n    -ms-flex-negative: 0;\\n        flex-shrink: 0;\\n    margin-right: 1.5rem;\\n    text-align: right;\\n  }\\n  .field-label.is-small {\\n    font-size: 0.75rem;\\n    padding-top: 0.375em;\\n  }\\n  .field-label.is-normal {\\n    padding-top: 0.375em;\\n  }\\n  .field-label.is-medium {\\n    font-size: 1.25rem;\\n    padding-top: 0.375em;\\n  }\\n  .field-label.is-large {\\n    font-size: 1.5rem;\\n    padding-top: 0.375em;\\n  }\\n}\\n\\n.field-body .field .field {\\n  margin-bottom: 0;\\n}\\n@media screen and (min-width: 769px), print {\\n  .field-body {\\n    display: -webkit-box;\\n    display: -ms-flexbox;\\n    display: flex;\\n    -ms-flex-preferred-size: 0;\\n        flex-basis: 0;\\n    -webkit-box-flex: 5;\\n        -ms-flex-positive: 5;\\n            flex-grow: 5;\\n    -ms-flex-negative: 1;\\n        flex-shrink: 1;\\n  }\\n  .field-body .field {\\n    margin-bottom: 0;\\n  }\\n  .field-body > .field {\\n    -ms-flex-negative: 1;\\n        flex-shrink: 1;\\n  }\\n  .field-body > .field:not(.is-narrow) {\\n    -webkit-box-flex: 1;\\n        -ms-flex-positive: 1;\\n            flex-grow: 1;\\n  }\\n  .field-body > .field:not(:last-child) {\\n    margin-right: 0.75rem;\\n  }\\n}\\n\\n.control {\\n  -webkit-box-sizing: border-box;\\n          box-sizing: border-box;\\n  clear: both;\\n  font-size: 1rem;\\n  position: relative;\\n  text-align: inherit;\\n}\\n.control.has-icons-left .input:focus ~ .icon,\\n.control.has-icons-left .select:focus ~ .icon, .control.has-icons-right .input:focus ~ .icon,\\n.control.has-icons-right .select:focus ~ .icon {\\n  color: hsl(0deg, 0%, 29%);\\n}\\n.control.has-icons-left .input.is-small ~ .icon,\\n.control.has-icons-left .select.is-small ~ .icon, .control.has-icons-right .input.is-small ~ .icon,\\n.control.has-icons-right .select.is-small ~ .icon {\\n  font-size: 0.75rem;\\n}\\n.control.has-icons-left .input.is-medium ~ .icon,\\n.control.has-icons-left .select.is-medium ~ .icon, .control.has-icons-right .input.is-medium ~ .icon,\\n.control.has-icons-right .select.is-medium ~ .icon {\\n  font-size: 1.25rem;\\n}\\n.control.has-icons-left .input.is-large ~ .icon,\\n.control.has-icons-left .select.is-large ~ .icon, .control.has-icons-right .input.is-large ~ .icon,\\n.control.has-icons-right .select.is-large ~ .icon {\\n  font-size: 1.5rem;\\n}\\n.control.has-icons-left .icon, .control.has-icons-right .icon {\\n  color: hsl(0deg, 0%, 86%);\\n  height: 2.5em;\\n  pointer-events: none;\\n  position: absolute;\\n  top: 0;\\n  width: 2.5em;\\n  z-index: 4;\\n}\\n.control.has-icons-left .input,\\n.control.has-icons-left .select select {\\n  padding-left: 2.5em;\\n}\\n.control.has-icons-left .icon.is-left {\\n  left: 0;\\n}\\n.control.has-icons-right .input,\\n.control.has-icons-right .select select {\\n  padding-right: 2.5em;\\n}\\n.control.has-icons-right .icon.is-right {\\n  right: 0;\\n}\\n.control.is-loading::after {\\n  position: absolute !important;\\n  right: 0.625em;\\n  top: 0.625em;\\n  z-index: 4;\\n}\\n.control.is-loading.is-small:after {\\n  font-size: 0.75rem;\\n}\\n.control.is-loading.is-medium:after {\\n  font-size: 1.25rem;\\n}\\n.control.is-loading.is-large:after {\\n  font-size: 1.5rem;\\n}\\n\\n/* Bulma Components */\\n.breadcrumb {\\n  font-size: 1rem;\\n  white-space: nowrap;\\n}\\n.breadcrumb a {\\n  -webkit-box-align: center;\\n      -ms-flex-align: center;\\n          align-items: center;\\n  color: hsl(229deg, 53%, 53%);\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n  -webkit-box-pack: center;\\n      -ms-flex-pack: center;\\n          justify-content: center;\\n  padding: 0 0.75em;\\n}\\n.breadcrumb a:hover {\\n  color: hsl(0deg, 0%, 21%);\\n}\\n.breadcrumb li {\\n  -webkit-box-align: center;\\n      -ms-flex-align: center;\\n          align-items: center;\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n}\\n.breadcrumb li:first-child a {\\n  padding-left: 0;\\n}\\n.breadcrumb li.is-active a {\\n  color: hsl(0deg, 0%, 21%);\\n  cursor: default;\\n  pointer-events: none;\\n}\\n.breadcrumb li + li::before {\\n  color: hsl(0deg, 0%, 71%);\\n  content: \\\"/\\\";\\n}\\n.breadcrumb ul,\\n.breadcrumb ol {\\n  -webkit-box-align: start;\\n      -ms-flex-align: start;\\n          align-items: flex-start;\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n  -ms-flex-wrap: wrap;\\n      flex-wrap: wrap;\\n  -webkit-box-pack: start;\\n      -ms-flex-pack: start;\\n          justify-content: flex-start;\\n}\\n.breadcrumb .icon:first-child {\\n  margin-right: 0.5em;\\n}\\n.breadcrumb .icon:last-child {\\n  margin-left: 0.5em;\\n}\\n.breadcrumb.is-centered ol,\\n.breadcrumb.is-centered ul {\\n  -webkit-box-pack: center;\\n      -ms-flex-pack: center;\\n          justify-content: center;\\n}\\n.breadcrumb.is-right ol,\\n.breadcrumb.is-right ul {\\n  -webkit-box-pack: end;\\n      -ms-flex-pack: end;\\n          justify-content: flex-end;\\n}\\n.breadcrumb.is-small {\\n  font-size: 0.75rem;\\n}\\n.breadcrumb.is-medium {\\n  font-size: 1.25rem;\\n}\\n.breadcrumb.is-large {\\n  font-size: 1.5rem;\\n}\\n.breadcrumb.has-arrow-separator li + li::before {\\n  content: \\\"→\\\";\\n}\\n.breadcrumb.has-bullet-separator li + li::before {\\n  content: \\\"•\\\";\\n}\\n.breadcrumb.has-dot-separator li + li::before {\\n  content: \\\"·\\\";\\n}\\n.breadcrumb.has-succeeds-separator li + li::before {\\n  content: \\\"≻\\\";\\n}\\n\\n.card {\\n  background-color: hsl(0deg, 0%, 100%);\\n  border-radius: 0.25rem;\\n  -webkit-box-shadow: 0 0.5em 1em -0.125em rgba(10, 10, 10, 0.1), 0 0px 0 1px rgba(10, 10, 10, 0.02);\\n          box-shadow: 0 0.5em 1em -0.125em rgba(10, 10, 10, 0.1), 0 0px 0 1px rgba(10, 10, 10, 0.02);\\n  color: hsl(0deg, 0%, 29%);\\n  max-width: 100%;\\n  position: relative;\\n}\\n\\n.card-footer:first-child, .card-content:first-child, .card-header:first-child {\\n  border-top-left-radius: 0.25rem;\\n  border-top-right-radius: 0.25rem;\\n}\\n.card-footer:last-child, .card-content:last-child, .card-header:last-child {\\n  border-bottom-left-radius: 0.25rem;\\n  border-bottom-right-radius: 0.25rem;\\n}\\n\\n.card-header {\\n  background-color: transparent;\\n  -webkit-box-align: stretch;\\n      -ms-flex-align: stretch;\\n          align-items: stretch;\\n  -webkit-box-shadow: 0 0.125em 0.25em rgba(10, 10, 10, 0.1);\\n          box-shadow: 0 0.125em 0.25em rgba(10, 10, 10, 0.1);\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n}\\n\\n.card-header-title {\\n  -webkit-box-align: center;\\n      -ms-flex-align: center;\\n          align-items: center;\\n  color: hsl(0deg, 0%, 21%);\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n  -webkit-box-flex: 1;\\n      -ms-flex-positive: 1;\\n          flex-grow: 1;\\n  font-weight: 700;\\n  padding: 0.75rem 1rem;\\n}\\n.card-header-title.is-centered {\\n  -webkit-box-pack: center;\\n      -ms-flex-pack: center;\\n          justify-content: center;\\n}\\n\\n.card-header-icon {\\n  -moz-appearance: none;\\n  -webkit-appearance: none;\\n  appearance: none;\\n  background: none;\\n  border: none;\\n  color: currentColor;\\n  font-family: inherit;\\n  font-size: 1em;\\n  margin: 0;\\n  padding: 0;\\n  -webkit-box-align: center;\\n      -ms-flex-align: center;\\n          align-items: center;\\n  cursor: pointer;\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n  -webkit-box-pack: center;\\n      -ms-flex-pack: center;\\n          justify-content: center;\\n  padding: 0.75rem 1rem;\\n}\\n\\n.card-image {\\n  display: block;\\n  position: relative;\\n}\\n.card-image:first-child img {\\n  border-top-left-radius: 0.25rem;\\n  border-top-right-radius: 0.25rem;\\n}\\n.card-image:last-child img {\\n  border-bottom-left-radius: 0.25rem;\\n  border-bottom-right-radius: 0.25rem;\\n}\\n\\n.card-content {\\n  background-color: transparent;\\n  padding: 1.5rem;\\n}\\n\\n.card-footer {\\n  background-color: transparent;\\n  border-top: 1px solid hsl(0deg, 0%, 93%);\\n  -webkit-box-align: stretch;\\n      -ms-flex-align: stretch;\\n          align-items: stretch;\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n}\\n\\n.card-footer-item {\\n  -webkit-box-align: center;\\n      -ms-flex-align: center;\\n          align-items: center;\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n  -ms-flex-preferred-size: 0;\\n      flex-basis: 0;\\n  -webkit-box-flex: 1;\\n      -ms-flex-positive: 1;\\n          flex-grow: 1;\\n  -ms-flex-negative: 0;\\n      flex-shrink: 0;\\n  -webkit-box-pack: center;\\n      -ms-flex-pack: center;\\n          justify-content: center;\\n  padding: 0.75rem;\\n}\\n.card-footer-item:not(:last-child) {\\n  border-right: 1px solid hsl(0deg, 0%, 93%);\\n}\\n\\n.card .media:not(:last-child) {\\n  margin-bottom: 1.5rem;\\n}\\n\\n.dropdown {\\n  display: -webkit-inline-box;\\n  display: -ms-inline-flexbox;\\n  display: inline-flex;\\n  position: relative;\\n  vertical-align: top;\\n}\\n.dropdown.is-active .dropdown-menu, .dropdown.is-hoverable:hover .dropdown-menu {\\n  display: block;\\n}\\n.dropdown.is-right .dropdown-menu {\\n  left: auto;\\n  right: 0;\\n}\\n.dropdown.is-up .dropdown-menu {\\n  bottom: 100%;\\n  padding-bottom: 4px;\\n  padding-top: initial;\\n  top: auto;\\n}\\n\\n.dropdown-menu {\\n  display: none;\\n  left: 0;\\n  min-width: 12rem;\\n  padding-top: 4px;\\n  position: absolute;\\n  top: 100%;\\n  z-index: 20;\\n}\\n\\n.dropdown-content {\\n  background-color: hsl(0deg, 0%, 100%);\\n  border-radius: 4px;\\n  -webkit-box-shadow: 0 0.5em 1em -0.125em rgba(10, 10, 10, 0.1), 0 0px 0 1px rgba(10, 10, 10, 0.02);\\n          box-shadow: 0 0.5em 1em -0.125em rgba(10, 10, 10, 0.1), 0 0px 0 1px rgba(10, 10, 10, 0.02);\\n  padding-bottom: 0.5rem;\\n  padding-top: 0.5rem;\\n}\\n\\n.dropdown-item {\\n  color: hsl(0deg, 0%, 29%);\\n  display: block;\\n  font-size: 0.875rem;\\n  line-height: 1.5;\\n  padding: 0.375rem 1rem;\\n  position: relative;\\n}\\n\\na.dropdown-item,\\nbutton.dropdown-item {\\n  padding-right: 3rem;\\n  text-align: inherit;\\n  white-space: nowrap;\\n  width: 100%;\\n}\\na.dropdown-item:hover,\\nbutton.dropdown-item:hover {\\n  background-color: hsl(0deg, 0%, 96%);\\n  color: hsl(0deg, 0%, 4%);\\n}\\na.dropdown-item.is-active,\\nbutton.dropdown-item.is-active {\\n  background-color: hsl(229deg, 53%, 53%);\\n  color: #fff;\\n}\\n\\n.dropdown-divider {\\n  background-color: hsl(0deg, 0%, 93%);\\n  border: none;\\n  display: block;\\n  height: 1px;\\n  margin: 0.5rem 0;\\n}\\n\\n.level {\\n  -webkit-box-align: center;\\n      -ms-flex-align: center;\\n          align-items: center;\\n  -webkit-box-pack: justify;\\n      -ms-flex-pack: justify;\\n          justify-content: space-between;\\n}\\n.level code {\\n  border-radius: 4px;\\n}\\n.level img {\\n  display: inline-block;\\n  vertical-align: top;\\n}\\n.level.is-mobile {\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n}\\n.level.is-mobile .level-left,\\n.level.is-mobile .level-right {\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n}\\n.level.is-mobile .level-left + .level-right {\\n  margin-top: 0;\\n}\\n.level.is-mobile .level-item:not(:last-child) {\\n  margin-bottom: 0;\\n  margin-right: 0.75rem;\\n}\\n.level.is-mobile .level-item:not(.is-narrow) {\\n  -webkit-box-flex: 1;\\n      -ms-flex-positive: 1;\\n          flex-grow: 1;\\n}\\n@media screen and (min-width: 769px), print {\\n  .level {\\n    display: -webkit-box;\\n    display: -ms-flexbox;\\n    display: flex;\\n  }\\n  .level > .level-item:not(.is-narrow) {\\n    -webkit-box-flex: 1;\\n        -ms-flex-positive: 1;\\n            flex-grow: 1;\\n  }\\n}\\n\\n.level-item {\\n  -webkit-box-align: center;\\n      -ms-flex-align: center;\\n          align-items: center;\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n  -ms-flex-preferred-size: auto;\\n      flex-basis: auto;\\n  -webkit-box-flex: 0;\\n      -ms-flex-positive: 0;\\n          flex-grow: 0;\\n  -ms-flex-negative: 0;\\n      flex-shrink: 0;\\n  -webkit-box-pack: center;\\n      -ms-flex-pack: center;\\n          justify-content: center;\\n}\\n.level-item .title,\\n.level-item .subtitle {\\n  margin-bottom: 0;\\n}\\n@media screen and (max-width: 768px) {\\n  .level-item:not(:last-child) {\\n    margin-bottom: 0.75rem;\\n  }\\n}\\n\\n.level-left,\\n.level-right {\\n  -ms-flex-preferred-size: auto;\\n      flex-basis: auto;\\n  -webkit-box-flex: 0;\\n      -ms-flex-positive: 0;\\n          flex-grow: 0;\\n  -ms-flex-negative: 0;\\n      flex-shrink: 0;\\n}\\n.level-left .level-item.is-flexible,\\n.level-right .level-item.is-flexible {\\n  -webkit-box-flex: 1;\\n      -ms-flex-positive: 1;\\n          flex-grow: 1;\\n}\\n@media screen and (min-width: 769px), print {\\n  .level-left .level-item:not(:last-child),\\n.level-right .level-item:not(:last-child) {\\n    margin-right: 0.75rem;\\n  }\\n}\\n\\n.level-left {\\n  -webkit-box-align: center;\\n      -ms-flex-align: center;\\n          align-items: center;\\n  -webkit-box-pack: start;\\n      -ms-flex-pack: start;\\n          justify-content: flex-start;\\n}\\n@media screen and (max-width: 768px) {\\n  .level-left + .level-right {\\n    margin-top: 1.5rem;\\n  }\\n}\\n@media screen and (min-width: 769px), print {\\n  .level-left {\\n    display: -webkit-box;\\n    display: -ms-flexbox;\\n    display: flex;\\n  }\\n}\\n\\n.level-right {\\n  -webkit-box-align: center;\\n      -ms-flex-align: center;\\n          align-items: center;\\n  -webkit-box-pack: end;\\n      -ms-flex-pack: end;\\n          justify-content: flex-end;\\n}\\n@media screen and (min-width: 769px), print {\\n  .level-right {\\n    display: -webkit-box;\\n    display: -ms-flexbox;\\n    display: flex;\\n  }\\n}\\n\\n.media {\\n  -webkit-box-align: start;\\n      -ms-flex-align: start;\\n          align-items: flex-start;\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n  text-align: inherit;\\n}\\n.media .content:not(:last-child) {\\n  margin-bottom: 0.75rem;\\n}\\n.media .media {\\n  border-top: 1px solid rgba(219, 219, 219, 0.5);\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n  padding-top: 0.75rem;\\n}\\n.media .media .content:not(:last-child),\\n.media .media .control:not(:last-child) {\\n  margin-bottom: 0.5rem;\\n}\\n.media .media .media {\\n  padding-top: 0.5rem;\\n}\\n.media .media .media + .media {\\n  margin-top: 0.5rem;\\n}\\n.media + .media {\\n  border-top: 1px solid rgba(219, 219, 219, 0.5);\\n  margin-top: 1rem;\\n  padding-top: 1rem;\\n}\\n.media.is-large + .media {\\n  margin-top: 1.5rem;\\n  padding-top: 1.5rem;\\n}\\n\\n.media-left,\\n.media-right {\\n  -ms-flex-preferred-size: auto;\\n      flex-basis: auto;\\n  -webkit-box-flex: 0;\\n      -ms-flex-positive: 0;\\n          flex-grow: 0;\\n  -ms-flex-negative: 0;\\n      flex-shrink: 0;\\n}\\n\\n.media-left {\\n  margin-right: 1rem;\\n}\\n\\n.media-right {\\n  margin-left: 1rem;\\n}\\n\\n.media-content {\\n  -ms-flex-preferred-size: auto;\\n      flex-basis: auto;\\n  -webkit-box-flex: 1;\\n      -ms-flex-positive: 1;\\n          flex-grow: 1;\\n  -ms-flex-negative: 1;\\n      flex-shrink: 1;\\n  text-align: inherit;\\n}\\n\\n@media screen and (max-width: 768px) {\\n  .media-content {\\n    overflow-x: auto;\\n  }\\n}\\n.menu {\\n  font-size: 1rem;\\n}\\n.menu.is-small {\\n  font-size: 0.75rem;\\n}\\n.menu.is-medium {\\n  font-size: 1.25rem;\\n}\\n.menu.is-large {\\n  font-size: 1.5rem;\\n}\\n\\n.menu-list {\\n  line-height: 1.25;\\n}\\n.menu-list a {\\n  border-radius: 2px;\\n  color: hsl(0deg, 0%, 29%);\\n  display: block;\\n  padding: 0.5em 0.75em;\\n}\\n.menu-list a:hover {\\n  background-color: hsl(0deg, 0%, 96%);\\n  color: hsl(0deg, 0%, 21%);\\n}\\n.menu-list a.is-active {\\n  background-color: hsl(229deg, 53%, 53%);\\n  color: #fff;\\n}\\n.menu-list li ul {\\n  border-left: 1px solid hsl(0deg, 0%, 86%);\\n  margin: 0.75em;\\n  padding-left: 0.75em;\\n}\\n\\n.menu-label {\\n  color: hsl(0deg, 0%, 48%);\\n  font-size: 0.75em;\\n  letter-spacing: 0.1em;\\n  text-transform: uppercase;\\n}\\n.menu-label:not(:first-child) {\\n  margin-top: 1em;\\n}\\n.menu-label:not(:last-child) {\\n  margin-bottom: 1em;\\n}\\n\\n.message {\\n  background-color: hsl(0deg, 0%, 96%);\\n  border-radius: 4px;\\n  font-size: 1rem;\\n}\\n.message strong {\\n  color: currentColor;\\n}\\n.message a:not(.button):not(.tag):not(.dropdown-item) {\\n  color: currentColor;\\n  text-decoration: underline;\\n}\\n.message.is-small {\\n  font-size: 0.75rem;\\n}\\n.message.is-medium {\\n  font-size: 1.25rem;\\n}\\n.message.is-large {\\n  font-size: 1.5rem;\\n}\\n.message.is-white {\\n  background-color: white;\\n}\\n.message.is-white .message-header {\\n  background-color: hsl(0deg, 0%, 100%);\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.message.is-white .message-body {\\n  border-color: hsl(0deg, 0%, 100%);\\n}\\n.message.is-black {\\n  background-color: #fafafa;\\n}\\n.message.is-black .message-header {\\n  background-color: hsl(0deg, 0%, 4%);\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.message.is-black .message-body {\\n  border-color: hsl(0deg, 0%, 4%);\\n}\\n.message.is-light {\\n  background-color: #fafafa;\\n}\\n.message.is-light .message-header {\\n  background-color: hsl(0deg, 0%, 96%);\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.message.is-light .message-body {\\n  border-color: hsl(0deg, 0%, 96%);\\n}\\n.message.is-dark {\\n  background-color: #fafafa;\\n}\\n.message.is-dark .message-header {\\n  background-color: hsl(0deg, 0%, 21%);\\n  color: #fff;\\n}\\n.message.is-dark .message-body {\\n  border-color: hsl(0deg, 0%, 21%);\\n}\\n.message.is-primary {\\n  background-color: #ebfffc;\\n}\\n.message.is-primary .message-header {\\n  background-color: hsl(171deg, 100%, 41%);\\n  color: #fff;\\n}\\n.message.is-primary .message-body {\\n  border-color: hsl(171deg, 100%, 41%);\\n  color: #00947e;\\n}\\n.message.is-link {\\n  background-color: #eff1fa;\\n}\\n.message.is-link .message-header {\\n  background-color: hsl(229deg, 53%, 53%);\\n  color: #fff;\\n}\\n.message.is-link .message-body {\\n  border-color: hsl(229deg, 53%, 53%);\\n  color: #3850b7;\\n}\\n.message.is-info {\\n  background-color: #eff5fb;\\n}\\n.message.is-info .message-header {\\n  background-color: hsl(207deg, 61%, 53%);\\n  color: #fff;\\n}\\n.message.is-info .message-body {\\n  border-color: hsl(207deg, 61%, 53%);\\n  color: #296fa8;\\n}\\n.message.is-success {\\n  background-color: #effaf5;\\n}\\n.message.is-success .message-header {\\n  background-color: hsl(153deg, 53%, 53%);\\n  color: #fff;\\n}\\n.message.is-success .message-body {\\n  border-color: hsl(153deg, 53%, 53%);\\n  color: #257953;\\n}\\n.message.is-warning {\\n  background-color: #fffaeb;\\n}\\n.message.is-warning .message-header {\\n  background-color: hsl(44deg, 100%, 77%);\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.message.is-warning .message-body {\\n  border-color: hsl(44deg, 100%, 77%);\\n  color: #946c00;\\n}\\n.message.is-danger {\\n  background-color: #feecf0;\\n}\\n.message.is-danger .message-header {\\n  background-color: hsl(348deg, 86%, 61%);\\n  color: #fff;\\n}\\n.message.is-danger .message-body {\\n  border-color: hsl(348deg, 86%, 61%);\\n  color: #cc0f35;\\n}\\n\\n.message-header {\\n  -webkit-box-align: center;\\n      -ms-flex-align: center;\\n          align-items: center;\\n  background-color: hsl(0deg, 0%, 29%);\\n  border-radius: 4px 4px 0 0;\\n  color: #fff;\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n  font-weight: 700;\\n  -webkit-box-pack: justify;\\n      -ms-flex-pack: justify;\\n          justify-content: space-between;\\n  line-height: 1.25;\\n  padding: 0.75em 1em;\\n  position: relative;\\n}\\n.message-header .delete {\\n  -webkit-box-flex: 0;\\n      -ms-flex-positive: 0;\\n          flex-grow: 0;\\n  -ms-flex-negative: 0;\\n      flex-shrink: 0;\\n  margin-left: 0.75em;\\n}\\n.message-header + .message-body {\\n  border-width: 0;\\n  border-top-left-radius: 0;\\n  border-top-right-radius: 0;\\n}\\n\\n.message-body {\\n  border-color: hsl(0deg, 0%, 86%);\\n  border-radius: 4px;\\n  border-style: solid;\\n  border-width: 0 0 0 4px;\\n  color: hsl(0deg, 0%, 29%);\\n  padding: 1.25em 1.5em;\\n}\\n.message-body code,\\n.message-body pre {\\n  background-color: hsl(0deg, 0%, 100%);\\n}\\n.message-body pre code {\\n  background-color: transparent;\\n}\\n\\n.modal {\\n  -webkit-box-align: center;\\n      -ms-flex-align: center;\\n          align-items: center;\\n  display: none;\\n  -webkit-box-orient: vertical;\\n  -webkit-box-direction: normal;\\n      -ms-flex-direction: column;\\n          flex-direction: column;\\n  -webkit-box-pack: center;\\n      -ms-flex-pack: center;\\n          justify-content: center;\\n  overflow: hidden;\\n  position: fixed;\\n  z-index: 40;\\n}\\n.modal.is-active {\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n}\\n\\n.modal-background {\\n  background-color: rgba(10, 10, 10, 0.86);\\n}\\n\\n.modal-content,\\n.modal-card {\\n  margin: 0 20px;\\n  max-height: calc(100vh - 160px);\\n  overflow: auto;\\n  position: relative;\\n  width: 100%;\\n}\\n@media screen and (min-width: 769px) {\\n  .modal-content,\\n.modal-card {\\n    margin: 0 auto;\\n    max-height: calc(100vh - 40px);\\n    width: 640px;\\n  }\\n}\\n\\n.modal-close {\\n  background: none;\\n  height: 40px;\\n  position: fixed;\\n  right: 20px;\\n  top: 20px;\\n  width: 40px;\\n}\\n\\n.modal-card {\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n  -webkit-box-orient: vertical;\\n  -webkit-box-direction: normal;\\n      -ms-flex-direction: column;\\n          flex-direction: column;\\n  max-height: calc(100vh - 40px);\\n  overflow: hidden;\\n  -ms-overflow-y: visible;\\n}\\n\\n.modal-card-head,\\n.modal-card-foot {\\n  -webkit-box-align: center;\\n      -ms-flex-align: center;\\n          align-items: center;\\n  background-color: hsl(0deg, 0%, 96%);\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n  -ms-flex-negative: 0;\\n      flex-shrink: 0;\\n  -webkit-box-pack: start;\\n      -ms-flex-pack: start;\\n          justify-content: flex-start;\\n  padding: 20px;\\n  position: relative;\\n}\\n\\n.modal-card-head {\\n  border-bottom: 1px solid hsl(0deg, 0%, 86%);\\n  border-top-left-radius: 6px;\\n  border-top-right-radius: 6px;\\n}\\n\\n.modal-card-title {\\n  color: hsl(0deg, 0%, 21%);\\n  -webkit-box-flex: 1;\\n      -ms-flex-positive: 1;\\n          flex-grow: 1;\\n  -ms-flex-negative: 0;\\n      flex-shrink: 0;\\n  font-size: 1.5rem;\\n  line-height: 1;\\n}\\n\\n.modal-card-foot {\\n  border-bottom-left-radius: 6px;\\n  border-bottom-right-radius: 6px;\\n  border-top: 1px solid hsl(0deg, 0%, 86%);\\n}\\n.modal-card-foot .button:not(:last-child) {\\n  margin-right: 0.5em;\\n}\\n\\n.modal-card-body {\\n  -webkit-overflow-scrolling: touch;\\n  background-color: hsl(0deg, 0%, 100%);\\n  -webkit-box-flex: 1;\\n      -ms-flex-positive: 1;\\n          flex-grow: 1;\\n  -ms-flex-negative: 1;\\n      flex-shrink: 1;\\n  overflow: auto;\\n  padding: 20px;\\n}\\n\\n.navbar {\\n  background-color: hsl(0deg, 0%, 100%);\\n  min-height: 3.25rem;\\n  position: relative;\\n  z-index: 30;\\n}\\n.navbar.is-white {\\n  background-color: hsl(0deg, 0%, 100%);\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.navbar.is-white .navbar-brand > .navbar-item,\\n.navbar.is-white .navbar-brand .navbar-link {\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.navbar.is-white .navbar-brand > a.navbar-item:focus, .navbar.is-white .navbar-brand > a.navbar-item:hover, .navbar.is-white .navbar-brand > a.navbar-item.is-active,\\n.navbar.is-white .navbar-brand .navbar-link:focus,\\n.navbar.is-white .navbar-brand .navbar-link:hover,\\n.navbar.is-white .navbar-brand .navbar-link.is-active {\\n  background-color: #f2f2f2;\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.navbar.is-white .navbar-brand .navbar-link::after {\\n  border-color: hsl(0deg, 0%, 4%);\\n}\\n.navbar.is-white .navbar-burger {\\n  color: hsl(0deg, 0%, 4%);\\n}\\n@media screen and (min-width: 1024px) {\\n  .navbar.is-white .navbar-start > .navbar-item,\\n.navbar.is-white .navbar-start .navbar-link,\\n.navbar.is-white .navbar-end > .navbar-item,\\n.navbar.is-white .navbar-end .navbar-link {\\n    color: hsl(0deg, 0%, 4%);\\n  }\\n  .navbar.is-white .navbar-start > a.navbar-item:focus, .navbar.is-white .navbar-start > a.navbar-item:hover, .navbar.is-white .navbar-start > a.navbar-item.is-active,\\n.navbar.is-white .navbar-start .navbar-link:focus,\\n.navbar.is-white .navbar-start .navbar-link:hover,\\n.navbar.is-white .navbar-start .navbar-link.is-active,\\n.navbar.is-white .navbar-end > a.navbar-item:focus,\\n.navbar.is-white .navbar-end > a.navbar-item:hover,\\n.navbar.is-white .navbar-end > a.navbar-item.is-active,\\n.navbar.is-white .navbar-end .navbar-link:focus,\\n.navbar.is-white .navbar-end .navbar-link:hover,\\n.navbar.is-white .navbar-end .navbar-link.is-active {\\n    background-color: #f2f2f2;\\n    color: hsl(0deg, 0%, 4%);\\n  }\\n  .navbar.is-white .navbar-start .navbar-link::after,\\n.navbar.is-white .navbar-end .navbar-link::after {\\n    border-color: hsl(0deg, 0%, 4%);\\n  }\\n  .navbar.is-white .navbar-item.has-dropdown:focus .navbar-link,\\n.navbar.is-white .navbar-item.has-dropdown:hover .navbar-link,\\n.navbar.is-white .navbar-item.has-dropdown.is-active .navbar-link {\\n    background-color: #f2f2f2;\\n    color: hsl(0deg, 0%, 4%);\\n  }\\n  .navbar.is-white .navbar-dropdown a.navbar-item.is-active {\\n    background-color: hsl(0deg, 0%, 100%);\\n    color: hsl(0deg, 0%, 4%);\\n  }\\n}\\n.navbar.is-black {\\n  background-color: hsl(0deg, 0%, 4%);\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.navbar.is-black .navbar-brand > .navbar-item,\\n.navbar.is-black .navbar-brand .navbar-link {\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.navbar.is-black .navbar-brand > a.navbar-item:focus, .navbar.is-black .navbar-brand > a.navbar-item:hover, .navbar.is-black .navbar-brand > a.navbar-item.is-active,\\n.navbar.is-black .navbar-brand .navbar-link:focus,\\n.navbar.is-black .navbar-brand .navbar-link:hover,\\n.navbar.is-black .navbar-brand .navbar-link.is-active {\\n  background-color: black;\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.navbar.is-black .navbar-brand .navbar-link::after {\\n  border-color: hsl(0deg, 0%, 100%);\\n}\\n.navbar.is-black .navbar-burger {\\n  color: hsl(0deg, 0%, 100%);\\n}\\n@media screen and (min-width: 1024px) {\\n  .navbar.is-black .navbar-start > .navbar-item,\\n.navbar.is-black .navbar-start .navbar-link,\\n.navbar.is-black .navbar-end > .navbar-item,\\n.navbar.is-black .navbar-end .navbar-link {\\n    color: hsl(0deg, 0%, 100%);\\n  }\\n  .navbar.is-black .navbar-start > a.navbar-item:focus, .navbar.is-black .navbar-start > a.navbar-item:hover, .navbar.is-black .navbar-start > a.navbar-item.is-active,\\n.navbar.is-black .navbar-start .navbar-link:focus,\\n.navbar.is-black .navbar-start .navbar-link:hover,\\n.navbar.is-black .navbar-start .navbar-link.is-active,\\n.navbar.is-black .navbar-end > a.navbar-item:focus,\\n.navbar.is-black .navbar-end > a.navbar-item:hover,\\n.navbar.is-black .navbar-end > a.navbar-item.is-active,\\n.navbar.is-black .navbar-end .navbar-link:focus,\\n.navbar.is-black .navbar-end .navbar-link:hover,\\n.navbar.is-black .navbar-end .navbar-link.is-active {\\n    background-color: black;\\n    color: hsl(0deg, 0%, 100%);\\n  }\\n  .navbar.is-black .navbar-start .navbar-link::after,\\n.navbar.is-black .navbar-end .navbar-link::after {\\n    border-color: hsl(0deg, 0%, 100%);\\n  }\\n  .navbar.is-black .navbar-item.has-dropdown:focus .navbar-link,\\n.navbar.is-black .navbar-item.has-dropdown:hover .navbar-link,\\n.navbar.is-black .navbar-item.has-dropdown.is-active .navbar-link {\\n    background-color: black;\\n    color: hsl(0deg, 0%, 100%);\\n  }\\n  .navbar.is-black .navbar-dropdown a.navbar-item.is-active {\\n    background-color: hsl(0deg, 0%, 4%);\\n    color: hsl(0deg, 0%, 100%);\\n  }\\n}\\n.navbar.is-light {\\n  background-color: hsl(0deg, 0%, 96%);\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.navbar.is-light .navbar-brand > .navbar-item,\\n.navbar.is-light .navbar-brand .navbar-link {\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.navbar.is-light .navbar-brand > a.navbar-item:focus, .navbar.is-light .navbar-brand > a.navbar-item:hover, .navbar.is-light .navbar-brand > a.navbar-item.is-active,\\n.navbar.is-light .navbar-brand .navbar-link:focus,\\n.navbar.is-light .navbar-brand .navbar-link:hover,\\n.navbar.is-light .navbar-brand .navbar-link.is-active {\\n  background-color: #e8e8e8;\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.navbar.is-light .navbar-brand .navbar-link::after {\\n  border-color: rgba(0, 0, 0, 0.7);\\n}\\n.navbar.is-light .navbar-burger {\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n@media screen and (min-width: 1024px) {\\n  .navbar.is-light .navbar-start > .navbar-item,\\n.navbar.is-light .navbar-start .navbar-link,\\n.navbar.is-light .navbar-end > .navbar-item,\\n.navbar.is-light .navbar-end .navbar-link {\\n    color: rgba(0, 0, 0, 0.7);\\n  }\\n  .navbar.is-light .navbar-start > a.navbar-item:focus, .navbar.is-light .navbar-start > a.navbar-item:hover, .navbar.is-light .navbar-start > a.navbar-item.is-active,\\n.navbar.is-light .navbar-start .navbar-link:focus,\\n.navbar.is-light .navbar-start .navbar-link:hover,\\n.navbar.is-light .navbar-start .navbar-link.is-active,\\n.navbar.is-light .navbar-end > a.navbar-item:focus,\\n.navbar.is-light .navbar-end > a.navbar-item:hover,\\n.navbar.is-light .navbar-end > a.navbar-item.is-active,\\n.navbar.is-light .navbar-end .navbar-link:focus,\\n.navbar.is-light .navbar-end .navbar-link:hover,\\n.navbar.is-light .navbar-end .navbar-link.is-active {\\n    background-color: #e8e8e8;\\n    color: rgba(0, 0, 0, 0.7);\\n  }\\n  .navbar.is-light .navbar-start .navbar-link::after,\\n.navbar.is-light .navbar-end .navbar-link::after {\\n    border-color: rgba(0, 0, 0, 0.7);\\n  }\\n  .navbar.is-light .navbar-item.has-dropdown:focus .navbar-link,\\n.navbar.is-light .navbar-item.has-dropdown:hover .navbar-link,\\n.navbar.is-light .navbar-item.has-dropdown.is-active .navbar-link {\\n    background-color: #e8e8e8;\\n    color: rgba(0, 0, 0, 0.7);\\n  }\\n  .navbar.is-light .navbar-dropdown a.navbar-item.is-active {\\n    background-color: hsl(0deg, 0%, 96%);\\n    color: rgba(0, 0, 0, 0.7);\\n  }\\n}\\n.navbar.is-dark {\\n  background-color: hsl(0deg, 0%, 21%);\\n  color: #fff;\\n}\\n.navbar.is-dark .navbar-brand > .navbar-item,\\n.navbar.is-dark .navbar-brand .navbar-link {\\n  color: #fff;\\n}\\n.navbar.is-dark .navbar-brand > a.navbar-item:focus, .navbar.is-dark .navbar-brand > a.navbar-item:hover, .navbar.is-dark .navbar-brand > a.navbar-item.is-active,\\n.navbar.is-dark .navbar-brand .navbar-link:focus,\\n.navbar.is-dark .navbar-brand .navbar-link:hover,\\n.navbar.is-dark .navbar-brand .navbar-link.is-active {\\n  background-color: #292929;\\n  color: #fff;\\n}\\n.navbar.is-dark .navbar-brand .navbar-link::after {\\n  border-color: #fff;\\n}\\n.navbar.is-dark .navbar-burger {\\n  color: #fff;\\n}\\n@media screen and (min-width: 1024px) {\\n  .navbar.is-dark .navbar-start > .navbar-item,\\n.navbar.is-dark .navbar-start .navbar-link,\\n.navbar.is-dark .navbar-end > .navbar-item,\\n.navbar.is-dark .navbar-end .navbar-link {\\n    color: #fff;\\n  }\\n  .navbar.is-dark .navbar-start > a.navbar-item:focus, .navbar.is-dark .navbar-start > a.navbar-item:hover, .navbar.is-dark .navbar-start > a.navbar-item.is-active,\\n.navbar.is-dark .navbar-start .navbar-link:focus,\\n.navbar.is-dark .navbar-start .navbar-link:hover,\\n.navbar.is-dark .navbar-start .navbar-link.is-active,\\n.navbar.is-dark .navbar-end > a.navbar-item:focus,\\n.navbar.is-dark .navbar-end > a.navbar-item:hover,\\n.navbar.is-dark .navbar-end > a.navbar-item.is-active,\\n.navbar.is-dark .navbar-end .navbar-link:focus,\\n.navbar.is-dark .navbar-end .navbar-link:hover,\\n.navbar.is-dark .navbar-end .navbar-link.is-active {\\n    background-color: #292929;\\n    color: #fff;\\n  }\\n  .navbar.is-dark .navbar-start .navbar-link::after,\\n.navbar.is-dark .navbar-end .navbar-link::after {\\n    border-color: #fff;\\n  }\\n  .navbar.is-dark .navbar-item.has-dropdown:focus .navbar-link,\\n.navbar.is-dark .navbar-item.has-dropdown:hover .navbar-link,\\n.navbar.is-dark .navbar-item.has-dropdown.is-active .navbar-link {\\n    background-color: #292929;\\n    color: #fff;\\n  }\\n  .navbar.is-dark .navbar-dropdown a.navbar-item.is-active {\\n    background-color: hsl(0deg, 0%, 21%);\\n    color: #fff;\\n  }\\n}\\n.navbar.is-primary {\\n  background-color: hsl(171deg, 100%, 41%);\\n  color: #fff;\\n}\\n.navbar.is-primary .navbar-brand > .navbar-item,\\n.navbar.is-primary .navbar-brand .navbar-link {\\n  color: #fff;\\n}\\n.navbar.is-primary .navbar-brand > a.navbar-item:focus, .navbar.is-primary .navbar-brand > a.navbar-item:hover, .navbar.is-primary .navbar-brand > a.navbar-item.is-active,\\n.navbar.is-primary .navbar-brand .navbar-link:focus,\\n.navbar.is-primary .navbar-brand .navbar-link:hover,\\n.navbar.is-primary .navbar-brand .navbar-link.is-active {\\n  background-color: #00b89c;\\n  color: #fff;\\n}\\n.navbar.is-primary .navbar-brand .navbar-link::after {\\n  border-color: #fff;\\n}\\n.navbar.is-primary .navbar-burger {\\n  color: #fff;\\n}\\n@media screen and (min-width: 1024px) {\\n  .navbar.is-primary .navbar-start > .navbar-item,\\n.navbar.is-primary .navbar-start .navbar-link,\\n.navbar.is-primary .navbar-end > .navbar-item,\\n.navbar.is-primary .navbar-end .navbar-link {\\n    color: #fff;\\n  }\\n  .navbar.is-primary .navbar-start > a.navbar-item:focus, .navbar.is-primary .navbar-start > a.navbar-item:hover, .navbar.is-primary .navbar-start > a.navbar-item.is-active,\\n.navbar.is-primary .navbar-start .navbar-link:focus,\\n.navbar.is-primary .navbar-start .navbar-link:hover,\\n.navbar.is-primary .navbar-start .navbar-link.is-active,\\n.navbar.is-primary .navbar-end > a.navbar-item:focus,\\n.navbar.is-primary .navbar-end > a.navbar-item:hover,\\n.navbar.is-primary .navbar-end > a.navbar-item.is-active,\\n.navbar.is-primary .navbar-end .navbar-link:focus,\\n.navbar.is-primary .navbar-end .navbar-link:hover,\\n.navbar.is-primary .navbar-end .navbar-link.is-active {\\n    background-color: #00b89c;\\n    color: #fff;\\n  }\\n  .navbar.is-primary .navbar-start .navbar-link::after,\\n.navbar.is-primary .navbar-end .navbar-link::after {\\n    border-color: #fff;\\n  }\\n  .navbar.is-primary .navbar-item.has-dropdown:focus .navbar-link,\\n.navbar.is-primary .navbar-item.has-dropdown:hover .navbar-link,\\n.navbar.is-primary .navbar-item.has-dropdown.is-active .navbar-link {\\n    background-color: #00b89c;\\n    color: #fff;\\n  }\\n  .navbar.is-primary .navbar-dropdown a.navbar-item.is-active {\\n    background-color: hsl(171deg, 100%, 41%);\\n    color: #fff;\\n  }\\n}\\n.navbar.is-link {\\n  background-color: hsl(229deg, 53%, 53%);\\n  color: #fff;\\n}\\n.navbar.is-link .navbar-brand > .navbar-item,\\n.navbar.is-link .navbar-brand .navbar-link {\\n  color: #fff;\\n}\\n.navbar.is-link .navbar-brand > a.navbar-item:focus, .navbar.is-link .navbar-brand > a.navbar-item:hover, .navbar.is-link .navbar-brand > a.navbar-item.is-active,\\n.navbar.is-link .navbar-brand .navbar-link:focus,\\n.navbar.is-link .navbar-brand .navbar-link:hover,\\n.navbar.is-link .navbar-brand .navbar-link.is-active {\\n  background-color: #3a51bb;\\n  color: #fff;\\n}\\n.navbar.is-link .navbar-brand .navbar-link::after {\\n  border-color: #fff;\\n}\\n.navbar.is-link .navbar-burger {\\n  color: #fff;\\n}\\n@media screen and (min-width: 1024px) {\\n  .navbar.is-link .navbar-start > .navbar-item,\\n.navbar.is-link .navbar-start .navbar-link,\\n.navbar.is-link .navbar-end > .navbar-item,\\n.navbar.is-link .navbar-end .navbar-link {\\n    color: #fff;\\n  }\\n  .navbar.is-link .navbar-start > a.navbar-item:focus, .navbar.is-link .navbar-start > a.navbar-item:hover, .navbar.is-link .navbar-start > a.navbar-item.is-active,\\n.navbar.is-link .navbar-start .navbar-link:focus,\\n.navbar.is-link .navbar-start .navbar-link:hover,\\n.navbar.is-link .navbar-start .navbar-link.is-active,\\n.navbar.is-link .navbar-end > a.navbar-item:focus,\\n.navbar.is-link .navbar-end > a.navbar-item:hover,\\n.navbar.is-link .navbar-end > a.navbar-item.is-active,\\n.navbar.is-link .navbar-end .navbar-link:focus,\\n.navbar.is-link .navbar-end .navbar-link:hover,\\n.navbar.is-link .navbar-end .navbar-link.is-active {\\n    background-color: #3a51bb;\\n    color: #fff;\\n  }\\n  .navbar.is-link .navbar-start .navbar-link::after,\\n.navbar.is-link .navbar-end .navbar-link::after {\\n    border-color: #fff;\\n  }\\n  .navbar.is-link .navbar-item.has-dropdown:focus .navbar-link,\\n.navbar.is-link .navbar-item.has-dropdown:hover .navbar-link,\\n.navbar.is-link .navbar-item.has-dropdown.is-active .navbar-link {\\n    background-color: #3a51bb;\\n    color: #fff;\\n  }\\n  .navbar.is-link .navbar-dropdown a.navbar-item.is-active {\\n    background-color: hsl(229deg, 53%, 53%);\\n    color: #fff;\\n  }\\n}\\n.navbar.is-info {\\n  background-color: hsl(207deg, 61%, 53%);\\n  color: #fff;\\n}\\n.navbar.is-info .navbar-brand > .navbar-item,\\n.navbar.is-info .navbar-brand .navbar-link {\\n  color: #fff;\\n}\\n.navbar.is-info .navbar-brand > a.navbar-item:focus, .navbar.is-info .navbar-brand > a.navbar-item:hover, .navbar.is-info .navbar-brand > a.navbar-item.is-active,\\n.navbar.is-info .navbar-brand .navbar-link:focus,\\n.navbar.is-info .navbar-brand .navbar-link:hover,\\n.navbar.is-info .navbar-brand .navbar-link.is-active {\\n  background-color: #3082c5;\\n  color: #fff;\\n}\\n.navbar.is-info .navbar-brand .navbar-link::after {\\n  border-color: #fff;\\n}\\n.navbar.is-info .navbar-burger {\\n  color: #fff;\\n}\\n@media screen and (min-width: 1024px) {\\n  .navbar.is-info .navbar-start > .navbar-item,\\n.navbar.is-info .navbar-start .navbar-link,\\n.navbar.is-info .navbar-end > .navbar-item,\\n.navbar.is-info .navbar-end .navbar-link {\\n    color: #fff;\\n  }\\n  .navbar.is-info .navbar-start > a.navbar-item:focus, .navbar.is-info .navbar-start > a.navbar-item:hover, .navbar.is-info .navbar-start > a.navbar-item.is-active,\\n.navbar.is-info .navbar-start .navbar-link:focus,\\n.navbar.is-info .navbar-start .navbar-link:hover,\\n.navbar.is-info .navbar-start .navbar-link.is-active,\\n.navbar.is-info .navbar-end > a.navbar-item:focus,\\n.navbar.is-info .navbar-end > a.navbar-item:hover,\\n.navbar.is-info .navbar-end > a.navbar-item.is-active,\\n.navbar.is-info .navbar-end .navbar-link:focus,\\n.navbar.is-info .navbar-end .navbar-link:hover,\\n.navbar.is-info .navbar-end .navbar-link.is-active {\\n    background-color: #3082c5;\\n    color: #fff;\\n  }\\n  .navbar.is-info .navbar-start .navbar-link::after,\\n.navbar.is-info .navbar-end .navbar-link::after {\\n    border-color: #fff;\\n  }\\n  .navbar.is-info .navbar-item.has-dropdown:focus .navbar-link,\\n.navbar.is-info .navbar-item.has-dropdown:hover .navbar-link,\\n.navbar.is-info .navbar-item.has-dropdown.is-active .navbar-link {\\n    background-color: #3082c5;\\n    color: #fff;\\n  }\\n  .navbar.is-info .navbar-dropdown a.navbar-item.is-active {\\n    background-color: hsl(207deg, 61%, 53%);\\n    color: #fff;\\n  }\\n}\\n.navbar.is-success {\\n  background-color: hsl(153deg, 53%, 53%);\\n  color: #fff;\\n}\\n.navbar.is-success .navbar-brand > .navbar-item,\\n.navbar.is-success .navbar-brand .navbar-link {\\n  color: #fff;\\n}\\n.navbar.is-success .navbar-brand > a.navbar-item:focus, .navbar.is-success .navbar-brand > a.navbar-item:hover, .navbar.is-success .navbar-brand > a.navbar-item.is-active,\\n.navbar.is-success .navbar-brand .navbar-link:focus,\\n.navbar.is-success .navbar-brand .navbar-link:hover,\\n.navbar.is-success .navbar-brand .navbar-link.is-active {\\n  background-color: #3abb81;\\n  color: #fff;\\n}\\n.navbar.is-success .navbar-brand .navbar-link::after {\\n  border-color: #fff;\\n}\\n.navbar.is-success .navbar-burger {\\n  color: #fff;\\n}\\n@media screen and (min-width: 1024px) {\\n  .navbar.is-success .navbar-start > .navbar-item,\\n.navbar.is-success .navbar-start .navbar-link,\\n.navbar.is-success .navbar-end > .navbar-item,\\n.navbar.is-success .navbar-end .navbar-link {\\n    color: #fff;\\n  }\\n  .navbar.is-success .navbar-start > a.navbar-item:focus, .navbar.is-success .navbar-start > a.navbar-item:hover, .navbar.is-success .navbar-start > a.navbar-item.is-active,\\n.navbar.is-success .navbar-start .navbar-link:focus,\\n.navbar.is-success .navbar-start .navbar-link:hover,\\n.navbar.is-success .navbar-start .navbar-link.is-active,\\n.navbar.is-success .navbar-end > a.navbar-item:focus,\\n.navbar.is-success .navbar-end > a.navbar-item:hover,\\n.navbar.is-success .navbar-end > a.navbar-item.is-active,\\n.navbar.is-success .navbar-end .navbar-link:focus,\\n.navbar.is-success .navbar-end .navbar-link:hover,\\n.navbar.is-success .navbar-end .navbar-link.is-active {\\n    background-color: #3abb81;\\n    color: #fff;\\n  }\\n  .navbar.is-success .navbar-start .navbar-link::after,\\n.navbar.is-success .navbar-end .navbar-link::after {\\n    border-color: #fff;\\n  }\\n  .navbar.is-success .navbar-item.has-dropdown:focus .navbar-link,\\n.navbar.is-success .navbar-item.has-dropdown:hover .navbar-link,\\n.navbar.is-success .navbar-item.has-dropdown.is-active .navbar-link {\\n    background-color: #3abb81;\\n    color: #fff;\\n  }\\n  .navbar.is-success .navbar-dropdown a.navbar-item.is-active {\\n    background-color: hsl(153deg, 53%, 53%);\\n    color: #fff;\\n  }\\n}\\n.navbar.is-warning {\\n  background-color: hsl(44deg, 100%, 77%);\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.navbar.is-warning .navbar-brand > .navbar-item,\\n.navbar.is-warning .navbar-brand .navbar-link {\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.navbar.is-warning .navbar-brand > a.navbar-item:focus, .navbar.is-warning .navbar-brand > a.navbar-item:hover, .navbar.is-warning .navbar-brand > a.navbar-item.is-active,\\n.navbar.is-warning .navbar-brand .navbar-link:focus,\\n.navbar.is-warning .navbar-brand .navbar-link:hover,\\n.navbar.is-warning .navbar-brand .navbar-link.is-active {\\n  background-color: #ffd970;\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.navbar.is-warning .navbar-brand .navbar-link::after {\\n  border-color: rgba(0, 0, 0, 0.7);\\n}\\n.navbar.is-warning .navbar-burger {\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n@media screen and (min-width: 1024px) {\\n  .navbar.is-warning .navbar-start > .navbar-item,\\n.navbar.is-warning .navbar-start .navbar-link,\\n.navbar.is-warning .navbar-end > .navbar-item,\\n.navbar.is-warning .navbar-end .navbar-link {\\n    color: rgba(0, 0, 0, 0.7);\\n  }\\n  .navbar.is-warning .navbar-start > a.navbar-item:focus, .navbar.is-warning .navbar-start > a.navbar-item:hover, .navbar.is-warning .navbar-start > a.navbar-item.is-active,\\n.navbar.is-warning .navbar-start .navbar-link:focus,\\n.navbar.is-warning .navbar-start .navbar-link:hover,\\n.navbar.is-warning .navbar-start .navbar-link.is-active,\\n.navbar.is-warning .navbar-end > a.navbar-item:focus,\\n.navbar.is-warning .navbar-end > a.navbar-item:hover,\\n.navbar.is-warning .navbar-end > a.navbar-item.is-active,\\n.navbar.is-warning .navbar-end .navbar-link:focus,\\n.navbar.is-warning .navbar-end .navbar-link:hover,\\n.navbar.is-warning .navbar-end .navbar-link.is-active {\\n    background-color: #ffd970;\\n    color: rgba(0, 0, 0, 0.7);\\n  }\\n  .navbar.is-warning .navbar-start .navbar-link::after,\\n.navbar.is-warning .navbar-end .navbar-link::after {\\n    border-color: rgba(0, 0, 0, 0.7);\\n  }\\n  .navbar.is-warning .navbar-item.has-dropdown:focus .navbar-link,\\n.navbar.is-warning .navbar-item.has-dropdown:hover .navbar-link,\\n.navbar.is-warning .navbar-item.has-dropdown.is-active .navbar-link {\\n    background-color: #ffd970;\\n    color: rgba(0, 0, 0, 0.7);\\n  }\\n  .navbar.is-warning .navbar-dropdown a.navbar-item.is-active {\\n    background-color: hsl(44deg, 100%, 77%);\\n    color: rgba(0, 0, 0, 0.7);\\n  }\\n}\\n.navbar.is-danger {\\n  background-color: hsl(348deg, 86%, 61%);\\n  color: #fff;\\n}\\n.navbar.is-danger .navbar-brand > .navbar-item,\\n.navbar.is-danger .navbar-brand .navbar-link {\\n  color: #fff;\\n}\\n.navbar.is-danger .navbar-brand > a.navbar-item:focus, .navbar.is-danger .navbar-brand > a.navbar-item:hover, .navbar.is-danger .navbar-brand > a.navbar-item.is-active,\\n.navbar.is-danger .navbar-brand .navbar-link:focus,\\n.navbar.is-danger .navbar-brand .navbar-link:hover,\\n.navbar.is-danger .navbar-brand .navbar-link.is-active {\\n  background-color: #ef2e55;\\n  color: #fff;\\n}\\n.navbar.is-danger .navbar-brand .navbar-link::after {\\n  border-color: #fff;\\n}\\n.navbar.is-danger .navbar-burger {\\n  color: #fff;\\n}\\n@media screen and (min-width: 1024px) {\\n  .navbar.is-danger .navbar-start > .navbar-item,\\n.navbar.is-danger .navbar-start .navbar-link,\\n.navbar.is-danger .navbar-end > .navbar-item,\\n.navbar.is-danger .navbar-end .navbar-link {\\n    color: #fff;\\n  }\\n  .navbar.is-danger .navbar-start > a.navbar-item:focus, .navbar.is-danger .navbar-start > a.navbar-item:hover, .navbar.is-danger .navbar-start > a.navbar-item.is-active,\\n.navbar.is-danger .navbar-start .navbar-link:focus,\\n.navbar.is-danger .navbar-start .navbar-link:hover,\\n.navbar.is-danger .navbar-start .navbar-link.is-active,\\n.navbar.is-danger .navbar-end > a.navbar-item:focus,\\n.navbar.is-danger .navbar-end > a.navbar-item:hover,\\n.navbar.is-danger .navbar-end > a.navbar-item.is-active,\\n.navbar.is-danger .navbar-end .navbar-link:focus,\\n.navbar.is-danger .navbar-end .navbar-link:hover,\\n.navbar.is-danger .navbar-end .navbar-link.is-active {\\n    background-color: #ef2e55;\\n    color: #fff;\\n  }\\n  .navbar.is-danger .navbar-start .navbar-link::after,\\n.navbar.is-danger .navbar-end .navbar-link::after {\\n    border-color: #fff;\\n  }\\n  .navbar.is-danger .navbar-item.has-dropdown:focus .navbar-link,\\n.navbar.is-danger .navbar-item.has-dropdown:hover .navbar-link,\\n.navbar.is-danger .navbar-item.has-dropdown.is-active .navbar-link {\\n    background-color: #ef2e55;\\n    color: #fff;\\n  }\\n  .navbar.is-danger .navbar-dropdown a.navbar-item.is-active {\\n    background-color: hsl(348deg, 86%, 61%);\\n    color: #fff;\\n  }\\n}\\n.navbar > .container {\\n  -webkit-box-align: stretch;\\n      -ms-flex-align: stretch;\\n          align-items: stretch;\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n  min-height: 3.25rem;\\n  width: 100%;\\n}\\n.navbar.has-shadow {\\n  -webkit-box-shadow: 0 2px 0 0 hsl(0deg, 0%, 96%);\\n          box-shadow: 0 2px 0 0 hsl(0deg, 0%, 96%);\\n}\\n.navbar.is-fixed-bottom, .navbar.is-fixed-top {\\n  left: 0;\\n  position: fixed;\\n  right: 0;\\n  z-index: 30;\\n}\\n.navbar.is-fixed-bottom {\\n  bottom: 0;\\n}\\n.navbar.is-fixed-bottom.has-shadow {\\n  -webkit-box-shadow: 0 -2px 0 0 hsl(0deg, 0%, 96%);\\n          box-shadow: 0 -2px 0 0 hsl(0deg, 0%, 96%);\\n}\\n.navbar.is-fixed-top {\\n  top: 0;\\n}\\n\\nhtml.has-navbar-fixed-top,\\nbody.has-navbar-fixed-top {\\n  padding-top: 3.25rem;\\n}\\nhtml.has-navbar-fixed-bottom,\\nbody.has-navbar-fixed-bottom {\\n  padding-bottom: 3.25rem;\\n}\\n\\n.navbar-brand,\\n.navbar-tabs {\\n  -webkit-box-align: stretch;\\n      -ms-flex-align: stretch;\\n          align-items: stretch;\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n  -ms-flex-negative: 0;\\n      flex-shrink: 0;\\n  min-height: 3.25rem;\\n}\\n\\n.navbar-brand a.navbar-item:focus, .navbar-brand a.navbar-item:hover {\\n  background-color: transparent;\\n}\\n\\n.navbar-tabs {\\n  -webkit-overflow-scrolling: touch;\\n  max-width: 100vw;\\n  overflow-x: auto;\\n  overflow-y: hidden;\\n}\\n\\n.navbar-burger {\\n  color: hsl(0deg, 0%, 29%);\\n  cursor: pointer;\\n  display: block;\\n  height: 3.25rem;\\n  position: relative;\\n  width: 3.25rem;\\n  margin-left: auto;\\n}\\n.navbar-burger span {\\n  background-color: currentColor;\\n  display: block;\\n  height: 1px;\\n  left: calc(50% - 8px);\\n  position: absolute;\\n  -webkit-transform-origin: center;\\n          transform-origin: center;\\n  -webkit-transition-duration: 86ms;\\n          transition-duration: 86ms;\\n  -webkit-transition-property: background-color, opacity, -webkit-transform;\\n  transition-property: background-color, opacity, -webkit-transform;\\n  transition-property: background-color, opacity, transform;\\n  transition-property: background-color, opacity, transform, -webkit-transform;\\n  -webkit-transition-timing-function: ease-out;\\n          transition-timing-function: ease-out;\\n  width: 16px;\\n}\\n.navbar-burger span:nth-child(1) {\\n  top: calc(50% - 6px);\\n}\\n.navbar-burger span:nth-child(2) {\\n  top: calc(50% - 1px);\\n}\\n.navbar-burger span:nth-child(3) {\\n  top: calc(50% + 4px);\\n}\\n.navbar-burger:hover {\\n  background-color: rgba(0, 0, 0, 0.05);\\n}\\n.navbar-burger.is-active span:nth-child(1) {\\n  -webkit-transform: translateY(5px) rotate(45deg);\\n          transform: translateY(5px) rotate(45deg);\\n}\\n.navbar-burger.is-active span:nth-child(2) {\\n  opacity: 0;\\n}\\n.navbar-burger.is-active span:nth-child(3) {\\n  -webkit-transform: translateY(-5px) rotate(-45deg);\\n          transform: translateY(-5px) rotate(-45deg);\\n}\\n\\n.navbar-menu {\\n  display: none;\\n}\\n\\n.navbar-item,\\n.navbar-link {\\n  color: hsl(0deg, 0%, 29%);\\n  display: block;\\n  line-height: 1.5;\\n  padding: 0.5rem 0.75rem;\\n  position: relative;\\n}\\n.navbar-item .icon:only-child,\\n.navbar-link .icon:only-child {\\n  margin-left: -0.25rem;\\n  margin-right: -0.25rem;\\n}\\n\\na.navbar-item,\\n.navbar-link {\\n  cursor: pointer;\\n}\\na.navbar-item:focus, a.navbar-item:focus-within, a.navbar-item:hover, a.navbar-item.is-active,\\n.navbar-link:focus,\\n.navbar-link:focus-within,\\n.navbar-link:hover,\\n.navbar-link.is-active {\\n  background-color: hsl(0deg, 0%, 98%);\\n  color: hsl(229deg, 53%, 53%);\\n}\\n\\n.navbar-item {\\n  -webkit-box-flex: 0;\\n      -ms-flex-positive: 0;\\n          flex-grow: 0;\\n  -ms-flex-negative: 0;\\n      flex-shrink: 0;\\n}\\n.navbar-item img {\\n  max-height: 1.75rem;\\n}\\n.navbar-item.has-dropdown {\\n  padding: 0;\\n}\\n.navbar-item.is-expanded {\\n  -webkit-box-flex: 1;\\n      -ms-flex-positive: 1;\\n          flex-grow: 1;\\n  -ms-flex-negative: 1;\\n      flex-shrink: 1;\\n}\\n.navbar-item.is-tab {\\n  border-bottom: 1px solid transparent;\\n  min-height: 3.25rem;\\n  padding-bottom: calc(0.5rem - 1px);\\n}\\n.navbar-item.is-tab:focus, .navbar-item.is-tab:hover {\\n  background-color: transparent;\\n  border-bottom-color: hsl(229deg, 53%, 53%);\\n}\\n.navbar-item.is-tab.is-active {\\n  background-color: transparent;\\n  border-bottom-color: hsl(229deg, 53%, 53%);\\n  border-bottom-style: solid;\\n  border-bottom-width: 3px;\\n  color: hsl(229deg, 53%, 53%);\\n  padding-bottom: calc(0.5rem - 3px);\\n}\\n\\n.navbar-content {\\n  -webkit-box-flex: 1;\\n      -ms-flex-positive: 1;\\n          flex-grow: 1;\\n  -ms-flex-negative: 1;\\n      flex-shrink: 1;\\n}\\n\\n.navbar-link:not(.is-arrowless) {\\n  padding-right: 2.5em;\\n}\\n.navbar-link:not(.is-arrowless)::after {\\n  border-color: hsl(229deg, 53%, 53%);\\n  margin-top: -0.375em;\\n  right: 1.125em;\\n}\\n\\n.navbar-dropdown {\\n  font-size: 0.875rem;\\n  padding-bottom: 0.5rem;\\n  padding-top: 0.5rem;\\n}\\n.navbar-dropdown .navbar-item {\\n  padding-left: 1.5rem;\\n  padding-right: 1.5rem;\\n}\\n\\n.navbar-divider {\\n  background-color: hsl(0deg, 0%, 96%);\\n  border: none;\\n  display: none;\\n  height: 2px;\\n  margin: 0.5rem 0;\\n}\\n\\n@media screen and (max-width: 1023px) {\\n  .navbar > .container {\\n    display: block;\\n  }\\n  .navbar-brand .navbar-item,\\n.navbar-tabs .navbar-item {\\n    -webkit-box-align: center;\\n        -ms-flex-align: center;\\n            align-items: center;\\n    display: -webkit-box;\\n    display: -ms-flexbox;\\n    display: flex;\\n  }\\n  .navbar-link::after {\\n    display: none;\\n  }\\n  .navbar-menu {\\n    background-color: hsl(0deg, 0%, 100%);\\n    -webkit-box-shadow: 0 8px 16px rgba(10, 10, 10, 0.1);\\n            box-shadow: 0 8px 16px rgba(10, 10, 10, 0.1);\\n    padding: 0.5rem 0;\\n  }\\n  .navbar-menu.is-active {\\n    display: block;\\n  }\\n  .navbar.is-fixed-bottom-touch, .navbar.is-fixed-top-touch {\\n    left: 0;\\n    position: fixed;\\n    right: 0;\\n    z-index: 30;\\n  }\\n  .navbar.is-fixed-bottom-touch {\\n    bottom: 0;\\n  }\\n  .navbar.is-fixed-bottom-touch.has-shadow {\\n    -webkit-box-shadow: 0 -2px 3px rgba(10, 10, 10, 0.1);\\n            box-shadow: 0 -2px 3px rgba(10, 10, 10, 0.1);\\n  }\\n  .navbar.is-fixed-top-touch {\\n    top: 0;\\n  }\\n  .navbar.is-fixed-top .navbar-menu, .navbar.is-fixed-top-touch .navbar-menu {\\n    -webkit-overflow-scrolling: touch;\\n    max-height: calc(100vh - 3.25rem);\\n    overflow: auto;\\n  }\\n  html.has-navbar-fixed-top-touch,\\nbody.has-navbar-fixed-top-touch {\\n    padding-top: 3.25rem;\\n  }\\n  html.has-navbar-fixed-bottom-touch,\\nbody.has-navbar-fixed-bottom-touch {\\n    padding-bottom: 3.25rem;\\n  }\\n}\\n@media screen and (min-width: 1024px) {\\n  .navbar,\\n.navbar-menu,\\n.navbar-start,\\n.navbar-end {\\n    -webkit-box-align: stretch;\\n        -ms-flex-align: stretch;\\n            align-items: stretch;\\n    display: -webkit-box;\\n    display: -ms-flexbox;\\n    display: flex;\\n  }\\n  .navbar {\\n    min-height: 3.25rem;\\n  }\\n  .navbar.is-spaced {\\n    padding: 1rem 2rem;\\n  }\\n  .navbar.is-spaced .navbar-start,\\n.navbar.is-spaced .navbar-end {\\n    -webkit-box-align: center;\\n        -ms-flex-align: center;\\n            align-items: center;\\n  }\\n  .navbar.is-spaced a.navbar-item,\\n.navbar.is-spaced .navbar-link {\\n    border-radius: 4px;\\n  }\\n  .navbar.is-transparent a.navbar-item:focus, .navbar.is-transparent a.navbar-item:hover, .navbar.is-transparent a.navbar-item.is-active,\\n.navbar.is-transparent .navbar-link:focus,\\n.navbar.is-transparent .navbar-link:hover,\\n.navbar.is-transparent .navbar-link.is-active {\\n    background-color: transparent !important;\\n  }\\n  .navbar.is-transparent .navbar-item.has-dropdown.is-active .navbar-link, .navbar.is-transparent .navbar-item.has-dropdown.is-hoverable:focus .navbar-link, .navbar.is-transparent .navbar-item.has-dropdown.is-hoverable:focus-within .navbar-link, .navbar.is-transparent .navbar-item.has-dropdown.is-hoverable:hover .navbar-link {\\n    background-color: transparent !important;\\n  }\\n  .navbar.is-transparent .navbar-dropdown a.navbar-item:focus, .navbar.is-transparent .navbar-dropdown a.navbar-item:hover {\\n    background-color: hsl(0deg, 0%, 96%);\\n    color: hsl(0deg, 0%, 4%);\\n  }\\n  .navbar.is-transparent .navbar-dropdown a.navbar-item.is-active {\\n    background-color: hsl(0deg, 0%, 96%);\\n    color: hsl(229deg, 53%, 53%);\\n  }\\n  .navbar-burger {\\n    display: none;\\n  }\\n  .navbar-item,\\n.navbar-link {\\n    -webkit-box-align: center;\\n        -ms-flex-align: center;\\n            align-items: center;\\n    display: -webkit-box;\\n    display: -ms-flexbox;\\n    display: flex;\\n  }\\n  .navbar-item.has-dropdown {\\n    -webkit-box-align: stretch;\\n        -ms-flex-align: stretch;\\n            align-items: stretch;\\n  }\\n  .navbar-item.has-dropdown-up .navbar-link::after {\\n    -webkit-transform: rotate(135deg) translate(0.25em, -0.25em);\\n            transform: rotate(135deg) translate(0.25em, -0.25em);\\n  }\\n  .navbar-item.has-dropdown-up .navbar-dropdown {\\n    border-bottom: 2px solid hsl(0deg, 0%, 86%);\\n    border-radius: 6px 6px 0 0;\\n    border-top: none;\\n    bottom: 100%;\\n    -webkit-box-shadow: 0 -8px 8px rgba(10, 10, 10, 0.1);\\n            box-shadow: 0 -8px 8px rgba(10, 10, 10, 0.1);\\n    top: auto;\\n  }\\n  .navbar-item.is-active .navbar-dropdown, .navbar-item.is-hoverable:focus .navbar-dropdown, .navbar-item.is-hoverable:focus-within .navbar-dropdown, .navbar-item.is-hoverable:hover .navbar-dropdown {\\n    display: block;\\n  }\\n  .navbar.is-spaced .navbar-item.is-active .navbar-dropdown, .navbar-item.is-active .navbar-dropdown.is-boxed, .navbar.is-spaced .navbar-item.is-hoverable:focus .navbar-dropdown, .navbar-item.is-hoverable:focus .navbar-dropdown.is-boxed, .navbar.is-spaced .navbar-item.is-hoverable:focus-within .navbar-dropdown, .navbar-item.is-hoverable:focus-within .navbar-dropdown.is-boxed, .navbar.is-spaced .navbar-item.is-hoverable:hover .navbar-dropdown, .navbar-item.is-hoverable:hover .navbar-dropdown.is-boxed {\\n    opacity: 1;\\n    pointer-events: auto;\\n    -webkit-transform: translateY(0);\\n            transform: translateY(0);\\n  }\\n  .navbar-menu {\\n    -webkit-box-flex: 1;\\n        -ms-flex-positive: 1;\\n            flex-grow: 1;\\n    -ms-flex-negative: 0;\\n        flex-shrink: 0;\\n  }\\n  .navbar-start {\\n    -webkit-box-pack: start;\\n        -ms-flex-pack: start;\\n            justify-content: flex-start;\\n    margin-right: auto;\\n  }\\n  .navbar-end {\\n    -webkit-box-pack: end;\\n        -ms-flex-pack: end;\\n            justify-content: flex-end;\\n    margin-left: auto;\\n  }\\n  .navbar-dropdown {\\n    background-color: hsl(0deg, 0%, 100%);\\n    border-bottom-left-radius: 6px;\\n    border-bottom-right-radius: 6px;\\n    border-top: 2px solid hsl(0deg, 0%, 86%);\\n    -webkit-box-shadow: 0 8px 8px rgba(10, 10, 10, 0.1);\\n            box-shadow: 0 8px 8px rgba(10, 10, 10, 0.1);\\n    display: none;\\n    font-size: 0.875rem;\\n    left: 0;\\n    min-width: 100%;\\n    position: absolute;\\n    top: 100%;\\n    z-index: 20;\\n  }\\n  .navbar-dropdown .navbar-item {\\n    padding: 0.375rem 1rem;\\n    white-space: nowrap;\\n  }\\n  .navbar-dropdown a.navbar-item {\\n    padding-right: 3rem;\\n  }\\n  .navbar-dropdown a.navbar-item:focus, .navbar-dropdown a.navbar-item:hover {\\n    background-color: hsl(0deg, 0%, 96%);\\n    color: hsl(0deg, 0%, 4%);\\n  }\\n  .navbar-dropdown a.navbar-item.is-active {\\n    background-color: hsl(0deg, 0%, 96%);\\n    color: hsl(229deg, 53%, 53%);\\n  }\\n  .navbar.is-spaced .navbar-dropdown, .navbar-dropdown.is-boxed {\\n    border-radius: 6px;\\n    border-top: none;\\n    -webkit-box-shadow: 0 8px 8px rgba(10, 10, 10, 0.1), 0 0 0 1px rgba(10, 10, 10, 0.1);\\n            box-shadow: 0 8px 8px rgba(10, 10, 10, 0.1), 0 0 0 1px rgba(10, 10, 10, 0.1);\\n    display: block;\\n    opacity: 0;\\n    pointer-events: none;\\n    top: calc(100% + (-4px));\\n    -webkit-transform: translateY(-5px);\\n            transform: translateY(-5px);\\n    -webkit-transition-duration: 86ms;\\n            transition-duration: 86ms;\\n    -webkit-transition-property: opacity, -webkit-transform;\\n    transition-property: opacity, -webkit-transform;\\n    transition-property: opacity, transform;\\n    transition-property: opacity, transform, -webkit-transform;\\n  }\\n  .navbar-dropdown.is-right {\\n    left: auto;\\n    right: 0;\\n  }\\n  .navbar-divider {\\n    display: block;\\n  }\\n  .navbar > .container .navbar-brand,\\n.container > .navbar .navbar-brand {\\n    margin-left: -0.75rem;\\n  }\\n  .navbar > .container .navbar-menu,\\n.container > .navbar .navbar-menu {\\n    margin-right: -0.75rem;\\n  }\\n  .navbar.is-fixed-bottom-desktop, .navbar.is-fixed-top-desktop {\\n    left: 0;\\n    position: fixed;\\n    right: 0;\\n    z-index: 30;\\n  }\\n  .navbar.is-fixed-bottom-desktop {\\n    bottom: 0;\\n  }\\n  .navbar.is-fixed-bottom-desktop.has-shadow {\\n    -webkit-box-shadow: 0 -2px 3px rgba(10, 10, 10, 0.1);\\n            box-shadow: 0 -2px 3px rgba(10, 10, 10, 0.1);\\n  }\\n  .navbar.is-fixed-top-desktop {\\n    top: 0;\\n  }\\n  html.has-navbar-fixed-top-desktop,\\nbody.has-navbar-fixed-top-desktop {\\n    padding-top: 3.25rem;\\n  }\\n  html.has-navbar-fixed-bottom-desktop,\\nbody.has-navbar-fixed-bottom-desktop {\\n    padding-bottom: 3.25rem;\\n  }\\n  html.has-spaced-navbar-fixed-top,\\nbody.has-spaced-navbar-fixed-top {\\n    padding-top: 5.25rem;\\n  }\\n  html.has-spaced-navbar-fixed-bottom,\\nbody.has-spaced-navbar-fixed-bottom {\\n    padding-bottom: 5.25rem;\\n  }\\n  a.navbar-item.is-active,\\n.navbar-link.is-active {\\n    color: hsl(0deg, 0%, 4%);\\n  }\\n  a.navbar-item.is-active:not(:focus):not(:hover),\\n.navbar-link.is-active:not(:focus):not(:hover) {\\n    background-color: transparent;\\n  }\\n  .navbar-item.has-dropdown:focus .navbar-link, .navbar-item.has-dropdown:hover .navbar-link, .navbar-item.has-dropdown.is-active .navbar-link {\\n    background-color: hsl(0deg, 0%, 98%);\\n  }\\n}\\n.hero.is-fullheight-with-navbar {\\n  min-height: calc(100vh - 3.25rem);\\n}\\n\\n.pagination {\\n  font-size: 1rem;\\n  margin: -0.25rem;\\n}\\n.pagination.is-small {\\n  font-size: 0.75rem;\\n}\\n.pagination.is-medium {\\n  font-size: 1.25rem;\\n}\\n.pagination.is-large {\\n  font-size: 1.5rem;\\n}\\n.pagination.is-rounded .pagination-previous,\\n.pagination.is-rounded .pagination-next {\\n  padding-left: 1em;\\n  padding-right: 1em;\\n  border-radius: 9999px;\\n}\\n.pagination.is-rounded .pagination-link {\\n  border-radius: 9999px;\\n}\\n\\n.pagination,\\n.pagination-list {\\n  -webkit-box-align: center;\\n      -ms-flex-align: center;\\n          align-items: center;\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n  -webkit-box-pack: center;\\n      -ms-flex-pack: center;\\n          justify-content: center;\\n  text-align: center;\\n}\\n\\n.pagination-previous,\\n.pagination-next,\\n.pagination-link,\\n.pagination-ellipsis {\\n  font-size: 1em;\\n  -webkit-box-pack: center;\\n      -ms-flex-pack: center;\\n          justify-content: center;\\n  margin: 0.25rem;\\n  padding-left: 0.5em;\\n  padding-right: 0.5em;\\n  text-align: center;\\n}\\n\\n.pagination-previous,\\n.pagination-next,\\n.pagination-link {\\n  border-color: hsl(0deg, 0%, 86%);\\n  color: hsl(0deg, 0%, 21%);\\n  min-width: 2.5em;\\n}\\n.pagination-previous:hover,\\n.pagination-next:hover,\\n.pagination-link:hover {\\n  border-color: hsl(0deg, 0%, 71%);\\n  color: hsl(0deg, 0%, 21%);\\n}\\n.pagination-previous:focus,\\n.pagination-next:focus,\\n.pagination-link:focus {\\n  border-color: hsl(229deg, 53%, 53%);\\n}\\n.pagination-previous:active,\\n.pagination-next:active,\\n.pagination-link:active {\\n  -webkit-box-shadow: inset 0 1px 2px rgba(10, 10, 10, 0.2);\\n          box-shadow: inset 0 1px 2px rgba(10, 10, 10, 0.2);\\n}\\n.pagination-previous[disabled],\\n.pagination-next[disabled],\\n.pagination-link[disabled] {\\n  background-color: hsl(0deg, 0%, 86%);\\n  border-color: hsl(0deg, 0%, 86%);\\n  -webkit-box-shadow: none;\\n          box-shadow: none;\\n  color: hsl(0deg, 0%, 48%);\\n  opacity: 0.5;\\n}\\n\\n.pagination-previous,\\n.pagination-next {\\n  padding-left: 0.75em;\\n  padding-right: 0.75em;\\n  white-space: nowrap;\\n}\\n\\n.pagination-link.is-current {\\n  background-color: hsl(229deg, 53%, 53%);\\n  border-color: hsl(229deg, 53%, 53%);\\n  color: #fff;\\n}\\n\\n.pagination-ellipsis {\\n  color: hsl(0deg, 0%, 71%);\\n  pointer-events: none;\\n}\\n\\n.pagination-list {\\n  -ms-flex-wrap: wrap;\\n      flex-wrap: wrap;\\n}\\n.pagination-list li {\\n  list-style: none;\\n}\\n\\n@media screen and (max-width: 768px) {\\n  .pagination {\\n    -ms-flex-wrap: wrap;\\n        flex-wrap: wrap;\\n  }\\n  .pagination-previous,\\n.pagination-next {\\n    -webkit-box-flex: 1;\\n        -ms-flex-positive: 1;\\n            flex-grow: 1;\\n    -ms-flex-negative: 1;\\n        flex-shrink: 1;\\n  }\\n  .pagination-list li {\\n    -webkit-box-flex: 1;\\n        -ms-flex-positive: 1;\\n            flex-grow: 1;\\n    -ms-flex-negative: 1;\\n        flex-shrink: 1;\\n  }\\n}\\n@media screen and (min-width: 769px), print {\\n  .pagination-list {\\n    -webkit-box-flex: 1;\\n        -ms-flex-positive: 1;\\n            flex-grow: 1;\\n    -ms-flex-negative: 1;\\n        flex-shrink: 1;\\n    -webkit-box-pack: start;\\n        -ms-flex-pack: start;\\n            justify-content: flex-start;\\n    -webkit-box-ordinal-group: 2;\\n        -ms-flex-order: 1;\\n            order: 1;\\n  }\\n  .pagination-previous,\\n.pagination-next,\\n.pagination-link,\\n.pagination-ellipsis {\\n    margin-bottom: 0;\\n    margin-top: 0;\\n  }\\n  .pagination-previous {\\n    -webkit-box-ordinal-group: 3;\\n        -ms-flex-order: 2;\\n            order: 2;\\n  }\\n  .pagination-next {\\n    -webkit-box-ordinal-group: 4;\\n        -ms-flex-order: 3;\\n            order: 3;\\n  }\\n  .pagination {\\n    -webkit-box-pack: justify;\\n        -ms-flex-pack: justify;\\n            justify-content: space-between;\\n    margin-bottom: 0;\\n    margin-top: 0;\\n  }\\n  .pagination.is-centered .pagination-previous {\\n    -webkit-box-ordinal-group: 2;\\n        -ms-flex-order: 1;\\n            order: 1;\\n  }\\n  .pagination.is-centered .pagination-list {\\n    -webkit-box-pack: center;\\n        -ms-flex-pack: center;\\n            justify-content: center;\\n    -webkit-box-ordinal-group: 3;\\n        -ms-flex-order: 2;\\n            order: 2;\\n  }\\n  .pagination.is-centered .pagination-next {\\n    -webkit-box-ordinal-group: 4;\\n        -ms-flex-order: 3;\\n            order: 3;\\n  }\\n  .pagination.is-right .pagination-previous {\\n    -webkit-box-ordinal-group: 2;\\n        -ms-flex-order: 1;\\n            order: 1;\\n  }\\n  .pagination.is-right .pagination-next {\\n    -webkit-box-ordinal-group: 3;\\n        -ms-flex-order: 2;\\n            order: 2;\\n  }\\n  .pagination.is-right .pagination-list {\\n    -webkit-box-pack: end;\\n        -ms-flex-pack: end;\\n            justify-content: flex-end;\\n    -webkit-box-ordinal-group: 4;\\n        -ms-flex-order: 3;\\n            order: 3;\\n  }\\n}\\n.panel {\\n  border-radius: 6px;\\n  -webkit-box-shadow: 0 0.5em 1em -0.125em rgba(10, 10, 10, 0.1), 0 0px 0 1px rgba(10, 10, 10, 0.02);\\n          box-shadow: 0 0.5em 1em -0.125em rgba(10, 10, 10, 0.1), 0 0px 0 1px rgba(10, 10, 10, 0.02);\\n  font-size: 1rem;\\n}\\n.panel:not(:last-child) {\\n  margin-bottom: 1.5rem;\\n}\\n.panel.is-white .panel-heading {\\n  background-color: hsl(0deg, 0%, 100%);\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.panel.is-white .panel-tabs a.is-active {\\n  border-bottom-color: hsl(0deg, 0%, 100%);\\n}\\n.panel.is-white .panel-block.is-active .panel-icon {\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.panel.is-black .panel-heading {\\n  background-color: hsl(0deg, 0%, 4%);\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.panel.is-black .panel-tabs a.is-active {\\n  border-bottom-color: hsl(0deg, 0%, 4%);\\n}\\n.panel.is-black .panel-block.is-active .panel-icon {\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.panel.is-light .panel-heading {\\n  background-color: hsl(0deg, 0%, 96%);\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.panel.is-light .panel-tabs a.is-active {\\n  border-bottom-color: hsl(0deg, 0%, 96%);\\n}\\n.panel.is-light .panel-block.is-active .panel-icon {\\n  color: hsl(0deg, 0%, 96%);\\n}\\n.panel.is-dark .panel-heading {\\n  background-color: hsl(0deg, 0%, 21%);\\n  color: #fff;\\n}\\n.panel.is-dark .panel-tabs a.is-active {\\n  border-bottom-color: hsl(0deg, 0%, 21%);\\n}\\n.panel.is-dark .panel-block.is-active .panel-icon {\\n  color: hsl(0deg, 0%, 21%);\\n}\\n.panel.is-primary .panel-heading {\\n  background-color: hsl(171deg, 100%, 41%);\\n  color: #fff;\\n}\\n.panel.is-primary .panel-tabs a.is-active {\\n  border-bottom-color: hsl(171deg, 100%, 41%);\\n}\\n.panel.is-primary .panel-block.is-active .panel-icon {\\n  color: hsl(171deg, 100%, 41%);\\n}\\n.panel.is-link .panel-heading {\\n  background-color: hsl(229deg, 53%, 53%);\\n  color: #fff;\\n}\\n.panel.is-link .panel-tabs a.is-active {\\n  border-bottom-color: hsl(229deg, 53%, 53%);\\n}\\n.panel.is-link .panel-block.is-active .panel-icon {\\n  color: hsl(229deg, 53%, 53%);\\n}\\n.panel.is-info .panel-heading {\\n  background-color: hsl(207deg, 61%, 53%);\\n  color: #fff;\\n}\\n.panel.is-info .panel-tabs a.is-active {\\n  border-bottom-color: hsl(207deg, 61%, 53%);\\n}\\n.panel.is-info .panel-block.is-active .panel-icon {\\n  color: hsl(207deg, 61%, 53%);\\n}\\n.panel.is-success .panel-heading {\\n  background-color: hsl(153deg, 53%, 53%);\\n  color: #fff;\\n}\\n.panel.is-success .panel-tabs a.is-active {\\n  border-bottom-color: hsl(153deg, 53%, 53%);\\n}\\n.panel.is-success .panel-block.is-active .panel-icon {\\n  color: hsl(153deg, 53%, 53%);\\n}\\n.panel.is-warning .panel-heading {\\n  background-color: hsl(44deg, 100%, 77%);\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.panel.is-warning .panel-tabs a.is-active {\\n  border-bottom-color: hsl(44deg, 100%, 77%);\\n}\\n.panel.is-warning .panel-block.is-active .panel-icon {\\n  color: hsl(44deg, 100%, 77%);\\n}\\n.panel.is-danger .panel-heading {\\n  background-color: hsl(348deg, 86%, 61%);\\n  color: #fff;\\n}\\n.panel.is-danger .panel-tabs a.is-active {\\n  border-bottom-color: hsl(348deg, 86%, 61%);\\n}\\n.panel.is-danger .panel-block.is-active .panel-icon {\\n  color: hsl(348deg, 86%, 61%);\\n}\\n\\n.panel-tabs:not(:last-child),\\n.panel-block:not(:last-child) {\\n  border-bottom: 1px solid hsl(0deg, 0%, 93%);\\n}\\n\\n.panel-heading {\\n  background-color: hsl(0deg, 0%, 93%);\\n  border-radius: 6px 6px 0 0;\\n  color: hsl(0deg, 0%, 21%);\\n  font-size: 1.25em;\\n  font-weight: 700;\\n  line-height: 1.25;\\n  padding: 0.75em 1em;\\n}\\n\\n.panel-tabs {\\n  -webkit-box-align: end;\\n      -ms-flex-align: end;\\n          align-items: flex-end;\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n  font-size: 0.875em;\\n  -webkit-box-pack: center;\\n      -ms-flex-pack: center;\\n          justify-content: center;\\n}\\n.panel-tabs a {\\n  border-bottom: 1px solid hsl(0deg, 0%, 86%);\\n  margin-bottom: -1px;\\n  padding: 0.5em;\\n}\\n.panel-tabs a.is-active {\\n  border-bottom-color: hsl(0deg, 0%, 29%);\\n  color: hsl(0deg, 0%, 21%);\\n}\\n\\n.panel-list a {\\n  color: hsl(0deg, 0%, 29%);\\n}\\n.panel-list a:hover {\\n  color: hsl(229deg, 53%, 53%);\\n}\\n\\n.panel-block {\\n  -webkit-box-align: center;\\n      -ms-flex-align: center;\\n          align-items: center;\\n  color: hsl(0deg, 0%, 21%);\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n  -webkit-box-pack: start;\\n      -ms-flex-pack: start;\\n          justify-content: flex-start;\\n  padding: 0.5em 0.75em;\\n}\\n.panel-block input[type=checkbox] {\\n  margin-right: 0.75em;\\n}\\n.panel-block > .control {\\n  -webkit-box-flex: 1;\\n      -ms-flex-positive: 1;\\n          flex-grow: 1;\\n  -ms-flex-negative: 1;\\n      flex-shrink: 1;\\n  width: 100%;\\n}\\n.panel-block.is-wrapped {\\n  -ms-flex-wrap: wrap;\\n      flex-wrap: wrap;\\n}\\n.panel-block.is-active {\\n  border-left-color: hsl(229deg, 53%, 53%);\\n  color: hsl(0deg, 0%, 21%);\\n}\\n.panel-block.is-active .panel-icon {\\n  color: hsl(229deg, 53%, 53%);\\n}\\n.panel-block:last-child {\\n  border-bottom-left-radius: 6px;\\n  border-bottom-right-radius: 6px;\\n}\\n\\na.panel-block,\\nlabel.panel-block {\\n  cursor: pointer;\\n}\\na.panel-block:hover,\\nlabel.panel-block:hover {\\n  background-color: hsl(0deg, 0%, 96%);\\n}\\n\\n.panel-icon {\\n  display: inline-block;\\n  font-size: 14px;\\n  height: 1em;\\n  line-height: 1em;\\n  text-align: center;\\n  vertical-align: top;\\n  width: 1em;\\n  color: hsl(0deg, 0%, 48%);\\n  margin-right: 0.75em;\\n}\\n.panel-icon .fa {\\n  font-size: inherit;\\n  line-height: inherit;\\n}\\n\\n.tabs {\\n  -webkit-overflow-scrolling: touch;\\n  -webkit-box-align: stretch;\\n      -ms-flex-align: stretch;\\n          align-items: stretch;\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n  font-size: 1rem;\\n  -webkit-box-pack: justify;\\n      -ms-flex-pack: justify;\\n          justify-content: space-between;\\n  overflow: hidden;\\n  overflow-x: auto;\\n  white-space: nowrap;\\n}\\n.tabs a {\\n  -webkit-box-align: center;\\n      -ms-flex-align: center;\\n          align-items: center;\\n  border-bottom-color: hsl(0deg, 0%, 86%);\\n  border-bottom-style: solid;\\n  border-bottom-width: 1px;\\n  color: hsl(0deg, 0%, 29%);\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n  -webkit-box-pack: center;\\n      -ms-flex-pack: center;\\n          justify-content: center;\\n  margin-bottom: -1px;\\n  padding: 0.5em 1em;\\n  vertical-align: top;\\n}\\n.tabs a:hover {\\n  border-bottom-color: hsl(0deg, 0%, 21%);\\n  color: hsl(0deg, 0%, 21%);\\n}\\n.tabs li {\\n  display: block;\\n}\\n.tabs li.is-active a {\\n  border-bottom-color: hsl(229deg, 53%, 53%);\\n  color: hsl(229deg, 53%, 53%);\\n}\\n.tabs ul {\\n  -webkit-box-align: center;\\n      -ms-flex-align: center;\\n          align-items: center;\\n  border-bottom-color: hsl(0deg, 0%, 86%);\\n  border-bottom-style: solid;\\n  border-bottom-width: 1px;\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n  -webkit-box-flex: 1;\\n      -ms-flex-positive: 1;\\n          flex-grow: 1;\\n  -ms-flex-negative: 0;\\n      flex-shrink: 0;\\n  -webkit-box-pack: start;\\n      -ms-flex-pack: start;\\n          justify-content: flex-start;\\n}\\n.tabs ul.is-left {\\n  padding-right: 0.75em;\\n}\\n.tabs ul.is-center {\\n  -webkit-box-flex: 0;\\n      -ms-flex: none;\\n          flex: none;\\n  -webkit-box-pack: center;\\n      -ms-flex-pack: center;\\n          justify-content: center;\\n  padding-left: 0.75em;\\n  padding-right: 0.75em;\\n}\\n.tabs ul.is-right {\\n  -webkit-box-pack: end;\\n      -ms-flex-pack: end;\\n          justify-content: flex-end;\\n  padding-left: 0.75em;\\n}\\n.tabs .icon:first-child {\\n  margin-right: 0.5em;\\n}\\n.tabs .icon:last-child {\\n  margin-left: 0.5em;\\n}\\n.tabs.is-centered ul {\\n  -webkit-box-pack: center;\\n      -ms-flex-pack: center;\\n          justify-content: center;\\n}\\n.tabs.is-right ul {\\n  -webkit-box-pack: end;\\n      -ms-flex-pack: end;\\n          justify-content: flex-end;\\n}\\n.tabs.is-boxed a {\\n  border: 1px solid transparent;\\n  border-radius: 4px 4px 0 0;\\n}\\n.tabs.is-boxed a:hover {\\n  background-color: hsl(0deg, 0%, 96%);\\n  border-bottom-color: hsl(0deg, 0%, 86%);\\n}\\n.tabs.is-boxed li.is-active a {\\n  background-color: hsl(0deg, 0%, 100%);\\n  border-color: hsl(0deg, 0%, 86%);\\n  border-bottom-color: transparent !important;\\n}\\n.tabs.is-fullwidth li {\\n  -webkit-box-flex: 1;\\n      -ms-flex-positive: 1;\\n          flex-grow: 1;\\n  -ms-flex-negative: 0;\\n      flex-shrink: 0;\\n}\\n.tabs.is-toggle a {\\n  border-color: hsl(0deg, 0%, 86%);\\n  border-style: solid;\\n  border-width: 1px;\\n  margin-bottom: 0;\\n  position: relative;\\n}\\n.tabs.is-toggle a:hover {\\n  background-color: hsl(0deg, 0%, 96%);\\n  border-color: hsl(0deg, 0%, 71%);\\n  z-index: 2;\\n}\\n.tabs.is-toggle li + li {\\n  margin-left: -1px;\\n}\\n.tabs.is-toggle li:first-child a {\\n  border-top-left-radius: 4px;\\n  border-bottom-left-radius: 4px;\\n}\\n.tabs.is-toggle li:last-child a {\\n  border-top-right-radius: 4px;\\n  border-bottom-right-radius: 4px;\\n}\\n.tabs.is-toggle li.is-active a {\\n  background-color: hsl(229deg, 53%, 53%);\\n  border-color: hsl(229deg, 53%, 53%);\\n  color: #fff;\\n  z-index: 1;\\n}\\n.tabs.is-toggle ul {\\n  border-bottom: none;\\n}\\n.tabs.is-toggle.is-toggle-rounded li:first-child a {\\n  border-bottom-left-radius: 9999px;\\n  border-top-left-radius: 9999px;\\n  padding-left: 1.25em;\\n}\\n.tabs.is-toggle.is-toggle-rounded li:last-child a {\\n  border-bottom-right-radius: 9999px;\\n  border-top-right-radius: 9999px;\\n  padding-right: 1.25em;\\n}\\n.tabs.is-small {\\n  font-size: 0.75rem;\\n}\\n.tabs.is-medium {\\n  font-size: 1.25rem;\\n}\\n.tabs.is-large {\\n  font-size: 1.5rem;\\n}\\n\\n/* Bulma Grid */\\n.column {\\n  display: block;\\n  -ms-flex-preferred-size: 0;\\n      flex-basis: 0;\\n  -webkit-box-flex: 1;\\n      -ms-flex-positive: 1;\\n          flex-grow: 1;\\n  -ms-flex-negative: 1;\\n      flex-shrink: 1;\\n  padding: 0.75rem;\\n}\\n.columns.is-mobile > .column.is-narrow {\\n  -webkit-box-flex: 0;\\n      -ms-flex: none;\\n          flex: none;\\n  width: unset;\\n}\\n.columns.is-mobile > .column.is-full {\\n  -webkit-box-flex: 0;\\n      -ms-flex: none;\\n          flex: none;\\n  width: 100%;\\n}\\n.columns.is-mobile > .column.is-three-quarters {\\n  -webkit-box-flex: 0;\\n      -ms-flex: none;\\n          flex: none;\\n  width: 75%;\\n}\\n.columns.is-mobile > .column.is-two-thirds {\\n  -webkit-box-flex: 0;\\n      -ms-flex: none;\\n          flex: none;\\n  width: 66.6666%;\\n}\\n.columns.is-mobile > .column.is-half {\\n  -webkit-box-flex: 0;\\n      -ms-flex: none;\\n          flex: none;\\n  width: 50%;\\n}\\n.columns.is-mobile > .column.is-one-third {\\n  -webkit-box-flex: 0;\\n      -ms-flex: none;\\n          flex: none;\\n  width: 33.3333%;\\n}\\n.columns.is-mobile > .column.is-one-quarter {\\n  -webkit-box-flex: 0;\\n      -ms-flex: none;\\n          flex: none;\\n  width: 25%;\\n}\\n.columns.is-mobile > .column.is-one-fifth {\\n  -webkit-box-flex: 0;\\n      -ms-flex: none;\\n          flex: none;\\n  width: 20%;\\n}\\n.columns.is-mobile > .column.is-two-fifths {\\n  -webkit-box-flex: 0;\\n      -ms-flex: none;\\n          flex: none;\\n  width: 40%;\\n}\\n.columns.is-mobile > .column.is-three-fifths {\\n  -webkit-box-flex: 0;\\n      -ms-flex: none;\\n          flex: none;\\n  width: 60%;\\n}\\n.columns.is-mobile > .column.is-four-fifths {\\n  -webkit-box-flex: 0;\\n      -ms-flex: none;\\n          flex: none;\\n  width: 80%;\\n}\\n.columns.is-mobile > .column.is-offset-three-quarters {\\n  margin-left: 75%;\\n}\\n.columns.is-mobile > .column.is-offset-two-thirds {\\n  margin-left: 66.6666%;\\n}\\n.columns.is-mobile > .column.is-offset-half {\\n  margin-left: 50%;\\n}\\n.columns.is-mobile > .column.is-offset-one-third {\\n  margin-left: 33.3333%;\\n}\\n.columns.is-mobile > .column.is-offset-one-quarter {\\n  margin-left: 25%;\\n}\\n.columns.is-mobile > .column.is-offset-one-fifth {\\n  margin-left: 20%;\\n}\\n.columns.is-mobile > .column.is-offset-two-fifths {\\n  margin-left: 40%;\\n}\\n.columns.is-mobile > .column.is-offset-three-fifths {\\n  margin-left: 60%;\\n}\\n.columns.is-mobile > .column.is-offset-four-fifths {\\n  margin-left: 80%;\\n}\\n.columns.is-mobile > .column.is-0 {\\n  -webkit-box-flex: 0;\\n      -ms-flex: none;\\n          flex: none;\\n  width: 0%;\\n}\\n.columns.is-mobile > .column.is-offset-0 {\\n  margin-left: 0%;\\n}\\n.columns.is-mobile > .column.is-1 {\\n  -webkit-box-flex: 0;\\n      -ms-flex: none;\\n          flex: none;\\n  width: 8.33333337%;\\n}\\n.columns.is-mobile > .column.is-offset-1 {\\n  margin-left: 8.33333337%;\\n}\\n.columns.is-mobile > .column.is-2 {\\n  -webkit-box-flex: 0;\\n      -ms-flex: none;\\n          flex: none;\\n  width: 16.66666674%;\\n}\\n.columns.is-mobile > .column.is-offset-2 {\\n  margin-left: 16.66666674%;\\n}\\n.columns.is-mobile > .column.is-3 {\\n  -webkit-box-flex: 0;\\n      -ms-flex: none;\\n          flex: none;\\n  width: 25%;\\n}\\n.columns.is-mobile > .column.is-offset-3 {\\n  margin-left: 25%;\\n}\\n.columns.is-mobile > .column.is-4 {\\n  -webkit-box-flex: 0;\\n      -ms-flex: none;\\n          flex: none;\\n  width: 33.33333337%;\\n}\\n.columns.is-mobile > .column.is-offset-4 {\\n  margin-left: 33.33333337%;\\n}\\n.columns.is-mobile > .column.is-5 {\\n  -webkit-box-flex: 0;\\n      -ms-flex: none;\\n          flex: none;\\n  width: 41.66666674%;\\n}\\n.columns.is-mobile > .column.is-offset-5 {\\n  margin-left: 41.66666674%;\\n}\\n.columns.is-mobile > .column.is-6 {\\n  -webkit-box-flex: 0;\\n      -ms-flex: none;\\n          flex: none;\\n  width: 50%;\\n}\\n.columns.is-mobile > .column.is-offset-6 {\\n  margin-left: 50%;\\n}\\n.columns.is-mobile > .column.is-7 {\\n  -webkit-box-flex: 0;\\n      -ms-flex: none;\\n          flex: none;\\n  width: 58.33333337%;\\n}\\n.columns.is-mobile > .column.is-offset-7 {\\n  margin-left: 58.33333337%;\\n}\\n.columns.is-mobile > .column.is-8 {\\n  -webkit-box-flex: 0;\\n      -ms-flex: none;\\n          flex: none;\\n  width: 66.66666674%;\\n}\\n.columns.is-mobile > .column.is-offset-8 {\\n  margin-left: 66.66666674%;\\n}\\n.columns.is-mobile > .column.is-9 {\\n  -webkit-box-flex: 0;\\n      -ms-flex: none;\\n          flex: none;\\n  width: 75%;\\n}\\n.columns.is-mobile > .column.is-offset-9 {\\n  margin-left: 75%;\\n}\\n.columns.is-mobile > .column.is-10 {\\n  -webkit-box-flex: 0;\\n      -ms-flex: none;\\n          flex: none;\\n  width: 83.33333337%;\\n}\\n.columns.is-mobile > .column.is-offset-10 {\\n  margin-left: 83.33333337%;\\n}\\n.columns.is-mobile > .column.is-11 {\\n  -webkit-box-flex: 0;\\n      -ms-flex: none;\\n          flex: none;\\n  width: 91.66666674%;\\n}\\n.columns.is-mobile > .column.is-offset-11 {\\n  margin-left: 91.66666674%;\\n}\\n.columns.is-mobile > .column.is-12 {\\n  -webkit-box-flex: 0;\\n      -ms-flex: none;\\n          flex: none;\\n  width: 100%;\\n}\\n.columns.is-mobile > .column.is-offset-12 {\\n  margin-left: 100%;\\n}\\n@media screen and (max-width: 768px) {\\n  .column.is-narrow-mobile {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: unset;\\n  }\\n  .column.is-full-mobile {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 100%;\\n  }\\n  .column.is-three-quarters-mobile {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 75%;\\n  }\\n  .column.is-two-thirds-mobile {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 66.6666%;\\n  }\\n  .column.is-half-mobile {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 50%;\\n  }\\n  .column.is-one-third-mobile {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 33.3333%;\\n  }\\n  .column.is-one-quarter-mobile {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 25%;\\n  }\\n  .column.is-one-fifth-mobile {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 20%;\\n  }\\n  .column.is-two-fifths-mobile {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 40%;\\n  }\\n  .column.is-three-fifths-mobile {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 60%;\\n  }\\n  .column.is-four-fifths-mobile {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 80%;\\n  }\\n  .column.is-offset-three-quarters-mobile {\\n    margin-left: 75%;\\n  }\\n  .column.is-offset-two-thirds-mobile {\\n    margin-left: 66.6666%;\\n  }\\n  .column.is-offset-half-mobile {\\n    margin-left: 50%;\\n  }\\n  .column.is-offset-one-third-mobile {\\n    margin-left: 33.3333%;\\n  }\\n  .column.is-offset-one-quarter-mobile {\\n    margin-left: 25%;\\n  }\\n  .column.is-offset-one-fifth-mobile {\\n    margin-left: 20%;\\n  }\\n  .column.is-offset-two-fifths-mobile {\\n    margin-left: 40%;\\n  }\\n  .column.is-offset-three-fifths-mobile {\\n    margin-left: 60%;\\n  }\\n  .column.is-offset-four-fifths-mobile {\\n    margin-left: 80%;\\n  }\\n  .column.is-0-mobile {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 0%;\\n  }\\n  .column.is-offset-0-mobile {\\n    margin-left: 0%;\\n  }\\n  .column.is-1-mobile {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 8.33333337%;\\n  }\\n  .column.is-offset-1-mobile {\\n    margin-left: 8.33333337%;\\n  }\\n  .column.is-2-mobile {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 16.66666674%;\\n  }\\n  .column.is-offset-2-mobile {\\n    margin-left: 16.66666674%;\\n  }\\n  .column.is-3-mobile {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 25%;\\n  }\\n  .column.is-offset-3-mobile {\\n    margin-left: 25%;\\n  }\\n  .column.is-4-mobile {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 33.33333337%;\\n  }\\n  .column.is-offset-4-mobile {\\n    margin-left: 33.33333337%;\\n  }\\n  .column.is-5-mobile {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 41.66666674%;\\n  }\\n  .column.is-offset-5-mobile {\\n    margin-left: 41.66666674%;\\n  }\\n  .column.is-6-mobile {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 50%;\\n  }\\n  .column.is-offset-6-mobile {\\n    margin-left: 50%;\\n  }\\n  .column.is-7-mobile {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 58.33333337%;\\n  }\\n  .column.is-offset-7-mobile {\\n    margin-left: 58.33333337%;\\n  }\\n  .column.is-8-mobile {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 66.66666674%;\\n  }\\n  .column.is-offset-8-mobile {\\n    margin-left: 66.66666674%;\\n  }\\n  .column.is-9-mobile {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 75%;\\n  }\\n  .column.is-offset-9-mobile {\\n    margin-left: 75%;\\n  }\\n  .column.is-10-mobile {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 83.33333337%;\\n  }\\n  .column.is-offset-10-mobile {\\n    margin-left: 83.33333337%;\\n  }\\n  .column.is-11-mobile {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 91.66666674%;\\n  }\\n  .column.is-offset-11-mobile {\\n    margin-left: 91.66666674%;\\n  }\\n  .column.is-12-mobile {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 100%;\\n  }\\n  .column.is-offset-12-mobile {\\n    margin-left: 100%;\\n  }\\n}\\n@media screen and (min-width: 769px), print {\\n  .column.is-narrow, .column.is-narrow-tablet {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: unset;\\n  }\\n  .column.is-full, .column.is-full-tablet {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 100%;\\n  }\\n  .column.is-three-quarters, .column.is-three-quarters-tablet {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 75%;\\n  }\\n  .column.is-two-thirds, .column.is-two-thirds-tablet {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 66.6666%;\\n  }\\n  .column.is-half, .column.is-half-tablet {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 50%;\\n  }\\n  .column.is-one-third, .column.is-one-third-tablet {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 33.3333%;\\n  }\\n  .column.is-one-quarter, .column.is-one-quarter-tablet {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 25%;\\n  }\\n  .column.is-one-fifth, .column.is-one-fifth-tablet {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 20%;\\n  }\\n  .column.is-two-fifths, .column.is-two-fifths-tablet {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 40%;\\n  }\\n  .column.is-three-fifths, .column.is-three-fifths-tablet {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 60%;\\n  }\\n  .column.is-four-fifths, .column.is-four-fifths-tablet {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 80%;\\n  }\\n  .column.is-offset-three-quarters, .column.is-offset-three-quarters-tablet {\\n    margin-left: 75%;\\n  }\\n  .column.is-offset-two-thirds, .column.is-offset-two-thirds-tablet {\\n    margin-left: 66.6666%;\\n  }\\n  .column.is-offset-half, .column.is-offset-half-tablet {\\n    margin-left: 50%;\\n  }\\n  .column.is-offset-one-third, .column.is-offset-one-third-tablet {\\n    margin-left: 33.3333%;\\n  }\\n  .column.is-offset-one-quarter, .column.is-offset-one-quarter-tablet {\\n    margin-left: 25%;\\n  }\\n  .column.is-offset-one-fifth, .column.is-offset-one-fifth-tablet {\\n    margin-left: 20%;\\n  }\\n  .column.is-offset-two-fifths, .column.is-offset-two-fifths-tablet {\\n    margin-left: 40%;\\n  }\\n  .column.is-offset-three-fifths, .column.is-offset-three-fifths-tablet {\\n    margin-left: 60%;\\n  }\\n  .column.is-offset-four-fifths, .column.is-offset-four-fifths-tablet {\\n    margin-left: 80%;\\n  }\\n  .column.is-0, .column.is-0-tablet {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 0%;\\n  }\\n  .column.is-offset-0, .column.is-offset-0-tablet {\\n    margin-left: 0%;\\n  }\\n  .column.is-1, .column.is-1-tablet {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 8.33333337%;\\n  }\\n  .column.is-offset-1, .column.is-offset-1-tablet {\\n    margin-left: 8.33333337%;\\n  }\\n  .column.is-2, .column.is-2-tablet {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 16.66666674%;\\n  }\\n  .column.is-offset-2, .column.is-offset-2-tablet {\\n    margin-left: 16.66666674%;\\n  }\\n  .column.is-3, .column.is-3-tablet {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 25%;\\n  }\\n  .column.is-offset-3, .column.is-offset-3-tablet {\\n    margin-left: 25%;\\n  }\\n  .column.is-4, .column.is-4-tablet {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 33.33333337%;\\n  }\\n  .column.is-offset-4, .column.is-offset-4-tablet {\\n    margin-left: 33.33333337%;\\n  }\\n  .column.is-5, .column.is-5-tablet {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 41.66666674%;\\n  }\\n  .column.is-offset-5, .column.is-offset-5-tablet {\\n    margin-left: 41.66666674%;\\n  }\\n  .column.is-6, .column.is-6-tablet {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 50%;\\n  }\\n  .column.is-offset-6, .column.is-offset-6-tablet {\\n    margin-left: 50%;\\n  }\\n  .column.is-7, .column.is-7-tablet {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 58.33333337%;\\n  }\\n  .column.is-offset-7, .column.is-offset-7-tablet {\\n    margin-left: 58.33333337%;\\n  }\\n  .column.is-8, .column.is-8-tablet {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 66.66666674%;\\n  }\\n  .column.is-offset-8, .column.is-offset-8-tablet {\\n    margin-left: 66.66666674%;\\n  }\\n  .column.is-9, .column.is-9-tablet {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 75%;\\n  }\\n  .column.is-offset-9, .column.is-offset-9-tablet {\\n    margin-left: 75%;\\n  }\\n  .column.is-10, .column.is-10-tablet {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 83.33333337%;\\n  }\\n  .column.is-offset-10, .column.is-offset-10-tablet {\\n    margin-left: 83.33333337%;\\n  }\\n  .column.is-11, .column.is-11-tablet {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 91.66666674%;\\n  }\\n  .column.is-offset-11, .column.is-offset-11-tablet {\\n    margin-left: 91.66666674%;\\n  }\\n  .column.is-12, .column.is-12-tablet {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 100%;\\n  }\\n  .column.is-offset-12, .column.is-offset-12-tablet {\\n    margin-left: 100%;\\n  }\\n}\\n@media screen and (max-width: 1023px) {\\n  .column.is-narrow-touch {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: unset;\\n  }\\n  .column.is-full-touch {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 100%;\\n  }\\n  .column.is-three-quarters-touch {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 75%;\\n  }\\n  .column.is-two-thirds-touch {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 66.6666%;\\n  }\\n  .column.is-half-touch {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 50%;\\n  }\\n  .column.is-one-third-touch {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 33.3333%;\\n  }\\n  .column.is-one-quarter-touch {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 25%;\\n  }\\n  .column.is-one-fifth-touch {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 20%;\\n  }\\n  .column.is-two-fifths-touch {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 40%;\\n  }\\n  .column.is-three-fifths-touch {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 60%;\\n  }\\n  .column.is-four-fifths-touch {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 80%;\\n  }\\n  .column.is-offset-three-quarters-touch {\\n    margin-left: 75%;\\n  }\\n  .column.is-offset-two-thirds-touch {\\n    margin-left: 66.6666%;\\n  }\\n  .column.is-offset-half-touch {\\n    margin-left: 50%;\\n  }\\n  .column.is-offset-one-third-touch {\\n    margin-left: 33.3333%;\\n  }\\n  .column.is-offset-one-quarter-touch {\\n    margin-left: 25%;\\n  }\\n  .column.is-offset-one-fifth-touch {\\n    margin-left: 20%;\\n  }\\n  .column.is-offset-two-fifths-touch {\\n    margin-left: 40%;\\n  }\\n  .column.is-offset-three-fifths-touch {\\n    margin-left: 60%;\\n  }\\n  .column.is-offset-four-fifths-touch {\\n    margin-left: 80%;\\n  }\\n  .column.is-0-touch {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 0%;\\n  }\\n  .column.is-offset-0-touch {\\n    margin-left: 0%;\\n  }\\n  .column.is-1-touch {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 8.33333337%;\\n  }\\n  .column.is-offset-1-touch {\\n    margin-left: 8.33333337%;\\n  }\\n  .column.is-2-touch {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 16.66666674%;\\n  }\\n  .column.is-offset-2-touch {\\n    margin-left: 16.66666674%;\\n  }\\n  .column.is-3-touch {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 25%;\\n  }\\n  .column.is-offset-3-touch {\\n    margin-left: 25%;\\n  }\\n  .column.is-4-touch {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 33.33333337%;\\n  }\\n  .column.is-offset-4-touch {\\n    margin-left: 33.33333337%;\\n  }\\n  .column.is-5-touch {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 41.66666674%;\\n  }\\n  .column.is-offset-5-touch {\\n    margin-left: 41.66666674%;\\n  }\\n  .column.is-6-touch {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 50%;\\n  }\\n  .column.is-offset-6-touch {\\n    margin-left: 50%;\\n  }\\n  .column.is-7-touch {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 58.33333337%;\\n  }\\n  .column.is-offset-7-touch {\\n    margin-left: 58.33333337%;\\n  }\\n  .column.is-8-touch {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 66.66666674%;\\n  }\\n  .column.is-offset-8-touch {\\n    margin-left: 66.66666674%;\\n  }\\n  .column.is-9-touch {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 75%;\\n  }\\n  .column.is-offset-9-touch {\\n    margin-left: 75%;\\n  }\\n  .column.is-10-touch {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 83.33333337%;\\n  }\\n  .column.is-offset-10-touch {\\n    margin-left: 83.33333337%;\\n  }\\n  .column.is-11-touch {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 91.66666674%;\\n  }\\n  .column.is-offset-11-touch {\\n    margin-left: 91.66666674%;\\n  }\\n  .column.is-12-touch {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 100%;\\n  }\\n  .column.is-offset-12-touch {\\n    margin-left: 100%;\\n  }\\n}\\n@media screen and (min-width: 1024px) {\\n  .column.is-narrow-desktop {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: unset;\\n  }\\n  .column.is-full-desktop {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 100%;\\n  }\\n  .column.is-three-quarters-desktop {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 75%;\\n  }\\n  .column.is-two-thirds-desktop {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 66.6666%;\\n  }\\n  .column.is-half-desktop {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 50%;\\n  }\\n  .column.is-one-third-desktop {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 33.3333%;\\n  }\\n  .column.is-one-quarter-desktop {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 25%;\\n  }\\n  .column.is-one-fifth-desktop {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 20%;\\n  }\\n  .column.is-two-fifths-desktop {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 40%;\\n  }\\n  .column.is-three-fifths-desktop {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 60%;\\n  }\\n  .column.is-four-fifths-desktop {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 80%;\\n  }\\n  .column.is-offset-three-quarters-desktop {\\n    margin-left: 75%;\\n  }\\n  .column.is-offset-two-thirds-desktop {\\n    margin-left: 66.6666%;\\n  }\\n  .column.is-offset-half-desktop {\\n    margin-left: 50%;\\n  }\\n  .column.is-offset-one-third-desktop {\\n    margin-left: 33.3333%;\\n  }\\n  .column.is-offset-one-quarter-desktop {\\n    margin-left: 25%;\\n  }\\n  .column.is-offset-one-fifth-desktop {\\n    margin-left: 20%;\\n  }\\n  .column.is-offset-two-fifths-desktop {\\n    margin-left: 40%;\\n  }\\n  .column.is-offset-three-fifths-desktop {\\n    margin-left: 60%;\\n  }\\n  .column.is-offset-four-fifths-desktop {\\n    margin-left: 80%;\\n  }\\n  .column.is-0-desktop {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 0%;\\n  }\\n  .column.is-offset-0-desktop {\\n    margin-left: 0%;\\n  }\\n  .column.is-1-desktop {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 8.33333337%;\\n  }\\n  .column.is-offset-1-desktop {\\n    margin-left: 8.33333337%;\\n  }\\n  .column.is-2-desktop {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 16.66666674%;\\n  }\\n  .column.is-offset-2-desktop {\\n    margin-left: 16.66666674%;\\n  }\\n  .column.is-3-desktop {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 25%;\\n  }\\n  .column.is-offset-3-desktop {\\n    margin-left: 25%;\\n  }\\n  .column.is-4-desktop {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 33.33333337%;\\n  }\\n  .column.is-offset-4-desktop {\\n    margin-left: 33.33333337%;\\n  }\\n  .column.is-5-desktop {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 41.66666674%;\\n  }\\n  .column.is-offset-5-desktop {\\n    margin-left: 41.66666674%;\\n  }\\n  .column.is-6-desktop {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 50%;\\n  }\\n  .column.is-offset-6-desktop {\\n    margin-left: 50%;\\n  }\\n  .column.is-7-desktop {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 58.33333337%;\\n  }\\n  .column.is-offset-7-desktop {\\n    margin-left: 58.33333337%;\\n  }\\n  .column.is-8-desktop {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 66.66666674%;\\n  }\\n  .column.is-offset-8-desktop {\\n    margin-left: 66.66666674%;\\n  }\\n  .column.is-9-desktop {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 75%;\\n  }\\n  .column.is-offset-9-desktop {\\n    margin-left: 75%;\\n  }\\n  .column.is-10-desktop {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 83.33333337%;\\n  }\\n  .column.is-offset-10-desktop {\\n    margin-left: 83.33333337%;\\n  }\\n  .column.is-11-desktop {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 91.66666674%;\\n  }\\n  .column.is-offset-11-desktop {\\n    margin-left: 91.66666674%;\\n  }\\n  .column.is-12-desktop {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 100%;\\n  }\\n  .column.is-offset-12-desktop {\\n    margin-left: 100%;\\n  }\\n}\\n@media screen and (min-width: 1216px) {\\n  .column.is-narrow-widescreen {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: unset;\\n  }\\n  .column.is-full-widescreen {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 100%;\\n  }\\n  .column.is-three-quarters-widescreen {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 75%;\\n  }\\n  .column.is-two-thirds-widescreen {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 66.6666%;\\n  }\\n  .column.is-half-widescreen {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 50%;\\n  }\\n  .column.is-one-third-widescreen {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 33.3333%;\\n  }\\n  .column.is-one-quarter-widescreen {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 25%;\\n  }\\n  .column.is-one-fifth-widescreen {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 20%;\\n  }\\n  .column.is-two-fifths-widescreen {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 40%;\\n  }\\n  .column.is-three-fifths-widescreen {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 60%;\\n  }\\n  .column.is-four-fifths-widescreen {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 80%;\\n  }\\n  .column.is-offset-three-quarters-widescreen {\\n    margin-left: 75%;\\n  }\\n  .column.is-offset-two-thirds-widescreen {\\n    margin-left: 66.6666%;\\n  }\\n  .column.is-offset-half-widescreen {\\n    margin-left: 50%;\\n  }\\n  .column.is-offset-one-third-widescreen {\\n    margin-left: 33.3333%;\\n  }\\n  .column.is-offset-one-quarter-widescreen {\\n    margin-left: 25%;\\n  }\\n  .column.is-offset-one-fifth-widescreen {\\n    margin-left: 20%;\\n  }\\n  .column.is-offset-two-fifths-widescreen {\\n    margin-left: 40%;\\n  }\\n  .column.is-offset-three-fifths-widescreen {\\n    margin-left: 60%;\\n  }\\n  .column.is-offset-four-fifths-widescreen {\\n    margin-left: 80%;\\n  }\\n  .column.is-0-widescreen {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 0%;\\n  }\\n  .column.is-offset-0-widescreen {\\n    margin-left: 0%;\\n  }\\n  .column.is-1-widescreen {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 8.33333337%;\\n  }\\n  .column.is-offset-1-widescreen {\\n    margin-left: 8.33333337%;\\n  }\\n  .column.is-2-widescreen {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 16.66666674%;\\n  }\\n  .column.is-offset-2-widescreen {\\n    margin-left: 16.66666674%;\\n  }\\n  .column.is-3-widescreen {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 25%;\\n  }\\n  .column.is-offset-3-widescreen {\\n    margin-left: 25%;\\n  }\\n  .column.is-4-widescreen {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 33.33333337%;\\n  }\\n  .column.is-offset-4-widescreen {\\n    margin-left: 33.33333337%;\\n  }\\n  .column.is-5-widescreen {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 41.66666674%;\\n  }\\n  .column.is-offset-5-widescreen {\\n    margin-left: 41.66666674%;\\n  }\\n  .column.is-6-widescreen {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 50%;\\n  }\\n  .column.is-offset-6-widescreen {\\n    margin-left: 50%;\\n  }\\n  .column.is-7-widescreen {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 58.33333337%;\\n  }\\n  .column.is-offset-7-widescreen {\\n    margin-left: 58.33333337%;\\n  }\\n  .column.is-8-widescreen {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 66.66666674%;\\n  }\\n  .column.is-offset-8-widescreen {\\n    margin-left: 66.66666674%;\\n  }\\n  .column.is-9-widescreen {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 75%;\\n  }\\n  .column.is-offset-9-widescreen {\\n    margin-left: 75%;\\n  }\\n  .column.is-10-widescreen {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 83.33333337%;\\n  }\\n  .column.is-offset-10-widescreen {\\n    margin-left: 83.33333337%;\\n  }\\n  .column.is-11-widescreen {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 91.66666674%;\\n  }\\n  .column.is-offset-11-widescreen {\\n    margin-left: 91.66666674%;\\n  }\\n  .column.is-12-widescreen {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 100%;\\n  }\\n  .column.is-offset-12-widescreen {\\n    margin-left: 100%;\\n  }\\n}\\n@media screen and (min-width: 1408px) {\\n  .column.is-narrow-fullhd {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: unset;\\n  }\\n  .column.is-full-fullhd {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 100%;\\n  }\\n  .column.is-three-quarters-fullhd {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 75%;\\n  }\\n  .column.is-two-thirds-fullhd {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 66.6666%;\\n  }\\n  .column.is-half-fullhd {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 50%;\\n  }\\n  .column.is-one-third-fullhd {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 33.3333%;\\n  }\\n  .column.is-one-quarter-fullhd {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 25%;\\n  }\\n  .column.is-one-fifth-fullhd {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 20%;\\n  }\\n  .column.is-two-fifths-fullhd {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 40%;\\n  }\\n  .column.is-three-fifths-fullhd {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 60%;\\n  }\\n  .column.is-four-fifths-fullhd {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 80%;\\n  }\\n  .column.is-offset-three-quarters-fullhd {\\n    margin-left: 75%;\\n  }\\n  .column.is-offset-two-thirds-fullhd {\\n    margin-left: 66.6666%;\\n  }\\n  .column.is-offset-half-fullhd {\\n    margin-left: 50%;\\n  }\\n  .column.is-offset-one-third-fullhd {\\n    margin-left: 33.3333%;\\n  }\\n  .column.is-offset-one-quarter-fullhd {\\n    margin-left: 25%;\\n  }\\n  .column.is-offset-one-fifth-fullhd {\\n    margin-left: 20%;\\n  }\\n  .column.is-offset-two-fifths-fullhd {\\n    margin-left: 40%;\\n  }\\n  .column.is-offset-three-fifths-fullhd {\\n    margin-left: 60%;\\n  }\\n  .column.is-offset-four-fifths-fullhd {\\n    margin-left: 80%;\\n  }\\n  .column.is-0-fullhd {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 0%;\\n  }\\n  .column.is-offset-0-fullhd {\\n    margin-left: 0%;\\n  }\\n  .column.is-1-fullhd {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 8.33333337%;\\n  }\\n  .column.is-offset-1-fullhd {\\n    margin-left: 8.33333337%;\\n  }\\n  .column.is-2-fullhd {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 16.66666674%;\\n  }\\n  .column.is-offset-2-fullhd {\\n    margin-left: 16.66666674%;\\n  }\\n  .column.is-3-fullhd {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 25%;\\n  }\\n  .column.is-offset-3-fullhd {\\n    margin-left: 25%;\\n  }\\n  .column.is-4-fullhd {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 33.33333337%;\\n  }\\n  .column.is-offset-4-fullhd {\\n    margin-left: 33.33333337%;\\n  }\\n  .column.is-5-fullhd {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 41.66666674%;\\n  }\\n  .column.is-offset-5-fullhd {\\n    margin-left: 41.66666674%;\\n  }\\n  .column.is-6-fullhd {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 50%;\\n  }\\n  .column.is-offset-6-fullhd {\\n    margin-left: 50%;\\n  }\\n  .column.is-7-fullhd {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 58.33333337%;\\n  }\\n  .column.is-offset-7-fullhd {\\n    margin-left: 58.33333337%;\\n  }\\n  .column.is-8-fullhd {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 66.66666674%;\\n  }\\n  .column.is-offset-8-fullhd {\\n    margin-left: 66.66666674%;\\n  }\\n  .column.is-9-fullhd {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 75%;\\n  }\\n  .column.is-offset-9-fullhd {\\n    margin-left: 75%;\\n  }\\n  .column.is-10-fullhd {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 83.33333337%;\\n  }\\n  .column.is-offset-10-fullhd {\\n    margin-left: 83.33333337%;\\n  }\\n  .column.is-11-fullhd {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 91.66666674%;\\n  }\\n  .column.is-offset-11-fullhd {\\n    margin-left: 91.66666674%;\\n  }\\n  .column.is-12-fullhd {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 100%;\\n  }\\n  .column.is-offset-12-fullhd {\\n    margin-left: 100%;\\n  }\\n}\\n\\n.columns {\\n  margin-left: -0.75rem;\\n  margin-right: -0.75rem;\\n  margin-top: -0.75rem;\\n}\\n.columns:last-child {\\n  margin-bottom: -0.75rem;\\n}\\n.columns:not(:last-child) {\\n  margin-bottom: calc(1.5rem - 0.75rem);\\n}\\n.columns.is-centered {\\n  -webkit-box-pack: center;\\n      -ms-flex-pack: center;\\n          justify-content: center;\\n}\\n.columns.is-gapless {\\n  margin-left: 0;\\n  margin-right: 0;\\n  margin-top: 0;\\n}\\n.columns.is-gapless > .column {\\n  margin: 0;\\n  padding: 0 !important;\\n}\\n.columns.is-gapless:not(:last-child) {\\n  margin-bottom: 1.5rem;\\n}\\n.columns.is-gapless:last-child {\\n  margin-bottom: 0;\\n}\\n.columns.is-mobile {\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n}\\n.columns.is-multiline {\\n  -ms-flex-wrap: wrap;\\n      flex-wrap: wrap;\\n}\\n.columns.is-vcentered {\\n  -webkit-box-align: center;\\n      -ms-flex-align: center;\\n          align-items: center;\\n}\\n@media screen and (min-width: 769px), print {\\n  .columns:not(.is-desktop) {\\n    display: -webkit-box;\\n    display: -ms-flexbox;\\n    display: flex;\\n  }\\n}\\n@media screen and (min-width: 1024px) {\\n  .columns.is-desktop {\\n    display: -webkit-box;\\n    display: -ms-flexbox;\\n    display: flex;\\n  }\\n}\\n\\n.columns.is-variable {\\n  --columnGap: 0.75rem;\\n  margin-left: calc(-1 * var(--columnGap));\\n  margin-right: calc(-1 * var(--columnGap));\\n}\\n.columns.is-variable > .column {\\n  padding-left: var(--columnGap);\\n  padding-right: var(--columnGap);\\n}\\n.columns.is-variable.is-0 {\\n  --columnGap: 0rem;\\n}\\n@media screen and (max-width: 768px) {\\n  .columns.is-variable.is-0-mobile {\\n    --columnGap: 0rem;\\n  }\\n}\\n@media screen and (min-width: 769px), print {\\n  .columns.is-variable.is-0-tablet {\\n    --columnGap: 0rem;\\n  }\\n}\\n@media screen and (min-width: 769px) and (max-width: 1023px) {\\n  .columns.is-variable.is-0-tablet-only {\\n    --columnGap: 0rem;\\n  }\\n}\\n@media screen and (max-width: 1023px) {\\n  .columns.is-variable.is-0-touch {\\n    --columnGap: 0rem;\\n  }\\n}\\n@media screen and (min-width: 1024px) {\\n  .columns.is-variable.is-0-desktop {\\n    --columnGap: 0rem;\\n  }\\n}\\n@media screen and (min-width: 1024px) and (max-width: 1215px) {\\n  .columns.is-variable.is-0-desktop-only {\\n    --columnGap: 0rem;\\n  }\\n}\\n@media screen and (min-width: 1216px) {\\n  .columns.is-variable.is-0-widescreen {\\n    --columnGap: 0rem;\\n  }\\n}\\n@media screen and (min-width: 1216px) and (max-width: 1407px) {\\n  .columns.is-variable.is-0-widescreen-only {\\n    --columnGap: 0rem;\\n  }\\n}\\n@media screen and (min-width: 1408px) {\\n  .columns.is-variable.is-0-fullhd {\\n    --columnGap: 0rem;\\n  }\\n}\\n.columns.is-variable.is-1 {\\n  --columnGap: 0.25rem;\\n}\\n@media screen and (max-width: 768px) {\\n  .columns.is-variable.is-1-mobile {\\n    --columnGap: 0.25rem;\\n  }\\n}\\n@media screen and (min-width: 769px), print {\\n  .columns.is-variable.is-1-tablet {\\n    --columnGap: 0.25rem;\\n  }\\n}\\n@media screen and (min-width: 769px) and (max-width: 1023px) {\\n  .columns.is-variable.is-1-tablet-only {\\n    --columnGap: 0.25rem;\\n  }\\n}\\n@media screen and (max-width: 1023px) {\\n  .columns.is-variable.is-1-touch {\\n    --columnGap: 0.25rem;\\n  }\\n}\\n@media screen and (min-width: 1024px) {\\n  .columns.is-variable.is-1-desktop {\\n    --columnGap: 0.25rem;\\n  }\\n}\\n@media screen and (min-width: 1024px) and (max-width: 1215px) {\\n  .columns.is-variable.is-1-desktop-only {\\n    --columnGap: 0.25rem;\\n  }\\n}\\n@media screen and (min-width: 1216px) {\\n  .columns.is-variable.is-1-widescreen {\\n    --columnGap: 0.25rem;\\n  }\\n}\\n@media screen and (min-width: 1216px) and (max-width: 1407px) {\\n  .columns.is-variable.is-1-widescreen-only {\\n    --columnGap: 0.25rem;\\n  }\\n}\\n@media screen and (min-width: 1408px) {\\n  .columns.is-variable.is-1-fullhd {\\n    --columnGap: 0.25rem;\\n  }\\n}\\n.columns.is-variable.is-2 {\\n  --columnGap: 0.5rem;\\n}\\n@media screen and (max-width: 768px) {\\n  .columns.is-variable.is-2-mobile {\\n    --columnGap: 0.5rem;\\n  }\\n}\\n@media screen and (min-width: 769px), print {\\n  .columns.is-variable.is-2-tablet {\\n    --columnGap: 0.5rem;\\n  }\\n}\\n@media screen and (min-width: 769px) and (max-width: 1023px) {\\n  .columns.is-variable.is-2-tablet-only {\\n    --columnGap: 0.5rem;\\n  }\\n}\\n@media screen and (max-width: 1023px) {\\n  .columns.is-variable.is-2-touch {\\n    --columnGap: 0.5rem;\\n  }\\n}\\n@media screen and (min-width: 1024px) {\\n  .columns.is-variable.is-2-desktop {\\n    --columnGap: 0.5rem;\\n  }\\n}\\n@media screen and (min-width: 1024px) and (max-width: 1215px) {\\n  .columns.is-variable.is-2-desktop-only {\\n    --columnGap: 0.5rem;\\n  }\\n}\\n@media screen and (min-width: 1216px) {\\n  .columns.is-variable.is-2-widescreen {\\n    --columnGap: 0.5rem;\\n  }\\n}\\n@media screen and (min-width: 1216px) and (max-width: 1407px) {\\n  .columns.is-variable.is-2-widescreen-only {\\n    --columnGap: 0.5rem;\\n  }\\n}\\n@media screen and (min-width: 1408px) {\\n  .columns.is-variable.is-2-fullhd {\\n    --columnGap: 0.5rem;\\n  }\\n}\\n.columns.is-variable.is-3 {\\n  --columnGap: 0.75rem;\\n}\\n@media screen and (max-width: 768px) {\\n  .columns.is-variable.is-3-mobile {\\n    --columnGap: 0.75rem;\\n  }\\n}\\n@media screen and (min-width: 769px), print {\\n  .columns.is-variable.is-3-tablet {\\n    --columnGap: 0.75rem;\\n  }\\n}\\n@media screen and (min-width: 769px) and (max-width: 1023px) {\\n  .columns.is-variable.is-3-tablet-only {\\n    --columnGap: 0.75rem;\\n  }\\n}\\n@media screen and (max-width: 1023px) {\\n  .columns.is-variable.is-3-touch {\\n    --columnGap: 0.75rem;\\n  }\\n}\\n@media screen and (min-width: 1024px) {\\n  .columns.is-variable.is-3-desktop {\\n    --columnGap: 0.75rem;\\n  }\\n}\\n@media screen and (min-width: 1024px) and (max-width: 1215px) {\\n  .columns.is-variable.is-3-desktop-only {\\n    --columnGap: 0.75rem;\\n  }\\n}\\n@media screen and (min-width: 1216px) {\\n  .columns.is-variable.is-3-widescreen {\\n    --columnGap: 0.75rem;\\n  }\\n}\\n@media screen and (min-width: 1216px) and (max-width: 1407px) {\\n  .columns.is-variable.is-3-widescreen-only {\\n    --columnGap: 0.75rem;\\n  }\\n}\\n@media screen and (min-width: 1408px) {\\n  .columns.is-variable.is-3-fullhd {\\n    --columnGap: 0.75rem;\\n  }\\n}\\n.columns.is-variable.is-4 {\\n  --columnGap: 1rem;\\n}\\n@media screen and (max-width: 768px) {\\n  .columns.is-variable.is-4-mobile {\\n    --columnGap: 1rem;\\n  }\\n}\\n@media screen and (min-width: 769px), print {\\n  .columns.is-variable.is-4-tablet {\\n    --columnGap: 1rem;\\n  }\\n}\\n@media screen and (min-width: 769px) and (max-width: 1023px) {\\n  .columns.is-variable.is-4-tablet-only {\\n    --columnGap: 1rem;\\n  }\\n}\\n@media screen and (max-width: 1023px) {\\n  .columns.is-variable.is-4-touch {\\n    --columnGap: 1rem;\\n  }\\n}\\n@media screen and (min-width: 1024px) {\\n  .columns.is-variable.is-4-desktop {\\n    --columnGap: 1rem;\\n  }\\n}\\n@media screen and (min-width: 1024px) and (max-width: 1215px) {\\n  .columns.is-variable.is-4-desktop-only {\\n    --columnGap: 1rem;\\n  }\\n}\\n@media screen and (min-width: 1216px) {\\n  .columns.is-variable.is-4-widescreen {\\n    --columnGap: 1rem;\\n  }\\n}\\n@media screen and (min-width: 1216px) and (max-width: 1407px) {\\n  .columns.is-variable.is-4-widescreen-only {\\n    --columnGap: 1rem;\\n  }\\n}\\n@media screen and (min-width: 1408px) {\\n  .columns.is-variable.is-4-fullhd {\\n    --columnGap: 1rem;\\n  }\\n}\\n.columns.is-variable.is-5 {\\n  --columnGap: 1.25rem;\\n}\\n@media screen and (max-width: 768px) {\\n  .columns.is-variable.is-5-mobile {\\n    --columnGap: 1.25rem;\\n  }\\n}\\n@media screen and (min-width: 769px), print {\\n  .columns.is-variable.is-5-tablet {\\n    --columnGap: 1.25rem;\\n  }\\n}\\n@media screen and (min-width: 769px) and (max-width: 1023px) {\\n  .columns.is-variable.is-5-tablet-only {\\n    --columnGap: 1.25rem;\\n  }\\n}\\n@media screen and (max-width: 1023px) {\\n  .columns.is-variable.is-5-touch {\\n    --columnGap: 1.25rem;\\n  }\\n}\\n@media screen and (min-width: 1024px) {\\n  .columns.is-variable.is-5-desktop {\\n    --columnGap: 1.25rem;\\n  }\\n}\\n@media screen and (min-width: 1024px) and (max-width: 1215px) {\\n  .columns.is-variable.is-5-desktop-only {\\n    --columnGap: 1.25rem;\\n  }\\n}\\n@media screen and (min-width: 1216px) {\\n  .columns.is-variable.is-5-widescreen {\\n    --columnGap: 1.25rem;\\n  }\\n}\\n@media screen and (min-width: 1216px) and (max-width: 1407px) {\\n  .columns.is-variable.is-5-widescreen-only {\\n    --columnGap: 1.25rem;\\n  }\\n}\\n@media screen and (min-width: 1408px) {\\n  .columns.is-variable.is-5-fullhd {\\n    --columnGap: 1.25rem;\\n  }\\n}\\n.columns.is-variable.is-6 {\\n  --columnGap: 1.5rem;\\n}\\n@media screen and (max-width: 768px) {\\n  .columns.is-variable.is-6-mobile {\\n    --columnGap: 1.5rem;\\n  }\\n}\\n@media screen and (min-width: 769px), print {\\n  .columns.is-variable.is-6-tablet {\\n    --columnGap: 1.5rem;\\n  }\\n}\\n@media screen and (min-width: 769px) and (max-width: 1023px) {\\n  .columns.is-variable.is-6-tablet-only {\\n    --columnGap: 1.5rem;\\n  }\\n}\\n@media screen and (max-width: 1023px) {\\n  .columns.is-variable.is-6-touch {\\n    --columnGap: 1.5rem;\\n  }\\n}\\n@media screen and (min-width: 1024px) {\\n  .columns.is-variable.is-6-desktop {\\n    --columnGap: 1.5rem;\\n  }\\n}\\n@media screen and (min-width: 1024px) and (max-width: 1215px) {\\n  .columns.is-variable.is-6-desktop-only {\\n    --columnGap: 1.5rem;\\n  }\\n}\\n@media screen and (min-width: 1216px) {\\n  .columns.is-variable.is-6-widescreen {\\n    --columnGap: 1.5rem;\\n  }\\n}\\n@media screen and (min-width: 1216px) and (max-width: 1407px) {\\n  .columns.is-variable.is-6-widescreen-only {\\n    --columnGap: 1.5rem;\\n  }\\n}\\n@media screen and (min-width: 1408px) {\\n  .columns.is-variable.is-6-fullhd {\\n    --columnGap: 1.5rem;\\n  }\\n}\\n.columns.is-variable.is-7 {\\n  --columnGap: 1.75rem;\\n}\\n@media screen and (max-width: 768px) {\\n  .columns.is-variable.is-7-mobile {\\n    --columnGap: 1.75rem;\\n  }\\n}\\n@media screen and (min-width: 769px), print {\\n  .columns.is-variable.is-7-tablet {\\n    --columnGap: 1.75rem;\\n  }\\n}\\n@media screen and (min-width: 769px) and (max-width: 1023px) {\\n  .columns.is-variable.is-7-tablet-only {\\n    --columnGap: 1.75rem;\\n  }\\n}\\n@media screen and (max-width: 1023px) {\\n  .columns.is-variable.is-7-touch {\\n    --columnGap: 1.75rem;\\n  }\\n}\\n@media screen and (min-width: 1024px) {\\n  .columns.is-variable.is-7-desktop {\\n    --columnGap: 1.75rem;\\n  }\\n}\\n@media screen and (min-width: 1024px) and (max-width: 1215px) {\\n  .columns.is-variable.is-7-desktop-only {\\n    --columnGap: 1.75rem;\\n  }\\n}\\n@media screen and (min-width: 1216px) {\\n  .columns.is-variable.is-7-widescreen {\\n    --columnGap: 1.75rem;\\n  }\\n}\\n@media screen and (min-width: 1216px) and (max-width: 1407px) {\\n  .columns.is-variable.is-7-widescreen-only {\\n    --columnGap: 1.75rem;\\n  }\\n}\\n@media screen and (min-width: 1408px) {\\n  .columns.is-variable.is-7-fullhd {\\n    --columnGap: 1.75rem;\\n  }\\n}\\n.columns.is-variable.is-8 {\\n  --columnGap: 2rem;\\n}\\n@media screen and (max-width: 768px) {\\n  .columns.is-variable.is-8-mobile {\\n    --columnGap: 2rem;\\n  }\\n}\\n@media screen and (min-width: 769px), print {\\n  .columns.is-variable.is-8-tablet {\\n    --columnGap: 2rem;\\n  }\\n}\\n@media screen and (min-width: 769px) and (max-width: 1023px) {\\n  .columns.is-variable.is-8-tablet-only {\\n    --columnGap: 2rem;\\n  }\\n}\\n@media screen and (max-width: 1023px) {\\n  .columns.is-variable.is-8-touch {\\n    --columnGap: 2rem;\\n  }\\n}\\n@media screen and (min-width: 1024px) {\\n  .columns.is-variable.is-8-desktop {\\n    --columnGap: 2rem;\\n  }\\n}\\n@media screen and (min-width: 1024px) and (max-width: 1215px) {\\n  .columns.is-variable.is-8-desktop-only {\\n    --columnGap: 2rem;\\n  }\\n}\\n@media screen and (min-width: 1216px) {\\n  .columns.is-variable.is-8-widescreen {\\n    --columnGap: 2rem;\\n  }\\n}\\n@media screen and (min-width: 1216px) and (max-width: 1407px) {\\n  .columns.is-variable.is-8-widescreen-only {\\n    --columnGap: 2rem;\\n  }\\n}\\n@media screen and (min-width: 1408px) {\\n  .columns.is-variable.is-8-fullhd {\\n    --columnGap: 2rem;\\n  }\\n}\\n\\n.tile {\\n  -webkit-box-align: stretch;\\n      -ms-flex-align: stretch;\\n          align-items: stretch;\\n  display: block;\\n  -ms-flex-preferred-size: 0;\\n      flex-basis: 0;\\n  -webkit-box-flex: 1;\\n      -ms-flex-positive: 1;\\n          flex-grow: 1;\\n  -ms-flex-negative: 1;\\n      flex-shrink: 1;\\n  min-height: -webkit-min-content;\\n  min-height: -moz-min-content;\\n  min-height: min-content;\\n}\\n.tile.is-ancestor {\\n  margin-left: -0.75rem;\\n  margin-right: -0.75rem;\\n  margin-top: -0.75rem;\\n}\\n.tile.is-ancestor:last-child {\\n  margin-bottom: -0.75rem;\\n}\\n.tile.is-ancestor:not(:last-child) {\\n  margin-bottom: 0.75rem;\\n}\\n.tile.is-child {\\n  margin: 0 !important;\\n}\\n.tile.is-parent {\\n  padding: 0.75rem;\\n}\\n.tile.is-vertical {\\n  -webkit-box-orient: vertical;\\n  -webkit-box-direction: normal;\\n      -ms-flex-direction: column;\\n          flex-direction: column;\\n}\\n.tile.is-vertical > .tile.is-child:not(:last-child) {\\n  margin-bottom: 1.5rem !important;\\n}\\n@media screen and (min-width: 769px), print {\\n  .tile:not(.is-child) {\\n    display: -webkit-box;\\n    display: -ms-flexbox;\\n    display: flex;\\n  }\\n  .tile.is-1 {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 8.33333337%;\\n  }\\n  .tile.is-2 {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 16.66666674%;\\n  }\\n  .tile.is-3 {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 25%;\\n  }\\n  .tile.is-4 {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 33.33333337%;\\n  }\\n  .tile.is-5 {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 41.66666674%;\\n  }\\n  .tile.is-6 {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 50%;\\n  }\\n  .tile.is-7 {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 58.33333337%;\\n  }\\n  .tile.is-8 {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 66.66666674%;\\n  }\\n  .tile.is-9 {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 75%;\\n  }\\n  .tile.is-10 {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 83.33333337%;\\n  }\\n  .tile.is-11 {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 91.66666674%;\\n  }\\n  .tile.is-12 {\\n    -webkit-box-flex: 0;\\n        -ms-flex: none;\\n            flex: none;\\n    width: 100%;\\n  }\\n}\\n\\n/* Bulma Helpers */\\n.has-text-white {\\n  color: hsl(0deg, 0%, 100%) !important;\\n}\\n\\na.has-text-white:hover, a.has-text-white:focus {\\n  color: #e6e6e6 !important;\\n}\\n\\n.has-background-white {\\n  background-color: hsl(0deg, 0%, 100%) !important;\\n}\\n\\n.has-text-black {\\n  color: hsl(0deg, 0%, 4%) !important;\\n}\\n\\na.has-text-black:hover, a.has-text-black:focus {\\n  color: black !important;\\n}\\n\\n.has-background-black {\\n  background-color: hsl(0deg, 0%, 4%) !important;\\n}\\n\\n.has-text-light {\\n  color: hsl(0deg, 0%, 96%) !important;\\n}\\n\\na.has-text-light:hover, a.has-text-light:focus {\\n  color: #dbdbdb !important;\\n}\\n\\n.has-background-light {\\n  background-color: hsl(0deg, 0%, 96%) !important;\\n}\\n\\n.has-text-dark {\\n  color: hsl(0deg, 0%, 21%) !important;\\n}\\n\\na.has-text-dark:hover, a.has-text-dark:focus {\\n  color: #1c1c1c !important;\\n}\\n\\n.has-background-dark {\\n  background-color: hsl(0deg, 0%, 21%) !important;\\n}\\n\\n.has-text-primary {\\n  color: hsl(171deg, 100%, 41%) !important;\\n}\\n\\na.has-text-primary:hover, a.has-text-primary:focus {\\n  color: #009e86 !important;\\n}\\n\\n.has-background-primary {\\n  background-color: hsl(171deg, 100%, 41%) !important;\\n}\\n\\n.has-text-primary-light {\\n  color: #ebfffc !important;\\n}\\n\\na.has-text-primary-light:hover, a.has-text-primary-light:focus {\\n  color: #b8fff4 !important;\\n}\\n\\n.has-background-primary-light {\\n  background-color: #ebfffc !important;\\n}\\n\\n.has-text-primary-dark {\\n  color: #00947e !important;\\n}\\n\\na.has-text-primary-dark:hover, a.has-text-primary-dark:focus {\\n  color: #00c7a9 !important;\\n}\\n\\n.has-background-primary-dark {\\n  background-color: #00947e !important;\\n}\\n\\n.has-text-link {\\n  color: hsl(229deg, 53%, 53%) !important;\\n}\\n\\na.has-text-link:hover, a.has-text-link:focus {\\n  color: #3449a8 !important;\\n}\\n\\n.has-background-link {\\n  background-color: hsl(229deg, 53%, 53%) !important;\\n}\\n\\n.has-text-link-light {\\n  color: #eff1fa !important;\\n}\\n\\na.has-text-link-light:hover, a.has-text-link-light:focus {\\n  color: #c8cfee !important;\\n}\\n\\n.has-background-link-light {\\n  background-color: #eff1fa !important;\\n}\\n\\n.has-text-link-dark {\\n  color: #3850b7 !important;\\n}\\n\\na.has-text-link-dark:hover, a.has-text-link-dark:focus {\\n  color: #576dcb !important;\\n}\\n\\n.has-background-link-dark {\\n  background-color: #3850b7 !important;\\n}\\n\\n.has-text-info {\\n  color: hsl(207deg, 61%, 53%) !important;\\n}\\n\\na.has-text-info:hover, a.has-text-info:focus {\\n  color: #2b74b1 !important;\\n}\\n\\n.has-background-info {\\n  background-color: hsl(207deg, 61%, 53%) !important;\\n}\\n\\n.has-text-info-light {\\n  color: #eff5fb !important;\\n}\\n\\na.has-text-info-light:hover, a.has-text-info-light:focus {\\n  color: #c6ddf1 !important;\\n}\\n\\n.has-background-info-light {\\n  background-color: #eff5fb !important;\\n}\\n\\n.has-text-info-dark {\\n  color: #296fa8 !important;\\n}\\n\\na.has-text-info-dark:hover, a.has-text-info-dark:focus {\\n  color: #368ace !important;\\n}\\n\\n.has-background-info-dark {\\n  background-color: #296fa8 !important;\\n}\\n\\n.has-text-success {\\n  color: hsl(153deg, 53%, 53%) !important;\\n}\\n\\na.has-text-success:hover, a.has-text-success:focus {\\n  color: #34a873 !important;\\n}\\n\\n.has-background-success {\\n  background-color: hsl(153deg, 53%, 53%) !important;\\n}\\n\\n.has-text-success-light {\\n  color: #effaf5 !important;\\n}\\n\\na.has-text-success-light:hover, a.has-text-success-light:focus {\\n  color: #c8eedd !important;\\n}\\n\\n.has-background-success-light {\\n  background-color: #effaf5 !important;\\n}\\n\\n.has-text-success-dark {\\n  color: #257953 !important;\\n}\\n\\na.has-text-success-dark:hover, a.has-text-success-dark:focus {\\n  color: #31a06e !important;\\n}\\n\\n.has-background-success-dark {\\n  background-color: #257953 !important;\\n}\\n\\n.has-text-warning {\\n  color: hsl(44deg, 100%, 77%) !important;\\n}\\n\\na.has-text-warning:hover, a.has-text-warning:focus {\\n  color: #ffd257 !important;\\n}\\n\\n.has-background-warning {\\n  background-color: hsl(44deg, 100%, 77%) !important;\\n}\\n\\n.has-text-warning-light {\\n  color: #fffaeb !important;\\n}\\n\\na.has-text-warning-light:hover, a.has-text-warning-light:focus {\\n  color: #ffecb8 !important;\\n}\\n\\n.has-background-warning-light {\\n  background-color: #fffaeb !important;\\n}\\n\\n.has-text-warning-dark {\\n  color: #946c00 !important;\\n}\\n\\na.has-text-warning-dark:hover, a.has-text-warning-dark:focus {\\n  color: #c79200 !important;\\n}\\n\\n.has-background-warning-dark {\\n  background-color: #946c00 !important;\\n}\\n\\n.has-text-danger {\\n  color: hsl(348deg, 86%, 61%) !important;\\n}\\n\\na.has-text-danger:hover, a.has-text-danger:focus {\\n  color: #ee1742 !important;\\n}\\n\\n.has-background-danger {\\n  background-color: hsl(348deg, 86%, 61%) !important;\\n}\\n\\n.has-text-danger-light {\\n  color: #feecf0 !important;\\n}\\n\\na.has-text-danger-light:hover, a.has-text-danger-light:focus {\\n  color: #fabdc9 !important;\\n}\\n\\n.has-background-danger-light {\\n  background-color: #feecf0 !important;\\n}\\n\\n.has-text-danger-dark {\\n  color: #cc0f35 !important;\\n}\\n\\na.has-text-danger-dark:hover, a.has-text-danger-dark:focus {\\n  color: #ee2049 !important;\\n}\\n\\n.has-background-danger-dark {\\n  background-color: #cc0f35 !important;\\n}\\n\\n.has-text-black-bis {\\n  color: hsl(0deg, 0%, 7%) !important;\\n}\\n\\n.has-background-black-bis {\\n  background-color: hsl(0deg, 0%, 7%) !important;\\n}\\n\\n.has-text-black-ter {\\n  color: hsl(0deg, 0%, 14%) !important;\\n}\\n\\n.has-background-black-ter {\\n  background-color: hsl(0deg, 0%, 14%) !important;\\n}\\n\\n.has-text-grey-darker {\\n  color: hsl(0deg, 0%, 21%) !important;\\n}\\n\\n.has-background-grey-darker {\\n  background-color: hsl(0deg, 0%, 21%) !important;\\n}\\n\\n.has-text-grey-dark {\\n  color: hsl(0deg, 0%, 29%) !important;\\n}\\n\\n.has-background-grey-dark {\\n  background-color: hsl(0deg, 0%, 29%) !important;\\n}\\n\\n.has-text-grey {\\n  color: hsl(0deg, 0%, 48%) !important;\\n}\\n\\n.has-background-grey {\\n  background-color: hsl(0deg, 0%, 48%) !important;\\n}\\n\\n.has-text-grey-light {\\n  color: hsl(0deg, 0%, 71%) !important;\\n}\\n\\n.has-background-grey-light {\\n  background-color: hsl(0deg, 0%, 71%) !important;\\n}\\n\\n.has-text-grey-lighter {\\n  color: hsl(0deg, 0%, 86%) !important;\\n}\\n\\n.has-background-grey-lighter {\\n  background-color: hsl(0deg, 0%, 86%) !important;\\n}\\n\\n.has-text-white-ter {\\n  color: hsl(0deg, 0%, 96%) !important;\\n}\\n\\n.has-background-white-ter {\\n  background-color: hsl(0deg, 0%, 96%) !important;\\n}\\n\\n.has-text-white-bis {\\n  color: hsl(0deg, 0%, 98%) !important;\\n}\\n\\n.has-background-white-bis {\\n  background-color: hsl(0deg, 0%, 98%) !important;\\n}\\n\\n.is-flex-direction-row {\\n  -webkit-box-orient: horizontal !important;\\n  -webkit-box-direction: normal !important;\\n      -ms-flex-direction: row !important;\\n          flex-direction: row !important;\\n}\\n\\n.is-flex-direction-row-reverse {\\n  -webkit-box-orient: horizontal !important;\\n  -webkit-box-direction: reverse !important;\\n      -ms-flex-direction: row-reverse !important;\\n          flex-direction: row-reverse !important;\\n}\\n\\n.is-flex-direction-column {\\n  -webkit-box-orient: vertical !important;\\n  -webkit-box-direction: normal !important;\\n      -ms-flex-direction: column !important;\\n          flex-direction: column !important;\\n}\\n\\n.is-flex-direction-column-reverse {\\n  -webkit-box-orient: vertical !important;\\n  -webkit-box-direction: reverse !important;\\n      -ms-flex-direction: column-reverse !important;\\n          flex-direction: column-reverse !important;\\n}\\n\\n.is-flex-wrap-nowrap {\\n  -ms-flex-wrap: nowrap !important;\\n      flex-wrap: nowrap !important;\\n}\\n\\n.is-flex-wrap-wrap {\\n  -ms-flex-wrap: wrap !important;\\n      flex-wrap: wrap !important;\\n}\\n\\n.is-flex-wrap-wrap-reverse {\\n  -ms-flex-wrap: wrap-reverse !important;\\n      flex-wrap: wrap-reverse !important;\\n}\\n\\n.is-justify-content-flex-start {\\n  -webkit-box-pack: start !important;\\n      -ms-flex-pack: start !important;\\n          justify-content: flex-start !important;\\n}\\n\\n.is-justify-content-flex-end {\\n  -webkit-box-pack: end !important;\\n      -ms-flex-pack: end !important;\\n          justify-content: flex-end !important;\\n}\\n\\n.is-justify-content-center {\\n  -webkit-box-pack: center !important;\\n      -ms-flex-pack: center !important;\\n          justify-content: center !important;\\n}\\n\\n.is-justify-content-space-between {\\n  -webkit-box-pack: justify !important;\\n      -ms-flex-pack: justify !important;\\n          justify-content: space-between !important;\\n}\\n\\n.is-justify-content-space-around {\\n  -ms-flex-pack: distribute !important;\\n      justify-content: space-around !important;\\n}\\n\\n.is-justify-content-space-evenly {\\n  -webkit-box-pack: space-evenly !important;\\n      -ms-flex-pack: space-evenly !important;\\n          justify-content: space-evenly !important;\\n}\\n\\n.is-justify-content-start {\\n  -webkit-box-pack: start !important;\\n      -ms-flex-pack: start !important;\\n          justify-content: start !important;\\n}\\n\\n.is-justify-content-end {\\n  -webkit-box-pack: end !important;\\n      -ms-flex-pack: end !important;\\n          justify-content: end !important;\\n}\\n\\n.is-justify-content-left {\\n  -webkit-box-pack: left !important;\\n      -ms-flex-pack: left !important;\\n          justify-content: left !important;\\n}\\n\\n.is-justify-content-right {\\n  -webkit-box-pack: right !important;\\n      -ms-flex-pack: right !important;\\n          justify-content: right !important;\\n}\\n\\n.is-align-content-flex-start {\\n  -ms-flex-line-pack: start !important;\\n      align-content: flex-start !important;\\n}\\n\\n.is-align-content-flex-end {\\n  -ms-flex-line-pack: end !important;\\n      align-content: flex-end !important;\\n}\\n\\n.is-align-content-center {\\n  -ms-flex-line-pack: center !important;\\n      align-content: center !important;\\n}\\n\\n.is-align-content-space-between {\\n  -ms-flex-line-pack: justify !important;\\n      align-content: space-between !important;\\n}\\n\\n.is-align-content-space-around {\\n  -ms-flex-line-pack: distribute !important;\\n      align-content: space-around !important;\\n}\\n\\n.is-align-content-space-evenly {\\n  -ms-flex-line-pack: space-evenly !important;\\n      align-content: space-evenly !important;\\n}\\n\\n.is-align-content-stretch {\\n  -ms-flex-line-pack: stretch !important;\\n      align-content: stretch !important;\\n}\\n\\n.is-align-content-start {\\n  -ms-flex-line-pack: start !important;\\n      align-content: start !important;\\n}\\n\\n.is-align-content-end {\\n  -ms-flex-line-pack: end !important;\\n      align-content: end !important;\\n}\\n\\n.is-align-content-baseline {\\n  -ms-flex-line-pack: baseline !important;\\n      align-content: baseline !important;\\n}\\n\\n.is-align-items-stretch {\\n  -webkit-box-align: stretch !important;\\n      -ms-flex-align: stretch !important;\\n          align-items: stretch !important;\\n}\\n\\n.is-align-items-flex-start {\\n  -webkit-box-align: start !important;\\n      -ms-flex-align: start !important;\\n          align-items: flex-start !important;\\n}\\n\\n.is-align-items-flex-end {\\n  -webkit-box-align: end !important;\\n      -ms-flex-align: end !important;\\n          align-items: flex-end !important;\\n}\\n\\n.is-align-items-center {\\n  -webkit-box-align: center !important;\\n      -ms-flex-align: center !important;\\n          align-items: center !important;\\n}\\n\\n.is-align-items-baseline {\\n  -webkit-box-align: baseline !important;\\n      -ms-flex-align: baseline !important;\\n          align-items: baseline !important;\\n}\\n\\n.is-align-items-start {\\n  -webkit-box-align: start !important;\\n      -ms-flex-align: start !important;\\n          align-items: start !important;\\n}\\n\\n.is-align-items-end {\\n  -webkit-box-align: end !important;\\n      -ms-flex-align: end !important;\\n          align-items: end !important;\\n}\\n\\n.is-align-items-self-start {\\n  -webkit-box-align: self-start !important;\\n      -ms-flex-align: self-start !important;\\n          align-items: self-start !important;\\n}\\n\\n.is-align-items-self-end {\\n  -webkit-box-align: self-end !important;\\n      -ms-flex-align: self-end !important;\\n          align-items: self-end !important;\\n}\\n\\n.is-align-self-auto {\\n  -ms-flex-item-align: auto !important;\\n      align-self: auto !important;\\n}\\n\\n.is-align-self-flex-start {\\n  -ms-flex-item-align: start !important;\\n      align-self: flex-start !important;\\n}\\n\\n.is-align-self-flex-end {\\n  -ms-flex-item-align: end !important;\\n      align-self: flex-end !important;\\n}\\n\\n.is-align-self-center {\\n  -ms-flex-item-align: center !important;\\n      align-self: center !important;\\n}\\n\\n.is-align-self-baseline {\\n  -ms-flex-item-align: baseline !important;\\n      align-self: baseline !important;\\n}\\n\\n.is-align-self-stretch {\\n  -ms-flex-item-align: stretch !important;\\n      align-self: stretch !important;\\n}\\n\\n.is-flex-grow-0 {\\n  -webkit-box-flex: 0 !important;\\n      -ms-flex-positive: 0 !important;\\n          flex-grow: 0 !important;\\n}\\n\\n.is-flex-grow-1 {\\n  -webkit-box-flex: 1 !important;\\n      -ms-flex-positive: 1 !important;\\n          flex-grow: 1 !important;\\n}\\n\\n.is-flex-grow-2 {\\n  -webkit-box-flex: 2 !important;\\n      -ms-flex-positive: 2 !important;\\n          flex-grow: 2 !important;\\n}\\n\\n.is-flex-grow-3 {\\n  -webkit-box-flex: 3 !important;\\n      -ms-flex-positive: 3 !important;\\n          flex-grow: 3 !important;\\n}\\n\\n.is-flex-grow-4 {\\n  -webkit-box-flex: 4 !important;\\n      -ms-flex-positive: 4 !important;\\n          flex-grow: 4 !important;\\n}\\n\\n.is-flex-grow-5 {\\n  -webkit-box-flex: 5 !important;\\n      -ms-flex-positive: 5 !important;\\n          flex-grow: 5 !important;\\n}\\n\\n.is-flex-shrink-0 {\\n  -ms-flex-negative: 0 !important;\\n      flex-shrink: 0 !important;\\n}\\n\\n.is-flex-shrink-1 {\\n  -ms-flex-negative: 1 !important;\\n      flex-shrink: 1 !important;\\n}\\n\\n.is-flex-shrink-2 {\\n  -ms-flex-negative: 2 !important;\\n      flex-shrink: 2 !important;\\n}\\n\\n.is-flex-shrink-3 {\\n  -ms-flex-negative: 3 !important;\\n      flex-shrink: 3 !important;\\n}\\n\\n.is-flex-shrink-4 {\\n  -ms-flex-negative: 4 !important;\\n      flex-shrink: 4 !important;\\n}\\n\\n.is-flex-shrink-5 {\\n  -ms-flex-negative: 5 !important;\\n      flex-shrink: 5 !important;\\n}\\n\\n.is-clearfix::after {\\n  clear: both;\\n  content: \\\" \\\";\\n  display: table;\\n}\\n\\n.is-pulled-left {\\n  float: left !important;\\n}\\n\\n.is-pulled-right {\\n  float: right !important;\\n}\\n\\n.is-radiusless {\\n  border-radius: 0 !important;\\n}\\n\\n.is-shadowless {\\n  -webkit-box-shadow: none !important;\\n          box-shadow: none !important;\\n}\\n\\n.is-clickable {\\n  cursor: pointer !important;\\n  pointer-events: all !important;\\n}\\n\\n.is-clipped {\\n  overflow: hidden !important;\\n}\\n\\n.is-relative {\\n  position: relative !important;\\n}\\n\\n.is-marginless {\\n  margin: 0 !important;\\n}\\n\\n.is-paddingless {\\n  padding: 0 !important;\\n}\\n\\n.m-0 {\\n  margin: 0 !important;\\n}\\n\\n.mt-0 {\\n  margin-top: 0 !important;\\n}\\n\\n.mr-0 {\\n  margin-right: 0 !important;\\n}\\n\\n.mb-0 {\\n  margin-bottom: 0 !important;\\n}\\n\\n.ml-0 {\\n  margin-left: 0 !important;\\n}\\n\\n.mx-0 {\\n  margin-left: 0 !important;\\n  margin-right: 0 !important;\\n}\\n\\n.my-0 {\\n  margin-top: 0 !important;\\n  margin-bottom: 0 !important;\\n}\\n\\n.m-1 {\\n  margin: 0.25rem !important;\\n}\\n\\n.mt-1 {\\n  margin-top: 0.25rem !important;\\n}\\n\\n.mr-1 {\\n  margin-right: 0.25rem !important;\\n}\\n\\n.mb-1 {\\n  margin-bottom: 0.25rem !important;\\n}\\n\\n.ml-1 {\\n  margin-left: 0.25rem !important;\\n}\\n\\n.mx-1 {\\n  margin-left: 0.25rem !important;\\n  margin-right: 0.25rem !important;\\n}\\n\\n.my-1 {\\n  margin-top: 0.25rem !important;\\n  margin-bottom: 0.25rem !important;\\n}\\n\\n.m-2 {\\n  margin: 0.5rem !important;\\n}\\n\\n.mt-2 {\\n  margin-top: 0.5rem !important;\\n}\\n\\n.mr-2 {\\n  margin-right: 0.5rem !important;\\n}\\n\\n.mb-2 {\\n  margin-bottom: 0.5rem !important;\\n}\\n\\n.ml-2 {\\n  margin-left: 0.5rem !important;\\n}\\n\\n.mx-2 {\\n  margin-left: 0.5rem !important;\\n  margin-right: 0.5rem !important;\\n}\\n\\n.my-2 {\\n  margin-top: 0.5rem !important;\\n  margin-bottom: 0.5rem !important;\\n}\\n\\n.m-3 {\\n  margin: 0.75rem !important;\\n}\\n\\n.mt-3 {\\n  margin-top: 0.75rem !important;\\n}\\n\\n.mr-3 {\\n  margin-right: 0.75rem !important;\\n}\\n\\n.mb-3 {\\n  margin-bottom: 0.75rem !important;\\n}\\n\\n.ml-3 {\\n  margin-left: 0.75rem !important;\\n}\\n\\n.mx-3 {\\n  margin-left: 0.75rem !important;\\n  margin-right: 0.75rem !important;\\n}\\n\\n.my-3 {\\n  margin-top: 0.75rem !important;\\n  margin-bottom: 0.75rem !important;\\n}\\n\\n.m-4 {\\n  margin: 1rem !important;\\n}\\n\\n.mt-4 {\\n  margin-top: 1rem !important;\\n}\\n\\n.mr-4 {\\n  margin-right: 1rem !important;\\n}\\n\\n.mb-4 {\\n  margin-bottom: 1rem !important;\\n}\\n\\n.ml-4 {\\n  margin-left: 1rem !important;\\n}\\n\\n.mx-4 {\\n  margin-left: 1rem !important;\\n  margin-right: 1rem !important;\\n}\\n\\n.my-4 {\\n  margin-top: 1rem !important;\\n  margin-bottom: 1rem !important;\\n}\\n\\n.m-5 {\\n  margin: 1.5rem !important;\\n}\\n\\n.mt-5 {\\n  margin-top: 1.5rem !important;\\n}\\n\\n.mr-5 {\\n  margin-right: 1.5rem !important;\\n}\\n\\n.mb-5 {\\n  margin-bottom: 1.5rem !important;\\n}\\n\\n.ml-5 {\\n  margin-left: 1.5rem !important;\\n}\\n\\n.mx-5 {\\n  margin-left: 1.5rem !important;\\n  margin-right: 1.5rem !important;\\n}\\n\\n.my-5 {\\n  margin-top: 1.5rem !important;\\n  margin-bottom: 1.5rem !important;\\n}\\n\\n.m-6 {\\n  margin: 3rem !important;\\n}\\n\\n.mt-6 {\\n  margin-top: 3rem !important;\\n}\\n\\n.mr-6 {\\n  margin-right: 3rem !important;\\n}\\n\\n.mb-6 {\\n  margin-bottom: 3rem !important;\\n}\\n\\n.ml-6 {\\n  margin-left: 3rem !important;\\n}\\n\\n.mx-6 {\\n  margin-left: 3rem !important;\\n  margin-right: 3rem !important;\\n}\\n\\n.my-6 {\\n  margin-top: 3rem !important;\\n  margin-bottom: 3rem !important;\\n}\\n\\n.m-auto {\\n  margin: auto !important;\\n}\\n\\n.mt-auto {\\n  margin-top: auto !important;\\n}\\n\\n.mr-auto {\\n  margin-right: auto !important;\\n}\\n\\n.mb-auto {\\n  margin-bottom: auto !important;\\n}\\n\\n.ml-auto {\\n  margin-left: auto !important;\\n}\\n\\n.mx-auto {\\n  margin-left: auto !important;\\n  margin-right: auto !important;\\n}\\n\\n.my-auto {\\n  margin-top: auto !important;\\n  margin-bottom: auto !important;\\n}\\n\\n.p-0 {\\n  padding: 0 !important;\\n}\\n\\n.pt-0 {\\n  padding-top: 0 !important;\\n}\\n\\n.pr-0 {\\n  padding-right: 0 !important;\\n}\\n\\n.pb-0 {\\n  padding-bottom: 0 !important;\\n}\\n\\n.pl-0 {\\n  padding-left: 0 !important;\\n}\\n\\n.px-0 {\\n  padding-left: 0 !important;\\n  padding-right: 0 !important;\\n}\\n\\n.py-0 {\\n  padding-top: 0 !important;\\n  padding-bottom: 0 !important;\\n}\\n\\n.p-1 {\\n  padding: 0.25rem !important;\\n}\\n\\n.pt-1 {\\n  padding-top: 0.25rem !important;\\n}\\n\\n.pr-1 {\\n  padding-right: 0.25rem !important;\\n}\\n\\n.pb-1 {\\n  padding-bottom: 0.25rem !important;\\n}\\n\\n.pl-1 {\\n  padding-left: 0.25rem !important;\\n}\\n\\n.px-1 {\\n  padding-left: 0.25rem !important;\\n  padding-right: 0.25rem !important;\\n}\\n\\n.py-1 {\\n  padding-top: 0.25rem !important;\\n  padding-bottom: 0.25rem !important;\\n}\\n\\n.p-2 {\\n  padding: 0.5rem !important;\\n}\\n\\n.pt-2 {\\n  padding-top: 0.5rem !important;\\n}\\n\\n.pr-2 {\\n  padding-right: 0.5rem !important;\\n}\\n\\n.pb-2 {\\n  padding-bottom: 0.5rem !important;\\n}\\n\\n.pl-2 {\\n  padding-left: 0.5rem !important;\\n}\\n\\n.px-2 {\\n  padding-left: 0.5rem !important;\\n  padding-right: 0.5rem !important;\\n}\\n\\n.py-2 {\\n  padding-top: 0.5rem !important;\\n  padding-bottom: 0.5rem !important;\\n}\\n\\n.p-3 {\\n  padding: 0.75rem !important;\\n}\\n\\n.pt-3 {\\n  padding-top: 0.75rem !important;\\n}\\n\\n.pr-3 {\\n  padding-right: 0.75rem !important;\\n}\\n\\n.pb-3 {\\n  padding-bottom: 0.75rem !important;\\n}\\n\\n.pl-3 {\\n  padding-left: 0.75rem !important;\\n}\\n\\n.px-3 {\\n  padding-left: 0.75rem !important;\\n  padding-right: 0.75rem !important;\\n}\\n\\n.py-3 {\\n  padding-top: 0.75rem !important;\\n  padding-bottom: 0.75rem !important;\\n}\\n\\n.p-4 {\\n  padding: 1rem !important;\\n}\\n\\n.pt-4 {\\n  padding-top: 1rem !important;\\n}\\n\\n.pr-4 {\\n  padding-right: 1rem !important;\\n}\\n\\n.pb-4 {\\n  padding-bottom: 1rem !important;\\n}\\n\\n.pl-4 {\\n  padding-left: 1rem !important;\\n}\\n\\n.px-4 {\\n  padding-left: 1rem !important;\\n  padding-right: 1rem !important;\\n}\\n\\n.py-4 {\\n  padding-top: 1rem !important;\\n  padding-bottom: 1rem !important;\\n}\\n\\n.p-5 {\\n  padding: 1.5rem !important;\\n}\\n\\n.pt-5 {\\n  padding-top: 1.5rem !important;\\n}\\n\\n.pr-5 {\\n  padding-right: 1.5rem !important;\\n}\\n\\n.pb-5 {\\n  padding-bottom: 1.5rem !important;\\n}\\n\\n.pl-5 {\\n  padding-left: 1.5rem !important;\\n}\\n\\n.px-5 {\\n  padding-left: 1.5rem !important;\\n  padding-right: 1.5rem !important;\\n}\\n\\n.py-5 {\\n  padding-top: 1.5rem !important;\\n  padding-bottom: 1.5rem !important;\\n}\\n\\n.p-6 {\\n  padding: 3rem !important;\\n}\\n\\n.pt-6 {\\n  padding-top: 3rem !important;\\n}\\n\\n.pr-6 {\\n  padding-right: 3rem !important;\\n}\\n\\n.pb-6 {\\n  padding-bottom: 3rem !important;\\n}\\n\\n.pl-6 {\\n  padding-left: 3rem !important;\\n}\\n\\n.px-6 {\\n  padding-left: 3rem !important;\\n  padding-right: 3rem !important;\\n}\\n\\n.py-6 {\\n  padding-top: 3rem !important;\\n  padding-bottom: 3rem !important;\\n}\\n\\n.p-auto {\\n  padding: auto !important;\\n}\\n\\n.pt-auto {\\n  padding-top: auto !important;\\n}\\n\\n.pr-auto {\\n  padding-right: auto !important;\\n}\\n\\n.pb-auto {\\n  padding-bottom: auto !important;\\n}\\n\\n.pl-auto {\\n  padding-left: auto !important;\\n}\\n\\n.px-auto {\\n  padding-left: auto !important;\\n  padding-right: auto !important;\\n}\\n\\n.py-auto {\\n  padding-top: auto !important;\\n  padding-bottom: auto !important;\\n}\\n\\n.is-size-1 {\\n  font-size: 3rem !important;\\n}\\n\\n.is-size-2 {\\n  font-size: 2.5rem !important;\\n}\\n\\n.is-size-3 {\\n  font-size: 2rem !important;\\n}\\n\\n.is-size-4 {\\n  font-size: 1.5rem !important;\\n}\\n\\n.is-size-5 {\\n  font-size: 1.25rem !important;\\n}\\n\\n.is-size-6 {\\n  font-size: 1rem !important;\\n}\\n\\n.is-size-7 {\\n  font-size: 0.75rem !important;\\n}\\n\\n@media screen and (max-width: 768px) {\\n  .is-size-1-mobile {\\n    font-size: 3rem !important;\\n  }\\n  .is-size-2-mobile {\\n    font-size: 2.5rem !important;\\n  }\\n  .is-size-3-mobile {\\n    font-size: 2rem !important;\\n  }\\n  .is-size-4-mobile {\\n    font-size: 1.5rem !important;\\n  }\\n  .is-size-5-mobile {\\n    font-size: 1.25rem !important;\\n  }\\n  .is-size-6-mobile {\\n    font-size: 1rem !important;\\n  }\\n  .is-size-7-mobile {\\n    font-size: 0.75rem !important;\\n  }\\n}\\n@media screen and (min-width: 769px), print {\\n  .is-size-1-tablet {\\n    font-size: 3rem !important;\\n  }\\n  .is-size-2-tablet {\\n    font-size: 2.5rem !important;\\n  }\\n  .is-size-3-tablet {\\n    font-size: 2rem !important;\\n  }\\n  .is-size-4-tablet {\\n    font-size: 1.5rem !important;\\n  }\\n  .is-size-5-tablet {\\n    font-size: 1.25rem !important;\\n  }\\n  .is-size-6-tablet {\\n    font-size: 1rem !important;\\n  }\\n  .is-size-7-tablet {\\n    font-size: 0.75rem !important;\\n  }\\n}\\n@media screen and (max-width: 1023px) {\\n  .is-size-1-touch {\\n    font-size: 3rem !important;\\n  }\\n  .is-size-2-touch {\\n    font-size: 2.5rem !important;\\n  }\\n  .is-size-3-touch {\\n    font-size: 2rem !important;\\n  }\\n  .is-size-4-touch {\\n    font-size: 1.5rem !important;\\n  }\\n  .is-size-5-touch {\\n    font-size: 1.25rem !important;\\n  }\\n  .is-size-6-touch {\\n    font-size: 1rem !important;\\n  }\\n  .is-size-7-touch {\\n    font-size: 0.75rem !important;\\n  }\\n}\\n@media screen and (min-width: 1024px) {\\n  .is-size-1-desktop {\\n    font-size: 3rem !important;\\n  }\\n  .is-size-2-desktop {\\n    font-size: 2.5rem !important;\\n  }\\n  .is-size-3-desktop {\\n    font-size: 2rem !important;\\n  }\\n  .is-size-4-desktop {\\n    font-size: 1.5rem !important;\\n  }\\n  .is-size-5-desktop {\\n    font-size: 1.25rem !important;\\n  }\\n  .is-size-6-desktop {\\n    font-size: 1rem !important;\\n  }\\n  .is-size-7-desktop {\\n    font-size: 0.75rem !important;\\n  }\\n}\\n@media screen and (min-width: 1216px) {\\n  .is-size-1-widescreen {\\n    font-size: 3rem !important;\\n  }\\n  .is-size-2-widescreen {\\n    font-size: 2.5rem !important;\\n  }\\n  .is-size-3-widescreen {\\n    font-size: 2rem !important;\\n  }\\n  .is-size-4-widescreen {\\n    font-size: 1.5rem !important;\\n  }\\n  .is-size-5-widescreen {\\n    font-size: 1.25rem !important;\\n  }\\n  .is-size-6-widescreen {\\n    font-size: 1rem !important;\\n  }\\n  .is-size-7-widescreen {\\n    font-size: 0.75rem !important;\\n  }\\n}\\n@media screen and (min-width: 1408px) {\\n  .is-size-1-fullhd {\\n    font-size: 3rem !important;\\n  }\\n  .is-size-2-fullhd {\\n    font-size: 2.5rem !important;\\n  }\\n  .is-size-3-fullhd {\\n    font-size: 2rem !important;\\n  }\\n  .is-size-4-fullhd {\\n    font-size: 1.5rem !important;\\n  }\\n  .is-size-5-fullhd {\\n    font-size: 1.25rem !important;\\n  }\\n  .is-size-6-fullhd {\\n    font-size: 1rem !important;\\n  }\\n  .is-size-7-fullhd {\\n    font-size: 0.75rem !important;\\n  }\\n}\\n.has-text-centered {\\n  text-align: center !important;\\n}\\n\\n.has-text-justified {\\n  text-align: justify !important;\\n}\\n\\n.has-text-left {\\n  text-align: left !important;\\n}\\n\\n.has-text-right {\\n  text-align: right !important;\\n}\\n\\n@media screen and (max-width: 768px) {\\n  .has-text-centered-mobile {\\n    text-align: center !important;\\n  }\\n}\\n@media screen and (min-width: 769px), print {\\n  .has-text-centered-tablet {\\n    text-align: center !important;\\n  }\\n}\\n@media screen and (min-width: 769px) and (max-width: 1023px) {\\n  .has-text-centered-tablet-only {\\n    text-align: center !important;\\n  }\\n}\\n@media screen and (max-width: 1023px) {\\n  .has-text-centered-touch {\\n    text-align: center !important;\\n  }\\n}\\n@media screen and (min-width: 1024px) {\\n  .has-text-centered-desktop {\\n    text-align: center !important;\\n  }\\n}\\n@media screen and (min-width: 1024px) and (max-width: 1215px) {\\n  .has-text-centered-desktop-only {\\n    text-align: center !important;\\n  }\\n}\\n@media screen and (min-width: 1216px) {\\n  .has-text-centered-widescreen {\\n    text-align: center !important;\\n  }\\n}\\n@media screen and (min-width: 1216px) and (max-width: 1407px) {\\n  .has-text-centered-widescreen-only {\\n    text-align: center !important;\\n  }\\n}\\n@media screen and (min-width: 1408px) {\\n  .has-text-centered-fullhd {\\n    text-align: center !important;\\n  }\\n}\\n@media screen and (max-width: 768px) {\\n  .has-text-justified-mobile {\\n    text-align: justify !important;\\n  }\\n}\\n@media screen and (min-width: 769px), print {\\n  .has-text-justified-tablet {\\n    text-align: justify !important;\\n  }\\n}\\n@media screen and (min-width: 769px) and (max-width: 1023px) {\\n  .has-text-justified-tablet-only {\\n    text-align: justify !important;\\n  }\\n}\\n@media screen and (max-width: 1023px) {\\n  .has-text-justified-touch {\\n    text-align: justify !important;\\n  }\\n}\\n@media screen and (min-width: 1024px) {\\n  .has-text-justified-desktop {\\n    text-align: justify !important;\\n  }\\n}\\n@media screen and (min-width: 1024px) and (max-width: 1215px) {\\n  .has-text-justified-desktop-only {\\n    text-align: justify !important;\\n  }\\n}\\n@media screen and (min-width: 1216px) {\\n  .has-text-justified-widescreen {\\n    text-align: justify !important;\\n  }\\n}\\n@media screen and (min-width: 1216px) and (max-width: 1407px) {\\n  .has-text-justified-widescreen-only {\\n    text-align: justify !important;\\n  }\\n}\\n@media screen and (min-width: 1408px) {\\n  .has-text-justified-fullhd {\\n    text-align: justify !important;\\n  }\\n}\\n@media screen and (max-width: 768px) {\\n  .has-text-left-mobile {\\n    text-align: left !important;\\n  }\\n}\\n@media screen and (min-width: 769px), print {\\n  .has-text-left-tablet {\\n    text-align: left !important;\\n  }\\n}\\n@media screen and (min-width: 769px) and (max-width: 1023px) {\\n  .has-text-left-tablet-only {\\n    text-align: left !important;\\n  }\\n}\\n@media screen and (max-width: 1023px) {\\n  .has-text-left-touch {\\n    text-align: left !important;\\n  }\\n}\\n@media screen and (min-width: 1024px) {\\n  .has-text-left-desktop {\\n    text-align: left !important;\\n  }\\n}\\n@media screen and (min-width: 1024px) and (max-width: 1215px) {\\n  .has-text-left-desktop-only {\\n    text-align: left !important;\\n  }\\n}\\n@media screen and (min-width: 1216px) {\\n  .has-text-left-widescreen {\\n    text-align: left !important;\\n  }\\n}\\n@media screen and (min-width: 1216px) and (max-width: 1407px) {\\n  .has-text-left-widescreen-only {\\n    text-align: left !important;\\n  }\\n}\\n@media screen and (min-width: 1408px) {\\n  .has-text-left-fullhd {\\n    text-align: left !important;\\n  }\\n}\\n@media screen and (max-width: 768px) {\\n  .has-text-right-mobile {\\n    text-align: right !important;\\n  }\\n}\\n@media screen and (min-width: 769px), print {\\n  .has-text-right-tablet {\\n    text-align: right !important;\\n  }\\n}\\n@media screen and (min-width: 769px) and (max-width: 1023px) {\\n  .has-text-right-tablet-only {\\n    text-align: right !important;\\n  }\\n}\\n@media screen and (max-width: 1023px) {\\n  .has-text-right-touch {\\n    text-align: right !important;\\n  }\\n}\\n@media screen and (min-width: 1024px) {\\n  .has-text-right-desktop {\\n    text-align: right !important;\\n  }\\n}\\n@media screen and (min-width: 1024px) and (max-width: 1215px) {\\n  .has-text-right-desktop-only {\\n    text-align: right !important;\\n  }\\n}\\n@media screen and (min-width: 1216px) {\\n  .has-text-right-widescreen {\\n    text-align: right !important;\\n  }\\n}\\n@media screen and (min-width: 1216px) and (max-width: 1407px) {\\n  .has-text-right-widescreen-only {\\n    text-align: right !important;\\n  }\\n}\\n@media screen and (min-width: 1408px) {\\n  .has-text-right-fullhd {\\n    text-align: right !important;\\n  }\\n}\\n.is-capitalized {\\n  text-transform: capitalize !important;\\n}\\n\\n.is-lowercase {\\n  text-transform: lowercase !important;\\n}\\n\\n.is-uppercase {\\n  text-transform: uppercase !important;\\n}\\n\\n.is-italic {\\n  font-style: italic !important;\\n}\\n\\n.is-underlined {\\n  text-decoration: underline !important;\\n}\\n\\n.has-text-weight-light {\\n  font-weight: 300 !important;\\n}\\n\\n.has-text-weight-normal {\\n  font-weight: 400 !important;\\n}\\n\\n.has-text-weight-medium {\\n  font-weight: 500 !important;\\n}\\n\\n.has-text-weight-semibold {\\n  font-weight: 600 !important;\\n}\\n\\n.has-text-weight-bold {\\n  font-weight: 700 !important;\\n}\\n\\n.is-family-primary {\\n  font-family: BlinkMacSystemFont, -apple-system, \\\"Segoe UI\\\", \\\"Roboto\\\", \\\"Oxygen\\\", \\\"Ubuntu\\\", \\\"Cantarell\\\", \\\"Fira Sans\\\", \\\"Droid Sans\\\", \\\"Helvetica Neue\\\", \\\"Helvetica\\\", \\\"Arial\\\", sans-serif !important;\\n}\\n\\n.is-family-secondary {\\n  font-family: BlinkMacSystemFont, -apple-system, \\\"Segoe UI\\\", \\\"Roboto\\\", \\\"Oxygen\\\", \\\"Ubuntu\\\", \\\"Cantarell\\\", \\\"Fira Sans\\\", \\\"Droid Sans\\\", \\\"Helvetica Neue\\\", \\\"Helvetica\\\", \\\"Arial\\\", sans-serif !important;\\n}\\n\\n.is-family-sans-serif {\\n  font-family: BlinkMacSystemFont, -apple-system, \\\"Segoe UI\\\", \\\"Roboto\\\", \\\"Oxygen\\\", \\\"Ubuntu\\\", \\\"Cantarell\\\", \\\"Fira Sans\\\", \\\"Droid Sans\\\", \\\"Helvetica Neue\\\", \\\"Helvetica\\\", \\\"Arial\\\", sans-serif !important;\\n}\\n\\n.is-family-monospace {\\n  font-family: monospace !important;\\n}\\n\\n.is-family-code {\\n  font-family: monospace !important;\\n}\\n\\n.is-block {\\n  display: block !important;\\n}\\n\\n@media screen and (max-width: 768px) {\\n  .is-block-mobile {\\n    display: block !important;\\n  }\\n}\\n@media screen and (min-width: 769px), print {\\n  .is-block-tablet {\\n    display: block !important;\\n  }\\n}\\n@media screen and (min-width: 769px) and (max-width: 1023px) {\\n  .is-block-tablet-only {\\n    display: block !important;\\n  }\\n}\\n@media screen and (max-width: 1023px) {\\n  .is-block-touch {\\n    display: block !important;\\n  }\\n}\\n@media screen and (min-width: 1024px) {\\n  .is-block-desktop {\\n    display: block !important;\\n  }\\n}\\n@media screen and (min-width: 1024px) and (max-width: 1215px) {\\n  .is-block-desktop-only {\\n    display: block !important;\\n  }\\n}\\n@media screen and (min-width: 1216px) {\\n  .is-block-widescreen {\\n    display: block !important;\\n  }\\n}\\n@media screen and (min-width: 1216px) and (max-width: 1407px) {\\n  .is-block-widescreen-only {\\n    display: block !important;\\n  }\\n}\\n@media screen and (min-width: 1408px) {\\n  .is-block-fullhd {\\n    display: block !important;\\n  }\\n}\\n.is-flex {\\n  display: -webkit-box !important;\\n  display: -ms-flexbox !important;\\n  display: flex !important;\\n}\\n\\n@media screen and (max-width: 768px) {\\n  .is-flex-mobile {\\n    display: -webkit-box !important;\\n    display: -ms-flexbox !important;\\n    display: flex !important;\\n  }\\n}\\n@media screen and (min-width: 769px), print {\\n  .is-flex-tablet {\\n    display: -webkit-box !important;\\n    display: -ms-flexbox !important;\\n    display: flex !important;\\n  }\\n}\\n@media screen and (min-width: 769px) and (max-width: 1023px) {\\n  .is-flex-tablet-only {\\n    display: -webkit-box !important;\\n    display: -ms-flexbox !important;\\n    display: flex !important;\\n  }\\n}\\n@media screen and (max-width: 1023px) {\\n  .is-flex-touch {\\n    display: -webkit-box !important;\\n    display: -ms-flexbox !important;\\n    display: flex !important;\\n  }\\n}\\n@media screen and (min-width: 1024px) {\\n  .is-flex-desktop {\\n    display: -webkit-box !important;\\n    display: -ms-flexbox !important;\\n    display: flex !important;\\n  }\\n}\\n@media screen and (min-width: 1024px) and (max-width: 1215px) {\\n  .is-flex-desktop-only {\\n    display: -webkit-box !important;\\n    display: -ms-flexbox !important;\\n    display: flex !important;\\n  }\\n}\\n@media screen and (min-width: 1216px) {\\n  .is-flex-widescreen {\\n    display: -webkit-box !important;\\n    display: -ms-flexbox !important;\\n    display: flex !important;\\n  }\\n}\\n@media screen and (min-width: 1216px) and (max-width: 1407px) {\\n  .is-flex-widescreen-only {\\n    display: -webkit-box !important;\\n    display: -ms-flexbox !important;\\n    display: flex !important;\\n  }\\n}\\n@media screen and (min-width: 1408px) {\\n  .is-flex-fullhd {\\n    display: -webkit-box !important;\\n    display: -ms-flexbox !important;\\n    display: flex !important;\\n  }\\n}\\n.is-inline {\\n  display: inline !important;\\n}\\n\\n@media screen and (max-width: 768px) {\\n  .is-inline-mobile {\\n    display: inline !important;\\n  }\\n}\\n@media screen and (min-width: 769px), print {\\n  .is-inline-tablet {\\n    display: inline !important;\\n  }\\n}\\n@media screen and (min-width: 769px) and (max-width: 1023px) {\\n  .is-inline-tablet-only {\\n    display: inline !important;\\n  }\\n}\\n@media screen and (max-width: 1023px) {\\n  .is-inline-touch {\\n    display: inline !important;\\n  }\\n}\\n@media screen and (min-width: 1024px) {\\n  .is-inline-desktop {\\n    display: inline !important;\\n  }\\n}\\n@media screen and (min-width: 1024px) and (max-width: 1215px) {\\n  .is-inline-desktop-only {\\n    display: inline !important;\\n  }\\n}\\n@media screen and (min-width: 1216px) {\\n  .is-inline-widescreen {\\n    display: inline !important;\\n  }\\n}\\n@media screen and (min-width: 1216px) and (max-width: 1407px) {\\n  .is-inline-widescreen-only {\\n    display: inline !important;\\n  }\\n}\\n@media screen and (min-width: 1408px) {\\n  .is-inline-fullhd {\\n    display: inline !important;\\n  }\\n}\\n.is-inline-block {\\n  display: inline-block !important;\\n}\\n\\n@media screen and (max-width: 768px) {\\n  .is-inline-block-mobile {\\n    display: inline-block !important;\\n  }\\n}\\n@media screen and (min-width: 769px), print {\\n  .is-inline-block-tablet {\\n    display: inline-block !important;\\n  }\\n}\\n@media screen and (min-width: 769px) and (max-width: 1023px) {\\n  .is-inline-block-tablet-only {\\n    display: inline-block !important;\\n  }\\n}\\n@media screen and (max-width: 1023px) {\\n  .is-inline-block-touch {\\n    display: inline-block !important;\\n  }\\n}\\n@media screen and (min-width: 1024px) {\\n  .is-inline-block-desktop {\\n    display: inline-block !important;\\n  }\\n}\\n@media screen and (min-width: 1024px) and (max-width: 1215px) {\\n  .is-inline-block-desktop-only {\\n    display: inline-block !important;\\n  }\\n}\\n@media screen and (min-width: 1216px) {\\n  .is-inline-block-widescreen {\\n    display: inline-block !important;\\n  }\\n}\\n@media screen and (min-width: 1216px) and (max-width: 1407px) {\\n  .is-inline-block-widescreen-only {\\n    display: inline-block !important;\\n  }\\n}\\n@media screen and (min-width: 1408px) {\\n  .is-inline-block-fullhd {\\n    display: inline-block !important;\\n  }\\n}\\n.is-inline-flex {\\n  display: -webkit-inline-box !important;\\n  display: -ms-inline-flexbox !important;\\n  display: inline-flex !important;\\n}\\n\\n@media screen and (max-width: 768px) {\\n  .is-inline-flex-mobile {\\n    display: -webkit-inline-box !important;\\n    display: -ms-inline-flexbox !important;\\n    display: inline-flex !important;\\n  }\\n}\\n@media screen and (min-width: 769px), print {\\n  .is-inline-flex-tablet {\\n    display: -webkit-inline-box !important;\\n    display: -ms-inline-flexbox !important;\\n    display: inline-flex !important;\\n  }\\n}\\n@media screen and (min-width: 769px) and (max-width: 1023px) {\\n  .is-inline-flex-tablet-only {\\n    display: -webkit-inline-box !important;\\n    display: -ms-inline-flexbox !important;\\n    display: inline-flex !important;\\n  }\\n}\\n@media screen and (max-width: 1023px) {\\n  .is-inline-flex-touch {\\n    display: -webkit-inline-box !important;\\n    display: -ms-inline-flexbox !important;\\n    display: inline-flex !important;\\n  }\\n}\\n@media screen and (min-width: 1024px) {\\n  .is-inline-flex-desktop {\\n    display: -webkit-inline-box !important;\\n    display: -ms-inline-flexbox !important;\\n    display: inline-flex !important;\\n  }\\n}\\n@media screen and (min-width: 1024px) and (max-width: 1215px) {\\n  .is-inline-flex-desktop-only {\\n    display: -webkit-inline-box !important;\\n    display: -ms-inline-flexbox !important;\\n    display: inline-flex !important;\\n  }\\n}\\n@media screen and (min-width: 1216px) {\\n  .is-inline-flex-widescreen {\\n    display: -webkit-inline-box !important;\\n    display: -ms-inline-flexbox !important;\\n    display: inline-flex !important;\\n  }\\n}\\n@media screen and (min-width: 1216px) and (max-width: 1407px) {\\n  .is-inline-flex-widescreen-only {\\n    display: -webkit-inline-box !important;\\n    display: -ms-inline-flexbox !important;\\n    display: inline-flex !important;\\n  }\\n}\\n@media screen and (min-width: 1408px) {\\n  .is-inline-flex-fullhd {\\n    display: -webkit-inline-box !important;\\n    display: -ms-inline-flexbox !important;\\n    display: inline-flex !important;\\n  }\\n}\\n.is-hidden {\\n  display: none !important;\\n}\\n\\n.is-sr-only {\\n  border: none !important;\\n  clip: rect(0, 0, 0, 0) !important;\\n  height: 0.01em !important;\\n  overflow: hidden !important;\\n  padding: 0 !important;\\n  position: absolute !important;\\n  white-space: nowrap !important;\\n  width: 0.01em !important;\\n}\\n\\n@media screen and (max-width: 768px) {\\n  .is-hidden-mobile {\\n    display: none !important;\\n  }\\n}\\n@media screen and (min-width: 769px), print {\\n  .is-hidden-tablet {\\n    display: none !important;\\n  }\\n}\\n@media screen and (min-width: 769px) and (max-width: 1023px) {\\n  .is-hidden-tablet-only {\\n    display: none !important;\\n  }\\n}\\n@media screen and (max-width: 1023px) {\\n  .is-hidden-touch {\\n    display: none !important;\\n  }\\n}\\n@media screen and (min-width: 1024px) {\\n  .is-hidden-desktop {\\n    display: none !important;\\n  }\\n}\\n@media screen and (min-width: 1024px) and (max-width: 1215px) {\\n  .is-hidden-desktop-only {\\n    display: none !important;\\n  }\\n}\\n@media screen and (min-width: 1216px) {\\n  .is-hidden-widescreen {\\n    display: none !important;\\n  }\\n}\\n@media screen and (min-width: 1216px) and (max-width: 1407px) {\\n  .is-hidden-widescreen-only {\\n    display: none !important;\\n  }\\n}\\n@media screen and (min-width: 1408px) {\\n  .is-hidden-fullhd {\\n    display: none !important;\\n  }\\n}\\n.is-invisible {\\n  visibility: hidden !important;\\n}\\n\\n@media screen and (max-width: 768px) {\\n  .is-invisible-mobile {\\n    visibility: hidden !important;\\n  }\\n}\\n@media screen and (min-width: 769px), print {\\n  .is-invisible-tablet {\\n    visibility: hidden !important;\\n  }\\n}\\n@media screen and (min-width: 769px) and (max-width: 1023px) {\\n  .is-invisible-tablet-only {\\n    visibility: hidden !important;\\n  }\\n}\\n@media screen and (max-width: 1023px) {\\n  .is-invisible-touch {\\n    visibility: hidden !important;\\n  }\\n}\\n@media screen and (min-width: 1024px) {\\n  .is-invisible-desktop {\\n    visibility: hidden !important;\\n  }\\n}\\n@media screen and (min-width: 1024px) and (max-width: 1215px) {\\n  .is-invisible-desktop-only {\\n    visibility: hidden !important;\\n  }\\n}\\n@media screen and (min-width: 1216px) {\\n  .is-invisible-widescreen {\\n    visibility: hidden !important;\\n  }\\n}\\n@media screen and (min-width: 1216px) and (max-width: 1407px) {\\n  .is-invisible-widescreen-only {\\n    visibility: hidden !important;\\n  }\\n}\\n@media screen and (min-width: 1408px) {\\n  .is-invisible-fullhd {\\n    visibility: hidden !important;\\n  }\\n}\\n/* Bulma Layout */\\n.hero {\\n  -webkit-box-align: stretch;\\n      -ms-flex-align: stretch;\\n          align-items: stretch;\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n  -webkit-box-orient: vertical;\\n  -webkit-box-direction: normal;\\n      -ms-flex-direction: column;\\n          flex-direction: column;\\n  -webkit-box-pack: justify;\\n      -ms-flex-pack: justify;\\n          justify-content: space-between;\\n}\\n.hero .navbar {\\n  background: none;\\n}\\n.hero .tabs ul {\\n  border-bottom: none;\\n}\\n.hero.is-white {\\n  background-color: hsl(0deg, 0%, 100%);\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.hero.is-white a:not(.button):not(.dropdown-item):not(.tag):not(.pagination-link.is-current),\\n.hero.is-white strong {\\n  color: inherit;\\n}\\n.hero.is-white .title {\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.hero.is-white .subtitle {\\n  color: rgba(10, 10, 10, 0.9);\\n}\\n.hero.is-white .subtitle a:not(.button),\\n.hero.is-white .subtitle strong {\\n  color: hsl(0deg, 0%, 4%);\\n}\\n@media screen and (max-width: 1023px) {\\n  .hero.is-white .navbar-menu {\\n    background-color: hsl(0deg, 0%, 100%);\\n  }\\n}\\n.hero.is-white .navbar-item,\\n.hero.is-white .navbar-link {\\n  color: rgba(10, 10, 10, 0.7);\\n}\\n.hero.is-white a.navbar-item:hover, .hero.is-white a.navbar-item.is-active,\\n.hero.is-white .navbar-link:hover,\\n.hero.is-white .navbar-link.is-active {\\n  background-color: #f2f2f2;\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.hero.is-white .tabs a {\\n  color: hsl(0deg, 0%, 4%);\\n  opacity: 0.9;\\n}\\n.hero.is-white .tabs a:hover {\\n  opacity: 1;\\n}\\n.hero.is-white .tabs li.is-active a {\\n  color: hsl(0deg, 0%, 100%) !important;\\n  opacity: 1;\\n}\\n.hero.is-white .tabs.is-boxed a, .hero.is-white .tabs.is-toggle a {\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.hero.is-white .tabs.is-boxed a:hover, .hero.is-white .tabs.is-toggle a:hover {\\n  background-color: rgba(10, 10, 10, 0.1);\\n}\\n.hero.is-white .tabs.is-boxed li.is-active a, .hero.is-white .tabs.is-boxed li.is-active a:hover, .hero.is-white .tabs.is-toggle li.is-active a, .hero.is-white .tabs.is-toggle li.is-active a:hover {\\n  background-color: hsl(0deg, 0%, 4%);\\n  border-color: hsl(0deg, 0%, 4%);\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.hero.is-white.is-bold {\\n  background-image: linear-gradient(141deg, #e8e3e4 0%, hsl(0deg, 0%, 100%) 71%, white 100%);\\n}\\n@media screen and (max-width: 768px) {\\n  .hero.is-white.is-bold .navbar-menu {\\n    background-image: linear-gradient(141deg, #e8e3e4 0%, hsl(0deg, 0%, 100%) 71%, white 100%);\\n  }\\n}\\n.hero.is-black {\\n  background-color: hsl(0deg, 0%, 4%);\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.hero.is-black a:not(.button):not(.dropdown-item):not(.tag):not(.pagination-link.is-current),\\n.hero.is-black strong {\\n  color: inherit;\\n}\\n.hero.is-black .title {\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.hero.is-black .subtitle {\\n  color: rgba(255, 255, 255, 0.9);\\n}\\n.hero.is-black .subtitle a:not(.button),\\n.hero.is-black .subtitle strong {\\n  color: hsl(0deg, 0%, 100%);\\n}\\n@media screen and (max-width: 1023px) {\\n  .hero.is-black .navbar-menu {\\n    background-color: hsl(0deg, 0%, 4%);\\n  }\\n}\\n.hero.is-black .navbar-item,\\n.hero.is-black .navbar-link {\\n  color: rgba(255, 255, 255, 0.7);\\n}\\n.hero.is-black a.navbar-item:hover, .hero.is-black a.navbar-item.is-active,\\n.hero.is-black .navbar-link:hover,\\n.hero.is-black .navbar-link.is-active {\\n  background-color: black;\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.hero.is-black .tabs a {\\n  color: hsl(0deg, 0%, 100%);\\n  opacity: 0.9;\\n}\\n.hero.is-black .tabs a:hover {\\n  opacity: 1;\\n}\\n.hero.is-black .tabs li.is-active a {\\n  color: hsl(0deg, 0%, 4%) !important;\\n  opacity: 1;\\n}\\n.hero.is-black .tabs.is-boxed a, .hero.is-black .tabs.is-toggle a {\\n  color: hsl(0deg, 0%, 100%);\\n}\\n.hero.is-black .tabs.is-boxed a:hover, .hero.is-black .tabs.is-toggle a:hover {\\n  background-color: rgba(10, 10, 10, 0.1);\\n}\\n.hero.is-black .tabs.is-boxed li.is-active a, .hero.is-black .tabs.is-boxed li.is-active a:hover, .hero.is-black .tabs.is-toggle li.is-active a, .hero.is-black .tabs.is-toggle li.is-active a:hover {\\n  background-color: hsl(0deg, 0%, 100%);\\n  border-color: hsl(0deg, 0%, 100%);\\n  color: hsl(0deg, 0%, 4%);\\n}\\n.hero.is-black.is-bold {\\n  background-image: linear-gradient(141deg, black 0%, hsl(0deg, 0%, 4%) 71%, #181616 100%);\\n}\\n@media screen and (max-width: 768px) {\\n  .hero.is-black.is-bold .navbar-menu {\\n    background-image: linear-gradient(141deg, black 0%, hsl(0deg, 0%, 4%) 71%, #181616 100%);\\n  }\\n}\\n.hero.is-light {\\n  background-color: hsl(0deg, 0%, 96%);\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.hero.is-light a:not(.button):not(.dropdown-item):not(.tag):not(.pagination-link.is-current),\\n.hero.is-light strong {\\n  color: inherit;\\n}\\n.hero.is-light .title {\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.hero.is-light .subtitle {\\n  color: rgba(0, 0, 0, 0.9);\\n}\\n.hero.is-light .subtitle a:not(.button),\\n.hero.is-light .subtitle strong {\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n@media screen and (max-width: 1023px) {\\n  .hero.is-light .navbar-menu {\\n    background-color: hsl(0deg, 0%, 96%);\\n  }\\n}\\n.hero.is-light .navbar-item,\\n.hero.is-light .navbar-link {\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.hero.is-light a.navbar-item:hover, .hero.is-light a.navbar-item.is-active,\\n.hero.is-light .navbar-link:hover,\\n.hero.is-light .navbar-link.is-active {\\n  background-color: #e8e8e8;\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.hero.is-light .tabs a {\\n  color: rgba(0, 0, 0, 0.7);\\n  opacity: 0.9;\\n}\\n.hero.is-light .tabs a:hover {\\n  opacity: 1;\\n}\\n.hero.is-light .tabs li.is-active a {\\n  color: hsl(0deg, 0%, 96%) !important;\\n  opacity: 1;\\n}\\n.hero.is-light .tabs.is-boxed a, .hero.is-light .tabs.is-toggle a {\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.hero.is-light .tabs.is-boxed a:hover, .hero.is-light .tabs.is-toggle a:hover {\\n  background-color: rgba(10, 10, 10, 0.1);\\n}\\n.hero.is-light .tabs.is-boxed li.is-active a, .hero.is-light .tabs.is-boxed li.is-active a:hover, .hero.is-light .tabs.is-toggle li.is-active a, .hero.is-light .tabs.is-toggle li.is-active a:hover {\\n  background-color: rgba(0, 0, 0, 0.7);\\n  border-color: rgba(0, 0, 0, 0.7);\\n  color: hsl(0deg, 0%, 96%);\\n}\\n.hero.is-light.is-bold {\\n  background-image: linear-gradient(141deg, #dfd8d9 0%, hsl(0deg, 0%, 96%) 71%, white 100%);\\n}\\n@media screen and (max-width: 768px) {\\n  .hero.is-light.is-bold .navbar-menu {\\n    background-image: linear-gradient(141deg, #dfd8d9 0%, hsl(0deg, 0%, 96%) 71%, white 100%);\\n  }\\n}\\n.hero.is-dark {\\n  background-color: hsl(0deg, 0%, 21%);\\n  color: #fff;\\n}\\n.hero.is-dark a:not(.button):not(.dropdown-item):not(.tag):not(.pagination-link.is-current),\\n.hero.is-dark strong {\\n  color: inherit;\\n}\\n.hero.is-dark .title {\\n  color: #fff;\\n}\\n.hero.is-dark .subtitle {\\n  color: rgba(255, 255, 255, 0.9);\\n}\\n.hero.is-dark .subtitle a:not(.button),\\n.hero.is-dark .subtitle strong {\\n  color: #fff;\\n}\\n@media screen and (max-width: 1023px) {\\n  .hero.is-dark .navbar-menu {\\n    background-color: hsl(0deg, 0%, 21%);\\n  }\\n}\\n.hero.is-dark .navbar-item,\\n.hero.is-dark .navbar-link {\\n  color: rgba(255, 255, 255, 0.7);\\n}\\n.hero.is-dark a.navbar-item:hover, .hero.is-dark a.navbar-item.is-active,\\n.hero.is-dark .navbar-link:hover,\\n.hero.is-dark .navbar-link.is-active {\\n  background-color: #292929;\\n  color: #fff;\\n}\\n.hero.is-dark .tabs a {\\n  color: #fff;\\n  opacity: 0.9;\\n}\\n.hero.is-dark .tabs a:hover {\\n  opacity: 1;\\n}\\n.hero.is-dark .tabs li.is-active a {\\n  color: hsl(0deg, 0%, 21%) !important;\\n  opacity: 1;\\n}\\n.hero.is-dark .tabs.is-boxed a, .hero.is-dark .tabs.is-toggle a {\\n  color: #fff;\\n}\\n.hero.is-dark .tabs.is-boxed a:hover, .hero.is-dark .tabs.is-toggle a:hover {\\n  background-color: rgba(10, 10, 10, 0.1);\\n}\\n.hero.is-dark .tabs.is-boxed li.is-active a, .hero.is-dark .tabs.is-boxed li.is-active a:hover, .hero.is-dark .tabs.is-toggle li.is-active a, .hero.is-dark .tabs.is-toggle li.is-active a:hover {\\n  background-color: #fff;\\n  border-color: #fff;\\n  color: hsl(0deg, 0%, 21%);\\n}\\n.hero.is-dark.is-bold {\\n  background-image: linear-gradient(141deg, #1f191a 0%, hsl(0deg, 0%, 21%) 71%, #46403f 100%);\\n}\\n@media screen and (max-width: 768px) {\\n  .hero.is-dark.is-bold .navbar-menu {\\n    background-image: linear-gradient(141deg, #1f191a 0%, hsl(0deg, 0%, 21%) 71%, #46403f 100%);\\n  }\\n}\\n.hero.is-primary {\\n  background-color: hsl(171deg, 100%, 41%);\\n  color: #fff;\\n}\\n.hero.is-primary a:not(.button):not(.dropdown-item):not(.tag):not(.pagination-link.is-current),\\n.hero.is-primary strong {\\n  color: inherit;\\n}\\n.hero.is-primary .title {\\n  color: #fff;\\n}\\n.hero.is-primary .subtitle {\\n  color: rgba(255, 255, 255, 0.9);\\n}\\n.hero.is-primary .subtitle a:not(.button),\\n.hero.is-primary .subtitle strong {\\n  color: #fff;\\n}\\n@media screen and (max-width: 1023px) {\\n  .hero.is-primary .navbar-menu {\\n    background-color: hsl(171deg, 100%, 41%);\\n  }\\n}\\n.hero.is-primary .navbar-item,\\n.hero.is-primary .navbar-link {\\n  color: rgba(255, 255, 255, 0.7);\\n}\\n.hero.is-primary a.navbar-item:hover, .hero.is-primary a.navbar-item.is-active,\\n.hero.is-primary .navbar-link:hover,\\n.hero.is-primary .navbar-link.is-active {\\n  background-color: #00b89c;\\n  color: #fff;\\n}\\n.hero.is-primary .tabs a {\\n  color: #fff;\\n  opacity: 0.9;\\n}\\n.hero.is-primary .tabs a:hover {\\n  opacity: 1;\\n}\\n.hero.is-primary .tabs li.is-active a {\\n  color: hsl(171deg, 100%, 41%) !important;\\n  opacity: 1;\\n}\\n.hero.is-primary .tabs.is-boxed a, .hero.is-primary .tabs.is-toggle a {\\n  color: #fff;\\n}\\n.hero.is-primary .tabs.is-boxed a:hover, .hero.is-primary .tabs.is-toggle a:hover {\\n  background-color: rgba(10, 10, 10, 0.1);\\n}\\n.hero.is-primary .tabs.is-boxed li.is-active a, .hero.is-primary .tabs.is-boxed li.is-active a:hover, .hero.is-primary .tabs.is-toggle li.is-active a, .hero.is-primary .tabs.is-toggle li.is-active a:hover {\\n  background-color: #fff;\\n  border-color: #fff;\\n  color: hsl(171deg, 100%, 41%);\\n}\\n.hero.is-primary.is-bold {\\n  background-image: linear-gradient(141deg, #009e6c 0%, hsl(171deg, 100%, 41%) 71%, #00e7eb 100%);\\n}\\n@media screen and (max-width: 768px) {\\n  .hero.is-primary.is-bold .navbar-menu {\\n    background-image: linear-gradient(141deg, #009e6c 0%, hsl(171deg, 100%, 41%) 71%, #00e7eb 100%);\\n  }\\n}\\n.hero.is-link {\\n  background-color: hsl(229deg, 53%, 53%);\\n  color: #fff;\\n}\\n.hero.is-link a:not(.button):not(.dropdown-item):not(.tag):not(.pagination-link.is-current),\\n.hero.is-link strong {\\n  color: inherit;\\n}\\n.hero.is-link .title {\\n  color: #fff;\\n}\\n.hero.is-link .subtitle {\\n  color: rgba(255, 255, 255, 0.9);\\n}\\n.hero.is-link .subtitle a:not(.button),\\n.hero.is-link .subtitle strong {\\n  color: #fff;\\n}\\n@media screen and (max-width: 1023px) {\\n  .hero.is-link .navbar-menu {\\n    background-color: hsl(229deg, 53%, 53%);\\n  }\\n}\\n.hero.is-link .navbar-item,\\n.hero.is-link .navbar-link {\\n  color: rgba(255, 255, 255, 0.7);\\n}\\n.hero.is-link a.navbar-item:hover, .hero.is-link a.navbar-item.is-active,\\n.hero.is-link .navbar-link:hover,\\n.hero.is-link .navbar-link.is-active {\\n  background-color: #3a51bb;\\n  color: #fff;\\n}\\n.hero.is-link .tabs a {\\n  color: #fff;\\n  opacity: 0.9;\\n}\\n.hero.is-link .tabs a:hover {\\n  opacity: 1;\\n}\\n.hero.is-link .tabs li.is-active a {\\n  color: hsl(229deg, 53%, 53%) !important;\\n  opacity: 1;\\n}\\n.hero.is-link .tabs.is-boxed a, .hero.is-link .tabs.is-toggle a {\\n  color: #fff;\\n}\\n.hero.is-link .tabs.is-boxed a:hover, .hero.is-link .tabs.is-toggle a:hover {\\n  background-color: rgba(10, 10, 10, 0.1);\\n}\\n.hero.is-link .tabs.is-boxed li.is-active a, .hero.is-link .tabs.is-boxed li.is-active a:hover, .hero.is-link .tabs.is-toggle li.is-active a, .hero.is-link .tabs.is-toggle li.is-active a:hover {\\n  background-color: #fff;\\n  border-color: #fff;\\n  color: hsl(229deg, 53%, 53%);\\n}\\n.hero.is-link.is-bold {\\n  background-image: linear-gradient(141deg, #2959b3 0%, hsl(229deg, 53%, 53%) 71%, #5658d2 100%);\\n}\\n@media screen and (max-width: 768px) {\\n  .hero.is-link.is-bold .navbar-menu {\\n    background-image: linear-gradient(141deg, #2959b3 0%, hsl(229deg, 53%, 53%) 71%, #5658d2 100%);\\n  }\\n}\\n.hero.is-info {\\n  background-color: hsl(207deg, 61%, 53%);\\n  color: #fff;\\n}\\n.hero.is-info a:not(.button):not(.dropdown-item):not(.tag):not(.pagination-link.is-current),\\n.hero.is-info strong {\\n  color: inherit;\\n}\\n.hero.is-info .title {\\n  color: #fff;\\n}\\n.hero.is-info .subtitle {\\n  color: rgba(255, 255, 255, 0.9);\\n}\\n.hero.is-info .subtitle a:not(.button),\\n.hero.is-info .subtitle strong {\\n  color: #fff;\\n}\\n@media screen and (max-width: 1023px) {\\n  .hero.is-info .navbar-menu {\\n    background-color: hsl(207deg, 61%, 53%);\\n  }\\n}\\n.hero.is-info .navbar-item,\\n.hero.is-info .navbar-link {\\n  color: rgba(255, 255, 255, 0.7);\\n}\\n.hero.is-info a.navbar-item:hover, .hero.is-info a.navbar-item.is-active,\\n.hero.is-info .navbar-link:hover,\\n.hero.is-info .navbar-link.is-active {\\n  background-color: #3082c5;\\n  color: #fff;\\n}\\n.hero.is-info .tabs a {\\n  color: #fff;\\n  opacity: 0.9;\\n}\\n.hero.is-info .tabs a:hover {\\n  opacity: 1;\\n}\\n.hero.is-info .tabs li.is-active a {\\n  color: hsl(207deg, 61%, 53%) !important;\\n  opacity: 1;\\n}\\n.hero.is-info .tabs.is-boxed a, .hero.is-info .tabs.is-toggle a {\\n  color: #fff;\\n}\\n.hero.is-info .tabs.is-boxed a:hover, .hero.is-info .tabs.is-toggle a:hover {\\n  background-color: rgba(10, 10, 10, 0.1);\\n}\\n.hero.is-info .tabs.is-boxed li.is-active a, .hero.is-info .tabs.is-boxed li.is-active a:hover, .hero.is-info .tabs.is-toggle li.is-active a, .hero.is-info .tabs.is-toggle li.is-active a:hover {\\n  background-color: #fff;\\n  border-color: #fff;\\n  color: hsl(207deg, 61%, 53%);\\n}\\n.hero.is-info.is-bold {\\n  background-image: linear-gradient(141deg, #208fbc 0%, hsl(207deg, 61%, 53%) 71%, #4d83db 100%);\\n}\\n@media screen and (max-width: 768px) {\\n  .hero.is-info.is-bold .navbar-menu {\\n    background-image: linear-gradient(141deg, #208fbc 0%, hsl(207deg, 61%, 53%) 71%, #4d83db 100%);\\n  }\\n}\\n.hero.is-success {\\n  background-color: hsl(153deg, 53%, 53%);\\n  color: #fff;\\n}\\n.hero.is-success a:not(.button):not(.dropdown-item):not(.tag):not(.pagination-link.is-current),\\n.hero.is-success strong {\\n  color: inherit;\\n}\\n.hero.is-success .title {\\n  color: #fff;\\n}\\n.hero.is-success .subtitle {\\n  color: rgba(255, 255, 255, 0.9);\\n}\\n.hero.is-success .subtitle a:not(.button),\\n.hero.is-success .subtitle strong {\\n  color: #fff;\\n}\\n@media screen and (max-width: 1023px) {\\n  .hero.is-success .navbar-menu {\\n    background-color: hsl(153deg, 53%, 53%);\\n  }\\n}\\n.hero.is-success .navbar-item,\\n.hero.is-success .navbar-link {\\n  color: rgba(255, 255, 255, 0.7);\\n}\\n.hero.is-success a.navbar-item:hover, .hero.is-success a.navbar-item.is-active,\\n.hero.is-success .navbar-link:hover,\\n.hero.is-success .navbar-link.is-active {\\n  background-color: #3abb81;\\n  color: #fff;\\n}\\n.hero.is-success .tabs a {\\n  color: #fff;\\n  opacity: 0.9;\\n}\\n.hero.is-success .tabs a:hover {\\n  opacity: 1;\\n}\\n.hero.is-success .tabs li.is-active a {\\n  color: hsl(153deg, 53%, 53%) !important;\\n  opacity: 1;\\n}\\n.hero.is-success .tabs.is-boxed a, .hero.is-success .tabs.is-toggle a {\\n  color: #fff;\\n}\\n.hero.is-success .tabs.is-boxed a:hover, .hero.is-success .tabs.is-toggle a:hover {\\n  background-color: rgba(10, 10, 10, 0.1);\\n}\\n.hero.is-success .tabs.is-boxed li.is-active a, .hero.is-success .tabs.is-boxed li.is-active a:hover, .hero.is-success .tabs.is-toggle li.is-active a, .hero.is-success .tabs.is-toggle li.is-active a:hover {\\n  background-color: #fff;\\n  border-color: #fff;\\n  color: hsl(153deg, 53%, 53%);\\n}\\n.hero.is-success.is-bold {\\n  background-image: linear-gradient(141deg, #29b35e 0%, hsl(153deg, 53%, 53%) 71%, #56d2af 100%);\\n}\\n@media screen and (max-width: 768px) {\\n  .hero.is-success.is-bold .navbar-menu {\\n    background-image: linear-gradient(141deg, #29b35e 0%, hsl(153deg, 53%, 53%) 71%, #56d2af 100%);\\n  }\\n}\\n.hero.is-warning {\\n  background-color: hsl(44deg, 100%, 77%);\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.hero.is-warning a:not(.button):not(.dropdown-item):not(.tag):not(.pagination-link.is-current),\\n.hero.is-warning strong {\\n  color: inherit;\\n}\\n.hero.is-warning .title {\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.hero.is-warning .subtitle {\\n  color: rgba(0, 0, 0, 0.9);\\n}\\n.hero.is-warning .subtitle a:not(.button),\\n.hero.is-warning .subtitle strong {\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n@media screen and (max-width: 1023px) {\\n  .hero.is-warning .navbar-menu {\\n    background-color: hsl(44deg, 100%, 77%);\\n  }\\n}\\n.hero.is-warning .navbar-item,\\n.hero.is-warning .navbar-link {\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.hero.is-warning a.navbar-item:hover, .hero.is-warning a.navbar-item.is-active,\\n.hero.is-warning .navbar-link:hover,\\n.hero.is-warning .navbar-link.is-active {\\n  background-color: #ffd970;\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.hero.is-warning .tabs a {\\n  color: rgba(0, 0, 0, 0.7);\\n  opacity: 0.9;\\n}\\n.hero.is-warning .tabs a:hover {\\n  opacity: 1;\\n}\\n.hero.is-warning .tabs li.is-active a {\\n  color: hsl(44deg, 100%, 77%) !important;\\n  opacity: 1;\\n}\\n.hero.is-warning .tabs.is-boxed a, .hero.is-warning .tabs.is-toggle a {\\n  color: rgba(0, 0, 0, 0.7);\\n}\\n.hero.is-warning .tabs.is-boxed a:hover, .hero.is-warning .tabs.is-toggle a:hover {\\n  background-color: rgba(10, 10, 10, 0.1);\\n}\\n.hero.is-warning .tabs.is-boxed li.is-active a, .hero.is-warning .tabs.is-boxed li.is-active a:hover, .hero.is-warning .tabs.is-toggle li.is-active a, .hero.is-warning .tabs.is-toggle li.is-active a:hover {\\n  background-color: rgba(0, 0, 0, 0.7);\\n  border-color: rgba(0, 0, 0, 0.7);\\n  color: hsl(44deg, 100%, 77%);\\n}\\n.hero.is-warning.is-bold {\\n  background-image: linear-gradient(141deg, #ffb657 0%, hsl(44deg, 100%, 77%) 71%, #fff6a3 100%);\\n}\\n@media screen and (max-width: 768px) {\\n  .hero.is-warning.is-bold .navbar-menu {\\n    background-image: linear-gradient(141deg, #ffb657 0%, hsl(44deg, 100%, 77%) 71%, #fff6a3 100%);\\n  }\\n}\\n.hero.is-danger {\\n  background-color: hsl(348deg, 86%, 61%);\\n  color: #fff;\\n}\\n.hero.is-danger a:not(.button):not(.dropdown-item):not(.tag):not(.pagination-link.is-current),\\n.hero.is-danger strong {\\n  color: inherit;\\n}\\n.hero.is-danger .title {\\n  color: #fff;\\n}\\n.hero.is-danger .subtitle {\\n  color: rgba(255, 255, 255, 0.9);\\n}\\n.hero.is-danger .subtitle a:not(.button),\\n.hero.is-danger .subtitle strong {\\n  color: #fff;\\n}\\n@media screen and (max-width: 1023px) {\\n  .hero.is-danger .navbar-menu {\\n    background-color: hsl(348deg, 86%, 61%);\\n  }\\n}\\n.hero.is-danger .navbar-item,\\n.hero.is-danger .navbar-link {\\n  color: rgba(255, 255, 255, 0.7);\\n}\\n.hero.is-danger a.navbar-item:hover, .hero.is-danger a.navbar-item.is-active,\\n.hero.is-danger .navbar-link:hover,\\n.hero.is-danger .navbar-link.is-active {\\n  background-color: #ef2e55;\\n  color: #fff;\\n}\\n.hero.is-danger .tabs a {\\n  color: #fff;\\n  opacity: 0.9;\\n}\\n.hero.is-danger .tabs a:hover {\\n  opacity: 1;\\n}\\n.hero.is-danger .tabs li.is-active a {\\n  color: hsl(348deg, 86%, 61%) !important;\\n  opacity: 1;\\n}\\n.hero.is-danger .tabs.is-boxed a, .hero.is-danger .tabs.is-toggle a {\\n  color: #fff;\\n}\\n.hero.is-danger .tabs.is-boxed a:hover, .hero.is-danger .tabs.is-toggle a:hover {\\n  background-color: rgba(10, 10, 10, 0.1);\\n}\\n.hero.is-danger .tabs.is-boxed li.is-active a, .hero.is-danger .tabs.is-boxed li.is-active a:hover, .hero.is-danger .tabs.is-toggle li.is-active a, .hero.is-danger .tabs.is-toggle li.is-active a:hover {\\n  background-color: #fff;\\n  border-color: #fff;\\n  color: hsl(348deg, 86%, 61%);\\n}\\n.hero.is-danger.is-bold {\\n  background-image: linear-gradient(141deg, #fa0a62 0%, hsl(348deg, 86%, 61%) 71%, #f7595f 100%);\\n}\\n@media screen and (max-width: 768px) {\\n  .hero.is-danger.is-bold .navbar-menu {\\n    background-image: linear-gradient(141deg, #fa0a62 0%, hsl(348deg, 86%, 61%) 71%, #f7595f 100%);\\n  }\\n}\\n.hero.is-small .hero-body {\\n  padding: 1.5rem;\\n}\\n@media screen and (min-width: 769px), print {\\n  .hero.is-medium .hero-body {\\n    padding: 9rem 4.5rem;\\n  }\\n}\\n@media screen and (min-width: 769px), print {\\n  .hero.is-large .hero-body {\\n    padding: 18rem 6rem;\\n  }\\n}\\n.hero.is-halfheight .hero-body, .hero.is-fullheight .hero-body, .hero.is-fullheight-with-navbar .hero-body {\\n  -webkit-box-align: center;\\n      -ms-flex-align: center;\\n          align-items: center;\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n}\\n.hero.is-halfheight .hero-body > .container, .hero.is-fullheight .hero-body > .container, .hero.is-fullheight-with-navbar .hero-body > .container {\\n  -webkit-box-flex: 1;\\n      -ms-flex-positive: 1;\\n          flex-grow: 1;\\n  -ms-flex-negative: 1;\\n      flex-shrink: 1;\\n}\\n.hero.is-halfheight {\\n  min-height: 50vh;\\n}\\n.hero.is-fullheight {\\n  min-height: 100vh;\\n}\\n\\n.hero-video {\\n  overflow: hidden;\\n}\\n.hero-video video {\\n  left: 50%;\\n  min-height: 100%;\\n  min-width: 100%;\\n  position: absolute;\\n  top: 50%;\\n  -webkit-transform: translate3d(-50%, -50%, 0);\\n          transform: translate3d(-50%, -50%, 0);\\n}\\n.hero-video.is-transparent {\\n  opacity: 0.3;\\n}\\n@media screen and (max-width: 768px) {\\n  .hero-video {\\n    display: none;\\n  }\\n}\\n\\n.hero-buttons {\\n  margin-top: 1.5rem;\\n}\\n@media screen and (max-width: 768px) {\\n  .hero-buttons .button {\\n    display: -webkit-box;\\n    display: -ms-flexbox;\\n    display: flex;\\n  }\\n  .hero-buttons .button:not(:last-child) {\\n    margin-bottom: 0.75rem;\\n  }\\n}\\n@media screen and (min-width: 769px), print {\\n  .hero-buttons {\\n    display: -webkit-box;\\n    display: -ms-flexbox;\\n    display: flex;\\n    -webkit-box-pack: center;\\n        -ms-flex-pack: center;\\n            justify-content: center;\\n  }\\n  .hero-buttons .button:not(:last-child) {\\n    margin-right: 1.5rem;\\n  }\\n}\\n\\n.hero-head,\\n.hero-foot {\\n  -webkit-box-flex: 0;\\n      -ms-flex-positive: 0;\\n          flex-grow: 0;\\n  -ms-flex-negative: 0;\\n      flex-shrink: 0;\\n}\\n\\n.hero-body {\\n  -webkit-box-flex: 1;\\n      -ms-flex-positive: 1;\\n          flex-grow: 1;\\n  -ms-flex-negative: 0;\\n      flex-shrink: 0;\\n  padding: 3rem 1.5rem;\\n}\\n@media screen and (min-width: 769px), print {\\n  .hero-body {\\n    padding: 3rem 3rem;\\n  }\\n}\\n\\n.section {\\n  padding: 3rem 1.5rem;\\n}\\n@media screen and (min-width: 1024px) {\\n  .section {\\n    padding: 3rem 3rem;\\n  }\\n  .section.is-medium {\\n    padding: 9rem 4.5rem;\\n  }\\n  .section.is-large {\\n    padding: 18rem 6rem;\\n  }\\n}\\n\\n.footer {\\n  background-color: hsl(0deg, 0%, 98%);\\n  padding: 3rem 1.5rem 6rem;\\n}\\n\\n.vue-notification {\\n  padding: 10px;\\n  margin: 0 5px 5px;\\n  font-size: 14px;\\n  color: #ffffff;\\n  background: #44a4fc;\\n  border-left: 5px solid #187fe7;\\n}\\n.vue-notification.warning {\\n  background: hsl(44deg, 100%, 77%);\\n  border-left-color: #ffd970;\\n  color: #8a6500;\\n}\\n.vue-notification.danger {\\n  background: hsl(348deg, 86%, 61%);\\n  border-left-color: #ef2e55;\\n}\\n.vue-notification.success {\\n  background: hsl(153deg, 53%, 53%);\\n  border-left-color: #3abb81;\\n}\\n.vue-notification.info {\\n  background: hsl(207deg, 61%, 53%);\\n  border-left-color: #3082c5;\\n}\\n.vue-notification.primary {\\n  background: hsl(171deg, 100%, 41%);\\n  border-left-color: #00b89c;\\n}\\n.vue-notification.link {\\n  background: hsl(229deg, 53%, 53%);\\n  border-left-color: #3a51bb;\\n}\", \"\"]);\n// Exports\nmodule.exports = exports;\n\n\n//# sourceURL=webpack:///./src/assets/styles/notifications.scss?./node_modules/css-loader/dist/cjs.js??ref--8-oneOf-3-1!./node_modules/postcss-loader/src??ref--8-oneOf-3-2!./node_modules/sass-loader/dist/cjs.js??ref--8-oneOf-3-3");

/***/ }),

/***/ "./node_modules/css-loader/dist/cjs.js?!./node_modules/postcss-loader/src/index.js?!./src/assets/styles/effects.css":
/*!***************************************************************************************************************************************************!*\
  !*** ./node_modules/css-loader/dist/cjs.js??ref--6-oneOf-3-1!./node_modules/postcss-loader/src??ref--6-oneOf-3-2!./src/assets/styles/effects.css ***!
  \***************************************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("// Imports\nvar ___CSS_LOADER_API_IMPORT___ = __webpack_require__(/*! ../../../node_modules/css-loader/dist/runtime/api.js */ \"./node_modules/css-loader/dist/runtime/api.js\");\nexports = ___CSS_LOADER_API_IMPORT___(false);\n// Module\nexports.push([module.i, \".slide-fade-enter-active {\\n  -webkit-transition: all 0.4s ease;\\n  transition: all 0.4s ease;\\n}\\n\\n.slide-fade-enter {\\n  -webkit-transform: translateX(6px);\\n          transform: translateX(6px);\\n  opacity: 0;\\n}\\n\\n.fade-enter-active {\\n  -webkit-transition: opacity 0.4s ease;\\n  transition: opacity 0.4s ease;\\n}\\n.fade-enter {\\n  opacity: 0;\\n}\\n\\n/* .fade-enter-active,\\n.fade-leave-active {\\n  transition: opacity 0.3s ease;\\n}\\n.fade-enter,\\n.fade-leave-to {\\n  opacity: 0;\\n} */\\n\\n.pulse {\\n  -webkit-animation: pulse 1s linear infinite;\\n          animation: pulse 1s linear infinite;\\n}\\n\\n.pulse-fast-once {\\n  -webkit-animation: pulse 0.4s ease 1;\\n          animation: pulse 0.4s ease 1;\\n}\\n\\n@-webkit-keyframes pulse {\\n  0% {\\n    -webkit-transform: scale(1, 1);\\n            transform: scale(1, 1);\\n  }\\n  50% {\\n    -webkit-transform: scale(0.85, 0.85);\\n            transform: scale(0.85, 0.85);\\n  }\\n  100% {\\n    -webkit-transform: scale(1, 1);\\n            transform: scale(1, 1);\\n  }\\n}\\n\\n@keyframes pulse {\\n  0% {\\n    -webkit-transform: scale(1, 1);\\n            transform: scale(1, 1);\\n  }\\n  50% {\\n    -webkit-transform: scale(0.85, 0.85);\\n            transform: scale(0.85, 0.85);\\n  }\\n  100% {\\n    -webkit-transform: scale(1, 1);\\n            transform: scale(1, 1);\\n  }\\n}\\n\", \"\"]);\n// Exports\nmodule.exports = exports;\n\n\n//# sourceURL=webpack:///./src/assets/styles/effects.css?./node_modules/css-loader/dist/cjs.js??ref--6-oneOf-3-1!./node_modules/postcss-loader/src??ref--6-oneOf-3-2");

/***/ }),

/***/ "./node_modules/css-loader/dist/cjs.js?!./node_modules/postcss-loader/src/index.js?!./src/assets/styles/font.css":
/*!************************************************************************************************************************************************!*\
  !*** ./node_modules/css-loader/dist/cjs.js??ref--6-oneOf-3-1!./node_modules/postcss-loader/src??ref--6-oneOf-3-2!./src/assets/styles/font.css ***!
  \************************************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("// Imports\nvar ___CSS_LOADER_API_IMPORT___ = __webpack_require__(/*! ../../../node_modules/css-loader/dist/runtime/api.js */ \"./node_modules/css-loader/dist/runtime/api.js\");\nvar ___CSS_LOADER_GET_URL_IMPORT___ = __webpack_require__(/*! ../../../node_modules/css-loader/dist/runtime/getUrl.js */ \"./node_modules/css-loader/dist/runtime/getUrl.js\");\nvar ___CSS_LOADER_URL_IMPORT_0___ = __webpack_require__(/*! ../font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qNa7lqDY.woff2 */ \"./src/assets/font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qNa7lqDY.woff2\");\nvar ___CSS_LOADER_URL_IMPORT_1___ = __webpack_require__(/*! ../font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qPK7lqDY.woff2 */ \"./src/assets/font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qPK7lqDY.woff2\");\nvar ___CSS_LOADER_URL_IMPORT_2___ = __webpack_require__(/*! ../font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qNK7lqDY.woff2 */ \"./src/assets/font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qNK7lqDY.woff2\");\nvar ___CSS_LOADER_URL_IMPORT_3___ = __webpack_require__(/*! ../font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qO67lqDY.woff2 */ \"./src/assets/font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qO67lqDY.woff2\");\nvar ___CSS_LOADER_URL_IMPORT_4___ = __webpack_require__(/*! ../font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qN67lqDY.woff2 */ \"./src/assets/font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qN67lqDY.woff2\");\nvar ___CSS_LOADER_URL_IMPORT_5___ = __webpack_require__(/*! ../font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qNq7lqDY.woff2 */ \"./src/assets/font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qNq7lqDY.woff2\");\nvar ___CSS_LOADER_URL_IMPORT_6___ = __webpack_require__(/*! ../font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qOK7l.woff2 */ \"./src/assets/font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qOK7l.woff2\");\nexports = ___CSS_LOADER_API_IMPORT___(false);\nvar ___CSS_LOADER_URL_REPLACEMENT_0___ = ___CSS_LOADER_GET_URL_IMPORT___(___CSS_LOADER_URL_IMPORT_0___);\nvar ___CSS_LOADER_URL_REPLACEMENT_1___ = ___CSS_LOADER_GET_URL_IMPORT___(___CSS_LOADER_URL_IMPORT_1___);\nvar ___CSS_LOADER_URL_REPLACEMENT_2___ = ___CSS_LOADER_GET_URL_IMPORT___(___CSS_LOADER_URL_IMPORT_2___);\nvar ___CSS_LOADER_URL_REPLACEMENT_3___ = ___CSS_LOADER_GET_URL_IMPORT___(___CSS_LOADER_URL_IMPORT_3___);\nvar ___CSS_LOADER_URL_REPLACEMENT_4___ = ___CSS_LOADER_GET_URL_IMPORT___(___CSS_LOADER_URL_IMPORT_4___);\nvar ___CSS_LOADER_URL_REPLACEMENT_5___ = ___CSS_LOADER_GET_URL_IMPORT___(___CSS_LOADER_URL_IMPORT_5___);\nvar ___CSS_LOADER_URL_REPLACEMENT_6___ = ___CSS_LOADER_GET_URL_IMPORT___(___CSS_LOADER_URL_IMPORT_6___);\n// Module\nexports.push([module.i, \"/* cyrillic-ext */\\n@font-face {\\n    font-family: 'Source Sans Pro';\\n    font-style: normal;\\n    font-weight: 400;\\n    font-display: swap;\\n    src: local('Source Sans Pro Regular'), local('SourceSansPro-Regular'), url(\" + ___CSS_LOADER_URL_REPLACEMENT_0___ + \") format('woff2');\\n    unicode-range: U+0460-052F, U+1C80-1C88, U+20B4, U+2DE0-2DFF, U+A640-A69F, U+FE2E-FE2F;\\n}\\n\\n/* cyrillic */\\n@font-face {\\n    font-family: 'Source Sans Pro';\\n    font-style: normal;\\n    font-weight: 400;\\n    font-display: swap;\\n    src: local('Source Sans Pro Regular'), local('SourceSansPro-Regular'), url(\" + ___CSS_LOADER_URL_REPLACEMENT_1___ + \") format('woff2');\\n    unicode-range: U+0400-045F, U+0490-0491, U+04B0-04B1, U+2116;\\n}\\n\\n/* greek-ext */\\n@font-face {\\n    font-family: 'Source Sans Pro';\\n    font-style: normal;\\n    font-weight: 400;\\n    font-display: swap;\\n    src: local('Source Sans Pro Regular'), local('SourceSansPro-Regular'), url(\" + ___CSS_LOADER_URL_REPLACEMENT_2___ + \") format('woff2');\\n    unicode-range: U+1F00-1FFF;\\n}\\n\\n/* greek */\\n@font-face {\\n    font-family: 'Source Sans Pro';\\n    font-style: normal;\\n    font-weight: 400;\\n    font-display: swap;\\n    src: local('Source Sans Pro Regular'), local('SourceSansPro-Regular'), url(\" + ___CSS_LOADER_URL_REPLACEMENT_3___ + \") format('woff2');\\n    unicode-range: U+0370-03FF;\\n}\\n\\n/* vietnamese */\\n@font-face {\\n    font-family: 'Source Sans Pro';\\n    font-style: normal;\\n    font-weight: 400;\\n    font-display: swap;\\n    src: local('Source Sans Pro Regular'), local('SourceSansPro-Regular'), url(\" + ___CSS_LOADER_URL_REPLACEMENT_4___ + \") format('woff2');\\n    unicode-range: U+0102-0103, U+0110-0111, U+1EA0-1EF9, U+20AB;\\n}\\n\\n/* latin-ext */\\n@font-face {\\n    font-family: 'Source Sans Pro';\\n    font-style: normal;\\n    font-weight: 400;\\n    font-display: swap;\\n    src: local('Source Sans Pro Regular'), local('SourceSansPro-Regular'), url(\" + ___CSS_LOADER_URL_REPLACEMENT_5___ + \") format('woff2');\\n    unicode-range: U+0100-024F, U+0259, U+1E00-1EFF, U+2020, U+20A0-20AB, U+20AD-20CF, U+2113, U+2C60-2C7F, U+A720-A7FF;\\n}\\n\\n/* latin */\\n@font-face {\\n    font-family: 'Source Sans Pro';\\n    font-style: normal;\\n    font-weight: 400;\\n    font-display: swap;\\n    src: local('Source Sans Pro Regular'), local('SourceSansPro-Regular'), url(\" + ___CSS_LOADER_URL_REPLACEMENT_6___ + \") format('woff2');\\n    unicode-range: U+0000-00FF, U+0131, U+0152-0153, U+02BB-02BC, U+02C6, U+02DA, U+02DC, U+2000-206F, U+2074, U+20AC, U+2122, U+2191, U+2193, U+2212, U+2215, U+FEFF, U+FFFD;\\n}\", \"\"]);\n// Exports\nmodule.exports = exports;\n\n\n//# sourceURL=webpack:///./src/assets/styles/font.css?./node_modules/css-loader/dist/cjs.js??ref--6-oneOf-3-1!./node_modules/postcss-loader/src??ref--6-oneOf-3-2");

/***/ }),

/***/ "./node_modules/css-loader/dist/cjs.js?!./node_modules/postcss-loader/src/index.js?!./src/assets/styles/notificationbar.css":
/*!***********************************************************************************************************************************************************!*\
  !*** ./node_modules/css-loader/dist/cjs.js??ref--6-oneOf-3-1!./node_modules/postcss-loader/src??ref--6-oneOf-3-2!./src/assets/styles/notificationbar.css ***!
  \***********************************************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("// Imports\nvar ___CSS_LOADER_API_IMPORT___ = __webpack_require__(/*! ../../../node_modules/css-loader/dist/runtime/api.js */ \"./node_modules/css-loader/dist/runtime/api.js\");\nexports = ___CSS_LOADER_API_IMPORT___(false);\n// Module\nexports.push([module.i, \".notification-bar {\\n    position: fixed;\\n    z-index: 10;\\n    left: 50%;\\n    margin: auto;\\n    -webkit-transform: translateX(-50%);\\n            transform: translateX(-50%);\\n    top: 70px;\\n}\", \"\"]);\n// Exports\nmodule.exports = exports;\n\n\n//# sourceURL=webpack:///./src/assets/styles/notificationbar.css?./node_modules/css-loader/dist/cjs.js??ref--6-oneOf-3-1!./node_modules/postcss-loader/src??ref--6-oneOf-3-2");

/***/ }),

/***/ "./node_modules/css-loader/dist/cjs.js?!./node_modules/postcss-loader/src/index.js?!./src/assets/styles/spinner.css":
/*!***************************************************************************************************************************************************!*\
  !*** ./node_modules/css-loader/dist/cjs.js??ref--6-oneOf-3-1!./node_modules/postcss-loader/src??ref--6-oneOf-3-2!./src/assets/styles/spinner.css ***!
  \***************************************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("// Imports\nvar ___CSS_LOADER_API_IMPORT___ = __webpack_require__(/*! ../../../node_modules/css-loader/dist/runtime/api.js */ \"./node_modules/css-loader/dist/runtime/api.js\");\nexports = ___CSS_LOADER_API_IMPORT___(false);\n// Module\nexports.push([module.i, \".spinner-wrapper {\\n  display: -webkit-box;\\n  display: -ms-flexbox;\\n  display: flex;\\n}\\n\\n.spinner-wrapper.center {\\n  width: 100%;\\n  -webkit-box-pack: center;\\n      -ms-flex-pack: center;\\n          justify-content: center;\\n}\\n\\n.spinner.smaller {\\n  height: 15px !important;\\n  width: 15px !important;\\n}\\n\\n.spinner.small {\\n  height: 15px !important;\\n  width: 15px !important;\\n}\\n\\n.spinner.margin {\\n  margin-right: 0.75rem;\\n}\\n\\n.spinner.margin-left {\\n  margin-left: 0.75rem;\\n}\\n\\n.spinner {\\n  vertical-align: middle;\\n  display: inline-block;\\n  height: 20px;\\n  width: 20px;\\n  -webkit-animation: rotate 0.8s infinite linear;\\n          animation: rotate 0.8s infinite linear;\\n  border: 1.5px solid grey;\\n  border-right-color: transparent;\\n  border-radius: 50%;\\n}\\n\\n@-webkit-keyframes rotate {\\n  0% {\\n    -webkit-transform: rotate(0deg);\\n            transform: rotate(0deg);\\n  }\\n\\n  100% {\\n    -webkit-transform: rotate(360deg);\\n            transform: rotate(360deg);\\n  }\\n}\\n\\n@keyframes rotate {\\n  0% {\\n    -webkit-transform: rotate(0deg);\\n            transform: rotate(0deg);\\n  }\\n\\n  100% {\\n    -webkit-transform: rotate(360deg);\\n            transform: rotate(360deg);\\n  }\\n}\\n\", \"\"]);\n// Exports\nmodule.exports = exports;\n\n\n//# sourceURL=webpack:///./src/assets/styles/spinner.css?./node_modules/css-loader/dist/cjs.js??ref--6-oneOf-3-1!./node_modules/postcss-loader/src??ref--6-oneOf-3-2");

/***/ }),

/***/ "./node_modules/css-loader/dist/cjs.js?!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src/index.js?!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/App.vue?vue&type=style&index=0&id=7ba5bd90&scoped=true&lang=css&":
/*!*******************************************************************************************************************************************************************************************************************************************************************************************************************************************************!*\
  !*** ./node_modules/css-loader/dist/cjs.js??ref--6-oneOf-1-1!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src??ref--6-oneOf-1-2!./node_modules/cache-loader/dist/cjs.js??ref--0-0!./node_modules/vue-loader/lib??vue-loader-options!./src/App.vue?vue&type=style&index=0&id=7ba5bd90&scoped=true&lang=css& ***!
  \*******************************************************************************************************************************************************************************************************************************************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("// Imports\nvar ___CSS_LOADER_API_IMPORT___ = __webpack_require__(/*! ../node_modules/css-loader/dist/runtime/api.js */ \"./node_modules/css-loader/dist/runtime/api.js\");\nexports = ___CSS_LOADER_API_IMPORT___(false);\n// Module\nexports.push([module.i, \"\\n.full-bg[data-v-7ba5bd90] {\\n  background-color: black;\\n  background-image: url(\\\"/img/background.jpg\\\");\\n  background-position: center;\\n  background-repeat: no-repeat;\\n  background-size: cover;\\n  height: 100vh;\\n  /* calc(100vh - 52px); */\\n  overflow: hidden;\\n  -ms-overflow-style: none; /* IE and Edge */\\n  scrollbar-width: none; /* Firefox */\\n}\\n\", \"\"]);\n// Exports\nmodule.exports = exports;\n\n\n//# sourceURL=webpack:///./src/App.vue?./node_modules/css-loader/dist/cjs.js??ref--6-oneOf-1-1!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src??ref--6-oneOf-1-2!./node_modules/cache-loader/dist/cjs.js??ref--0-0!./node_modules/vue-loader/lib??vue-loader-options");

/***/ }),

/***/ "./node_modules/css-loader/dist/cjs.js?!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src/index.js?!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/main/Breadcrumb.vue?vue&type=style&index=0&id=11f3f7d9&lang=css&scoped=true&":
/*!******************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************!*\
  !*** ./node_modules/css-loader/dist/cjs.js??ref--6-oneOf-1-1!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src??ref--6-oneOf-1-2!./node_modules/cache-loader/dist/cjs.js??ref--0-0!./node_modules/vue-loader/lib??vue-loader-options!./src/components/main/Breadcrumb.vue?vue&type=style&index=0&id=11f3f7d9&lang=css&scoped=true& ***!
  \******************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("// Imports\nvar ___CSS_LOADER_API_IMPORT___ = __webpack_require__(/*! ../../../node_modules/css-loader/dist/runtime/api.js */ \"./node_modules/css-loader/dist/runtime/api.js\");\nexports = ___CSS_LOADER_API_IMPORT___(false);\n// Module\nexports.push([module.i, \"\\n.mg[data-v-11f3f7d9] {\\r\\n  margin-bottom: 4px;\\n}\\r\\n\", \"\"]);\n// Exports\nmodule.exports = exports;\n\n\n//# sourceURL=webpack:///./src/components/main/Breadcrumb.vue?./node_modules/css-loader/dist/cjs.js??ref--6-oneOf-1-1!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src??ref--6-oneOf-1-2!./node_modules/cache-loader/dist/cjs.js??ref--0-0!./node_modules/vue-loader/lib??vue-loader-options");

/***/ }),

/***/ "./node_modules/vue-style-loader/index.js?!./node_modules/css-loader/dist/cjs.js?!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src/index.js?!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/App.vue?vue&type=style&index=0&id=7ba5bd90&scoped=true&lang=css&":
/*!*********************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************!*\
  !*** ./node_modules/vue-style-loader??ref--6-oneOf-1-0!./node_modules/css-loader/dist/cjs.js??ref--6-oneOf-1-1!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src??ref--6-oneOf-1-2!./node_modules/cache-loader/dist/cjs.js??ref--0-0!./node_modules/vue-loader/lib??vue-loader-options!./src/App.vue?vue&type=style&index=0&id=7ba5bd90&scoped=true&lang=css& ***!
  \*********************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("// style-loader: Adds some css to the DOM by adding a <style> tag\n\n// load the styles\nvar content = __webpack_require__(/*! !../node_modules/css-loader/dist/cjs.js??ref--6-oneOf-1-1!../node_modules/vue-loader/lib/loaders/stylePostLoader.js!../node_modules/postcss-loader/src??ref--6-oneOf-1-2!../node_modules/cache-loader/dist/cjs.js??ref--0-0!../node_modules/vue-loader/lib??vue-loader-options!./App.vue?vue&type=style&index=0&id=7ba5bd90&scoped=true&lang=css& */ \"./node_modules/css-loader/dist/cjs.js?!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src/index.js?!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/App.vue?vue&type=style&index=0&id=7ba5bd90&scoped=true&lang=css&\");\nif(content.__esModule) content = content.default;\nif(typeof content === 'string') content = [[module.i, content, '']];\nif(content.locals) module.exports = content.locals;\n// add the styles to the DOM\nvar add = __webpack_require__(/*! ../node_modules/vue-style-loader/lib/addStylesClient.js */ \"./node_modules/vue-style-loader/lib/addStylesClient.js\").default\nvar update = add(\"51ed1074\", content, false, {\"sourceMap\":false,\"shadowMode\":false});\n// Hot Module Replacement\nif(false) {}\n\n//# sourceURL=webpack:///./src/App.vue?./node_modules/vue-style-loader??ref--6-oneOf-1-0!./node_modules/css-loader/dist/cjs.js??ref--6-oneOf-1-1!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src??ref--6-oneOf-1-2!./node_modules/cache-loader/dist/cjs.js??ref--0-0!./node_modules/vue-loader/lib??vue-loader-options");

/***/ }),

/***/ "./node_modules/vue-style-loader/index.js?!./node_modules/css-loader/dist/cjs.js?!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src/index.js?!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/main/Breadcrumb.vue?vue&type=style&index=0&id=11f3f7d9&lang=css&scoped=true&":
/*!********************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************!*\
  !*** ./node_modules/vue-style-loader??ref--6-oneOf-1-0!./node_modules/css-loader/dist/cjs.js??ref--6-oneOf-1-1!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src??ref--6-oneOf-1-2!./node_modules/cache-loader/dist/cjs.js??ref--0-0!./node_modules/vue-loader/lib??vue-loader-options!./src/components/main/Breadcrumb.vue?vue&type=style&index=0&id=11f3f7d9&lang=css&scoped=true& ***!
  \********************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("// style-loader: Adds some css to the DOM by adding a <style> tag\n\n// load the styles\nvar content = __webpack_require__(/*! !../../../node_modules/css-loader/dist/cjs.js??ref--6-oneOf-1-1!../../../node_modules/vue-loader/lib/loaders/stylePostLoader.js!../../../node_modules/postcss-loader/src??ref--6-oneOf-1-2!../../../node_modules/cache-loader/dist/cjs.js??ref--0-0!../../../node_modules/vue-loader/lib??vue-loader-options!./Breadcrumb.vue?vue&type=style&index=0&id=11f3f7d9&lang=css&scoped=true& */ \"./node_modules/css-loader/dist/cjs.js?!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src/index.js?!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/main/Breadcrumb.vue?vue&type=style&index=0&id=11f3f7d9&lang=css&scoped=true&\");\nif(content.__esModule) content = content.default;\nif(typeof content === 'string') content = [[module.i, content, '']];\nif(content.locals) module.exports = content.locals;\n// add the styles to the DOM\nvar add = __webpack_require__(/*! ../../../node_modules/vue-style-loader/lib/addStylesClient.js */ \"./node_modules/vue-style-loader/lib/addStylesClient.js\").default\nvar update = add(\"3b8b9864\", content, false, {\"sourceMap\":false,\"shadowMode\":false});\n// Hot Module Replacement\nif(false) {}\n\n//# sourceURL=webpack:///./src/components/main/Breadcrumb.vue?./node_modules/vue-style-loader??ref--6-oneOf-1-0!./node_modules/css-loader/dist/cjs.js??ref--6-oneOf-1-1!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src??ref--6-oneOf-1-2!./node_modules/cache-loader/dist/cjs.js??ref--0-0!./node_modules/vue-loader/lib??vue-loader-options");

/***/ }),

/***/ "./src/App.vue":
/*!*********************!*\
  !*** ./src/App.vue ***!
  \*********************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _App_vue_vue_type_template_id_7ba5bd90_scoped_true___WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./App.vue?vue&type=template&id=7ba5bd90&scoped=true& */ \"./src/App.vue?vue&type=template&id=7ba5bd90&scoped=true&\");\n/* harmony import */ var _App_vue_vue_type_script_lang_js___WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./App.vue?vue&type=script&lang=js& */ \"./src/App.vue?vue&type=script&lang=js&\");\n/* empty/unused harmony star reexport *//* harmony import */ var _App_vue_vue_type_style_index_0_id_7ba5bd90_scoped_true_lang_css___WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./App.vue?vue&type=style&index=0&id=7ba5bd90&scoped=true&lang=css& */ \"./src/App.vue?vue&type=style&index=0&id=7ba5bd90&scoped=true&lang=css&\");\n/* harmony import */ var _node_modules_vue_loader_lib_runtime_componentNormalizer_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../node_modules/vue-loader/lib/runtime/componentNormalizer.js */ \"./node_modules/vue-loader/lib/runtime/componentNormalizer.js\");\n\n\n\n\n\n\n/* normalize component */\n\nvar component = Object(_node_modules_vue_loader_lib_runtime_componentNormalizer_js__WEBPACK_IMPORTED_MODULE_3__[\"default\"])(\n  _App_vue_vue_type_script_lang_js___WEBPACK_IMPORTED_MODULE_1__[\"default\"],\n  _App_vue_vue_type_template_id_7ba5bd90_scoped_true___WEBPACK_IMPORTED_MODULE_0__[\"render\"],\n  _App_vue_vue_type_template_id_7ba5bd90_scoped_true___WEBPACK_IMPORTED_MODULE_0__[\"staticRenderFns\"],\n  false,\n  null,\n  \"7ba5bd90\",\n  null\n  \n)\n\n/* hot reload */\nif (false) { var api; }\ncomponent.options.__file = \"src/App.vue\"\n/* harmony default export */ __webpack_exports__[\"default\"] = (component.exports);\n\n//# sourceURL=webpack:///./src/App.vue?");

/***/ }),

/***/ "./src/App.vue?vue&type=script&lang=js&":
/*!**********************************************!*\
  !*** ./src/App.vue?vue&type=script&lang=js& ***!
  \**********************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_ref_12_0_node_modules_babel_loader_lib_index_js_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_App_vue_vue_type_script_lang_js___WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! -!../node_modules/cache-loader/dist/cjs.js??ref--12-0!../node_modules/babel-loader/lib!../node_modules/cache-loader/dist/cjs.js??ref--0-0!../node_modules/vue-loader/lib??vue-loader-options!./App.vue?vue&type=script&lang=js& */ \"./node_modules/cache-loader/dist/cjs.js?!./node_modules/babel-loader/lib/index.js!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/App.vue?vue&type=script&lang=js&\");\n/* empty/unused harmony star reexport */ /* harmony default export */ __webpack_exports__[\"default\"] = (_node_modules_cache_loader_dist_cjs_js_ref_12_0_node_modules_babel_loader_lib_index_js_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_App_vue_vue_type_script_lang_js___WEBPACK_IMPORTED_MODULE_0__[\"default\"]); \n\n//# sourceURL=webpack:///./src/App.vue?");

/***/ }),

/***/ "./src/App.vue?vue&type=style&index=0&id=7ba5bd90&scoped=true&lang=css&":
/*!******************************************************************************!*\
  !*** ./src/App.vue?vue&type=style&index=0&id=7ba5bd90&scoped=true&lang=css& ***!
  \******************************************************************************/
/*! no static exports found */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _node_modules_vue_style_loader_index_js_ref_6_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_6_oneOf_1_1_node_modules_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_6_oneOf_1_2_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_App_vue_vue_type_style_index_0_id_7ba5bd90_scoped_true_lang_css___WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! -!../node_modules/vue-style-loader??ref--6-oneOf-1-0!../node_modules/css-loader/dist/cjs.js??ref--6-oneOf-1-1!../node_modules/vue-loader/lib/loaders/stylePostLoader.js!../node_modules/postcss-loader/src??ref--6-oneOf-1-2!../node_modules/cache-loader/dist/cjs.js??ref--0-0!../node_modules/vue-loader/lib??vue-loader-options!./App.vue?vue&type=style&index=0&id=7ba5bd90&scoped=true&lang=css& */ \"./node_modules/vue-style-loader/index.js?!./node_modules/css-loader/dist/cjs.js?!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src/index.js?!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/App.vue?vue&type=style&index=0&id=7ba5bd90&scoped=true&lang=css&\");\n/* harmony import */ var _node_modules_vue_style_loader_index_js_ref_6_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_6_oneOf_1_1_node_modules_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_6_oneOf_1_2_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_App_vue_vue_type_style_index_0_id_7ba5bd90_scoped_true_lang_css___WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_node_modules_vue_style_loader_index_js_ref_6_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_6_oneOf_1_1_node_modules_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_6_oneOf_1_2_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_App_vue_vue_type_style_index_0_id_7ba5bd90_scoped_true_lang_css___WEBPACK_IMPORTED_MODULE_0__);\n/* harmony reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in _node_modules_vue_style_loader_index_js_ref_6_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_6_oneOf_1_1_node_modules_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_6_oneOf_1_2_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_App_vue_vue_type_style_index_0_id_7ba5bd90_scoped_true_lang_css___WEBPACK_IMPORTED_MODULE_0__) if([\"default\"].indexOf(__WEBPACK_IMPORT_KEY__) < 0) (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return _node_modules_vue_style_loader_index_js_ref_6_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_6_oneOf_1_1_node_modules_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_6_oneOf_1_2_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_App_vue_vue_type_style_index_0_id_7ba5bd90_scoped_true_lang_css___WEBPACK_IMPORTED_MODULE_0__[key]; }) }(__WEBPACK_IMPORT_KEY__));\n\n\n//# sourceURL=webpack:///./src/App.vue?");

/***/ }),

/***/ "./src/App.vue?vue&type=template&id=7ba5bd90&scoped=true&":
/*!****************************************************************!*\
  !*** ./src/App.vue?vue&type=template&id=7ba5bd90&scoped=true& ***!
  \****************************************************************/
/*! exports provided: render, staticRenderFns */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_cacheDirectory_node_modules_cache_vue_loader_cacheIdentifier_60671cf1_vue_loader_template_node_modules_vue_loader_lib_loaders_templateLoader_js_vue_loader_options_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_App_vue_vue_type_template_id_7ba5bd90_scoped_true___WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! -!../node_modules/cache-loader/dist/cjs.js?{\"cacheDirectory\":\"node_modules/.cache/vue-loader\",\"cacheIdentifier\":\"60671cf1-vue-loader-template\"}!../node_modules/vue-loader/lib/loaders/templateLoader.js??vue-loader-options!../node_modules/cache-loader/dist/cjs.js??ref--0-0!../node_modules/vue-loader/lib??vue-loader-options!./App.vue?vue&type=template&id=7ba5bd90&scoped=true& */ \"./node_modules/cache-loader/dist/cjs.js?{\\\"cacheDirectory\\\":\\\"node_modules/.cache/vue-loader\\\",\\\"cacheIdentifier\\\":\\\"60671cf1-vue-loader-template\\\"}!./node_modules/vue-loader/lib/loaders/templateLoader.js?!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/App.vue?vue&type=template&id=7ba5bd90&scoped=true&\");\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"render\", function() { return _node_modules_cache_loader_dist_cjs_js_cacheDirectory_node_modules_cache_vue_loader_cacheIdentifier_60671cf1_vue_loader_template_node_modules_vue_loader_lib_loaders_templateLoader_js_vue_loader_options_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_App_vue_vue_type_template_id_7ba5bd90_scoped_true___WEBPACK_IMPORTED_MODULE_0__[\"render\"]; });\n\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"staticRenderFns\", function() { return _node_modules_cache_loader_dist_cjs_js_cacheDirectory_node_modules_cache_vue_loader_cacheIdentifier_60671cf1_vue_loader_template_node_modules_vue_loader_lib_loaders_templateLoader_js_vue_loader_options_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_App_vue_vue_type_template_id_7ba5bd90_scoped_true___WEBPACK_IMPORTED_MODULE_0__[\"staticRenderFns\"]; });\n\n\n\n//# sourceURL=webpack:///./src/App.vue?");

/***/ }),

/***/ "./src/assets/font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qN67lqDY.woff2":
/*!*******************************************************************!*\
  !*** ./src/assets/font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qN67lqDY.woff2 ***!
  \*******************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("module.exports = __webpack_require__.p + \"fonts/6xK3dSBYKcSV-LCoeQqfX1RYOo3qN67lqDY.de194900.woff2\";\n\n//# sourceURL=webpack:///./src/assets/font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qN67lqDY.woff2?");

/***/ }),

/***/ "./src/assets/font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qNK7lqDY.woff2":
/*!*******************************************************************!*\
  !*** ./src/assets/font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qNK7lqDY.woff2 ***!
  \*******************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("module.exports = __webpack_require__.p + \"fonts/6xK3dSBYKcSV-LCoeQqfX1RYOo3qNK7lqDY.dd9d74f2.woff2\";\n\n//# sourceURL=webpack:///./src/assets/font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qNK7lqDY.woff2?");

/***/ }),

/***/ "./src/assets/font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qNa7lqDY.woff2":
/*!*******************************************************************!*\
  !*** ./src/assets/font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qNa7lqDY.woff2 ***!
  \*******************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("module.exports = __webpack_require__.p + \"fonts/6xK3dSBYKcSV-LCoeQqfX1RYOo3qNa7lqDY.edecc91f.woff2\";\n\n//# sourceURL=webpack:///./src/assets/font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qNa7lqDY.woff2?");

/***/ }),

/***/ "./src/assets/font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qNq7lqDY.woff2":
/*!*******************************************************************!*\
  !*** ./src/assets/font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qNq7lqDY.woff2 ***!
  \*******************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("module.exports = __webpack_require__.p + \"fonts/6xK3dSBYKcSV-LCoeQqfX1RYOo3qNq7lqDY.90823ba4.woff2\";\n\n//# sourceURL=webpack:///./src/assets/font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qNq7lqDY.woff2?");

/***/ }),

/***/ "./src/assets/font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qO67lqDY.woff2":
/*!*******************************************************************!*\
  !*** ./src/assets/font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qO67lqDY.woff2 ***!
  \*******************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("module.exports = __webpack_require__.p + \"fonts/6xK3dSBYKcSV-LCoeQqfX1RYOo3qO67lqDY.d92e79e3.woff2\";\n\n//# sourceURL=webpack:///./src/assets/font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qO67lqDY.woff2?");

/***/ }),

/***/ "./src/assets/font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qOK7l.woff2":
/*!****************************************************************!*\
  !*** ./src/assets/font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qOK7l.woff2 ***!
  \****************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("module.exports = __webpack_require__.p + \"fonts/6xK3dSBYKcSV-LCoeQqfX1RYOo3qOK7l.899c8f78.woff2\";\n\n//# sourceURL=webpack:///./src/assets/font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qOK7l.woff2?");

/***/ }),

/***/ "./src/assets/font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qPK7lqDY.woff2":
/*!*******************************************************************!*\
  !*** ./src/assets/font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qPK7lqDY.woff2 ***!
  \*******************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("module.exports = __webpack_require__.p + \"fonts/6xK3dSBYKcSV-LCoeQqfX1RYOo3qPK7lqDY.188d9403.woff2\";\n\n//# sourceURL=webpack:///./src/assets/font/6xK3dSBYKcSV-LCoeQqfX1RYOo3qPK7lqDY.woff2?");

/***/ }),

/***/ "./src/assets/styles/base.scss":
/*!*************************************!*\
  !*** ./src/assets/styles/base.scss ***!
  \*************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("// style-loader: Adds some css to the DOM by adding a <style> tag\n\n// load the styles\nvar content = __webpack_require__(/*! !../../../node_modules/css-loader/dist/cjs.js??ref--8-oneOf-3-1!../../../node_modules/postcss-loader/src??ref--8-oneOf-3-2!../../../node_modules/sass-loader/dist/cjs.js??ref--8-oneOf-3-3!./base.scss */ \"./node_modules/css-loader/dist/cjs.js?!./node_modules/postcss-loader/src/index.js?!./node_modules/sass-loader/dist/cjs.js?!./src/assets/styles/base.scss\");\nif(content.__esModule) content = content.default;\nif(typeof content === 'string') content = [[module.i, content, '']];\nif(content.locals) module.exports = content.locals;\n// add the styles to the DOM\nvar add = __webpack_require__(/*! ../../../node_modules/vue-style-loader/lib/addStylesClient.js */ \"./node_modules/vue-style-loader/lib/addStylesClient.js\").default\nvar update = add(\"46ede919\", content, false, {\"sourceMap\":false,\"shadowMode\":false});\n// Hot Module Replacement\nif(false) {}\n\n//# sourceURL=webpack:///./src/assets/styles/base.scss?");

/***/ }),

/***/ "./src/assets/styles/dark.scss":
/*!*************************************!*\
  !*** ./src/assets/styles/dark.scss ***!
  \*************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("// style-loader: Adds some css to the DOM by adding a <style> tag\n\n// load the styles\nvar content = __webpack_require__(/*! !../../../node_modules/css-loader/dist/cjs.js??ref--8-oneOf-3-1!../../../node_modules/postcss-loader/src??ref--8-oneOf-3-2!../../../node_modules/sass-loader/dist/cjs.js??ref--8-oneOf-3-3!./dark.scss */ \"./node_modules/css-loader/dist/cjs.js?!./node_modules/postcss-loader/src/index.js?!./node_modules/sass-loader/dist/cjs.js?!./src/assets/styles/dark.scss\");\nif(content.__esModule) content = content.default;\nif(typeof content === 'string') content = [[module.i, content, '']];\nif(content.locals) module.exports = content.locals;\n// add the styles to the DOM\nvar add = __webpack_require__(/*! ../../../node_modules/vue-style-loader/lib/addStylesClient.js */ \"./node_modules/vue-style-loader/lib/addStylesClient.js\").default\nvar update = add(\"e5381162\", content, false, {\"sourceMap\":false,\"shadowMode\":false});\n// Hot Module Replacement\nif(false) {}\n\n//# sourceURL=webpack:///./src/assets/styles/dark.scss?");

/***/ }),

/***/ "./src/assets/styles/effects.css":
/*!***************************************!*\
  !*** ./src/assets/styles/effects.css ***!
  \***************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("// style-loader: Adds some css to the DOM by adding a <style> tag\n\n// load the styles\nvar content = __webpack_require__(/*! !../../../node_modules/css-loader/dist/cjs.js??ref--6-oneOf-3-1!../../../node_modules/postcss-loader/src??ref--6-oneOf-3-2!./effects.css */ \"./node_modules/css-loader/dist/cjs.js?!./node_modules/postcss-loader/src/index.js?!./src/assets/styles/effects.css\");\nif(content.__esModule) content = content.default;\nif(typeof content === 'string') content = [[module.i, content, '']];\nif(content.locals) module.exports = content.locals;\n// add the styles to the DOM\nvar add = __webpack_require__(/*! ../../../node_modules/vue-style-loader/lib/addStylesClient.js */ \"./node_modules/vue-style-loader/lib/addStylesClient.js\").default\nvar update = add(\"057cb930\", content, false, {\"sourceMap\":false,\"shadowMode\":false});\n// Hot Module Replacement\nif(false) {}\n\n//# sourceURL=webpack:///./src/assets/styles/effects.css?");

/***/ }),

/***/ "./src/assets/styles/font.css":
/*!************************************!*\
  !*** ./src/assets/styles/font.css ***!
  \************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("// style-loader: Adds some css to the DOM by adding a <style> tag\n\n// load the styles\nvar content = __webpack_require__(/*! !../../../node_modules/css-loader/dist/cjs.js??ref--6-oneOf-3-1!../../../node_modules/postcss-loader/src??ref--6-oneOf-3-2!./font.css */ \"./node_modules/css-loader/dist/cjs.js?!./node_modules/postcss-loader/src/index.js?!./src/assets/styles/font.css\");\nif(content.__esModule) content = content.default;\nif(typeof content === 'string') content = [[module.i, content, '']];\nif(content.locals) module.exports = content.locals;\n// add the styles to the DOM\nvar add = __webpack_require__(/*! ../../../node_modules/vue-style-loader/lib/addStylesClient.js */ \"./node_modules/vue-style-loader/lib/addStylesClient.js\").default\nvar update = add(\"3398fe96\", content, false, {\"sourceMap\":false,\"shadowMode\":false});\n// Hot Module Replacement\nif(false) {}\n\n//# sourceURL=webpack:///./src/assets/styles/font.css?");

/***/ }),

/***/ "./src/assets/styles/notificationbar.css":
/*!***********************************************!*\
  !*** ./src/assets/styles/notificationbar.css ***!
  \***********************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("// style-loader: Adds some css to the DOM by adding a <style> tag\n\n// load the styles\nvar content = __webpack_require__(/*! !../../../node_modules/css-loader/dist/cjs.js??ref--6-oneOf-3-1!../../../node_modules/postcss-loader/src??ref--6-oneOf-3-2!./notificationbar.css */ \"./node_modules/css-loader/dist/cjs.js?!./node_modules/postcss-loader/src/index.js?!./src/assets/styles/notificationbar.css\");\nif(content.__esModule) content = content.default;\nif(typeof content === 'string') content = [[module.i, content, '']];\nif(content.locals) module.exports = content.locals;\n// add the styles to the DOM\nvar add = __webpack_require__(/*! ../../../node_modules/vue-style-loader/lib/addStylesClient.js */ \"./node_modules/vue-style-loader/lib/addStylesClient.js\").default\nvar update = add(\"541e9ff4\", content, false, {\"sourceMap\":false,\"shadowMode\":false});\n// Hot Module Replacement\nif(false) {}\n\n//# sourceURL=webpack:///./src/assets/styles/notificationbar.css?");

/***/ }),

/***/ "./src/assets/styles/notifications.scss":
/*!**********************************************!*\
  !*** ./src/assets/styles/notifications.scss ***!
  \**********************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("// style-loader: Adds some css to the DOM by adding a <style> tag\n\n// load the styles\nvar content = __webpack_require__(/*! !../../../node_modules/css-loader/dist/cjs.js??ref--8-oneOf-3-1!../../../node_modules/postcss-loader/src??ref--8-oneOf-3-2!../../../node_modules/sass-loader/dist/cjs.js??ref--8-oneOf-3-3!./notifications.scss */ \"./node_modules/css-loader/dist/cjs.js?!./node_modules/postcss-loader/src/index.js?!./node_modules/sass-loader/dist/cjs.js?!./src/assets/styles/notifications.scss\");\nif(content.__esModule) content = content.default;\nif(typeof content === 'string') content = [[module.i, content, '']];\nif(content.locals) module.exports = content.locals;\n// add the styles to the DOM\nvar add = __webpack_require__(/*! ../../../node_modules/vue-style-loader/lib/addStylesClient.js */ \"./node_modules/vue-style-loader/lib/addStylesClient.js\").default\nvar update = add(\"4fd3835b\", content, false, {\"sourceMap\":false,\"shadowMode\":false});\n// Hot Module Replacement\nif(false) {}\n\n//# sourceURL=webpack:///./src/assets/styles/notifications.scss?");

/***/ }),

/***/ "./src/assets/styles/spinner.css":
/*!***************************************!*\
  !*** ./src/assets/styles/spinner.css ***!
  \***************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("// style-loader: Adds some css to the DOM by adding a <style> tag\n\n// load the styles\nvar content = __webpack_require__(/*! !../../../node_modules/css-loader/dist/cjs.js??ref--6-oneOf-3-1!../../../node_modules/postcss-loader/src??ref--6-oneOf-3-2!./spinner.css */ \"./node_modules/css-loader/dist/cjs.js?!./node_modules/postcss-loader/src/index.js?!./src/assets/styles/spinner.css\");\nif(content.__esModule) content = content.default;\nif(typeof content === 'string') content = [[module.i, content, '']];\nif(content.locals) module.exports = content.locals;\n// add the styles to the DOM\nvar add = __webpack_require__(/*! ../../../node_modules/vue-style-loader/lib/addStylesClient.js */ \"./node_modules/vue-style-loader/lib/addStylesClient.js\").default\nvar update = add(\"70648f16\", content, false, {\"sourceMap\":false,\"shadowMode\":false});\n// Hot Module Replacement\nif(false) {}\n\n//# sourceURL=webpack:///./src/assets/styles/spinner.css?");

/***/ }),

/***/ "./src/components/main/Breadcrumb.vue":
/*!********************************************!*\
  !*** ./src/components/main/Breadcrumb.vue ***!
  \********************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _Breadcrumb_vue_vue_type_template_id_11f3f7d9_scoped_true___WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./Breadcrumb.vue?vue&type=template&id=11f3f7d9&scoped=true& */ \"./src/components/main/Breadcrumb.vue?vue&type=template&id=11f3f7d9&scoped=true&\");\n/* harmony import */ var _Breadcrumb_vue_vue_type_script_lang_js___WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./Breadcrumb.vue?vue&type=script&lang=js& */ \"./src/components/main/Breadcrumb.vue?vue&type=script&lang=js&\");\n/* empty/unused harmony star reexport *//* harmony import */ var _Breadcrumb_vue_vue_type_style_index_0_id_11f3f7d9_lang_css_scoped_true___WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./Breadcrumb.vue?vue&type=style&index=0&id=11f3f7d9&lang=css&scoped=true& */ \"./src/components/main/Breadcrumb.vue?vue&type=style&index=0&id=11f3f7d9&lang=css&scoped=true&\");\n/* harmony import */ var _node_modules_vue_loader_lib_runtime_componentNormalizer_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../../../node_modules/vue-loader/lib/runtime/componentNormalizer.js */ \"./node_modules/vue-loader/lib/runtime/componentNormalizer.js\");\n\n\n\n\n\n\n/* normalize component */\n\nvar component = Object(_node_modules_vue_loader_lib_runtime_componentNormalizer_js__WEBPACK_IMPORTED_MODULE_3__[\"default\"])(\n  _Breadcrumb_vue_vue_type_script_lang_js___WEBPACK_IMPORTED_MODULE_1__[\"default\"],\n  _Breadcrumb_vue_vue_type_template_id_11f3f7d9_scoped_true___WEBPACK_IMPORTED_MODULE_0__[\"render\"],\n  _Breadcrumb_vue_vue_type_template_id_11f3f7d9_scoped_true___WEBPACK_IMPORTED_MODULE_0__[\"staticRenderFns\"],\n  false,\n  null,\n  \"11f3f7d9\",\n  null\n  \n)\n\n/* hot reload */\nif (false) { var api; }\ncomponent.options.__file = \"src/components/main/Breadcrumb.vue\"\n/* harmony default export */ __webpack_exports__[\"default\"] = (component.exports);\n\n//# sourceURL=webpack:///./src/components/main/Breadcrumb.vue?");

/***/ }),

/***/ "./src/components/main/Breadcrumb.vue?vue&type=script&lang=js&":
/*!*********************************************************************!*\
  !*** ./src/components/main/Breadcrumb.vue?vue&type=script&lang=js& ***!
  \*********************************************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_ref_12_0_node_modules_babel_loader_lib_index_js_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_Breadcrumb_vue_vue_type_script_lang_js___WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! -!../../../node_modules/cache-loader/dist/cjs.js??ref--12-0!../../../node_modules/babel-loader/lib!../../../node_modules/cache-loader/dist/cjs.js??ref--0-0!../../../node_modules/vue-loader/lib??vue-loader-options!./Breadcrumb.vue?vue&type=script&lang=js& */ \"./node_modules/cache-loader/dist/cjs.js?!./node_modules/babel-loader/lib/index.js!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/main/Breadcrumb.vue?vue&type=script&lang=js&\");\n/* empty/unused harmony star reexport */ /* harmony default export */ __webpack_exports__[\"default\"] = (_node_modules_cache_loader_dist_cjs_js_ref_12_0_node_modules_babel_loader_lib_index_js_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_Breadcrumb_vue_vue_type_script_lang_js___WEBPACK_IMPORTED_MODULE_0__[\"default\"]); \n\n//# sourceURL=webpack:///./src/components/main/Breadcrumb.vue?");

/***/ }),

/***/ "./src/components/main/Breadcrumb.vue?vue&type=style&index=0&id=11f3f7d9&lang=css&scoped=true&":
/*!*****************************************************************************************************!*\
  !*** ./src/components/main/Breadcrumb.vue?vue&type=style&index=0&id=11f3f7d9&lang=css&scoped=true& ***!
  \*****************************************************************************************************/
/*! no static exports found */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _node_modules_vue_style_loader_index_js_ref_6_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_6_oneOf_1_1_node_modules_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_6_oneOf_1_2_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_Breadcrumb_vue_vue_type_style_index_0_id_11f3f7d9_lang_css_scoped_true___WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! -!../../../node_modules/vue-style-loader??ref--6-oneOf-1-0!../../../node_modules/css-loader/dist/cjs.js??ref--6-oneOf-1-1!../../../node_modules/vue-loader/lib/loaders/stylePostLoader.js!../../../node_modules/postcss-loader/src??ref--6-oneOf-1-2!../../../node_modules/cache-loader/dist/cjs.js??ref--0-0!../../../node_modules/vue-loader/lib??vue-loader-options!./Breadcrumb.vue?vue&type=style&index=0&id=11f3f7d9&lang=css&scoped=true& */ \"./node_modules/vue-style-loader/index.js?!./node_modules/css-loader/dist/cjs.js?!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src/index.js?!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/main/Breadcrumb.vue?vue&type=style&index=0&id=11f3f7d9&lang=css&scoped=true&\");\n/* harmony import */ var _node_modules_vue_style_loader_index_js_ref_6_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_6_oneOf_1_1_node_modules_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_6_oneOf_1_2_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_Breadcrumb_vue_vue_type_style_index_0_id_11f3f7d9_lang_css_scoped_true___WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_node_modules_vue_style_loader_index_js_ref_6_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_6_oneOf_1_1_node_modules_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_6_oneOf_1_2_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_Breadcrumb_vue_vue_type_style_index_0_id_11f3f7d9_lang_css_scoped_true___WEBPACK_IMPORTED_MODULE_0__);\n/* harmony reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in _node_modules_vue_style_loader_index_js_ref_6_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_6_oneOf_1_1_node_modules_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_6_oneOf_1_2_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_Breadcrumb_vue_vue_type_style_index_0_id_11f3f7d9_lang_css_scoped_true___WEBPACK_IMPORTED_MODULE_0__) if([\"default\"].indexOf(__WEBPACK_IMPORT_KEY__) < 0) (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return _node_modules_vue_style_loader_index_js_ref_6_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_6_oneOf_1_1_node_modules_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_6_oneOf_1_2_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_Breadcrumb_vue_vue_type_style_index_0_id_11f3f7d9_lang_css_scoped_true___WEBPACK_IMPORTED_MODULE_0__[key]; }) }(__WEBPACK_IMPORT_KEY__));\n\n\n//# sourceURL=webpack:///./src/components/main/Breadcrumb.vue?");

/***/ }),

/***/ "./src/components/main/Breadcrumb.vue?vue&type=template&id=11f3f7d9&scoped=true&":
/*!***************************************************************************************!*\
  !*** ./src/components/main/Breadcrumb.vue?vue&type=template&id=11f3f7d9&scoped=true& ***!
  \***************************************************************************************/
/*! exports provided: render, staticRenderFns */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_cacheDirectory_node_modules_cache_vue_loader_cacheIdentifier_60671cf1_vue_loader_template_node_modules_vue_loader_lib_loaders_templateLoader_js_vue_loader_options_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_Breadcrumb_vue_vue_type_template_id_11f3f7d9_scoped_true___WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! -!../../../node_modules/cache-loader/dist/cjs.js?{\"cacheDirectory\":\"node_modules/.cache/vue-loader\",\"cacheIdentifier\":\"60671cf1-vue-loader-template\"}!../../../node_modules/vue-loader/lib/loaders/templateLoader.js??vue-loader-options!../../../node_modules/cache-loader/dist/cjs.js??ref--0-0!../../../node_modules/vue-loader/lib??vue-loader-options!./Breadcrumb.vue?vue&type=template&id=11f3f7d9&scoped=true& */ \"./node_modules/cache-loader/dist/cjs.js?{\\\"cacheDirectory\\\":\\\"node_modules/.cache/vue-loader\\\",\\\"cacheIdentifier\\\":\\\"60671cf1-vue-loader-template\\\"}!./node_modules/vue-loader/lib/loaders/templateLoader.js?!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/main/Breadcrumb.vue?vue&type=template&id=11f3f7d9&scoped=true&\");\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"render\", function() { return _node_modules_cache_loader_dist_cjs_js_cacheDirectory_node_modules_cache_vue_loader_cacheIdentifier_60671cf1_vue_loader_template_node_modules_vue_loader_lib_loaders_templateLoader_js_vue_loader_options_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_Breadcrumb_vue_vue_type_template_id_11f3f7d9_scoped_true___WEBPACK_IMPORTED_MODULE_0__[\"render\"]; });\n\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"staticRenderFns\", function() { return _node_modules_cache_loader_dist_cjs_js_cacheDirectory_node_modules_cache_vue_loader_cacheIdentifier_60671cf1_vue_loader_template_node_modules_vue_loader_lib_loaders_templateLoader_js_vue_loader_options_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_Breadcrumb_vue_vue_type_template_id_11f3f7d9_scoped_true___WEBPACK_IMPORTED_MODULE_0__[\"staticRenderFns\"]; });\n\n\n\n//# sourceURL=webpack:///./src/components/main/Breadcrumb.vue?");

/***/ }),

/***/ "./src/components/main/Nav.vue":
/*!*************************************!*\
  !*** ./src/components/main/Nav.vue ***!
  \*************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _Nav_vue_vue_type_template_id_d8fd8586___WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./Nav.vue?vue&type=template&id=d8fd8586& */ \"./src/components/main/Nav.vue?vue&type=template&id=d8fd8586&\");\n/* harmony import */ var _node_modules_vue_loader_lib_runtime_componentNormalizer_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../../../node_modules/vue-loader/lib/runtime/componentNormalizer.js */ \"./node_modules/vue-loader/lib/runtime/componentNormalizer.js\");\n\nvar script = {}\n\n\n/* normalize component */\n\nvar component = Object(_node_modules_vue_loader_lib_runtime_componentNormalizer_js__WEBPACK_IMPORTED_MODULE_1__[\"default\"])(\n  script,\n  _Nav_vue_vue_type_template_id_d8fd8586___WEBPACK_IMPORTED_MODULE_0__[\"render\"],\n  _Nav_vue_vue_type_template_id_d8fd8586___WEBPACK_IMPORTED_MODULE_0__[\"staticRenderFns\"],\n  false,\n  null,\n  null,\n  null\n  \n)\n\n/* hot reload */\nif (false) { var api; }\ncomponent.options.__file = \"src/components/main/Nav.vue\"\n/* harmony default export */ __webpack_exports__[\"default\"] = (component.exports);\n\n//# sourceURL=webpack:///./src/components/main/Nav.vue?");

/***/ }),

/***/ "./src/components/main/Nav.vue?vue&type=template&id=d8fd8586&":
/*!********************************************************************!*\
  !*** ./src/components/main/Nav.vue?vue&type=template&id=d8fd8586& ***!
  \********************************************************************/
/*! exports provided: render, staticRenderFns */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_cacheDirectory_node_modules_cache_vue_loader_cacheIdentifier_60671cf1_vue_loader_template_node_modules_vue_loader_lib_loaders_templateLoader_js_vue_loader_options_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_Nav_vue_vue_type_template_id_d8fd8586___WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! -!../../../node_modules/cache-loader/dist/cjs.js?{\"cacheDirectory\":\"node_modules/.cache/vue-loader\",\"cacheIdentifier\":\"60671cf1-vue-loader-template\"}!../../../node_modules/vue-loader/lib/loaders/templateLoader.js??vue-loader-options!../../../node_modules/cache-loader/dist/cjs.js??ref--0-0!../../../node_modules/vue-loader/lib??vue-loader-options!./Nav.vue?vue&type=template&id=d8fd8586& */ \"./node_modules/cache-loader/dist/cjs.js?{\\\"cacheDirectory\\\":\\\"node_modules/.cache/vue-loader\\\",\\\"cacheIdentifier\\\":\\\"60671cf1-vue-loader-template\\\"}!./node_modules/vue-loader/lib/loaders/templateLoader.js?!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/main/Nav.vue?vue&type=template&id=d8fd8586&\");\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"render\", function() { return _node_modules_cache_loader_dist_cjs_js_cacheDirectory_node_modules_cache_vue_loader_cacheIdentifier_60671cf1_vue_loader_template_node_modules_vue_loader_lib_loaders_templateLoader_js_vue_loader_options_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_Nav_vue_vue_type_template_id_d8fd8586___WEBPACK_IMPORTED_MODULE_0__[\"render\"]; });\n\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"staticRenderFns\", function() { return _node_modules_cache_loader_dist_cjs_js_cacheDirectory_node_modules_cache_vue_loader_cacheIdentifier_60671cf1_vue_loader_template_node_modules_vue_loader_lib_loaders_templateLoader_js_vue_loader_options_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_Nav_vue_vue_type_template_id_d8fd8586___WEBPACK_IMPORTED_MODULE_0__[\"staticRenderFns\"]; });\n\n\n\n//# sourceURL=webpack:///./src/components/main/Nav.vue?");

/***/ }),

/***/ "./src/main.js":
/*!*********************!*\
  !*** ./src/main.js ***!
  \*********************/
/*! no exports provided */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var vue__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! vue */ \"./node_modules/vue/dist/vue.runtime.esm.js\");\n/* harmony import */ var _App_vue__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./App.vue */ \"./src/App.vue\");\n/* harmony import */ var _router__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./router */ \"./src/router/index.js\");\n/* harmony import */ var _store__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./store */ \"./src/store/index.js\");\n/* harmony import */ var vue_ls__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! vue-ls */ \"./node_modules/vue-ls/dist/vue-ls.js\");\n/* harmony import */ var vue_ls__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(vue_ls__WEBPACK_IMPORTED_MODULE_4__);\n/* harmony import */ var vue_notification__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! vue-notification */ \"./node_modules/vue-notification/dist/index.js\");\n/* harmony import */ var vue_notification__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(vue_notification__WEBPACK_IMPORTED_MODULE_5__);\n/* harmony import */ var _plugins_helper_index__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./plugins/helper/index */ \"./src/plugins/helper/index.js\");\n/* harmony import */ var _assets_styles_font_css__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @/assets/styles/font.css */ \"./src/assets/styles/font.css\");\n/* harmony import */ var _assets_styles_font_css__WEBPACK_IMPORTED_MODULE_7___default = /*#__PURE__*/__webpack_require__.n(_assets_styles_font_css__WEBPACK_IMPORTED_MODULE_7__);\n/* harmony import */ var _assets_styles_notifications_scss__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @/assets/styles/notifications.scss */ \"./src/assets/styles/notifications.scss\");\n/* harmony import */ var _assets_styles_notifications_scss__WEBPACK_IMPORTED_MODULE_8___default = /*#__PURE__*/__webpack_require__.n(_assets_styles_notifications_scss__WEBPACK_IMPORTED_MODULE_8__);\n/* harmony import */ var _assets_styles_dark_scss__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @/assets/styles/dark.scss */ \"./src/assets/styles/dark.scss\");\n/* harmony import */ var _assets_styles_dark_scss__WEBPACK_IMPORTED_MODULE_9___default = /*#__PURE__*/__webpack_require__.n(_assets_styles_dark_scss__WEBPACK_IMPORTED_MODULE_9__);\n/* harmony import */ var _mdi_font_scss_materialdesignicons_scss__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @mdi/font/scss/materialdesignicons.scss */ \"./node_modules/@mdi/font/scss/materialdesignicons.scss\");\n/* harmony import */ var _mdi_font_scss_materialdesignicons_scss__WEBPACK_IMPORTED_MODULE_10___default = /*#__PURE__*/__webpack_require__.n(_mdi_font_scss_materialdesignicons_scss__WEBPACK_IMPORTED_MODULE_10__);\n/* harmony import */ var _assets_styles_effects_css__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! @/assets/styles/effects.css */ \"./src/assets/styles/effects.css\");\n/* harmony import */ var _assets_styles_effects_css__WEBPACK_IMPORTED_MODULE_11___default = /*#__PURE__*/__webpack_require__.n(_assets_styles_effects_css__WEBPACK_IMPORTED_MODULE_11__);\n/* harmony import */ var _assets_styles_base_scss__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! @/assets/styles/base.scss */ \"./src/assets/styles/base.scss\");\n/* harmony import */ var _assets_styles_base_scss__WEBPACK_IMPORTED_MODULE_12___default = /*#__PURE__*/__webpack_require__.n(_assets_styles_base_scss__WEBPACK_IMPORTED_MODULE_12__);\n/* harmony import */ var _assets_styles_spinner_css__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! @/assets/styles/spinner.css */ \"./src/assets/styles/spinner.css\");\n/* harmony import */ var _assets_styles_spinner_css__WEBPACK_IMPORTED_MODULE_13___default = /*#__PURE__*/__webpack_require__.n(_assets_styles_spinner_css__WEBPACK_IMPORTED_MODULE_13__);\n/* harmony import */ var bulma_tooltip_dist_css_bulma_tooltip_min_css__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! bulma-tooltip/dist/css/bulma-tooltip.min.css */ \"./node_modules/bulma-tooltip/dist/css/bulma-tooltip.min.css\");\n/* harmony import */ var bulma_tooltip_dist_css_bulma_tooltip_min_css__WEBPACK_IMPORTED_MODULE_14___default = /*#__PURE__*/__webpack_require__.n(bulma_tooltip_dist_css_bulma_tooltip_min_css__WEBPACK_IMPORTED_MODULE_14__);\n/* harmony import */ var bulma_calendar_dist_css_bulma_calendar_min_css__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! bulma-calendar/dist/css/bulma-calendar.min.css */ \"./node_modules/bulma-calendar/dist/css/bulma-calendar.min.css\");\n/* harmony import */ var bulma_calendar_dist_css_bulma_calendar_min_css__WEBPACK_IMPORTED_MODULE_15___default = /*#__PURE__*/__webpack_require__.n(bulma_calendar_dist_css_bulma_calendar_min_css__WEBPACK_IMPORTED_MODULE_15__);\n/* harmony import */ var _assets_styles_notificationbar_css__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! @/assets/styles/notificationbar.css */ \"./src/assets/styles/notificationbar.css\");\n/* harmony import */ var _assets_styles_notificationbar_css__WEBPACK_IMPORTED_MODULE_16___default = /*#__PURE__*/__webpack_require__.n(_assets_styles_notificationbar_css__WEBPACK_IMPORTED_MODULE_16__);\n/* harmony import */ var bulma_o_steps_bulma_steps_min_css__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! bulma-o-steps/bulma-steps.min.css */ \"./node_modules/bulma-o-steps/bulma-steps.min.css\");\n/* harmony import */ var bulma_o_steps_bulma_steps_min_css__WEBPACK_IMPORTED_MODULE_17___default = /*#__PURE__*/__webpack_require__.n(bulma_o_steps_bulma_steps_min_css__WEBPACK_IMPORTED_MODULE_17__);\n/* harmony import */ var _utils_app__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(/*! @/utils/app */ \"./src/utils/app.js\");\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nvue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].use(vue_ls__WEBPACK_IMPORTED_MODULE_4___default.a);\nvue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].use(vue_notification__WEBPACK_IMPORTED_MODULE_5___default.a);\nvue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].use(_plugins_helper_index__WEBPACK_IMPORTED_MODULE_6__[\"default\"]);\nvue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].config.productionTip = false;\nnew vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"]({\n  router: _router__WEBPACK_IMPORTED_MODULE_2__[\"default\"],\n  store: _store__WEBPACK_IMPORTED_MODULE_3__[\"default\"],\n  render: h => h(_App_vue__WEBPACK_IMPORTED_MODULE_1__[\"default\"]),\n  created() {\n    Object(_utils_app__WEBPACK_IMPORTED_MODULE_18__[\"init\"])();\n  }\n}).$mount(\"#app\");\n\n//# sourceURL=webpack:///./src/main.js?");

/***/ }),

/***/ "./src/plugins/helper/app.js":
/*!***********************************!*\
  !*** ./src/plugins/helper/app.js ***!
  \***********************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _utils_http__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @/utils/http */ \"./src/utils/http.js\");\n\n/* harmony default export */ __webpack_exports__[\"default\"] = (function (Vue) {\n  return {\n    postApi: _utils_http__WEBPACK_IMPORTED_MODULE_0__[\"postApi\"],\n    async clearForm(form, newVal) {\n      for (const input of form.inputs) {\n        input.value = newVal;\n      }\n    },\n    notify(title, text, type, duration, speed) {\n      Vue.notify({\n        group: \"all\",\n        title: title || \"\",\n        text: text || \"\",\n        duration: duration || 4000,\n        speed: speed || 200,\n        type: type || \"success\"\n      });\n    },\n    wait(s) {\n      return new Promise(resolve => {\n        setTimeout(() => {\n          resolve();\n        }, s * 1000);\n      });\n    },\n    getProp(obj, propStr) {\n      if (obj && propStr) {\n        const arr = propStr.split(\".\");\n        while (arr.length && (obj = obj[arr.shift()]));\n        return obj;\n      }\n      return null;\n    },\n    filter(items, filter) {\n      items = items.filter(item => {\n        return this.doesObjMatch(item, filter);\n      });\n      return items;\n    },\n    checkFilter(item, filter, prop) {\n      if (filter[prop][0] == \"!\") {\n        return this.checkNotStrFilter(item, filter, prop);\n      } else {\n        return item[prop] === filter[prop] ? true : false;\n      }\n    },\n    checkNotStrFilter(item, filter, prop) {\n      filter[prop] = filter[prop].replace(\"!\", \"\");\n      return item[prop] !== filter[prop] ? true : false;\n    },\n    doesObjMatch(item, filter) {\n      item = Object.assign({}, item);\n      for (const prop in filter) {\n        if (!item[prop] && !filter[prop]) {\n          return true;\n        } else if (!item[prop] && filter[prop]) {\n          return false;\n        }\n\n        //console.log(item[prop]);\n\n        if (typeof item[prop] !== \"string\" && Object.getOwnPropertyNames(item[prop]).length != 0) {\n          return this.doesObjMatch(item[prop], filter[prop]);\n        } else {\n          // console.log(filter[prop]);\n          // console.log(item[prop]);\n\n          if (typeof item[prop] === \"string\") {\n            item[prop] = item[prop].toLowerCase();\n          }\n          if (typeof filter[prop] === \"string\") {\n            filter[prop] = filter[prop].toLowerCase();\n          }\n          if (typeof filter[prop] === \"string\" && filter[prop].includes(\"|\")) {\n            if (filter[prop].split(\"|\").indexOf(item[prop]) !== -1) {\n              return true;\n            }\n            return false;\n          } else {\n            return this.checkFilter(item, filter, prop);\n          }\n        }\n      }\n    }\n  };\n});\n\n//# sourceURL=webpack:///./src/plugins/helper/app.js?");

/***/ }),

/***/ "./src/plugins/helper/index.js":
/*!*************************************!*\
  !*** ./src/plugins/helper/index.js ***!
  \*************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _app_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./app.js */ \"./src/plugins/helper/app.js\");\n\n/* harmony default export */ __webpack_exports__[\"default\"] = (Vue => {\n  Object.defineProperties(Vue.prototype, {\n    $helpers: {\n      get() {\n        return Object(_app_js__WEBPACK_IMPORTED_MODULE_0__[\"default\"])(Vue);\n      }\n    }\n  });\n});\n\n//# sourceURL=webpack:///./src/plugins/helper/index.js?");

/***/ }),

/***/ "./src/router/index.js":
/*!*****************************!*\
  !*** ./src/router/index.js ***!
  \*****************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var vue__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! vue */ \"./node_modules/vue/dist/vue.runtime.esm.js\");\n/* harmony import */ var vue_router__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! vue-router */ \"./node_modules/vue-router/dist/vue-router.esm.js\");\n/* harmony import */ var _utils_socket__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @/utils/socket */ \"./src/utils/socket.js\");\n/* harmony import */ var _utils_auth__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @/utils/auth */ \"./src/utils/auth.js\");\n/* harmony import */ var _store__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @/store */ \"./src/store/index.js\");\n\n\n\n\n\nvue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].use(vue_router__WEBPACK_IMPORTED_MODULE_1__[\"default\"]);\nconst routes = [{\n  path: \"/signin\",\n  name: \"Login\",\n  component: () => __webpack_require__.e(/*! import() */ 45).then(__webpack_require__.bind(null, /*! ../views/Start */ \"./src/views/Start.vue\"))\n}, {\n  path: \"/signout\",\n  component: () => __webpack_require__.e(/*! import() */ 113).then(__webpack_require__.bind(null, /*! ../views/Signout */ \"./src/views/Signout.vue\"))\n}, {\n  path: \"/domains\",\n  name: \"DomainsRepos\",\n  component: () => __webpack_require__.e(/*! import() */ 110).then(__webpack_require__.bind(null, /*! ../views/DomainsRepos */ \"./src/views/DomainsRepos.vue\"))\n}, {\n  path: \"/domains/:domainUID\",\n  name: \"ComputersGroups\",\n  component: () => __webpack_require__.e(/*! import() */ 69).then(__webpack_require__.bind(null, /*! ../views/ComputersGroups */ \"./src/views/ComputersGroups.vue\"))\n}, {\n  path: \"/domains/:domainUID/computers/:computerUID/packages\",\n  name: \"ComputerPackages\",\n  component: () => __webpack_require__.e(/*! import() */ 109).then(__webpack_require__.bind(null, /*! ../views/ComputerPackages */ \"./src/views/ComputerPackages.vue\"))\n}, {\n  path: \"/domains/:domainUID/groups/:groupUID/packages\",\n  name: \"GroupPackages\",\n  component: () => Promise.all(/*! import() */[__webpack_require__.e(3), __webpack_require__.e(23), __webpack_require__.e(44)]).then(__webpack_require__.bind(null, /*! ../views/GroupPackages */ \"./src/views/GroupPackages.vue\"))\n}, {\n  path: \"/domains/:domainUID/shares\",\n  name: \"DomainShares\",\n  component: () => __webpack_require__.e(/*! import() */ 79).then(__webpack_require__.bind(null, /*! ../views/DomainShares */ \"./src/views/DomainShares.vue\"))\n}, {\n  path: \"/repos/:repoUID\",\n  name: \"Repos\",\n  component: () => Promise.all(/*! import() */[__webpack_require__.e(3), __webpack_require__.e(48)]).then(__webpack_require__.bind(null, /*! ../views/Repo */ \"./src/views/Repo.vue\"))\n}, {\n  path: \"/domains/:domainUID/computers/:computerUID/applications\",\n  name: \"ComputerApplications\",\n  component: () => Promise.all(/*! import() */[__webpack_require__.e(3), __webpack_require__.e(49)]).then(__webpack_require__.bind(null, /*! ../views/ComputerApplications */ \"./src/views/ComputerApplications.vue\"))\n}, {\n  path: \"/domains/:domainUID/applications\",\n  name: \"ComputersApplications\",\n  component: () => Promise.all(/*! import() */[__webpack_require__.e(3), __webpack_require__.e(46)]).then(__webpack_require__.bind(null, /*! ../views/ComputersApplications.vue */ \"./src/views/ComputersApplications.vue\"))\n}, {\n  path: \"/profile\",\n  name: \"Profile\",\n  component: () => __webpack_require__.e(/*! import() */ 111).then(__webpack_require__.bind(null, /*! ../views/Profile.vue */ \"./src/views/Profile.vue\"))\n}, {\n  path: \"/resetpassword/:challange\",\n  name: \"ResetPassword\",\n  component: () => Promise.all(/*! import() */[__webpack_require__.e(0), __webpack_require__.e(1), __webpack_require__.e(9), __webpack_require__.e(47)]).then(__webpack_require__.bind(null, /*! ../views/ResetPassword.vue */ \"./src/views/ResetPassword.vue\"))\n}, {\n  path: \"/settings\",\n  name: \"Settings\",\n  component: () => __webpack_require__.e(/*! import() */ 112).then(__webpack_require__.bind(null, /*! ../views/Settings.vue */ \"./src/views/Settings.vue\"))\n}, {\n  path: \"/unavailable\",\n  name: \"Unavailable\",\n  component: () => __webpack_require__.e(/*! import() */ 114).then(__webpack_require__.bind(null, /*! ../views/Unavailable.vue */ \"./src/views/Unavailable.vue\"))\n}, {\n  path: \"/api-documentation\",\n  name: \"API-Documentation\",\n  component: () => __webpack_require__.e(/*! import() */ 63).then(__webpack_require__.bind(null, /*! ../views/ApiDocumentation.vue */ \"./src/views/ApiDocumentation.vue\"))\n}];\nconst router = new vue_router__WEBPACK_IMPORTED_MODULE_1__[\"default\"]({\n  mode: \"history\",\n  base: \"/\",\n  linkActiveClass: \"is-active\",\n  linkExactActiveClass: \"is-active\",\n  routes\n});\nrouter.afterEach(to => {\n  if (!_store__WEBPACK_IMPORTED_MODULE_4__[\"default\"].state.auth.success && !to.path.includes(\"/resetpassword\") && to.path !== \"/signin\" && to.path !== \"/unavailable\") {\n    Object(_utils_auth__WEBPACK_IMPORTED_MODULE_3__[\"reroute\"])();\n    return;\n  }\n  Object(_utils_socket__WEBPACK_IMPORTED_MODULE_2__[\"connect\"])();\n});\n/* harmony default export */ __webpack_exports__[\"default\"] = (router);\n\n//# sourceURL=webpack:///./src/router/index.js?");

/***/ }),

/***/ "./src/store/auth.js":
/*!***************************!*\
  !*** ./src/store/auth.js ***!
  \***************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony default export */ __webpack_exports__[\"default\"] = ({\n  namespaced: true,\n  state: {\n    success: false,\n    user: {}\n  },\n  mutations: {\n    set(state, user) {\n      if (user && user.userUID) {\n        state.user = user;\n        state.success = true;\n      } else {\n        state.user = null;\n        state.success = false;\n      }\n    }\n  },\n  actions: {},\n  modules: {}\n});\n\n//# sourceURL=webpack:///./src/store/auth.js?");

/***/ }),

/***/ "./src/store/computer.js":
/*!*******************************!*\
  !*** ./src/store/computer.js ***!
  \*******************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _utils_http__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @/utils/http */ \"./src/utils/http.js\");\n/* harmony import */ var vue__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! vue */ \"./node_modules/vue/dist/vue.runtime.esm.js\");\n/* harmony import */ var _utils_order__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @/utils/order */ \"./src/utils/order.js\");\n\n\n\n\n/* harmony default export */ __webpack_exports__[\"default\"] = ({\n  namespaced: true,\n  state: {\n    computers: [],\n    groups: [],\n    domainUID: null\n  },\n  mutations: {\n    setDomainUID(state, {\n      domainUID\n    }) {\n      state.domainUID = domainUID;\n    },\n    mergeComputer(state, {\n      c,\n      obj\n    }) {\n      const index = state.computers.findIndex(x => x.uid === c.uid);\n      if (index !== -1) {\n        const item = state.computers[index];\n        vue__WEBPACK_IMPORTED_MODULE_1__[\"default\"].set(state.computers, index, {\n          ...item,\n          ...obj\n        });\n      } else if (obj) state.computers.unshift(obj);\n    },\n    editComputer(state, data) {\n      const {\n        c,\n        obj\n      } = data;\n      const index = state.computers.findIndex(x => x.uid === c.uid);\n      const item = state.computers[index];\n      vue__WEBPACK_IMPORTED_MODULE_1__[\"default\"].set(state.computers, index, {\n        ...item,\n        ...obj\n      });\n    },\n    replaceComputer(state, c) {\n      const index = state.computers.findIndex(x => x.uid === c.uid);\n      vue__WEBPACK_IMPORTED_MODULE_1__[\"default\"].set(state.computers, index, c);\n    },\n    addComputer(state, computer) {\n      state.computers.unshift(computer);\n    },\n    removeComputer(state, computerUID) {\n      const index = state.computers.findIndex(x => x.uid === computerUID);\n      if (index !== -1) vue__WEBPACK_IMPORTED_MODULE_1__[\"default\"].delete(state.computers, index);\n    },\n    set(state, data) {\n      if (data) {\n        state.computers = data.computers;\n        state.groups = data.groups;\n      }\n    },\n    setComputers(state, computers) {\n      state.computers = computers;\n    },\n    clear(state) {\n      state.groups = [];\n      state.computers = [];\n      state.domainUID = null;\n    }\n  },\n  actions: {\n    async fetch({\n      commit,\n      state,\n      dispatch,\n      rootState\n    }, {\n      domainUID,\n      force = false\n    }) {\n      if (force || domainUID !== state.domainUID) {\n        commit(\"setDomainUID\", {\n          domainUID\n        }); //state.domainUID = domainUID;\n\n        const res = await Object(_utils_http__WEBPACK_IMPORTED_MODULE_0__[\"postApi\"])(\"get/domainComputers\", {\n          domainUID: domainUID\n        });\n        if (res) {\n          var _res$, _rootState$settings$u, _res$2;\n          await dispatch(\"settings/getUserSetting\", {\n            path: \"computers\",\n            key: \"order\"\n          }, {\n            root: true\n          });\n          const items = {\n            computers: Object(_utils_order__WEBPACK_IMPORTED_MODULE_2__[\"_order\"])((_res$ = res[0]) === null || _res$ === void 0 ? void 0 : _res$.computers, (_rootState$settings$u = rootState.settings.user.computers) === null || _rootState$settings$u === void 0 ? void 0 : _rootState$settings$u.order),\n            groups: (_res$2 = res[0]) === null || _res$2 === void 0 ? void 0 : _res$2.groups\n          };\n          commit(\"set\", items);\n        }\n      }\n    },\n    async delete({\n      commit\n    }, {\n      computerUID,\n      domainUID\n    }) {\n      const res = await Object(_utils_http__WEBPACK_IMPORTED_MODULE_0__[\"postApi\"])(\"delete/computer\", {\n        domainUID: domainUID,\n        uid: computerUID\n      });\n      commit(\"removeComputer\", computerUID);\n    },\n    async fetchComputer({\n      commit\n    }, {\n      domainUID,\n      computerUID\n    }) {\n      const res = await Object(_utils_http__WEBPACK_IMPORTED_MODULE_0__[\"postApi\"])(\"get/domainComputer\", {\n        domainUID: domainUID,\n        computerUID: computerUID\n      });\n      if (res[0] && res[0][0]) commit(\"mergeComputer\", {\n        c: {\n          uid: res[0][0].uid\n        },\n        obj: res[0][0]\n      });\n    },\n    async mergeComputer({\n      commit\n    }, {\n      c,\n      obj\n    }) {\n      commit(\"mergeComputer\", {\n        c,\n        obj\n      });\n    },\n    async order({\n      dispatch,\n      commit,\n      state,\n      rootState\n    }, order) {\n      var _rootState$settings$u2;\n      const stateOrder = (_rootState$settings$u2 = rootState.settings.user.computers) === null || _rootState$settings$u2 === void 0 ? void 0 : _rootState$settings$u2.order;\n      order = Object(_utils_order__WEBPACK_IMPORTED_MODULE_2__[\"getReversed\"])(stateOrder, order);\n      dispatch(\"settings/setUser\", {\n        path: \"computers\",\n        key: \"order\",\n        value: order\n      }, {\n        root: true\n      });\n      commit(\"setComputers\", Object(_utils_order__WEBPACK_IMPORTED_MODULE_2__[\"_order\"])(state.computers, order));\n    }\n  },\n  getters: {\n    singleComputer: state => computerUID => {\n      return state.computers.find(x => x.uid === computerUID);\n    },\n    singleGroup: state => groupUID => {\n      return state.groups.find(x => x.uid === groupUID);\n    }\n  },\n  modules: {}\n});\n\n//# sourceURL=webpack:///./src/store/computer.js?");

/***/ }),

/***/ "./src/store/computerPackage.js":
/*!**************************************!*\
  !*** ./src/store/computerPackage.js ***!
  \**************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var vue__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! vue */ \"./node_modules/vue/dist/vue.runtime.esm.js\");\n/* harmony import */ var _utils_http__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @/utils/http */ \"./src/utils/http.js\");\n/* harmony import */ var _utils_mdc__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @/utils/mdc */ \"./src/utils/mdc.js\");\n/* harmony import */ var _utils_packages__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @/utils/packages */ \"./src/utils/packages.js\");\n/* harmony import */ var _utils_packageOrder__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @/utils/packageOrder */ \"./src/utils/packageOrder.js\");\n/* harmony import */ var _utils_order__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @/utils/order */ \"./src/utils/order.js\");\n\n\n\n\n\n\n\n/* harmony default export */ __webpack_exports__[\"default\"] = ({\n  namespaced: true,\n  state: {\n    mergedPackages: {},\n    mdcPackages: [],\n    chocoPackages: [],\n    fullyLoadedPackages: {},\n    computerUID: null\n  },\n  mutations: {\n    selectItem(state, p) {\n      for (const key of Object.keys(state.mergedPackages)) {\n        for (const x of state.mergedPackages[key]) {\n          if (x.selectedForAction) x.selectedForAction = false;\n        }\n      }\n      if (p) vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(p, \"selectedForAction\", true);\n    },\n    removeMergedPackage(state, p) {\n      const {\n        name,\n        uid\n      } = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"getPackageNameVersionAndHash\"])(p);\n      const index = state.mergedPackages[name + uid].findIndex(x => Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"isSamePackage\"])(x, p));\n      vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].delete(state.mergedPackages[name + uid], index);\n    },\n    mergeMergedPackage(state, p) {\n      const {\n        name,\n        uid\n      } = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"getPackageNameVersionAndHash\"])(p);\n      const packages = state.mergedPackages[name + uid];\n      if (packages) {\n        const index = packages.findIndex(x => Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"isSamePackage\"])(x, p));\n        if (index !== -1) {\n          const item = state.mergedPackages[name + uid][index];\n          vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(state.mergedPackages[name + uid], index, {\n            ...item,\n            ...p\n          });\n        } else state.mergedPackages[name + uid].unshift(p);\n      } else vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(state.mergedPackages, [name + uid], [p]);\n    },\n    mergeMdcPackage(state, p) {\n      const index = state.mdcPackages.findIndex(x => Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"isSamePackage\"])(x, p));\n      if (index !== -1) {\n        const item = state.mdcPackages[index];\n        vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(state.mdcPackages, index, {\n          ...item,\n          ...p\n        });\n      } else state.mdcPackages.unshift(p);\n    },\n    editMergedPackage(state, {\n      p,\n      obj\n    }) {\n      const {\n        name,\n        uid\n      } = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"getPackageNameVersionAndHash\"])(p);\n      const index = state.mergedPackages[name + uid].findIndex(x => Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"isSamePackage\"])(x, p));\n      const item = state.mergedPackages[name + uid][index];\n      if (item) vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(state.mergedPackages[name + uid], index, {\n        ...item,\n        ...obj\n      });\n    },\n    replaceMergedPackage(state, {\n      p,\n      obj\n    }) {\n      const {\n        name,\n        uid\n      } = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"getPackageNameVersionAndHash\"])(p);\n      const index = state.mergedPackages[name + uid].findIndex(x => Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"isSamePackage\"])(x, p));\n      vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(state.mergedPackages[name + uid], index, obj);\n    },\n    addMergedPackage(state, p) {\n      const {\n        name,\n        uid\n      } = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"getPackageNameVersionAndHash\"])(p);\n      if (!state.mergedPackages[name + uid]) {\n        state.mergedPackages[name + uid] = [];\n      }\n      state.mergedPackages[name + uid].unshift(p);\n    },\n    setMergedPackageVersions(state, ps) {\n      if (ps.length > 0) {\n        const {\n          name,\n          uid\n        } = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"getPackageNameVersionAndHash\"])(ps[0]);\n        vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(state.mergedPackages, [name + uid], ps);\n        vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(state.fullyLoadedPackages, [name + uid], true);\n      }\n    },\n    setMergedPackages(state, packages) {\n      state.mergedPackages = packages;\n    },\n    setChocoPackages(state, chocoPackages) {\n      state.chocoPackages = chocoPackages;\n    },\n    setMdcPackages(state, mdcPackages) {\n      state.mdcPackages = mdcPackages;\n    },\n    mergeMdcPackages(state, mdcPackages) {\n      state.mdcPackages = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"removeMdcDuplicates\"])([].concat.apply([], [state.mdcPackages, mdcPackages]));\n    },\n    clear(state) {\n      state.mergedPackages = {};\n      state.fullyLoadedPackages = {};\n      state.mdcPackages = [];\n      state.chocoPackages = [];\n      state.computerUID = null;\n    }\n  },\n  actions: {\n    async orderMergedPackages({\n      dispatch,\n      commit,\n      state,\n      rootState\n    }, order) {\n      var _rootState$settings$u;\n      const stateOrder = (_rootState$settings$u = rootState.settings.user.computerPackages) === null || _rootState$settings$u === void 0 ? void 0 : _rootState$settings$u.order;\n      order = Object(_utils_order__WEBPACK_IMPORTED_MODULE_5__[\"getReversed\"])(stateOrder, order);\n      dispatch(\"settings/setUser\", {\n        path: \"computerPackages\",\n        key: \"order\",\n        value: order\n      }, {\n        root: true\n      });\n      return Object(_utils_packageOrder__WEBPACK_IMPORTED_MODULE_4__[\"orderPackages\"])(state.mergedPackages, order).then(transformedPackages => commit(\"setMergedPackages\", transformedPackages));\n    },\n    async fetchMdcPackages({\n      commit,\n      state,\n      rootState\n    }, data) {\n      if (state.mdcPackages.length === 0 || data.force) {\n        const mdcRes = await Object(_utils_http__WEBPACK_IMPORTED_MODULE_1__[\"postApi\"])(\"get/latestComputerPackages\", {\n          domainUID: data.domainUID,\n          computerUIDs: data.computerUIDs\n        });\n        if (rootState.settings.user && rootState.settings.user.profile && rootState.settings.user.profile.infobar.workingStatus) {\n          const p = mdcRes[0].packages.find(x => x.command.status === \"working\");\n          commit(\"infobar/setPackage\", p, {\n            root: true\n          });\n        } else commit(\"infobar/setPackage\", null, {\n          root: true\n        });\n        commit(\"setMdcPackages\", mdcRes[0].packages);\n      }\n    },\n    async fetchAndMerge({\n      dispatch,\n      commit,\n      state,\n      rootState\n    }, data) {\n      await Promise.all([dispatch(\"fetchMdcPackages\", data), dispatch(\"source/fetch\", {\n        domainUID: data.domainUID\n      }, {\n        root: true\n      }), dispatch(\"settings/getUserSetting\", {\n        path: \"computerPackages\",\n        key: \"order\"\n      }, {\n        root: true\n      })]);\n      const filters = await Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"getChocoPackageFilter\"])(rootState.source.sources, state.mdcPackages);\n      const chocoRes = await Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"getChocoPackagesFromFilter\"])(filters);\n      const chocoPackages = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"stripPackages\"])(chocoRes);\n      const packages = await Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"mergePackages\"])(state.mdcPackages, chocoPackages, true);\n      return Object(_utils_packageOrder__WEBPACK_IMPORTED_MODULE_4__[\"orderPackages\"])(packages, rootState.settings.user.computerPackages.order).then(_utils_packages__WEBPACK_IMPORTED_MODULE_3__[\"transformPackages\"]).then(transformedPackages => commit(\"setMergedPackages\", transformedPackages));\n    },\n    async searchFetchAndMerge({\n      dispatch,\n      commit,\n      state,\n      rootState\n    }, data) {\n      await dispatch(\"fetchMdcPackages\", data);\n      const chocoRes = await Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"getChocoPackagesFromFilter\"])(data.filters, false);\n      const chocoPackages = await Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"correctMissingChocoPackages\"])(state.mdcPackages, chocoRes);\n      const packages = await Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"mergePackages\"])(chocoPackages, state.mdcPackages, true, true);\n      commit(\"setMergedPackages\", await Object(_utils_packages__WEBPACK_IMPORTED_MODULE_3__[\"transformPackages\"])(await Object(_utils_packageOrder__WEBPACK_IMPORTED_MODULE_4__[\"orderPackages\"])(packages, rootState.settings.user.computerPackages.order)));\n    }\n  },\n  getters: {\n    selectedItem: state => {\n      for (const key of Object.keys(state.mergedPackages)) {\n        const item = state.mergedPackages[key].find(x => x.selectedForAction);\n        if (item) return item;\n      }\n    },\n    mergedPackage: state => p => {\n      try {\n        const {\n          name,\n          uid\n        } = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"getPackageNameVersionAndHash\"])(p);\n        const packages = state.mergedPackages[name + uid];\n        if (packages) {\n          return packages.find(x => Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"isSamePackage\"])(x, p));\n        }\n        return null;\n      } catch (err) {\n        console.log(\"mergedPackage\", err);\n      }\n    },\n    packageGroup: state => ({\n      p,\n      filter\n    }) => {\n      const {\n        name,\n        uid\n      } = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"getPackageNameVersionAndHash\"])(p);\n      const packages = state.mergedPackages[name + uid];\n      if (packages) {\n        if (filter) return packages.filter(filter);else packages;\n      }\n      return [];\n    }\n  },\n  modules: {}\n});\n\n//# sourceURL=webpack:///./src/store/computerPackage.js?");

/***/ }),

/***/ "./src/store/domain.js":
/*!*****************************!*\
  !*** ./src/store/domain.js ***!
  \*****************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var vue__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! vue */ \"./node_modules/vue/dist/vue.runtime.esm.js\");\n/* harmony import */ var _utils_http__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @/utils/http */ \"./src/utils/http.js\");\n/* harmony import */ var _utils_order__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @/utils/order */ \"./src/utils/order.js\");\n\n\n\n/* harmony default export */ __webpack_exports__[\"default\"] = ({\n  namespaced: true,\n  state: {\n    domains: []\n  },\n  mutations: {\n    edit(state, {\n      d,\n      obj\n    }) {\n      const index = state.domains.findIndex(x => x.uid === d.uid);\n      if (index !== -1) {\n        const item = state.domains[index];\n        vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(state.domains, index, {\n          ...item,\n          ...obj\n        });\n      }\n    },\n    add(state, domain) {\n      state.domains.unshift(domain);\n    },\n    remove(state, d) {\n      const index = state.domains.findIndex(x => x.uid === d.uid);\n      if (index !== -1) vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].delete(state.domains, index);\n    },\n    set(state, domains) {\n      state.domains = domains;\n    },\n    clear(state) {\n      state.domains = [];\n    }\n  },\n  actions: {\n    async fetch({\n      dispatch,\n      rootState,\n      commit,\n      state\n    }, force) {\n      if (state.domains.length === 0 || force) {\n        const domains = await Object(_utils_http__WEBPACK_IMPORTED_MODULE_1__[\"postApi\"])(\"get/domains\");\n        if (domains) {\n          var _rootState$settings$u;\n          await dispatch(\"settings/getUserSetting\", {\n            path: \"domains\",\n            key: \"order\"\n          }, {\n            root: true\n          });\n          commit(\"set\", Object(_utils_order__WEBPACK_IMPORTED_MODULE_2__[\"_order\"])(domains, (_rootState$settings$u = rootState.settings.user.domains) === null || _rootState$settings$u === void 0 ? void 0 : _rootState$settings$u.order));\n        }\n      }\n    },\n    async add({\n      commit,\n      state\n    }, name) {\n      const res = await Object(_utils_http__WEBPACK_IMPORTED_MODULE_1__[\"postApi\"])(\"create/domain\", {\n        friendlyName: name,\n        domainDescription: \"\"\n      });\n      commit(\"add\", res[0]);\n    },\n    async delete({\n      commit,\n      state\n    }, domain) {\n      const res = await Object(_utils_http__WEBPACK_IMPORTED_MODULE_1__[\"postApi\"])(\"delete/domain\", {\n        uid: domain.uid\n      });\n      commit(\"remove\", domain);\n    },\n    async order({\n      dispatch,\n      commit,\n      state,\n      rootState\n    }, order) {\n      var _rootState$settings$u2;\n      const stateOrder = (_rootState$settings$u2 = rootState.settings.user.domains) === null || _rootState$settings$u2 === void 0 ? void 0 : _rootState$settings$u2.order;\n      order = Object(_utils_order__WEBPACK_IMPORTED_MODULE_2__[\"getReversed\"])(stateOrder, order);\n      dispatch(\"settings/setUser\", {\n        path: \"domains\",\n        key: \"order\",\n        value: order\n      }, {\n        root: true\n      });\n      commit(\"set\", Object(_utils_order__WEBPACK_IMPORTED_MODULE_2__[\"_order\"])(state.domains, order));\n    }\n  },\n  getters: {\n    single: state => domainUID => {\n      return state.domains.find(x => x.uid === domainUID);\n    }\n  },\n  modules: {}\n});\n\n//# sourceURL=webpack:///./src/store/domain.js?");

/***/ }),

/***/ "./src/store/group.js":
/*!****************************!*\
  !*** ./src/store/group.js ***!
  \****************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var vue__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! vue */ \"./node_modules/vue/dist/vue.runtime.esm.js\");\n/* harmony import */ var _utils_http__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @/utils/http */ \"./src/utils/http.js\");\n/* harmony import */ var _utils_order__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @/utils/order */ \"./src/utils/order.js\");\n\n\n\n/* harmony default export */ __webpack_exports__[\"default\"] = ({\n  namespaced: true,\n  state: {\n    groups: []\n  },\n  mutations: {\n    setComputers(state, {\n      g,\n      computers\n    }) {\n      const index = state.groups.findIndex(x => x.group.uid === g.uid);\n      if (index !== -1) {\n        const item = state.groups[index];\n        vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(state.groups[index], \"computers\", computers);\n      }\n    },\n    edit(state, {\n      g,\n      obj\n    }) {\n      const index = state.groups.findIndex(x => x.group.uid === g.uid);\n      if (index !== -1) {\n        const item = state.groups[index];\n        vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(state.groups[index], \"group\", {\n          ...item.group,\n          ...obj\n        });\n      }\n    },\n    add(state, group) {\n      state.groups.unshift(group);\n    },\n    remove(state, g) {\n      const index = state.groups.findIndex(x => x.group.uid === g.uid);\n      if (index !== -1) vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].delete(state.groups, index);\n    },\n    set(state, groups) {\n      state.groups = groups;\n    },\n    clear(state) {\n      state.groups = [];\n    }\n  },\n  actions: {\n    async fetch({\n      commit,\n      dispatch,\n      state,\n      rootState\n    }, data) {\n      if (state.groups.length === 0 || data.force) {\n        var _rootState$settings$u;\n        const groups = await Object(_utils_http__WEBPACK_IMPORTED_MODULE_1__[\"postApi\"])(\"get/domainGroups\", {\n          domainUID: data.domainUID\n        });\n        await dispatch(\"settings/getUserSetting\", {\n          path: \"groups\",\n          key: \"order\"\n        }, {\n          root: true\n        });\n        commit(\"set\", Object(_utils_order__WEBPACK_IMPORTED_MODULE_2__[\"_order\"])(groups, (_rootState$settings$u = rootState.settings.user.groups) === null || _rootState$settings$u === void 0 ? void 0 : _rootState$settings$u.order));\n      }\n    },\n    async fetchComputerGroups({\n      state\n    }, data) {\n      const result = await Object(_utils_http__WEBPACK_IMPORTED_MODULE_1__[\"postApi\"])(\"get/computerGroups\", {\n        domainUID: data.domainUID,\n        computerUID: data.computerUID\n      });\n      return result.filter(x => x);\n    },\n    async add({\n      commit,\n      state\n    }, data) {\n      const res = await Object(_utils_http__WEBPACK_IMPORTED_MODULE_1__[\"postApi\"])(\"create/computerGroup\", {\n        domainUID: data.domainUID,\n        computerUIDs: data.computerUIDs,\n        groupName: data.name,\n        groupCss: data.css || \"\"\n      });\n      commit(\"add\", res[0]);\n      return res[0];\n    },\n    async edit({\n      commit,\n      state\n    }, {\n      domainUID,\n      groupUID,\n      computerUIDs\n    }) {\n      const res = await Object(_utils_http__WEBPACK_IMPORTED_MODULE_1__[\"postApi\"])(\"set/computerGroup\", {\n        domainUID: domainUID,\n        groupUID: groupUID,\n        computerUIDs: computerUIDs\n      });\n      commit(\"setComputers\", {\n        g: res[0].group,\n        computers: res[0].computers\n      });\n    },\n    async order({\n      dispatch,\n      commit,\n      state,\n      rootState\n    }, order) {\n      var _rootState$settings$u2;\n      const stateOrder = (_rootState$settings$u2 = rootState.settings.user.groups) === null || _rootState$settings$u2 === void 0 ? void 0 : _rootState$settings$u2.order;\n      order = Object(_utils_order__WEBPACK_IMPORTED_MODULE_2__[\"getReversed\"])(stateOrder, order);\n      dispatch(\"settings/setUser\", {\n        path: \"groups\",\n        key: \"order\",\n        value: order\n      }, {\n        root: true\n      });\n      commit(\"set\", Object(_utils_order__WEBPACK_IMPORTED_MODULE_2__[\"_order\"])(state.groups, order));\n    }\n  },\n  getters: {\n    single: state => groupUID => {\n      return state.groups.find(x => x.group.uid === groupUID);\n    },\n    computerUIDs: state => groupUID => {\n      const group = state.groups.find(x => x.group.uid === groupUID);\n      if (group && group.computers) return group.computers.map(x => x.uid);else return [];\n    },\n    groups: state => computerUID => {\n      return state.groups.filter(group => group && group.computers.some(x => x && x.uid === computerUID));\n    }\n  },\n  modules: {}\n});\n\n//# sourceURL=webpack:///./src/store/group.js?");

/***/ }),

/***/ "./src/store/groupPackage.js":
/*!***********************************!*\
  !*** ./src/store/groupPackage.js ***!
  \***********************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var vue__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! vue */ \"./node_modules/vue/dist/vue.runtime.esm.js\");\n/* harmony import */ var _utils_http__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @/utils/http */ \"./src/utils/http.js\");\n/* harmony import */ var _utils_mdc__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @/utils/mdc */ \"./src/utils/mdc.js\");\n/* harmony import */ var _utils_groupPackage__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @/utils/groupPackage */ \"./src/utils/groupPackage.js\");\n/* harmony import */ var _utils_packages__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @/utils/packages */ \"./src/utils/packages.js\");\n/* harmony import */ var _utils_packageOrder__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @/utils/packageOrder */ \"./src/utils/packageOrder.js\");\n/* harmony import */ var _utils_order__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @/utils/order */ \"./src/utils/order.js\");\n\n\n\n\n\n\n\n\n/* harmony default export */ __webpack_exports__[\"default\"] = ({\n  namespaced: true,\n  state: {\n    computerPackages: {},\n    fullyLoadedPackages: {},\n    mergedPackages: {},\n    mdcPackages: [],\n    chocoPackages: [],\n    computerUID: null\n  },\n  mutations: {\n    selectItem(state, p) {\n      for (const key of Object.keys(state.mergedPackages)) {\n        for (const x of state.mergedPackages[key]) {\n          if (x.selectedForAction) x.selectedForAction = false;\n        }\n      }\n      if (p) vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(p, \"selectedForAction\", true);\n    },\n    removeMergedPackage(state, p) {\n      const {\n        name,\n        uid\n      } = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"getPackageNameVersionAndHash\"])(p);\n      const index = state.mergedPackages[name + uid].findIndex(x => Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"isSamePackage\"])(x, p));\n      vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].delete(state.mergedPackages[name + uid], index);\n    },\n    removeMdcPackage(state, p) {\n      const index = state.mdcPackages.findIndex(x => Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"isSamePackage\"])(x, p));\n      vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].delete(state.mdcPackages, index);\n    },\n    mergeMergedPackage(state, p) {\n      const {\n        name,\n        uid\n      } = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"getPackageNameVersionAndHash\"])(p);\n      const packages = state.mergedPackages[name + uid];\n      if (packages) {\n        const index = packages.findIndex(x => Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"isSamePackage\"])(x, p));\n        if (index !== -1) {\n          const item = state.mergedPackages[name + uid][index];\n          vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(state.mergedPackages[name + uid], index, {\n            ...item,\n            ...p\n          });\n        } else state.mergedPackages[name + uid].unshift(p);\n      } else vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(state.mergedPackages, [name + uid], [p]);\n    },\n    mergeMdcPackage(state, p) {\n      const index = state.mdcPackages.findIndex(x => Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"isSamePackage\"])(x, p));\n      if (index !== -1) {\n        const item = state.mdcPackages[index];\n        vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(state.mdcPackages, index, {\n          ...item,\n          ...p\n        });\n      } else state.mdcPackages.unshift(p);\n    },\n    editMergedPackage(state, {\n      p,\n      obj\n    }) {\n      const {\n        name,\n        uid\n      } = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"getPackageNameVersionAndHash\"])(p);\n      if (state.mergedPackages[name + uid]) {\n        const index = state.mergedPackages[name + uid].findIndex(x => Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"isSamePackage\"])(x, p));\n        const item = state.mergedPackages[name + uid][index];\n        if (item) {\n          vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(state.mergedPackages[name + uid], index, {\n            ...item,\n            ...obj\n          });\n        }\n      }\n    },\n    replaceMergedPackage(state, {\n      p,\n      obj\n    }) {\n      const {\n        name,\n        uid\n      } = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"getPackageNameVersionAndHash\"])(p);\n      const index = state.mergedPackages[name + uid].findIndex(x => Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"isSamePackage\"])(x, p));\n      vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(state.mergedPackages[name + uid], index, obj);\n    },\n    addMergedPackage(state, p) {\n      const {\n        name,\n        uid\n      } = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"getPackageNameVersionAndHash\"])(p);\n      if (!state.mergedPackages[name + uid]) {\n        state.mergedPackages[name + uid] = [];\n      }\n      state.mergedPackages[name + uid].unshift(p);\n    },\n    setMergedPackageVersions(state, ps) {\n      if (ps.length > 0) {\n        const {\n          name,\n          uid\n        } = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"getPackageNameVersionAndHash\"])(ps[0]);\n        vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(state.mergedPackages, [name + uid], ps);\n        vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(state.fullyLoadedPackages, [name + uid], true);\n      }\n    },\n    setMergedPackages(state, packages) {\n      state.mergedPackages = packages;\n    },\n    setChocoPackages(state, chocoPackages) {\n      state.chocoPackages = chocoPackages;\n    },\n    setMdcPackages(state, mdcPackages) {\n      state.mdcPackages = mdcPackages;\n    },\n    setComputerPackages(state, cps) {\n      if (cps.packages.length !== 0) {\n        const {\n          hash\n        } = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"getPackageNameVersionAndHash\"])(cps.packages[0]);\n        state.computerPackages[hash] = cps.packages;\n      }\n    },\n    mergeComputerPackage(state, p) {\n      const {\n        name,\n        version,\n        uid\n      } = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"getPackageNameVersionAndHash\"])(p);\n      const location = name + version + uid;\n      const packages = state.computerPackages[location];\n      if (packages) {\n        const index = packages.findIndex(x => Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"isSamePackage\"])(x, p) && x.computerUID === p.computerUID);\n        if (index !== -1) {\n          const item = state.computerPackages[location][index];\n          vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(state.computerPackages[location], index, {\n            ...item,\n            ...p\n          });\n        } else state.computerPackages[location].unshift(p);\n      } else vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(state.computerPackages, [location], [p]);\n    },\n    clear(state) {\n      state.computerPackages = {};\n      state.mergedPackages = {};\n      state.fullyLoadedPackages = {};\n      state.mdcPackages = [];\n      state.chocoPackages = [];\n      state.computerUID = null;\n    }\n  },\n  actions: {\n    async orderMergedPackages({\n      commit,\n      state,\n      dispatch,\n      rootState\n    }, order) {\n      var _rootState$settings$u;\n      const stateOrder = (_rootState$settings$u = rootState.settings.user.groupPackages) === null || _rootState$settings$u === void 0 ? void 0 : _rootState$settings$u.order;\n      order = Object(_utils_order__WEBPACK_IMPORTED_MODULE_6__[\"getReversed\"])(stateOrder, order);\n      dispatch(\"settings/setUser\", {\n        path: \"groupPackages\",\n        key: \"order\",\n        value: order\n      }, {\n        root: true\n      });\n      return Object(_utils_packageOrder__WEBPACK_IMPORTED_MODULE_5__[\"orderPackages\"])(state.mergedPackages, order).then(transformedPackages => commit(\"setMergedPackages\", transformedPackages));\n    },\n    async getDuplicateDomainPackages({\n      commit,\n      state\n    }, {\n      name,\n      domainUID\n    }) {\n      return await Object(_utils_http__WEBPACK_IMPORTED_MODULE_1__[\"postApi\"])(\"get/domainGroupPackages\", {\n        domainUID,\n        name\n      });\n    },\n    async fetchMdcPackages({\n      commit,\n      state\n    }, data) {\n      if (state.mdcPackages.length === 0 || data.force) {\n        const mdcRes = await Object(_utils_http__WEBPACK_IMPORTED_MODULE_1__[\"postApi\"])(\"get/latestGroupPackages\", {\n          domainUID: data.domainUID,\n          groupUID: data.groupUID\n        });\n        commit(\"setMdcPackages\", mdcRes[0]);\n      }\n    },\n    async getAccountGroupPackages({\n      state\n    }, {\n      domainUID\n    }) {\n      return await Object(_utils_http__WEBPACK_IMPORTED_MODULE_1__[\"postApi\"])(\"get/accountGroupPackages\", {\n        domainUID\n      });\n    },\n    async fetchAndMerge({\n      dispatch,\n      commit,\n      state,\n      rootState,\n      rootGetters\n    }, data) {\n      await dispatch(\"fetchMdcPackages\", data);\n      await dispatch(\"source/fetch\", {\n        domainUID: data.domainUID\n      }, {\n        root: true\n      });\n      const filters = await Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"getChocoPackageFilter\"])(rootState.source.sources, state.mdcPackages);\n      const chocoRes = await Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"getChocoPackagesFromFilter\"])(filters);\n      const chocoPackages = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"stripPackages\"])(chocoRes);\n      const packages = await Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"mergePackages\"])(state.mdcPackages, chocoPackages, true);\n      await dispatch(\"group/fetch\", {\n        domainUID: data.domainUID\n      }, {\n        root: true\n      });\n      const group = rootGetters[\"group/single\"](data.groupUID);\n      return Object(_utils_packageOrder__WEBPACK_IMPORTED_MODULE_5__[\"orderPackages\"])(packages, rootState.settings.user.groupPackages.order).then(_utils_packages__WEBPACK_IMPORTED_MODULE_4__[\"transformPackages\"]).then(transformedPackages => {\n        commit(\"setMergedPackages\", transformedPackages);\n        Object(_utils_groupPackage__WEBPACK_IMPORTED_MODULE_3__[\"fetchPackagesStats\"])(packages, group, data.domainUID, true, true);\n      });\n    },\n    async searchFetchAndMerge({\n      dispatch,\n      commit,\n      state,\n      rootGetters,\n      rootState\n    }, data) {\n      await dispatch(\"fetchMdcPackages\", data);\n      const chocoRes = await Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"getChocoPackagesFromFilter\"])(data.filters, false);\n      const chocoPackages = await Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"correctMissingChocoPackages\"])(state.mdcPackages, chocoRes);\n      const packages = await Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"mergePackages\"])(chocoPackages, state.mdcPackages, true, true);\n      commit(\"setMergedPackages\", await Object(_utils_packages__WEBPACK_IMPORTED_MODULE_4__[\"transformPackages\"])(await Object(_utils_packageOrder__WEBPACK_IMPORTED_MODULE_5__[\"orderPackages\"])(packages, rootState.settings.user.groupPackages.order)));\n      await dispatch(\"group/fetch\", {\n        domainUID: data.domainUID\n      }, {\n        root: true\n      });\n      const group = rootGetters[\"group/single\"](data.groupUID);\n      Object(_utils_groupPackage__WEBPACK_IMPORTED_MODULE_3__[\"fetchPackagesStats\"])(packages, group, data.domainUID, true);\n    }\n  },\n  getters: {\n    selectedItem: state => {\n      for (const key of Object.keys(state.mergedPackages)) {\n        const item = state.mergedPackages[key].find(x => x.selectedForAction);\n        if (item) return item;\n      }\n    },\n    packageGroup: state => ({\n      p,\n      filter\n    }) => {\n      const {\n        name,\n        uid\n      } = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"getPackageNameVersionAndHash\"])(p);\n      const packages = state.mergedPackages[name + uid];\n      if (packages) {\n        if (filter) return packages.filter(filter);else packages;\n      }\n      return [];\n    },\n    mergedPackage: state => p => {\n      try {\n        const {\n          name,\n          uid\n        } = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"getPackageNameVersionAndHash\"])(p);\n        const packages = state.mergedPackages[name + uid];\n        if (packages) {\n          return packages.find(x => Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"isSamePackage\"])(x, p));\n        }\n        return null;\n      } catch (err) {\n        console.log(\"mergedPackage\", err);\n      }\n    }\n  },\n  modules: {}\n});\n\n//# sourceURL=webpack:///./src/store/groupPackage.js?");

/***/ }),

/***/ "./src/store/index.js":
/*!****************************!*\
  !*** ./src/store/index.js ***!
  \****************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var vue__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! vue */ \"./node_modules/vue/dist/vue.runtime.esm.js\");\n/* harmony import */ var vuex__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! vuex */ \"./node_modules/vuex/dist/vuex.esm.js\");\n/* harmony import */ var _auth__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./auth */ \"./src/store/auth.js\");\n/* harmony import */ var _socket__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./socket */ \"./src/store/socket.js\");\n/* harmony import */ var _domain__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./domain */ \"./src/store/domain.js\");\n/* harmony import */ var _computer__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./computer */ \"./src/store/computer.js\");\n/* harmony import */ var _computerPackage__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./computerPackage */ \"./src/store/computerPackage.js\");\n/* harmony import */ var _groupPackage__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./groupPackage */ \"./src/store/groupPackage.js\");\n/* harmony import */ var _group__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./group */ \"./src/store/group.js\");\n/* harmony import */ var _source__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./source */ \"./src/store/source.js\");\n/* harmony import */ var _powershell__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./powershell */ \"./src/store/powershell.js\");\n/* harmony import */ var _infobar__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! ./infobar */ \"./src/store/infobar.js\");\n/* harmony import */ var _settings__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! ./settings */ \"./src/store/settings.js\");\n\n\n\n\n\n\n\n\n\n\n\n\n\nvue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].use(vuex__WEBPACK_IMPORTED_MODULE_1__[\"default\"]);\n/* harmony default export */ __webpack_exports__[\"default\"] = (new vuex__WEBPACK_IMPORTED_MODULE_1__[\"default\"].Store({\n  strict: \"development\" !== \"production\",\n  modules: {\n    infobar: _infobar__WEBPACK_IMPORTED_MODULE_11__[\"default\"],\n    settings: _settings__WEBPACK_IMPORTED_MODULE_12__[\"default\"],\n    powershell: _powershell__WEBPACK_IMPORTED_MODULE_10__[\"default\"],\n    group: _group__WEBPACK_IMPORTED_MODULE_8__[\"default\"],\n    socket: _socket__WEBPACK_IMPORTED_MODULE_3__[\"default\"],\n    auth: _auth__WEBPACK_IMPORTED_MODULE_2__[\"default\"],\n    domain: _domain__WEBPACK_IMPORTED_MODULE_4__[\"default\"],\n    computer: _computer__WEBPACK_IMPORTED_MODULE_5__[\"default\"],\n    computerPackage: _computerPackage__WEBPACK_IMPORTED_MODULE_6__[\"default\"],\n    groupPackage: _groupPackage__WEBPACK_IMPORTED_MODULE_7__[\"default\"],\n    source: _source__WEBPACK_IMPORTED_MODULE_9__[\"default\"]\n  }\n}));\n\n//# sourceURL=webpack:///./src/store/index.js?");

/***/ }),

/***/ "./src/store/infobar.js":
/*!******************************!*\
  !*** ./src/store/infobar.js ***!
  \******************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\nfunction getText(p) {\n  const item = Object.assign({}, p);\n  let css = \"\";\n  let command = item.command.name;\n  if (item.command.name === \"install\") css = \"is-success\";\n  if (item.command.name === \"uninstall\") css = \"is-danger\";\n  if (item.command.name === \"upgrade\") {\n    css = \"is-info\";\n    command = \"upgrad\";\n  }\n  return `<span class='tags has-addons'>    \n    <span class='tag is-rounded is-default is-light'>\n     ${item.package.name} - ${item.version.version}\n    </span>\n    <span class='tag is-rounded is-capitalized is-light ${css}'>\n    ${command}ing\n    </span>\n  </span>`;\n}\n/* harmony default export */ __webpack_exports__[\"default\"] = ({\n  namespaced: true,\n  state: {\n    package: null,\n    text: \"\"\n  },\n  mutations: {\n    setPackage(state, p) {\n      state.package = p;\n      if (p && p.command && p.command.status === \"working\") {\n        state.text = getText(p);\n      } else state.text = \"\";\n    },\n    setText(state, text) {\n      state.text = text;\n    },\n    clear(state) {\n      state.workingPackage = null;\n    }\n  },\n  actions: {\n    checkAndSetPackage({\n      state,\n      commit,\n      rootState\n    }, p) {\n      if (!state.package || p.command.status === \"working\" || rootState.settings.user.profile.infobar && rootState.settings.user.profile.infobar.workingStatus && state.package.packageHash == p.package.packageHash && p.source.uid === state.package.source.uid) {\n        if (p.command.status === \"working\") commit(\"setPackage\", p);else commit(\"setPackage\", null);\n      }\n    }\n  }\n});\n\n//# sourceURL=webpack:///./src/store/infobar.js?");

/***/ }),

/***/ "./src/store/powershell.js":
/*!*********************************!*\
  !*** ./src/store/powershell.js ***!
  \*********************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var vue__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! vue */ \"./node_modules/vue/dist/vue.runtime.esm.js\");\n\n/* harmony default export */ __webpack_exports__[\"default\"] = ({\n  namespaced: true,\n  state: {\n    status: {\n      complete: true,\n      terminating: false\n    },\n    lines: [],\n    computerUID: null\n  },\n  mutations: {\n    setStatus(state, status) {\n      vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(state, \"status\", {\n        ...state.status,\n        ...status\n      });\n    },\n    setComputerUID(state, computerUID) {\n      vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(state, \"computerUID\", computerUID);\n    },\n    addLine(state, line) {\n      state.lines.push(line);\n    },\n    clear(state) {\n      vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(state, \"status\", {\n        complete: true,\n        terminating: false\n      });\n      state.computerUID = null;\n      state.lines = [];\n    }\n  }\n});\n\n//# sourceURL=webpack:///./src/store/powershell.js?");

/***/ }),

/***/ "./src/store/settings.js":
/*!*******************************!*\
  !*** ./src/store/settings.js ***!
  \*******************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var vue__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! vue */ \"./node_modules/vue/dist/vue.runtime.esm.js\");\n/* harmony import */ var _utils_http__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @/utils/http */ \"./src/utils/http.js\");\n/* harmony import */ var _router__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @/router */ \"./src/router/index.js\");\n/* harmony import */ var _utils_settings__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @/utils/settings */ \"./src/utils/settings.js\");\n\n\n\n\n/* harmony default export */ __webpack_exports__[\"default\"] = ({\n  namespaced: true,\n  state: {\n    user: {},\n    server: null,\n    initiated: false,\n    isLicenseConversionModalVisible: false,\n    licenseInfo: null\n  },\n  mutations: {\n    setLicenseInfo(state, licenseInfo) {\n      state.licenseInfo = licenseInfo;\n      if (licenseInfo.free <= 5) state.isLicenseConversionModalVisible = true;\n    },\n    setLicenseConversionVisible(state, isLicenseConversionModalVisible) {\n      state.isLicenseConversionModalVisible = isLicenseConversionModalVisible;\n    },\n    setInitiated(state, initiated) {\n      state.initiated = initiated;\n    },\n    setServer(state, settings) {\n      if (settings && settings.licenseEnabled === undefined) settings.licenseEnabled = true;\n      state.server = settings;\n      //console.log(settings);\n    },\n\n    setUser(state, {\n      path,\n      value\n    }) {\n      //console.log(\"setUser:\", path, value);\n      if (!state.user[path]) vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(state.user, [path], {});\n      vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(state.user, [path], {\n        ...state.user[path],\n        ...value\n      });\n    },\n    setUserSetting(state, {\n      path,\n      key,\n      value\n    }) {\n      //console.log(\"setUserSetting:\", path, key, value);\n      if (!state.user[path]) vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(state.user, [path], {});\n      if (!state.user[path][key]) vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(state.user[path], [key], {});\n\n      //console.log(state.user[path][key]);\n\n      if (typeof value === \"object\") {\n        vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(state.user[path], [key], {\n          ...state.user[path][key],\n          ...value\n        });\n      } else vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(state.user[path], [key], value);\n    },\n    clear(state) {\n      state.user = {};\n    }\n  },\n  actions: {\n    async getLicenseStats({\n      commit\n    }) {\n      try {\n        const data = await Object(_utils_http__WEBPACK_IMPORTED_MODULE_1__[\"postApi\"])(\"get/serverLicense\", {\n          withCredentials: true\n        });\n        commit(\"setLicenseInfo\", data);\n        return data;\n      } catch (error) {\n        console.error(\"Could not get license stats\", error);\n      }\n      return null;\n    },\n    async fetchServer({\n      commit\n    }) {\n      try {\n        const res = await Object(_utils_http__WEBPACK_IMPORTED_MODULE_1__[\"post\"])(`${_utils_settings__WEBPACK_IMPORTED_MODULE_3__[\"baseUrl\"]}/get/settings`);\n        const settings = res.data;\n        commit(\"setServer\", settings);\n        if (settings.sealed && settings.webUnsealEnabled) {\n          if (_router__WEBPACK_IMPORTED_MODULE_2__[\"default\"].currentRoute.path != \"/unavailable\") _router__WEBPACK_IMPORTED_MODULE_2__[\"default\"].push({\n            path: \"/unavailable\"\n          });\n          return false;\n        } else if (settings.sealed && !settings.webUnsealEnabled) {\n          if (_router__WEBPACK_IMPORTED_MODULE_2__[\"default\"].currentRoute.path != \"/unavailable\") _router__WEBPACK_IMPORTED_MODULE_2__[\"default\"].push({\n            path: \"/unavailable\"\n          });\n          return false;\n        }\n      } catch (e) {\n        if (_router__WEBPACK_IMPORTED_MODULE_2__[\"default\"].currentRoute.path != \"/unavailable\") _router__WEBPACK_IMPORTED_MODULE_2__[\"default\"].push({\n          path: \"/unavailable\"\n        });\n        return false;\n      }\n      return true;\n    },\n    async fetchUserSetting({\n      state,\n      commit\n    }, path) {\n      const response = await Object(_utils_http__WEBPACK_IMPORTED_MODULE_1__[\"postApi\"])(\"get/userSiteSetting\", {\n        key: path\n      });\n      //console.log(\"fetchUserSetting 1\", path, typeof response);\n      if (response && response[0] && response[0].value) {\n        //console.log(\"fetchUserSetting 2\", response[0]);\n        if (response[0].value.startsWith(\"{\")) {\n          //console.log(\"fetchUserSetting 3\", response[0]);\n          commit(\"setUser\", {\n            path,\n            value: JSON.parse(response[0].value)\n          });\n        } else {\n          console.log(\"Got unparsable settings: \", path);\n        }\n      } else commit(\"setUser\", {\n        path,\n        value: {}\n      });\n    },\n    async getUserSetting({\n      dispatch,\n      state,\n      commit\n    }, {\n      path,\n      key\n    }) {\n      //console.log(\"Action: getUserSetting:\", path, key, state.user);\n      if (!state.user[path]) await dispatch(\"fetchUserSetting\", path);\n      if (!state.user[path][key]) {\n        commit(\"setUserSetting\", {\n          path,\n          key,\n          value: {}\n        });\n      }\n      return state.user[path][key];\n    },\n    async getUserSettings({\n      dispatch,\n      state\n    }, {\n      path\n    }) {\n      //console.log(\"Action: getUserSettings:\", path, state.user);\n      if (!state.user[path]) await dispatch(\"fetchUserSetting\", path);\n      return state.user[path];\n    },\n    async setUser({\n      state,\n      commit\n    }, {\n      path,\n      key,\n      value\n    }) {\n      //console.log(\"setUser:\", path, key, value);\n      commit(\"setUserSetting\", {\n        path,\n        key,\n        value\n      });\n      // await postApi(\"set/userSiteSettings\", {\n      //   settings: { [path]: JSON.stringify({}) }\n      // });\n      await Object(_utils_http__WEBPACK_IMPORTED_MODULE_1__[\"postApi\"])(\"set/userSiteSettings\", {\n        settings: {\n          [path]: JSON.stringify(state.user[path])\n        }\n      });\n    }\n  },\n  getters: {},\n  modules: {}\n});\n\n//# sourceURL=webpack:///./src/store/settings.js?");

/***/ }),

/***/ "./src/store/socket.js":
/*!*****************************!*\
  !*** ./src/store/socket.js ***!
  \*****************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony default export */ __webpack_exports__[\"default\"] = ({\n  namespaced: true,\n  state: {\n    connected: false,\n    connecting: false,\n    domain: null,\n    reconnect: false\n  },\n  mutations: {\n    setDomain(state, domain) {\n      state.domain = domain;\n      state.reconnect = true;\n    },\n    setConnected(state, connected) {\n      state.connected = connected;\n    },\n    setConnecting(state, connecting) {\n      state.connecting = connecting;\n    },\n    setReconnect(state, reconnect) {\n      state.reconnect = reconnect;\n    },\n    clear(state) {\n      state.connected = false;\n      state.connecting = false;\n      state.instance = null;\n      state.domain = null;\n      state.reconnect = false;\n    }\n  }\n});\n\n//# sourceURL=webpack:///./src/store/socket.js?");

/***/ }),

/***/ "./src/store/source.js":
/*!*****************************!*\
  !*** ./src/store/source.js ***!
  \*****************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var vue__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! vue */ \"./node_modules/vue/dist/vue.runtime.esm.js\");\n/* harmony import */ var _utils_http__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @/utils/http */ \"./src/utils/http.js\");\n/* harmony import */ var _utils_mdc__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @/utils/mdc */ \"./src/utils/mdc.js\");\n/* harmony import */ var _utils_order__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @/utils/order */ \"./src/utils/order.js\");\n\n\n\n\n/* harmony default export */ __webpack_exports__[\"default\"] = ({\n  namespaced: true,\n  state: {\n    sources: [],\n    domainUID: null\n  },\n  mutations: {\n    edit(state, {\n      s,\n      obj\n    }) {\n      const index = state.sources.findIndex(x => x.uid === s.uid);\n      if (index !== -1) {\n        const item = state.sources[index];\n        vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].set(state.sources, index, {\n          ...item,\n          ...obj\n        });\n      }\n    },\n    add(state, source) {\n      state.sources.unshift(source);\n    },\n    remove(state, d) {\n      const index = state.sources.findIndex(x => x.uid === d.uid);\n      if (index !== -1) vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].delete(state.sources, index);\n    },\n    set(state, {\n      sources,\n      domainUID\n    }) {\n      state.sources = sources;\n      state.domainUID = domainUID;\n    },\n    clear(state) {\n      state.sources = [];\n      state.domainUID = null;\n    }\n  },\n  actions: {\n    async fetch({\n      commit,\n      state\n    }, {\n      domainUID,\n      force = false\n    }) {\n      if (state.sources.length === 0 || force || domainUID !== state.domainUID) {\n        const sources = await Object(_utils_http__WEBPACK_IMPORTED_MODULE_1__[\"postApi\"])(\"get/domainPackageSources\", {\n          domainUID: domainUID\n        });\n        commit(\"set\", {\n          sources: sources.map(x => Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"formSource\"])(x)),\n          domainUID\n        });\n      }\n    },\n    async fetchAll({\n      commit,\n      state,\n      rootState,\n      dispatch\n    }, force) {\n      if (state.sources.length === 0 || force) {\n        let sources = await Object(_utils_http__WEBPACK_IMPORTED_MODULE_1__[\"postApi\"])(\"get/packageSources\", {});\n        if (sources) {\n          var _rootState$settings$u;\n          await dispatch(\"settings/getUserSetting\", {\n            path: \"sources\",\n            key: \"order\"\n          }, {\n            root: true\n          });\n          sources = sources.map(x => Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"formSource\"])(x));\n          sources = Object(_utils_order__WEBPACK_IMPORTED_MODULE_3__[\"_order\"])(sources, (_rootState$settings$u = rootState.settings.user.sources) === null || _rootState$settings$u === void 0 ? void 0 : _rootState$settings$u.order);\n          commit(\"set\", {\n            sources: sources,\n            domainUID: null\n          });\n        }\n      }\n    },\n    async createInternal({\n      commit,\n      state\n    }, name) {\n      const res = await Object(_utils_http__WEBPACK_IMPORTED_MODULE_1__[\"postApi\"])(\"create/internalPackageSource\", {\n        name\n      });\n      if (res && res[0]) commit(\"add\", Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"formSource\"])(res[0]));\n    },\n    async createExternal({\n      commit,\n      state\n    }, {\n      name,\n      url\n    }) {\n      const res = await Object(_utils_http__WEBPACK_IMPORTED_MODULE_1__[\"postApi\"])(\"create/packageSource\", {\n        name: name,\n        url: url,\n        description: \"\",\n        username: \"\",\n        password: \"\",\n        key: \"\",\n        css: \"\"\n      });\n      if (res && res[0]) commit(\"add\", Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_2__[\"formSource\"])(res[0]));\n    },\n    async delete({\n      commit,\n      state\n    }, source) {\n      await Object(_utils_http__WEBPACK_IMPORTED_MODULE_1__[\"postApi\"])(\"delete/packageSource\", {\n        uid: source.uid\n      });\n      commit(\"remove\", source);\n    },\n    async order({\n      dispatch,\n      commit,\n      state,\n      rootState\n    }, order) {\n      var _rootState$settings$u2;\n      const stateOrder = (_rootState$settings$u2 = rootState.settings.user.sources) === null || _rootState$settings$u2 === void 0 ? void 0 : _rootState$settings$u2.order;\n      order = Object(_utils_order__WEBPACK_IMPORTED_MODULE_3__[\"getReversed\"])(stateOrder, order);\n      dispatch(\"settings/setUser\", {\n        path: \"sources\",\n        key: \"order\",\n        value: order\n      }, {\n        root: true\n      });\n      commit(\"set\", {\n        sources: Object(_utils_order__WEBPACK_IMPORTED_MODULE_3__[\"_order\"])(state.sources, order),\n        domainUID: state.domainUID\n      });\n    }\n  },\n  getters: {\n    single: state => repoUID => {\n      return state.sources.find(x => x.uid === repoUID);\n    }\n  }\n});\n\n//# sourceURL=webpack:///./src/store/source.js?");

/***/ }),

/***/ "./src/utils/app.js":
/*!**************************!*\
  !*** ./src/utils/app.js ***!
  \**************************/
/*! exports provided: init, loadSettings */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"init\", function() { return init; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"loadSettings\", function() { return loadSettings; });\n/* harmony import */ var _store__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @/store */ \"./src/store/index.js\");\n/* harmony import */ var _utils_auth__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @/utils/auth */ \"./src/utils/auth.js\");\n\n\nasync function init() {\n  Object(_utils_auth__WEBPACK_IMPORTED_MODULE_1__[\"loadAuth\"])();\n  await _store__WEBPACK_IMPORTED_MODULE_0__[\"default\"].dispatch(\"settings/fetchServer\");\n  await loadSettings();\n}\nasync function loadSettings() {\n  if (_store__WEBPACK_IMPORTED_MODULE_0__[\"default\"].state.auth.success) {\n    await _store__WEBPACK_IMPORTED_MODULE_0__[\"default\"].dispatch(\"settings/getUserSetting\", {\n      path: \"profile\",\n      key: \"notifications\"\n    });\n    await _store__WEBPACK_IMPORTED_MODULE_0__[\"default\"].dispatch(\"settings/getUserSetting\", {\n      path: \"profile\",\n      key: \"infobar\"\n    });\n    await _store__WEBPACK_IMPORTED_MODULE_0__[\"default\"].dispatch(\"settings/getLicenseStats\");\n  }\n}\n\n//# sourceURL=webpack:///./src/utils/app.js?");

/***/ }),

/***/ "./src/utils/auth.js":
/*!***************************!*\
  !*** ./src/utils/auth.js ***!
  \***************************/
/*! exports provided: loadAuth, setAuth, logout, reroute */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"loadAuth\", function() { return loadAuth; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"setAuth\", function() { return setAuth; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"logout\", function() { return logout; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"reroute\", function() { return reroute; });\n/* harmony import */ var vue__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! vue */ \"./node_modules/vue/dist/vue.runtime.esm.js\");\n/* harmony import */ var _store__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @/store */ \"./src/store/index.js\");\n/* harmony import */ var _router__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @/router */ \"./src/router/index.js\");\n/* harmony import */ var _http__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./http */ \"./src/utils/http.js\");\n\n\n\n\nfunction loadAuth() {\n  const user = vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].ls.get(\"user\");\n  setAuth(user);\n}\nfunction setAuth(user) {\n  if (user && user.userUID) vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].ls.set(\"user\", user);else vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].ls.clear();\n  _store__WEBPACK_IMPORTED_MODULE_1__[\"default\"].commit(\"auth/set\", user);\n}\nasync function logout(skipApiCall) {\n  try {\n    if (!skipApiCall) {\n      try {\n        await Object(_http__WEBPACK_IMPORTED_MODULE_3__[\"postApi\"])(\"logout\");\n      } catch (err) {\n        console.error(err);\n      }\n    }\n    setAuth({});\n    reroute();\n    _store__WEBPACK_IMPORTED_MODULE_1__[\"default\"].commit(\"computer/clear\");\n    _store__WEBPACK_IMPORTED_MODULE_1__[\"default\"].commit(\"computerPackage/clear\");\n    _store__WEBPACK_IMPORTED_MODULE_1__[\"default\"].commit(\"domain/clear\");\n    _store__WEBPACK_IMPORTED_MODULE_1__[\"default\"].commit(\"group/clear\");\n    _store__WEBPACK_IMPORTED_MODULE_1__[\"default\"].commit(\"groupPackage/clear\");\n    _store__WEBPACK_IMPORTED_MODULE_1__[\"default\"].commit(\"powershell/clear\");\n    _store__WEBPACK_IMPORTED_MODULE_1__[\"default\"].commit(\"socket/clear\");\n    _store__WEBPACK_IMPORTED_MODULE_1__[\"default\"].commit(\"source/clear\");\n    _store__WEBPACK_IMPORTED_MODULE_1__[\"default\"].commit(\"settings/clear\");\n  } catch (err) {\n    console.log(err);\n  }\n}\nfunction reroute() {\n  if (!_store__WEBPACK_IMPORTED_MODULE_1__[\"default\"].state.auth.success && _router__WEBPACK_IMPORTED_MODULE_2__[\"default\"].currentRoute.path != \"/signin\") _router__WEBPACK_IMPORTED_MODULE_2__[\"default\"].push({\n    path: \"/signin\"\n  });else _router__WEBPACK_IMPORTED_MODULE_2__[\"default\"].push({\n    path: \"/domains\"\n  });\n}\n\n//# sourceURL=webpack:///./src/utils/auth.js?");

/***/ }),

/***/ "./src/utils/computer.js":
/*!*******************************!*\
  !*** ./src/utils/computer.js ***!
  \*******************************/
/*! exports provided: getName, select, default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"getName\", function() { return getName; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"select\", function() { return select; });\nfunction getName(computer) {\n  if (computer) {\n    if (computer.friendlyName && computer.friendlyName != \"\") return computer.friendlyName;else return computer.name;\n  }\n  return null;\n}\nfunction select(computers, selectedComputers) {\n  return computers.map(x => {\n    if (selectedComputers.some(y => y.uid === x.uid)) x.selected = true;else x.selected = false;\n    return x;\n  });\n}\n/* harmony default export */ __webpack_exports__[\"default\"] = ({\n  getName,\n  select\n});\n\n//# sourceURL=webpack:///./src/utils/computer.js?");

/***/ }),

/***/ "./src/utils/computerNotice.js":
/*!*************************************!*\
  !*** ./src/utils/computerNotice.js ***!
  \*************************************/
/*! exports provided: computerNotice, notify */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"computerNotice\", function() { return computerNotice; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"notify\", function() { return notify; });\n/* harmony import */ var vue__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! vue */ \"./node_modules/vue/dist/vue.runtime.esm.js\");\n/* harmony import */ var _store__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @/store */ \"./src/store/index.js\");\n/* harmony import */ var _utils_computer__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @/utils/computer */ \"./src/utils/computer.js\");\n\n\n\nasync function computerNotice(item) {\n  if (_store__WEBPACK_IMPORTED_MODULE_1__[\"default\"].state.settings.user.profile && _store__WEBPACK_IMPORTED_MODULE_1__[\"default\"].state.settings.user.profile.notifications && _store__WEBPACK_IMPORTED_MODULE_1__[\"default\"].state.settings.user.profile.notifications.computerAdd && !_store__WEBPACK_IMPORTED_MODULE_1__[\"default\"].getters[\"computer/singleComputer\"](item.uid)) {\n    const name = Object(_utils_computer__WEBPACK_IMPORTED_MODULE_2__[\"getName\"])(item);\n    notify(\"New computer\", `'${name}' was added.`, \"success\", 0);\n  }\n}\nfunction notify(title, text, type, duration, speed) {\n  vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].notify({\n    group: \"all\",\n    title: title || \"\",\n    text: text || \"\",\n    duration: duration || 10000,\n    speed: speed || 200,\n    type: type || \"success\"\n  });\n}\n\n//# sourceURL=webpack:///./src/utils/computerNotice.js?");

/***/ }),

/***/ "./src/utils/document.js":
/*!*******************************!*\
  !*** ./src/utils/document.js ***!
  \*******************************/
/*! exports provided: focus, select, getId, downloadFile, getTextUrl, scrollToEnd, copyToClipboard, jump */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"focus\", function() { return focus; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"select\", function() { return select; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"getId\", function() { return getId; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"downloadFile\", function() { return downloadFile; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"getTextUrl\", function() { return getTextUrl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"scrollToEnd\", function() { return scrollToEnd; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"copyToClipboard\", function() { return copyToClipboard; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"jump\", function() { return jump; });\nfunction handleError(functionName, id) {\n  console.error(`${functionName}: element with id \"${id}\" was not found.`);\n}\nfunction focus(elementId) {\n  setTimeout(() => {\n    const el = document.getElementById(elementId);\n    if (el) el.focus();else handleError(focus.name, elementId);\n  });\n}\nfunction select(elementId) {\n  const el = document.getElementById(elementId);\n  if (el) el.select();else handleError(select.name, elementId);\n}\nfunction getId() {\n  return Math.random().toString(36).substring(7);\n}\nfunction downloadFile(url, fileName) {\n  const id = getId();\n  const link = document.createElement(\"a\");\n  link.id = id;\n  link.href = url;\n  if (fileName) link.download = fileName;\n  link.style.display = \"none\";\n  link.text = \"download\";\n  //link.target = \"_blank\";\n  document.body.appendChild(link);\n  document.getElementById(id).click();\n  document.body.appendChild(link).remove();\n}\nfunction getTextUrl(text, mime) {\n  if (!mime) mime = \"application/octet-stream\";\n  return `data:${mime};charset=utf-8,${encodeURIComponent(text)}`;\n}\nfunction scrollToEnd(id) {\n  const el = document.getElementById(id);\n  if (el && el.scrollHeight) el.scrollTop = el.scrollHeight - el.clientHeight;\n}\nfunction copyToClipboard(id) {\n  const range = document.createRange();\n  const el = document.getElementById(id);\n  if (el) {\n    range.selectNode(el);\n    window.getSelection().removeAllRanges();\n    window.getSelection().addRange(range);\n    document.execCommand(\"copy\");\n    window.getSelection().removeAllRanges();\n  }\n}\nfunction jump(id) {\n  setTimeout(() => {\n    const el = document.getElementById(id);\n    if (el) el.classList.add(\"pulse-fast-once\");\n  }, 0);\n}\n\n\n//# sourceURL=webpack:///./src/utils/document.js?");

/***/ }),

/***/ "./src/utils/groupPackage.js":
/*!***********************************!*\
  !*** ./src/utils/groupPackage.js ***!
  \***********************************/
/*! exports provided: getComputerPackages, getPackageStats, fetchPackagesStats */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"getComputerPackages\", function() { return getComputerPackages; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"getPackageStats\", function() { return getPackageStats; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"fetchPackagesStats\", function() { return fetchPackagesStats; });\n/* harmony import */ var _utils_mdc__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @/utils/mdc */ \"./src/utils/mdc.js\");\n/* harmony import */ var _utils_http__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @/utils/http */ \"./src/utils/http.js\");\n/* harmony import */ var _store_index__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @/store/index */ \"./src/store/index.js\");\n\n\n\nasync function getComputerPackages(item, computerUIDs, domainUID) {\n  const {\n    hash\n  } = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_0__[\"getPackageNameVersionAndHash\"])(item);\n  const res = await Object(_utils_http__WEBPACK_IMPORTED_MODULE_1__[\"postApi\"])(\"get/computerPackagesSlim\", {\n    packageHash: hash,\n    computerUIDs,\n    domainUID\n  });\n  return res[0];\n}\nfunction getPackageStats(groupPackages, computers, item) {\n  let stats = {};\n  const packagesToFilter = groupPackages.filter(x => Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_0__[\"isSamePackage\"])(x, item, true));\n  const installed = packagesToFilter.filter(x => x.command.status === \"done\" && x.command.name !== \"uninstall\");\n  const uninstalled = packagesToFilter.filter(x => x.command.status === \"done\" && x.command.name === \"uninstall\");\n  const pending = packagesToFilter.filter(x => x.command.status === \"pending\");\n  const failed = packagesToFilter.filter(x => x.command.status === \"failed\");\n  const working = packagesToFilter.filter(x => x.command.status === \"working\");\n  let allDone = false;\n  let procentDone = 0;\n  let procentFailed = 0;\n  let procentWorking = 0;\n  let procentInstalled = 0;\n  let procentUninstalled = 0;\n  let totalDone = 0;\n  let totalInstalled = 0;\n  let installedComputerUIDs = [];\n  let totalFailed = 0;\n  let failedComputerUIDs = [];\n  let totalWorking = 0;\n  let workingComputerUIDs = [];\n  let totalPending = 0;\n  let pendingComputerUIDs = [];\n  let totalUninstalled = 0;\n  let uninstalledComputerUIDs = [];\n  let totalNoStatus = 0;\n  let procentNoStatus = 0;\n  let noStatusComputerUIDs = [];\n  let totalComputers = computers.length;\n  const procentTotalComputers = 100 / totalComputers;\n  if (installed.length > 0) {\n    totalInstalled = installed.length;\n    installedComputerUIDs = installed.map(p => p.computerUID);\n  }\n  if (failed.length > 0) {\n    totalFailed = failed.length;\n    failedComputerUIDs = failed.map(p => p.computerUID);\n  }\n  if (working.length > 0) {\n    totalWorking = working.length;\n    workingComputerUIDs = working.map(p => p.computerUID);\n  }\n  if (pending.length > 0) {\n    totalPending = pending.length;\n    pendingComputerUIDs = pending.map(p => p.computerUID);\n  }\n  if (uninstalled.length > 0) {\n    totalUninstalled = uninstalled.length;\n    uninstalledComputerUIDs = uninstalled.map(p => p.computerUID);\n  }\n  noStatusComputerUIDs = computers.map(x => x.uid);\n  for (const uid of installedComputerUIDs) {\n    const index = noStatusComputerUIDs.indexOf(uid);\n    if (index != -1) noStatusComputerUIDs.splice(index, 1);\n  }\n  for (const uid of uninstalledComputerUIDs) {\n    const index = noStatusComputerUIDs.indexOf(uid);\n    if (index != -1) noStatusComputerUIDs.splice(index, 1);\n  }\n  for (const uid of failedComputerUIDs) {\n    const index = noStatusComputerUIDs.indexOf(uid);\n    if (index != -1) noStatusComputerUIDs.splice(index, 1);\n  }\n  for (const uid of workingComputerUIDs) {\n    const index = noStatusComputerUIDs.indexOf(uid);\n    if (index != -1) noStatusComputerUIDs.splice(index, 1);\n  }\n  if (totalInstalled === totalComputers && item.command.name === \"install\" || totalInstalled === totalComputers && item.command.name === \"upgrade\" || totalUninstalled === totalComputers && item.command.name === \"uninstall\") allDone = true;\n  if (item.command.name === \"install\" || item.command.name === \"upgrade\") totalDone = totalInstalled;else if (item.command.name === \"uninstall\") totalDone = totalUninstalled;\n  if (item.command.name === \"install\" || item.command.name === \"upgrade\") procentDone = procentTotalComputers * totalInstalled;else if (item.command.name === \"uninstall\") procentDone = procentTotalComputers * totalUninstalled;\n  procentDone = Math.round(procentDone);\n  procentFailed = procentTotalComputers * totalFailed;\n  procentFailed = Math.round(procentFailed);\n  procentInstalled = procentInstalled = procentTotalComputers * totalInstalled;\n  procentInstalled = Math.round(procentInstalled);\n  procentUninstalled = procentUninstalled = procentTotalComputers * totalUninstalled;\n  procentUninstalled = Math.round(procentUninstalled);\n  procentWorking = procentWorking = procentTotalComputers * totalWorking;\n  procentWorking = Math.round(procentWorking);\n  totalNoStatus = totalComputers - totalWorking - totalFailed - totalInstalled - totalUninstalled;\n  procentNoStatus = procentTotalComputers * totalNoStatus;\n  procentNoStatus = Math.round(procentNoStatus);\n  stats = {\n    totalDone,\n    allDone,\n    procentDone,\n    procentFailed,\n    procentInstalled,\n    procentUninstalled,\n    procentWorking,\n    totalComputers,\n    totalInstalled,\n    installedComputerUIDs,\n    totalWorking,\n    workingComputerUIDs,\n    totalUninstalled,\n    uninstalledComputerUIDs,\n    totalPending,\n    pendingComputerUIDs,\n    totalFailed,\n    failedComputerUIDs,\n    totalNoStatus,\n    procentNoStatus,\n    noStatusComputerUIDs\n  };\n  stats.installedComputers = getComputersFromUIDs(stats.installedComputerUIDs, computers);\n  stats.failedComputers = getComputersFromUIDs(stats.failedComputerUIDs, computers);\n  stats.workingComputers = getComputersFromUIDs(stats.workingComputerUIDs, computers);\n  stats.pendingComputers = getComputersFromUIDs(stats.pendingComputerUIDs, computers);\n  stats.uninstalledComputers = getComputersFromUIDs(stats.uninstalledComputerUIDs, computers);\n  stats.noStatusComputers = getComputersFromUIDs(stats.noStatusComputerUIDs, computers);\n  return stats;\n}\nfunction fetchPackagesStats(groupPackages, group, domainUID, force, addToStore) {\n  if (group && group.computers) {\n    groupPackages = [...groupPackages];\n    const computerUIDs = group.computers.map(x => x.uid);\n    const promises = [];\n    for (const item of groupPackages) {\n      if (!item.stats || force || item.command && item.command.name && !force) {\n        const promise = getComputerPackages(item, computerUIDs, domainUID).then(computerPackageInfo => {\n          if (addToStore) {\n            _store_index__WEBPACK_IMPORTED_MODULE_2__[\"default\"].commit(\"groupPackage/setComputerPackages\", computerPackageInfo);\n          }\n          return getPackageStats(computerPackageInfo.packages, group.computers, item);\n        }).then(stats => {\n          _store_index__WEBPACK_IMPORTED_MODULE_2__[\"default\"].commit(\"groupPackage/editMergedPackage\", {\n            p: item,\n            obj: {\n              stats: stats\n            }\n          });\n        });\n        promises.push(promise);\n      }\n    }\n    return Promise.all(promises);\n  }\n  return [];\n}\nfunction getComputersFromUIDs(computerUIDs, groupComputers) {\n  let computers = [];\n  if (computerUIDs) {\n    for (const computerUID of computerUIDs) {\n      computers = [...computers, ...groupComputers.filter(x => x.uid === computerUID)];\n    }\n  }\n  return computers;\n}\n\n//# sourceURL=webpack:///./src/utils/groupPackage.js?");

/***/ }),

/***/ "./src/utils/http.js":
/*!***************************!*\
  !*** ./src/utils/http.js ***!
  \***************************/
/*! exports provided: postApi, post, _delete */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"postApi\", function() { return postApi; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"post\", function() { return post; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"_delete\", function() { return _delete; });\n/* harmony import */ var _router__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @/router */ \"./src/router/index.js\");\n/* harmony import */ var axios__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! axios */ \"./node_modules/axios/index.js\");\n/* harmony import */ var axios__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(axios__WEBPACK_IMPORTED_MODULE_1__);\n/* harmony import */ var _settings__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./settings */ \"./src/utils/settings.js\");\n/* harmony import */ var _utils_auth__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @/utils/auth */ \"./src/utils/auth.js\");\n/* harmony import */ var _store_index__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @/store/index */ \"./src/store/index.js\");\n/* harmony import */ var vue__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! vue */ \"./node_modules/vue/dist/vue.runtime.esm.js\");\n\n\n\n\n\n\naxios__WEBPACK_IMPORTED_MODULE_1___default.a.defaults.withCredentials = true;\nasync function postApi(path, data, options = {}) {\n  if (!_store_index__WEBPACK_IMPORTED_MODULE_4__[\"default\"].state.auth.success && !options.skipAuth) {\n    //reroute();\n    return;\n  }\n  if (!options.skipAuth) path = `secure/${path}`;\n  if (!options.skipDataObject) data = {\n    data: data\n  };\n  try {\n    //console.log(`${baseUrl}/${path}`, data);\n    const res = await axios__WEBPACK_IMPORTED_MODULE_1___default.a.post(`${_settings__WEBPACK_IMPORTED_MODULE_2__[\"baseUrl\"]}/${path}`, data);\n    if (!options.fullDataObject) return res.data;\n    return res;\n  } catch (err) {\n    console.error(err);\n    if (err.response) {\n      if (err.response.status === 401 && _router__WEBPACK_IMPORTED_MODULE_0__[\"default\"].currentRoute.path != \"/signout\") Object(_utils_auth__WEBPACK_IMPORTED_MODULE_3__[\"logout\"])(true);else if (err.response.status === 403) vue__WEBPACK_IMPORTED_MODULE_5__[\"default\"].notify(\"Access denied\", `The request (${path}) was denied`, \"warning\");\n    }\n    throw err;\n  }\n}\nfunction post(url, data, config) {\n  return axios__WEBPACK_IMPORTED_MODULE_1___default.a.post(url, data, config);\n}\nfunction _delete(url, config) {\n  console.log(url);\n  return axios__WEBPACK_IMPORTED_MODULE_1___default.a.delete(url, config);\n}\n\n//# sourceURL=webpack:///./src/utils/http.js?");

/***/ }),

/***/ "./src/utils/mdc.js":
/*!**************************!*\
  !*** ./src/utils/mdc.js ***!
  \**************************/
/*! exports provided: formSource, getLatestChocoPackageFilter, getChocoPackageFilter, getChocoPackagesFromFilter, getPackageNameVersionAndHash, hasSamePackageName, isSamePackage, mergePackages, mergePackage, hasParam, toIsoDate, getChocoPackagesFromMdcPackages, getChocoPackageFromMdcPackage, correctMissingChocoPackages, stripPackages, removeChocoDuplicates, removeMdcDuplicates, getGroup, createChocoPseudoPackageFromMDCPackage */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"formSource\", function() { return formSource; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"getLatestChocoPackageFilter\", function() { return getLatestChocoPackageFilter; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"getChocoPackageFilter\", function() { return getChocoPackageFilter; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"getChocoPackagesFromFilter\", function() { return getChocoPackagesFromFilter; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"getPackageNameVersionAndHash\", function() { return getPackageNameVersionAndHash; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"hasSamePackageName\", function() { return hasSamePackageName; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"isSamePackage\", function() { return isSamePackage; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"mergePackages\", function() { return mergePackages; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"mergePackage\", function() { return mergePackage; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"hasParam\", function() { return hasParam; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"toIsoDate\", function() { return toIsoDate; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"getChocoPackagesFromMdcPackages\", function() { return getChocoPackagesFromMdcPackages; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"getChocoPackageFromMdcPackage\", function() { return getChocoPackageFromMdcPackage; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"correctMissingChocoPackages\", function() { return correctMissingChocoPackages; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"stripPackages\", function() { return stripPackages; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"removeChocoDuplicates\", function() { return removeChocoDuplicates; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"removeMdcDuplicates\", function() { return removeMdcDuplicates; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"getGroup\", function() { return getGroup; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"createChocoPseudoPackageFromMDCPackage\", function() { return createChocoPseudoPackageFromMDCPackage; });\n/* harmony import */ var _settings__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./settings */ \"./src/utils/settings.js\");\n/* harmony import */ var _utils_http__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @/utils/http */ \"./src/utils/http.js\");\n/* harmony import */ var _utils_packageOdata__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @/utils/packageOdata */ \"./src/utils/packageOdata.js\");\n/* harmony import */ var _store_index__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @/store/index */ \"./src/store/index.js\");\n\n\n\n\nfunction formSource(source) {\n  if (source && source.external == false) {\n    let urlToUse = \"\";\n    if (!source.version || source.version === 1) urlToUse = _settings__WEBPACK_IMPORTED_MODULE_0__[\"feedBaseUrl\"];else urlToUse = `${_settings__WEBPACK_IMPORTED_MODULE_0__[\"baseUrl\"]}/feeds`;\n    source.url = `${urlToUse}/${source.uid}/user/${source.key}/nuget/`;\n  }\n  return source;\n}\nfunction getLatestChocoPackageFilter(packageName, version, currentUrl) {\n  let filter = \"\";\n  if (version) filter = `Id%20eq%20%27${packageName}%27%20and%20Version%20eq%20%27${version}%27`;else filter = `Id%20eq%20%27${packageName}%27%20and%20IsLatestVersion%20eq%20true`;\n  if (currentUrl && currentUrl !== \"\") return `${currentUrl}%20or%20${filter}`;else return `${_utils_packageOdata__WEBPACK_IMPORTED_MODULE_2__[\"default\"].STRICT_FILTER_BASE_STRING}${filter}`;\n}\nasync function getChocoPackageFilter(sources, packages) {\n  const filterArr = [];\n  for (const source of sources) {\n    let filter = \"\";\n    const sourcePackages = packages.filter(p => p.source.uid === source.uid);\n    for (let i = 0; i <= sourcePackages.length; i++) {\n      const p = sourcePackages[i];\n      if (p) {\n        const {\n          name,\n          version\n        } = getPackageNameVersionAndHash(p);\n        filter = getLatestChocoPackageFilter(name, version, filter);\n      }\n      if ((filter.length > 1900 || sourcePackages.length <= i) && filter !== \"\") {\n        filterArr.push({\n          filter: filter,\n          source: source\n        });\n        filter = \"\";\n      }\n    }\n  }\n  return filterArr;\n}\nasync function getChocoPackagesFromFilter(filterArr, strip = true) {\n  const promiseArr = [];\n  for (const currentFilter of filterArr) {\n    promiseArr.push(Object(_utils_http__WEBPACK_IMPORTED_MODULE_1__[\"postApi\"])(\"choco/packages\", {\n      query: currentFilter.filter,\n      source: currentFilter.source\n    }));\n  }\n  const promiseRes = await Promise.all(promiseArr);\n  return [].concat.apply([], promiseRes.map(x => {\n    if (strip) return stripPackages(x.packages);else return x.packages;\n  }));\n\n  // return removeChocoDuplicates(\n  //   [].concat.apply(\n  //     [],\n  //     promiseRes.map((x) => {\n  //       if (strip) return stripPackages(x.packages);\n  //       else return x.packages;\n  //     })\n  //   )\n  // );\n}\n\nfunction getPackageNameVersionAndHash(p) {\n  if (p.chocoPackage && p.chocoPackage.Id && p.chocoPackage.Version) {\n    return {\n      name: p.chocoPackage.Id,\n      version: p.chocoPackage.Version,\n      hash: p.chocoPackage.PackageHash,\n      title: p.chocoPackage.Title,\n      uid: p.source.uid\n    };\n  } else if (p.package && p.package.name && p.version.version) {\n    return {\n      name: p.package.name,\n      version: p.version.version,\n      hash: p.version.packageHash,\n      title: p.package.name,\n      uid: p.source.uid\n    };\n  }\n  return null;\n}\nfunction hasSamePackageName(p1, p2) {\n  const p1NV = getPackageNameVersionAndHash(p1);\n  const p2NV = getPackageNameVersionAndHash(p2);\n  return p1NV.name === p2NV.name && p1.source.uid === p2.source.uid;\n}\nfunction isSamePackage(p1, p2) {\n  const p1NV = getPackageNameVersionAndHash(p1);\n  const p2NV = getPackageNameVersionAndHash(p2);\n  return p1NV.name === p2NV.name && p1NV.version === p2NV.version && p1.source.uid === p2.source.uid;\n}\nasync function mergePackages(packages1, packages2, selected = false, addIfEmpty) {\n  const mergedArr = [];\n  for (const p1 of packages1) {\n    p1.selected = selected;\n    const p2 = packages2.find(x => isSamePackage(x, p1));\n    if (p2) {\n      mergedArr.push(mergePackage(p1, p2));\n    } else {\n      if (addIfEmpty) mergedArr.push(p1);else mergedArr.push(mergePackage(p1, createChocoPseudoPackageFromMDCPackage(p1))); // console.log(\"not merged\", p1.package.name, p1.source.uid, p1);\n    }\n  }\n\n  return mergedArr;\n}\nfunction mergePackage(p1, p2) {\n  return Object.assign({\n    ...p1\n  }, {\n    ...p2\n  });\n}\nfunction hasParam(params, param) {\n  if (params && param) {\n    if (param && param.includes(\"|\")) {\n      param = param.replace(\"|\", \"\");\n    }\n    const arr = params.split(\"|\");\n    return arr.some(x => x.trim() == param);\n  }\n  return false;\n}\nfunction toIsoDate(date) {\n  if (date && date != \"\") {\n    date = convertToDate(date);\n    return date.toLocaleDateString([], {\n      //weekday: \"narrow\",\n      year: \"numeric\",\n      month: \"numeric\",\n      day: \"numeric\",\n      hour: \"numeric\",\n      minute: \"numeric\",\n      hour12: false\n    });\n  }\n  return \"\";\n}\nfunction convertToDate(dateStr) {\n  if (dateStr) {\n    var dateObj = new Date(dateStr);\n    return dateObj;\n  }\n  return null;\n}\nasync function getChocoPackagesFromMdcPackages(mdcPackages, domainUID) {\n  await _store_index__WEBPACK_IMPORTED_MODULE_3__[\"default\"].dispatch(\"source/fetch\", {\n    domainUID\n  });\n  const filters = await getChocoPackageFilter(_store_index__WEBPACK_IMPORTED_MODULE_3__[\"default\"].state.source.sources, mdcPackages);\n  const chocoPackages = await getChocoPackagesFromFilter(filters);\n  return await mergePackages(mdcPackages, chocoPackages);\n}\nasync function getChocoPackageFromMdcPackage(mdcPackage, domainUID) {\n  await _store_index__WEBPACK_IMPORTED_MODULE_3__[\"default\"].dispatch(\"source/fetch\", {\n    domainUID\n  });\n  const filters = await getChocoPackageFilter(_store_index__WEBPACK_IMPORTED_MODULE_3__[\"default\"].state.source.sources, [mdcPackage]);\n  const chocoRes = await getChocoPackagesFromFilter(filters);\n  const chocoPackages = stripPackages(chocoRes);\n  return chocoPackages[0];\n}\nasync function correctMissingChocoPackages(mdcPackages, chocoPackages) {\n  chocoPackages = [...chocoPackages];\n  const missingPackages = [];\n  const packagesToKeep = [];\n  for (const chocoPackage of chocoPackages) {\n    const missing = mdcPackages.find(x => !isSamePackage(x, chocoPackage, true) && hasSamePackageName(x, chocoPackage, true));\n    if (missing) {\n      missingPackages.push(missing);\n    } else packagesToKeep.push(chocoPackage);\n  }\n  const filters = await getChocoPackageFilter(_store_index__WEBPACK_IMPORTED_MODULE_3__[\"default\"].state.source.sources, missingPackages);\n  const chocoRes = await getChocoPackagesFromFilter(filters);\n  const newChocoPackages = stripPackages(chocoRes);\n  return [...packagesToKeep, ...newChocoPackages];\n}\nfunction stripPackages(packages) {\n  return packages.map(x => ({\n    chocoPackage: x.chocoPackage,\n    source: x.source\n  }));\n}\nfunction removeChocoDuplicates(packages) {\n  return packages.filter((x, index) => packages.findIndex(y => x.chocoPackage.Id === y.chocoPackage.Id && x.chocoPackage.PackageHash === y.chocoPackage.PackageHash && x.source.uid === y.source.uid && x.chocoPackage.Version === x.chocoPackage.Version) === index);\n}\nfunction removeMdcDuplicates(packages) {\n  return packages; //.filter((x, index) => packages.indexOf(x) === index);\n}\n\nfunction getGroup(item) {\n  if (item.groupInfo) {\n    if (item.groupInfo.autoGroup && item.groupInfo.isAutoUpgrade) return item.groupInfo.autoGroup;else if (item.groupInfo.group) return item.groupInfo.group;\n    return null;\n  }\n}\nfunction createChocoPseudoPackageFromMDCPackage(item) {\n  return {\n    chocoPackage: {\n      Id: item.package.name,\n      Title: item.package.name,\n      Version: item.version.version,\n      PackageHash: item.version.packageHash,\n      Pseudo: true\n    }\n  };\n}\n\n//# sourceURL=webpack:///./src/utils/mdc.js?");

/***/ }),

/***/ "./src/utils/order.js":
/*!****************************!*\
  !*** ./src/utils/order.js ***!
  \****************************/
/*! exports provided: normalizeOrder, _order, getReversed, dispatchDomainOrder, dispatchSourceOrder, dispatchComputerOrder, dispatchGroupOrder */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"normalizeOrder\", function() { return normalizeOrder; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"_order\", function() { return _order; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"getReversed\", function() { return getReversed; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"dispatchDomainOrder\", function() { return dispatchDomainOrder; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"dispatchSourceOrder\", function() { return dispatchSourceOrder; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"dispatchComputerOrder\", function() { return dispatchComputerOrder; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"dispatchGroupOrder\", function() { return dispatchGroupOrder; });\n/* harmony import */ var lodash_orderBy__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! lodash/orderBy */ \"./node_modules/lodash/orderBy.js\");\n/* harmony import */ var lodash_orderBy__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(lodash_orderBy__WEBPACK_IMPORTED_MODULE_0__);\n/* harmony import */ var _store_index__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @/store/index */ \"./src/store/index.js\");\n\n\nfunction normalizeOrder(order) {\n  if (!order) order = {};\n  if (!order.path) order.path = \"name\";\n  if (typeof order.path === \"string\") order.path = [order.path];\n  return order;\n}\nfunction _order(items, order) {\n  if (items) {\n    order = normalizeOrder({\n      ...order\n    });\n    return lodash_orderBy__WEBPACK_IMPORTED_MODULE_0___default()([...items], order.path, [order.reversed ? \"desc\" : \"asc\"]);\n  } else return [];\n}\nfunction getReversed(stateOrder, order) {\n  order = normalizeOrder(order);\n  stateOrder = normalizeOrder(stateOrder);\n  if (hasMultiple(order.path) && hasSame(stateOrder.path, order.path) && !stateOrder.reversed) {\n    if (getValue(stateOrder.path) === getValue(order.path)) {\n      order.path = order.path.reverse();\n    } else if (getValue(stateOrder.path) !== getValue(order.path)) {\n      order.reversed = !stateOrder.reversed;\n    }\n    return order;\n  } else if (getValue(stateOrder.path) === getValue(order.path)) {\n    order.reversed = !stateOrder.reversed;\n    return order;\n  } else return order;\n}\nfunction hasSame(obj, obj2) {\n  return obj.filter(x => obj2.some(y => y === x)).length === obj.length;\n}\nfunction hasMultiple(obj) {\n  return typeof obj === \"object\" && obj.length > 1;\n}\nfunction getValue(obj) {\n  if (typeof obj === \"object\") return obj[0];else return obj;\n}\nfunction dispatchDomainOrder(path, reversed) {\n  _store_index__WEBPACK_IMPORTED_MODULE_1__[\"default\"].dispatch(\"domain/order\", {\n    path: path,\n    reversed: !!reversed\n  });\n}\nfunction dispatchSourceOrder(path, reversed) {\n  _store_index__WEBPACK_IMPORTED_MODULE_1__[\"default\"].dispatch(\"source/order\", {\n    path: path,\n    reversed: !!reversed\n  });\n}\nfunction dispatchComputerOrder(path, reversed) {\n  _store_index__WEBPACK_IMPORTED_MODULE_1__[\"default\"].dispatch(\"computer/order\", {\n    path: path,\n    reversed: !!reversed\n  });\n}\nfunction dispatchGroupOrder(path, reversed) {\n  _store_index__WEBPACK_IMPORTED_MODULE_1__[\"default\"].dispatch(\"group/order\", {\n    path: path,\n    reversed: !!reversed\n  });\n}\n\n//# sourceURL=webpack:///./src/utils/order.js?");

/***/ }),

/***/ "./src/utils/packageDate.js":
/*!**********************************!*\
  !*** ./src/utils/packageDate.js ***!
  \**********************************/
/*! exports provided: isScheduleValid, objectifySchedule, default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"isScheduleValid\", function() { return isScheduleValid; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"objectifySchedule\", function() { return objectifySchedule; });\nfunction isScheduleValid(schedule) {\n  return schedule && validateDate(schedule.startDate) && validateDate(schedule.endDate) && validateDate(schedule.startTime) && validateDate(schedule.endTime) && schedule.repeatWeekDays;\n}\nfunction validateDate(date) {\n  try {\n    if (date) {\n      if (typeof date == \"object\") date = date.toISOString();\n      const regex = /^\\d{4}(-\\d\\d(-\\d\\d(T\\d\\d:\\d\\d(:\\d\\d)?(\\.\\d+)?(([+-]\\d\\d:\\d\\d)|Z)?)?)?)?$/i;\n      return regex.test(date);\n    }\n  } catch (ex) {\n    console.log(ex);\n  }\n  return false;\n}\nfunction objectifySchedule(schedule) {\n  const copy = {\n    ...schedule\n  };\n  copy.startDate = convertToDate(copy.startDate);\n  copy.endDate = convertToDate(copy.endDate);\n  copy.startTime = convertToDate(copy.startTime);\n  copy.endTime = convertToDate(copy.endTime);\n  return copy;\n}\nfunction convertToDate(dateStr) {\n  if (dateStr) {\n    return new Date(dateStr);\n  }\n  return null;\n}\n/* harmony default export */ __webpack_exports__[\"default\"] = ({\n  isScheduleValid,\n  objectifySchedule\n});\n\n//# sourceURL=webpack:///./src/utils/packageDate.js?");

/***/ }),

/***/ "./src/utils/packageNotice.js":
/*!************************************!*\
  !*** ./src/utils/packageNotice.js ***!
  \************************************/
/*! exports provided: packageNotice, notify */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"packageNotice\", function() { return packageNotice; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"notify\", function() { return notify; });\n/* harmony import */ var vue__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! vue */ \"./node_modules/vue/dist/vue.runtime.esm.js\");\n/* harmony import */ var _mdc__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./mdc */ \"./src/utils/mdc.js\");\n/* harmony import */ var _store__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @/store */ \"./src/store/index.js\");\n\n\n\nasync function packageNotice(item) {\n  if (_store__WEBPACK_IMPORTED_MODULE_2__[\"default\"].state.settings.user.profile && _store__WEBPACK_IMPORTED_MODULE_2__[\"default\"].state.settings.user.profile.notifications && _store__WEBPACK_IMPORTED_MODULE_2__[\"default\"].state.settings.user.profile.notifications.packageChange) {\n    const {\n      title,\n      version\n    } = Object(_mdc__WEBPACK_IMPORTED_MODULE_1__[\"getPackageNameVersionAndHash\"])(item);\n    const versionStr = ` - ${version}`;\n    if (item.command.status === \"done\" && item.command.name === \"install\") {\n      notify(`${title} ${versionStr}`, \"Installation was successful.\", \"success\");\n    }\n    if (item.command.status === \"done\" && item.command.name === \"upgrade\") {\n      notify(`${title} ${versionStr}`, \"Upgrade was successful.\");\n    } else if (item.command.status === \"done\" && item.command.name === \"uninstall\") {\n      notify(`${title} ${versionStr}`, \"Uninstallation was successful.\", \"success\");\n    } else if (item.command.status === \"working\" && item.command.name === \"install\") {\n      notify(`${title} ${versionStr}`, \"Installation has started.\", \"info\");\n    } else if (item.command.status === \"working\" && item.command.name === \"upgrade\") {\n      notify(`${title} ${versionStr}`, \"Upgrade has started.\", \"info\");\n    } else if (item.command.status === \"working\" && item.command.name === \"uninstall\") {\n      notify(`${title} ${versionStr}`, \"Uninstallation has started.\", \"info\");\n    } else if (item.command.status === \"failed.\" && item.command.name === \"uninstall\") {\n      notify(`${title} ${versionStr}`, \"Uninstallation failed.\", \"danger\", 0);\n    } else if (item.command.status === \"failed.\" && item.command.name === \"install\") {\n      notify(`${title} ${versionStr}`, \"Installation failed.\", \"danger\", 0);\n    } else if (item.command.status === \"failed.\" && item.command.name === \"upgrade\") {\n      notify(`${title} ${versionStr}`, \"Upgrade failed.\", \"danger\", 0);\n    }\n  }\n}\nfunction notify(title, text, type, duration, speed) {\n  vue__WEBPACK_IMPORTED_MODULE_0__[\"default\"].notify({\n    group: \"all\",\n    title: title || \"\",\n    text: text || \"\",\n    duration: duration || 10000,\n    speed: speed || 200,\n    type: type || \"success\"\n  });\n}\n\n//# sourceURL=webpack:///./src/utils/packageNotice.js?");

/***/ }),

/***/ "./src/utils/packageOdata.js":
/*!***********************************!*\
  !*** ./src/utils/packageOdata.js ***!
  \***********************************/
/*! exports provided: getPackageSearchString, default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"getPackageSearchString\", function() { return getPackageSearchString; });\nfunction getSearchString(searchText, includePrerelease, skip, top) {\n  searchText = searchText.toLowerCase().trim();\n  if (!skip) skip = 0;\n  if (!top) top = 15;\n  let filter = \"IsLatestVersion\";\n  if (includePrerelease) filter = \"IsAbsoluteLatestVersion\";\n  return `Search()?$filter=${filter}&searchTerm='${searchText}'&targetFramework=''&includePrerelease=${includePrerelease}&$skip=${skip}&$top=${top}&semVerLevel=2.0.0&$orderby=DownloadCount%20desc`;\n}\nfunction getLatestPackagesString(top, includePrerelease) {\n  if (!top) top = 10;\n  let filter = \"IsLatestVersion\";\n  if (includePrerelease) filter = \"IsAbsoluteLatestVersion\";\n  return `Packages?$top=${top}&$filter=${filter}&includePrerelease=${includePrerelease}&$orderby=DownloadCount%20desc`;\n}\nfunction getPackageSearchString(name, top, skip) {\n  return `Packages?$filter=Id%20eq%20%27${name}%27&$orderby=Published%20desc&$top=${top}&$skip=${skip}`;\n}\nconst STRICT_FILTER_BASE_STRING = `Packages?$filter=`;\n/* harmony default export */ __webpack_exports__[\"default\"] = ({\n  getSearchString,\n  getLatestPackagesString,\n  getPackageSearchString,\n  STRICT_FILTER_BASE_STRING\n});\n\n//# sourceURL=webpack:///./src/utils/packageOdata.js?");

/***/ }),

/***/ "./src/utils/packageOrder.js":
/*!***********************************!*\
  !*** ./src/utils/packageOrder.js ***!
  \***********************************/
/*! exports provided: orderPackages, dispatchOrder, dispatchGroupOrder */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"orderPackages\", function() { return orderPackages; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"dispatchOrder\", function() { return dispatchOrder; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"dispatchGroupOrder\", function() { return dispatchGroupOrder; });\n/* harmony import */ var lodash_orderBy__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! lodash/orderBy */ \"./node_modules/lodash/orderBy.js\");\n/* harmony import */ var lodash_orderBy__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(lodash_orderBy__WEBPACK_IMPORTED_MODULE_0__);\n/* harmony import */ var lodash_get__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! lodash/get */ \"./node_modules/lodash/get.js\");\n/* harmony import */ var lodash_get__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(lodash_get__WEBPACK_IMPORTED_MODULE_1__);\n/* harmony import */ var lodash_flatten__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! lodash/flatten */ \"./node_modules/lodash/flatten.js\");\n/* harmony import */ var lodash_flatten__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(lodash_flatten__WEBPACK_IMPORTED_MODULE_2__);\n/* harmony import */ var _store_index__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @/store/index */ \"./src/store/index.js\");\n/* harmony import */ var _utils_packages__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @/utils/packages */ \"./src/utils/packages.js\");\n/* harmony import */ var _order__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./order */ \"./src/utils/order.js\");\n\n\n\n\n\n\nasync function orderPackages(packagesObj, orderObject) {\n  orderObject = Object(_order__WEBPACK_IMPORTED_MODULE_5__[\"normalizeOrder\"])(orderObject);\n  const isArray = Array.isArray(packagesObj);\n  const orderedPackages = lodash_flatten__WEBPACK_IMPORTED_MODULE_2___default()(lodash_orderBy__WEBPACK_IMPORTED_MODULE_0___default()(packagesObj, [p => lodash_get__WEBPACK_IMPORTED_MODULE_1___default()(isArray ? p : p.find(p => p.selected), ...orderObject.path)], [orderObject.reversed ? \"desc\" : \"asc\"]));\n  if (isArray) return orderedPackages;else return await Object(_utils_packages__WEBPACK_IMPORTED_MODULE_4__[\"transformPackages\"])(orderedPackages);\n}\nfunction dispatchOrder(path, reversed) {\n  _store_index__WEBPACK_IMPORTED_MODULE_3__[\"default\"].dispatch(\"computerPackage/orderMergedPackages\", {\n    path: path,\n    reversed: !!reversed\n  });\n}\nfunction dispatchGroupOrder(path, reversed) {\n  _store_index__WEBPACK_IMPORTED_MODULE_3__[\"default\"].dispatch(\"groupPackage/orderMergedPackages\", {\n    path: path,\n    reversed: !!reversed\n  });\n}\n\n//# sourceURL=webpack:///./src/utils/packageOrder.js?");

/***/ }),

/***/ "./src/utils/packages.js":
/*!*******************************!*\
  !*** ./src/utils/packages.js ***!
  \*******************************/
/*! exports provided: getAllPackageVersions, getAllMdcPackageVersions, getAllMdcGroupPackageVersions, orderByVersion, compareVersions, getPackage, getNewestPackage, addTempParam, removeParam, findParam, transformPackages, formatPackage, upgradable, getAllMdcVersionsFn, getAllMdcVersions */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"getAllPackageVersions\", function() { return getAllPackageVersions; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"getAllMdcPackageVersions\", function() { return getAllMdcPackageVersions; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"getAllMdcGroupPackageVersions\", function() { return getAllMdcGroupPackageVersions; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"orderByVersion\", function() { return orderByVersion; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"compareVersions\", function() { return compareVersions; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"getPackage\", function() { return getPackage; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"getNewestPackage\", function() { return getNewestPackage; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"addTempParam\", function() { return addTempParam; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"removeParam\", function() { return removeParam; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"findParam\", function() { return findParam; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"transformPackages\", function() { return transformPackages; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"formatPackage\", function() { return formatPackage; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"upgradable\", function() { return upgradable; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"getAllMdcVersionsFn\", function() { return getAllMdcVersionsFn; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"getAllMdcVersions\", function() { return getAllMdcVersions; });\n/* harmony import */ var _utils_http__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @/utils/http */ \"./src/utils/http.js\");\n/* harmony import */ var _utils_packageDate__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @/utils/packageDate */ \"./src/utils/packageDate.js\");\n/* harmony import */ var _utils_packageOdata__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @/utils/packageOdata */ \"./src/utils/packageOdata.js\");\n/* harmony import */ var _utils_mdc__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @/utils/mdc */ \"./src/utils/mdc.js\");\n/* harmony import */ var _store_index__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @/store/index */ \"./src/store/index.js\");\n\n\n\n\n\nasync function getAllPackageVersions(items, item) {\n  items = JSON.parse(JSON.stringify(items));\n  let selectFirstPackage = false;\n  const {\n    name,\n    uid\n  } = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_3__[\"getPackageNameVersionAndHash\"])(item);\n  const visibleAndSelectedLength = items.filter(x => x.visible || x.selected).length;\n  const existing = items.find(x => Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_3__[\"isSamePackage\"])(x, item));\n  if (existing) {\n    existing.stats = item.stats;\n    existing.selected = true;\n    existing.visible = true;\n  } else selectFirstPackage = true;\n  const chocoResult = await Object(_utils_http__WEBPACK_IMPORTED_MODULE_0__[\"postApi\"])(\"choco/packages\", {\n    query: Object(_utils_packageOdata__WEBPACK_IMPORTED_MODULE_2__[\"getPackageSearchString\"])(name, 10, visibleAndSelectedLength == 1 ? 0 : visibleAndSelectedLength),\n    source: Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_3__[\"formSource\"])(item.source)\n  });\n  if (chocoResult && chocoResult.packages && chocoResult.packages.length !== 0) {\n    const chocoPackages = chocoResult.packages;\n    if (selectFirstPackage && chocoPackages.length !== 0) {\n      chocoPackages[0].selected = true;\n    }\n    const toAdd = [];\n    for (const chocoItem of chocoPackages) {\n      const existingPackage = items.find(x => Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_3__[\"isSamePackage\"])(x, chocoItem));\n      if (!existingPackage) {\n        chocoItem.visible = true;\n        toAdd.push(chocoItem);\n      } else {\n        existingPackage.visible = true;\n        existingPackage.chocoPackage = chocoItem.chocoPackage;\n      }\n    }\n    items.push(...toAdd);\n  }\n  return orderByVersion(items);\n}\nasync function getAllMdcPackageVersions(computerUID, domainUID, p) {\n  const {\n    name,\n    uid\n  } = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_3__[\"getPackageNameVersionAndHash\"])(p);\n  const res = await Object(_utils_http__WEBPACK_IMPORTED_MODULE_0__[\"postApi\"])(\"get/computerPackageAllVersions\", {\n    computerUIDs: [computerUID],\n    domainUID: domainUID,\n    sourceUID: uid,\n    name: name\n  });\n  return res[0].packages;\n}\nasync function getAllMdcGroupPackageVersions(groupUID, domainUID, p) {\n  const {\n    name,\n    uid\n  } = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_3__[\"getPackageNameVersionAndHash\"])(p);\n  const res = await Object(_utils_http__WEBPACK_IMPORTED_MODULE_0__[\"postApi\"])(\"get/groupPackageAllVersions\", {\n    groupUID: groupUID,\n    domainUID: domainUID,\n    sourceUID: uid,\n    name: name\n  });\n  return res[0];\n}\nfunction orderByVersion(packages) {\n  return packages.sort((p1, p2) => {\n    const {\n      version: v1\n    } = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_3__[\"getPackageNameVersionAndHash\"])(p1);\n    const {\n      version: v2\n    } = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_3__[\"getPackageNameVersionAndHash\"])(p2);\n    return compareVersions(v2, v1);\n  });\n}\nfunction compareVersions(a, b) {\n  let i, diff;\n  let regExStrip0 = /(\\.0+)+$/;\n  let segmentsA = a.replace(regExStrip0, \"\").split(\".\");\n  let segmentsB = b.replace(regExStrip0, \"\").split(\".\");\n  let l = Math.min(segmentsA.length, segmentsB.length);\n  for (i = 0; i < l; i++) {\n    diff = parseInt(segmentsA[i], 10) - parseInt(segmentsB[i], 10);\n    if (diff) return diff;\n  }\n  return segmentsA.length - segmentsB.length;\n}\nfunction getPackage(item, otherVersionItem) {\n  const itemCopy = {\n    ...item\n  };\n  if (itemCopy.otherVersions) {\n    const existingPackage = itemCopy.otherVersions.find(x => Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_3__[\"isSamePackage\"])(x, itemCopy));\n    if (existingPackage) {\n      existingPackage.version = itemCopy.version;\n      existingPackage.package = itemCopy.package;\n      existingPackage.command = itemCopy.command;\n      existingPackage.chocoPackage = itemCopy.chocoPackage;\n      existingPackage.groupInfo = itemCopy.groupInfo;\n      existingPackage.upgradable = itemCopy.upgradable;\n    }\n  }\n  itemCopy.version = otherVersionItem.version;\n  itemCopy.package = otherVersionItem.package;\n  itemCopy.command = otherVersionItem.command;\n  itemCopy.chocoPackage = otherVersionItem.chocoPackage;\n  itemCopy.groupInfo = otherVersionItem.groupInfo;\n  itemCopy.upgradable = false;\n  const newestPackage = getNewestPackage(itemCopy.otherVersions, itemCopy);\n  if (newestPackage) {\n    const versionResult = compareVersions(itemCopy.chocoPackage.Version, newestPackage.chocoPackage.Version);\n    if (versionResult > 0) {\n      itemCopy.upgradable = true;\n    }\n  }\n  itemCopy.showVersions = false;\n  return itemCopy;\n}\nfunction getNewestPackage(packages, item) {\n  let newest = null;\n  const {\n    name\n  } = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_3__[\"getPackageNameVersionAndHash\"])(item);\n  const filtered = packages.filter(x => x.package.name === name && x.command.name !== \"uninstall\" && x.command.status !== \"failed\" && x.version.version !== \"\" && x.source.uid === item.source.uid);\n  if (filtered && filtered.length > 0) {\n    newest = filtered[0];\n  }\n  let i = filtered.length;\n  while (i--) {\n    const currItem = filtered[i];\n    if (newest && newest.version && newest.version.version && currItem.version && currItem.version.version) {\n      const result = compareVersions(newest.version.version, currItem.version.version);\n      if (result < 0) {\n        newest = currItem;\n      }\n    }\n  }\n  return newest;\n}\nfunction addTempParam(params, param) {\n  if (param.includes(\"|\")) param = param.replace(\"|\", \"\");\n  if (!params) params = \"\";\n  var arr = params.split(\"|\");\n  if (!arr.some(x => x.trim() === param)) arr.push(param);else arr.splice(arr.indexOf(param), 1);\n  return arr.filter(x => x && x !== \"\").join(\"|\");\n}\nfunction removeParam(params, param) {\n  if (params && params != \"\") {\n    if (param.includes(\"|\")) param = param.replace(\"|\", \"\");\n    param = param.trim();\n    var arr = params.split(\"|\");\n    return arr.filter(x => x && x.trim() !== param).join(\"|\");\n  }\n}\nfunction findParam(params, param) {\n  if (params) {\n    if (param.includes(\"|\")) param = param.replace(\"|\", \"\");\n    param = param.trim();\n    var arr = params.split(\"|\");\n    return arr.find(x => x.trim().startsWith(param));\n  }\n  return null;\n}\nasync function transformPackages(packages) {\n  let packageInfos = packages.map(x => Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_3__[\"getPackageNameVersionAndHash\"])(x));\n  packageInfos = [...new Set(packageInfos)];\n  const promiseArr = [];\n  const toReturn = {};\n  for (let i = 0; i < packageInfos.length; i++) {\n    let promise = new Promise(resolve => {\n      const name = packageInfos[i].name;\n      const uid = packageInfos[i].uid;\n      const filteredPackages = packages.filter(x => {\n        const info = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_3__[\"getPackageNameVersionAndHash\"])(x);\n        return info.name === name && info.uid === uid;\n      });\n      toReturn[name + uid] = filteredPackages;\n      resolve();\n    });\n    promiseArr.push(promise);\n  }\n  await Promise.all(promiseArr);\n  return toReturn;\n}\nfunction formatPackage(item, action) {\n  const {\n    hash,\n    version,\n    name\n  } = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_3__[\"getPackageNameVersionAndHash\"])(item);\n  const schedule = {\n    ...item.tempSchedule\n  };\n  const command = {\n    ...item.tempCommand\n  };\n  if (!Object(_utils_packageDate__WEBPACK_IMPORTED_MODULE_1__[\"isScheduleValid\"])(schedule)) {\n    schedule.startDate = null;\n    schedule.endDate = null;\n    schedule.startTime = null;\n    schedule.endTime = null;\n    schedule.type = 0;\n  } else {\n    schedule.startDate = schedule.startDate.toISOString();\n    schedule.endDate = schedule.endDate.toISOString();\n    schedule.startTime = schedule.startTime.toISOString();\n    schedule.endTime = schedule.endTime.toISOString();\n  }\n  command.execStart = \"\";\n  command.execDone = \"\";\n  command.execLog = \"\";\n  command.execUser = \"\";\n  command.name = action;\n  command.status = \"pending\";\n  command.added = new Date().toISOString();\n  return {\n    schedule: schedule,\n    command: command,\n    version: {\n      version: version,\n      packageHash: hash\n    },\n    package: {\n      name: name\n    },\n    source: item.source\n  };\n}\nfunction upgradable(packages, p) {\n  const newestPackage = getNewestPackage(packages, p);\n  if (newestPackage) {\n    const {\n      version: newestVersion\n    } = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_3__[\"getPackageNameVersionAndHash\"])(newestPackage);\n    const {\n      version: pVersion\n    } = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_3__[\"getPackageNameVersionAndHash\"])(p);\n    return compareVersions(pVersion, newestVersion) > 0;\n  }\n  return false;\n}\nfunction getAllMdcVersionsFn(p, isGroup, params) {\n  if (isGroup) {\n    return () => getAllMdcGroupPackageVersions(params.groupUID, params.domainUID, p);\n  } else {\n    return () => getAllMdcPackageVersions(params.computerUID, params.domainUID, p);\n  }\n}\nasync function getAllMdcVersions(p, storeState, fn) {\n  const {\n    name,\n    uid\n  } = Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_3__[\"getPackageNameVersionAndHash\"])(p);\n  if (!_store_index__WEBPACK_IMPORTED_MODULE_4__[\"default\"].state[storeState].fullyLoadedPackages[name + uid]) {\n    const allPackages = (await fn()).filter(x => !_store_index__WEBPACK_IMPORTED_MODULE_4__[\"default\"].state[storeState].mergedPackages[name + uid].some(y => Object(_utils_mdc__WEBPACK_IMPORTED_MODULE_3__[\"isSamePackage\"])(x, y)));\n    allPackages.push(p);\n    return allPackages;\n  }\n}\n\n//# sourceURL=webpack:///./src/utils/packages.js?");

/***/ }),

/***/ "./src/utils/powershell.js":
/*!*********************************!*\
  !*** ./src/utils/powershell.js ***!
  \*********************************/
/*! exports provided: handlePowershellEvent */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"handlePowershellEvent\", function() { return handlePowershellEvent; });\n/* harmony import */ var _store__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @/store */ \"./src/store/index.js\");\n/* harmony import */ var _utils_document__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @/utils/document */ \"./src/utils/document.js\");\n\n\nfunction handlePowershellEvent(data) {\n  if (data.line.status == \"end\") {\n    _store__WEBPACK_IMPORTED_MODULE_0__[\"default\"].commit(\"powershell/setStatus\", {\n      complete: true,\n      terminating: false\n    });\n  } else if (data.line.status == \"noperm\") {\n    _store__WEBPACK_IMPORTED_MODULE_0__[\"default\"].commit(\"powershell/setStatus\", {\n      complete: true,\n      terminating: false\n    });\n  }\n  _store__WEBPACK_IMPORTED_MODULE_0__[\"default\"].commit(\"powershell/addLine\", data.line);\n  if (data.line.status === \"end\") {\n    Object(_utils_document__WEBPACK_IMPORTED_MODULE_1__[\"scrollToEnd\"])(\"pre-powershell\");\n    Object(_utils_document__WEBPACK_IMPORTED_MODULE_1__[\"focus\"])(\"input-powershell\");\n    setTimeout(() => Object(_utils_document__WEBPACK_IMPORTED_MODULE_1__[\"select\"])(\"input-powershell\"), 10);\n  }\n}\n\n//# sourceURL=webpack:///./src/utils/powershell.js?");

/***/ }),

/***/ "./src/utils/settings.js":
/*!*******************************!*\
  !*** ./src/utils/settings.js ***!
  \*******************************/
/*! exports provided: appBaseUrl, feedBaseUrl, packageBaseUrl, baseUrl */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"appBaseUrl\", function() { return appBaseUrl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"feedBaseUrl\", function() { return feedBaseUrl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"packageBaseUrl\", function() { return packageBaseUrl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"baseUrl\", function() { return baseUrl; });\nconst protocol = `${location.protocol}//`;\nconst domain = window.location.hostname.replace(\"app.\", \"\");\nlet baseUrl = `${protocol}api.${domain}`;\nif (window.location.hostname.includes(\"localhost\")) {\n  baseUrl = \"http://\" + window.location.hostname;\n}\nif (Object({\"NODE_ENV\":\"development\",\"BASE_URL\":\"/\"}).VUE_APP_STAGE == \"dev\") baseUrl += \":8181\";\nconst appBaseUrl = baseUrl;\nconst feedBaseUrl = `${baseUrl}/feed`;\nconst packageBaseUrl = `${baseUrl}/package`;\n\n\n//# sourceURL=webpack:///./src/utils/settings.js?");

/***/ }),

/***/ "./src/utils/socket.js":
/*!*****************************!*\
  !*** ./src/utils/socket.js ***!
  \*****************************/
/*! exports provided: instance, connect, disconnect, sendPowershellCommand, send, requestLog, requestGroupPackagesUpdate, disconnectComputers, cancelGroupPackageSchedule, cancelPackageSchedule, sendPackages */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"instance\", function() { return instance; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"connect\", function() { return connect; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"disconnect\", function() { return disconnect; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"sendPowershellCommand\", function() { return sendPowershellCommand; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"send\", function() { return send; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"requestLog\", function() { return requestLog; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"requestGroupPackagesUpdate\", function() { return requestGroupPackagesUpdate; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"disconnectComputers\", function() { return disconnectComputers; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"cancelGroupPackageSchedule\", function() { return cancelGroupPackageSchedule; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"cancelPackageSchedule\", function() { return cancelPackageSchedule; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"sendPackages\", function() { return sendPackages; });\n/* harmony import */ var _utils_http__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @/utils/http */ \"./src/utils/http.js\");\n/* harmony import */ var _settings__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./settings */ \"./src/utils/settings.js\");\n/* harmony import */ var _router__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @/router */ \"./src/router/index.js\");\n/* harmony import */ var _store__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @/store */ \"./src/store/index.js\");\n/* harmony import */ var socket_io_client__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! socket.io-client */ \"./node_modules/socket.io-client/lib/index.js\");\n/* harmony import */ var socket_io_client__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(socket_io_client__WEBPACK_IMPORTED_MODULE_4__);\n/* harmony import */ var _utils_packageNotice__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @/utils/packageNotice */ \"./src/utils/packageNotice.js\");\n/* harmony import */ var _utils_computerNotice__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @/utils/computerNotice */ \"./src/utils/computerNotice.js\");\n/* harmony import */ var _utils_powershell__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @/utils/powershell */ \"./src/utils/powershell.js\");\n/* harmony import */ var _mdc__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./mdc */ \"./src/utils/mdc.js\");\n/* harmony import */ var _utils_document__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @/utils/document */ \"./src/utils/document.js\");\n/* harmony import */ var _utils_groupPackage__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @/utils/groupPackage */ \"./src/utils/groupPackage.js\");\n\n\n\n\n\n\n\n\n\n\n\nlet instance = null;\nasync function connect(domain) {\n  try {\n    if (shouldDisconnect()) {\n      if (_store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].state.socket.connected && instance) {\n        disconnect();\n      }\n    }\n    if (shouldConnect(domain)) {\n      _store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].commit(\"socket/setConnecting\", true);\n      if (!domain) {\n        await _store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].dispatch(\"domain/fetch\");\n        domain = _store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].state.domain.domains.find(x => x.uid === _router__WEBPACK_IMPORTED_MODULE_2__[\"default\"].currentRoute.params.domainUID);\n      }\n      _store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].commit(\"socket/setDomain\", domain);\n      const authRes = await Object(_utils_http__WEBPACK_IMPORTED_MODULE_0__[\"postApi\"])(\"get/userSocketToken\", {});\n      const authData = authRes[0];\n      const {\n        sessionId,\n        token\n      } = authData;\n      instance = socket_io_client__WEBPACK_IMPORTED_MODULE_4___default()(_settings__WEBPACK_IMPORTED_MODULE_1__[\"baseUrl\"], {\n        ignoreServerCertificateValidation: false,\n        query: `userUID=${_store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].state.auth.user.userUID}&sessionId=${sessionId}&token=${token}&domainKey=${domain.key}`,\n        reconnection: false,\n        forceNew: false\n      });\n\n      // store.commit(\n      //   \"socket/setInstance\",\n      //   Object.freeze(\n      //     io(baseUrl, {\n      //       ignoreServerCertificateValidation: false,\n      //       query: `userUID=${store.state.auth.user.userUID}&sessionId=${sessionId}&token=${token}&domainKey=${domain.key}`,\n      //       reconnection: false,\n      //       forceNew: false,\n      //     })\n      //   )\n      // );\n\n      setEvents();\n      _store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].commit(\"socket/setConnecting\", false);\n    }\n  } catch (err) {\n    _store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].commit(\"socket/setConnecting\", false);\n    console.error(err);\n    await wait(5000);\n    connect();\n  }\n}\nfunction disconnect() {\n  if (_store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].state.socket.connected && instance) {\n    _store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].commit(\"socket/setReconnect\", false);\n    instance.disconnect();\n  }\n}\nfunction shouldConnect(domain) {\n  return domain || !_store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].state.socket.connected && !_store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].state.socket.connecting && _router__WEBPACK_IMPORTED_MODULE_2__[\"default\"].currentRoute.params.domainUID;\n}\nfunction shouldDisconnect() {\n  return _store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].state.socket.domain && _store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].state.socket.domain.uid !== _router__WEBPACK_IMPORTED_MODULE_2__[\"default\"].currentRoute.params.domainUID || !_router__WEBPACK_IMPORTED_MODULE_2__[\"default\"].currentRoute.params.domainUID;\n}\nfunction wait(time) {\n  return new Promise(resolve => {\n    setTimeout(() => {\n      resolve();\n    }, time);\n  });\n}\nfunction setEvents() {\n  setEvent(\"psStream\", data => {\n    //console.log(\"psStream\", data);\n\n    if (_store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].state.powershell.computerUID === data.computerUID) {\n      Object(_utils_powershell__WEBPACK_IMPORTED_MODULE_7__[\"handlePowershellEvent\"])(data);\n    }\n  });\n  setEvent(\"packageExecLog\", data => {\n    if (data && data.computerUID) {\n      if (_router__WEBPACK_IMPORTED_MODULE_2__[\"default\"].currentRoute.params.computerUID == data.computerUID) {\n        const existing = _store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].getters[\"computerPackage/mergedPackage\"]({\n          package: {\n            name: data.id\n          },\n          version: {\n            version: data.version\n          },\n          source: {\n            uid: data.sourceUID\n          }\n        });\n        if (existing) {\n          if (existing.command.execLog) existing.command.execLog += \"\\n\" + data.execLog;\n          if (!existing.command.execLog) existing.command.execLog = data.execLog;\n          _store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].commit(\"computerPackage/mergeMergedPackage\", existing);\n          setTimeout(() => {\n            Object(_utils_document__WEBPACK_IMPORTED_MODULE_9__[\"scrollToEnd\"])(\"modal-body\");\n          }, 50);\n        }\n      }\n    }\n  });\n  setEvent(\"systemInfoChange\", data => {\n    //console.log(\"systemInfoChange\", data);\n    if (data && _router__WEBPACK_IMPORTED_MODULE_2__[\"default\"].currentRoute.params.domainUID && _router__WEBPACK_IMPORTED_MODULE_2__[\"default\"].currentRoute.params.domainUID === _store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].state.computer.domainUID) {\n      _store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].dispatch(\"computer/mergeComputer\", {\n        c: data,\n        obj: data,\n        domainUID: _store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].state.computer.domainUID\n      });\n    }\n  });\n  setEvent(\"computerChange\", data => {\n    //console.log(\"computerChange\", data);\n\n    if (data && _router__WEBPACK_IMPORTED_MODULE_2__[\"default\"].currentRoute.params.domainUID && _router__WEBPACK_IMPORTED_MODULE_2__[\"default\"].currentRoute.params.domainUID === _store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].state.computer.domainUID) {\n      if (data && data.uid) {\n        Object(_utils_computerNotice__WEBPACK_IMPORTED_MODULE_6__[\"computerNotice\"])(data);\n      }\n      _store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].dispatch(\"computer/mergeComputer\", {\n        c: data,\n        obj: data,\n        domainUID: _store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].state.computer.domainUID\n      });\n    }\n  });\n  setEvent(\"packageChange\", async data => {\n    //console.log(\"packageChange\", data);\n    if (_router__WEBPACK_IMPORTED_MODULE_2__[\"default\"].currentRoute.params.computerUID && data.computerUIDs.some(x => x === _router__WEBPACK_IMPORTED_MODULE_2__[\"default\"].currentRoute.params.computerUID)) {\n      handleComputerPackageChange(data);\n    } else if (_router__WEBPACK_IMPORTED_MODULE_2__[\"default\"].currentRoute.params.groupUID) {\n      handleGroupPackageChange(data);\n    }\n  });\n  setEvent(\"connect\", () => {\n    _store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].commit(\"socket/setConnected\", true);\n    console.log(\"connected\");\n  });\n  setEvent(\"disconnect\", async () => {\n    console.log(\"disconnected\");\n    _store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].commit(\"socket/setConnected\", false);\n    if (_store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].state.socket.reconnect) {\n      await wait(3000);\n      console.log(\"reconnecting\");\n      connect();\n    }\n  });\n}\nfunction sendPowershellCommand(computerUID, command) {\n  if (_store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].state.socket.connected) {\n    instance.emit(\"psCommand\", {\n      computerUID: computerUID,\n      command\n    });\n    return true;\n  }\n  return false;\n}\nfunction send(event, data) {\n  if (!_store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].state.socket.connected) return false;\n  instance.emit(event, data);\n  return true;\n}\nfunction requestLog(computerUIDs) {\n  if (_store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].state.socket.connected) {\n    instance.emit(\"command\", {\n      computerUIDs: computerUIDs,\n      name: \"request\",\n      eventString: \"logRequest\"\n    });\n    return true;\n  }\n  return false;\n}\nfunction requestGroupPackagesUpdate(groupUID, computerUIDs) {\n  if (_store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].state.socket.connected) {\n    instance.emit(\"command\", {\n      computerUIDs: computerUIDs,\n      groupUID: groupUID,\n      name: \"send\",\n      queryName: \"computerGroupPackages\",\n      eventString: \"packageChange\"\n    });\n    return true;\n  }\n  return false;\n}\nfunction disconnectComputers(computerUIDs) {\n  if (_store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].state.socket.connected) {\n    instance.emit(\"command\", {\n      computerUIDs: computerUIDs,\n      name: \"disconnect\"\n    });\n    return true;\n  } else return false;\n}\nfunction cancelGroupPackageSchedule(groupUID, computerUIDs) {\n  if (_store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].state.socket.connected) {\n    instance.emit(\"command\", {\n      computerUIDs: computerUIDs,\n      groupUID: groupUID,\n      name: \"send\",\n      queryName: \"computerGroupPackages\",\n      eventString: \"cancelPackageSchedule\"\n    });\n    return true;\n  } else return false;\n}\nfunction cancelPackageSchedule(packages, computerUIDs) {\n  if (_store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].state.socket.connected) {\n    instance.emit(\"cancelPackageSchedule\", {\n      computerUIDs,\n      packages\n    });\n    return true;\n  } else return false;\n}\nasync function getChocoPackage(existingMergedPackage, mdcPackage) {\n  const p = {\n    ...mdcPackage\n  };\n  if (!existingMergedPackage || !existingMergedPackage.chocoPackage || !existingMergedPackage.chocoPackage.Id) {\n    const chocoPackage = await Object(_mdc__WEBPACK_IMPORTED_MODULE_8__[\"getChocoPackageFromMdcPackage\"])(p, _router__WEBPACK_IMPORTED_MODULE_2__[\"default\"].currentRoute.params.domainUID);\n    if (chocoPackage) p.chocoPackage = chocoPackage.chocoPackage;else console.error(\"choco package was not found\");\n  } else p.chocoPackage = existingMergedPackage.chocoPackage;\n  return p;\n}\nfunction setEvent(event, fn) {\n  instance.on(event, fn);\n  //store.commit(\"socket/setEvent\", { event: event, fn: fn });\n}\n\nasync function handleComputerPackageChange(data) {\n  for (const p of data.packages) {\n    _store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].commit(\"computerPackage/mergeMdcPackage\", p);\n    _store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].dispatch(\"infobar/checkAndSetPackage\", p);\n    const {\n      name,\n      uid\n    } = Object(_mdc__WEBPACK_IMPORTED_MODULE_8__[\"getPackageNameVersionAndHash\"])(p);\n    const existingPackages = _store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].state.computerPackage.mergedPackages[name + uid];\n    if (!existingPackages || existingPackages.filter(x => x.visible || x.selected).length === 0) {\n      const mergedPackage = await getChocoPackage(null, p);\n      mergedPackage.selected = true;\n      _store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].commit(\"computerPackage/mergeMergedPackage\", mergedPackage);\n      Object(_utils_packageNotice__WEBPACK_IMPORTED_MODULE_5__[\"packageNotice\"])(mergedPackage);\n    } else {\n      const existing = _store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].getters[\"computerPackage/mergedPackage\"](p);\n      if (existing) p.chocoPackage = existing.chocoPackage;\n      if (existing && existing.command && existing.command.execLog && (p.command.status == \"done\" || p.command.status == \"failed\")) p.command.execLog = existing.command.execLog;\n      _store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].commit(\"computerPackage/mergeMergedPackage\", p);\n      Object(_utils_packageNotice__WEBPACK_IMPORTED_MODULE_5__[\"packageNotice\"])(p);\n    }\n  }\n}\nasync function handleGroupPackageChange(data) {\n  for (const p of data.packages) {\n    const {\n      name,\n      version,\n      uid\n    } = Object(_mdc__WEBPACK_IMPORTED_MODULE_8__[\"getPackageNameVersionAndHash\"])(p);\n    const location = name + version + uid;\n    await _store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].dispatch(\"group/fetch\", {\n      domainUID: _router__WEBPACK_IMPORTED_MODULE_2__[\"default\"].currentRoute.params.domainUID\n    });\n    const group = _store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].getters[\"group/single\"](_router__WEBPACK_IMPORTED_MODULE_2__[\"default\"].currentRoute.params.groupUID);\n    _store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].commit(\"groupPackage/mergeComputerPackage\", p);\n    const stats = Object(_utils_groupPackage__WEBPACK_IMPORTED_MODULE_10__[\"getPackageStats\"])(_store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].state.groupPackage.computerPackages[location], group.computers, p);\n    _store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].commit(\"groupPackage/editMergedPackage\", {\n      p: p,\n      obj: {\n        stats: stats\n      }\n    });\n  }\n}\nfunction sendPackages(packages, computerUIDs, groupUID) {\n  if (_store__WEBPACK_IMPORTED_MODULE_3__[\"default\"].state.socket.connected) {\n    instance.emit(\"packageChange\", {\n      groupUID,\n      computerUIDs,\n      packages\n    });\n    return true;\n  } else return false;\n}\n\n//# sourceURL=webpack:///./src/utils/socket.js?");

/***/ }),

/***/ 0:
/*!***************************!*\
  !*** multi ./src/main.js ***!
  \***************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("module.exports = __webpack_require__(/*! ./src/main.js */\"./src/main.js\");\n\n\n//# sourceURL=webpack:///multi_./src/main.js?");

/***/ }),

/***/ 1:
/*!********************!*\
  !*** ws (ignored) ***!
  \********************/
/*! no static exports found */
/***/ (function(module, exports) {

eval("/* (ignored) */\n\n//# sourceURL=webpack:///ws_(ignored)?");

/***/ })

/******/ });